/*/////////////////////////////////////////////////////////////////////////////
//
//     spiral_rfft_double.c
//
//     This library was generated by Spiral 6.0, developed at Carnegie Mellon
//     University, http://www.spiral.net. This code is distributed under the
//     GNU general purpose software license version 2.0.
//
//     Commercial licenses and support are available through SpiralGen, Inc.
//     fft@spiralgen.com
//
*/

#include "spiral_fft.h"
#include "spiral_private.h"

/*************************************************
 * Main dispatch  
 *************************************************/

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double)(int n, const double *pSrc, double *pDst ) {
    switch(n) {
        case 4: return spiral_rfftfwd_double_4(pSrc, pDst );
        case 8: return spiral_rfftfwd_double_8(pSrc, pDst );
        case 16: return spiral_rfftfwd_double_16(pSrc, pDst );
        case 32: return spiral_rfftfwd_double_32(pSrc, pDst );
        case 64: return spiral_rfftfwd_double_64(pSrc, pDst );
        case 128: return spiral_rfftfwd_double_128(pSrc, pDst );
        case 256: return spiral_rfftfwd_double_256(pSrc, pDst );
        case 512: return spiral_rfftfwd_double_512(pSrc, pDst );
        case 1024: return spiral_rfftfwd_double_1024(pSrc, pDst );
        case 2048: return spiral_rfftfwd_double_2048(pSrc, pDst );
        case 4096: return spiral_rfftfwd_double_4096(pSrc, pDst );
        default: return SPIRAL_SIZE_NOT_SUPPORTED;
    }
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double)(int n, const double *pSrc, double *pDst ) {
    switch(n) {
        case 4: return spiral_rfftinv_double_4(pSrc, pDst );
        case 8: return spiral_rfftinv_double_8(pSrc, pDst );
        case 16: return spiral_rfftinv_double_16(pSrc, pDst );
        case 32: return spiral_rfftinv_double_32(pSrc, pDst );
        case 64: return spiral_rfftinv_double_64(pSrc, pDst );
        case 128: return spiral_rfftinv_double_128(pSrc, pDst );
        case 256: return spiral_rfftinv_double_256(pSrc, pDst );
        case 512: return spiral_rfftinv_double_512(pSrc, pDst );
        case 1024: return spiral_rfftinv_double_1024(pSrc, pDst );
        case 2048: return spiral_rfftinv_double_2048(pSrc, pDst );
        case 4096: return spiral_rfftinv_double_4096(pSrc, pDst );
        default: return SPIRAL_SIZE_NOT_SUPPORTED;
    }
}


/*************************************************
 * Individual transform sizes  
 *************************************************/

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_4)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a2, *a3;
    double t, t2;
    a = (src + 2);
    t = (*(src) + *(a));
    a2 = (src + 1);
    a3 = (src + 3);
    t2 = (*(a2) + *(a3));
    *(dst) = (t + t2);
    *((dst + 1)) = (t - t2);
    *((dst + 2)) = (*(src) - *(a));
    *((dst + 3)) = (*(a3) - *(a2));
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_8)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a2, *a3, *a4, *a5, *a6, *a7;
    double a8, a9, s, s2, t, t2, t3, t4, t5, t6, t7, t8;
    a = (src + 4);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    a2 = (src + 2);
    a3 = (src + 6);
    t3 = (*(a2) + *(a3));
    t4 = (*(a2) - *(a3));
    a4 = (src + 1);
    a5 = (src + 5);
    t5 = (*(a4) + *(a5));
    a6 = (src + 3);
    a7 = (src + 7);
    t6 = (*(a6) + *(a7));
    t7 = (t + t3);
    t8 = (t5 + t6);
    *(dst) = (t7 + t8);
    *((dst + 1)) = (t7 - t8);
    *((dst + 4)) = (t - t3);
    *((dst + 5)) = (t6 - t5);
    a8 = (0.70710678118654757*(*(a4) - *(a5)));
    a9 = (0.70710678118654757*(*(a6) - *(a7)));
    s = (a8 - a9);
    s2 = (a8 + a9);
    *((dst + 2)) = (t2 + s);
    *((dst + 3)) = -((t4 + s2));
    *((dst + 6)) = (t2 - s);
    *((dst + 7)) = (t4 - s2);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_16)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a71;
    double a02, a12, a8, a81, a9, a91, s, s01, s2, s3, s4, s5, s6, s7, s8, s9, t, t01, t02, t11, t12, t2
            , t21, t22, t3, t31, t32, t4, t41, t42, t5, t51, t52, t6, t61, t62, t7, t71, t72, t8, t81, t82, t9, t91;
    a = (src + 8);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    a2 = (src + 4);
    a3 = (src + 12);
    t3 = (*(a2) + *(a3));
    t4 = (*(a2) - *(a3));
    a4 = (src + 2);
    a5 = (src + 10);
    t5 = (*(a4) + *(a5));
    a6 = (src + 6);
    a7 = (src + 14);
    t6 = (*(a6) + *(a7));
    t7 = (t + t3);
    t8 = (t - t3);
    t9 = (t5 + t6);
    t01 = (t5 - t6);
    a8 = (0.70710678118654757*(*(a4) - *(a5)));
    a9 = (0.70710678118654757*(*(a6) - *(a7)));
    s = (a8 - a9);
    s2 = (a8 + a9);
    t11 = (t2 + s);
    t21 = (t4 + s2);
    t31 = (t2 - s);
    t41 = (s2 - t4);
    a01 = (src + 1);
    a11 = (src + 9);
    t51 = (*(a01) + *(a11));
    t61 = (*(a01) - *(a11));
    a21 = (src + 5);
    a31 = (src + 13);
    t71 = (*(a21) + *(a31));
    t81 = (*(a21) - *(a31));
    a41 = (src + 3);
    a51 = (src + 11);
    t91 = (*(a41) + *(a51));
    a61 = (src + 7);
    a71 = (src + 15);
    t02 = (*(a61) + *(a71));
    t12 = (t51 + t71);
    t22 = (t91 + t02);
    a81 = (0.70710678118654757*(*(a41) - *(a51)));
    a91 = (0.70710678118654757*(*(a61) - *(a71)));
    s3 = (a81 - a91);
    s4 = (a81 + a91);
    t32 = (t61 + s3);
    t42 = (t81 + s4);
    t52 = (t61 - s3);
    t62 = (s4 - t81);
    t72 = (t7 + t9);
    t82 = (t12 + t22);
    *(dst) = (t72 + t82);
    *((dst + 1)) = (t72 - t82);
    *((dst + 8)) = (t7 - t9);
    *((dst + 9)) = (t22 - t12);
    s5 = ((0.92387953251128674*t32) - (0.38268343236508978*t42));
    s6 = ((0.38268343236508978*t32) + (0.92387953251128674*t42));
    *((dst + 2)) = (t11 + s5);
    *((dst + 3)) = -((t21 + s6));
    *((dst + 14)) = (t11 - s5);
    *((dst + 15)) = (t21 - s6);
    a02 = (0.70710678118654757*(t51 - t71));
    a12 = (0.70710678118654757*(t91 - t02));
    s7 = (a02 - a12);
    s8 = (a02 + a12);
    *((dst + 4)) = (t8 + s7);
    *((dst + 5)) = -((t01 + s8));
    *((dst + 12)) = (t8 - s7);
    *((dst + 13)) = (t01 - s8);
    s9 = ((0.38268343236508978*t52) - (0.92387953251128674*t62));
    s01 = ((0.92387953251128674*t52) + (0.38268343236508978*t62));
    *((dst + 6)) = (t31 + s9);
    *((dst + 7)) = -((t41 + s01));
    *((dst + 10)) = (t31 - s9);
    *((dst + 11)) = (t41 - s01);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_32)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a01, *a02, *a03, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52
            , *a53, *a6, *a61, *a62, *a63, *a7, *a71, *a72, *a73;
    double a04, a14, a24, a34, a8, a81, a82, a83, a9, a91, a92, a93, s, s01, s02, s11, s12, s2, s21, s22, s3, s31
            , s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s72, s8, s81, s82, s9, s91, t, t01, t02, t03
            , t04, t05, t06, t07, t08, t11, t12, t13, t14, t15, t16, t17, t18, t2, t21, t22, t23, t24, t25, t26, t27, t28
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t4, t41, t42, t43, t44, t45, t46, t47, t48, t5, t51, t52, t53
            , t54, t55, t56, t57, t58, t6, t61, t62, t63, t64, t65, t66, t67, t68, t7, t71, t72, t73, t74, t75, t76, t77
            , t8, t81, t82, t83, t84, t85, t86, t87, t9, t91, t92, t93, t94, t95, t96, t97;
    a = (src + 16);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    a2 = (src + 8);
    a3 = (src + 24);
    t3 = (*(a2) + *(a3));
    t4 = (*(a2) - *(a3));
    a4 = (src + 4);
    a5 = (src + 20);
    t5 = (*(a4) + *(a5));
    a6 = (src + 12);
    a7 = (src + 28);
    t6 = (*(a6) + *(a7));
    t7 = (t + t3);
    t8 = (t - t3);
    t9 = (t5 + t6);
    t01 = (t5 - t6);
    a8 = (0.70710678118654757*(*(a4) - *(a5)));
    a9 = (0.70710678118654757*(*(a6) - *(a7)));
    s = (a8 - a9);
    s2 = (a8 + a9);
    t11 = (t2 + s);
    t21 = (t4 + s2);
    t31 = (t2 - s);
    t41 = (s2 - t4);
    a01 = (src + 1);
    a11 = (src + 17);
    t51 = (*(a01) + *(a11));
    t61 = (*(a01) - *(a11));
    a21 = (src + 9);
    a31 = (src + 25);
    t71 = (*(a21) + *(a31));
    t81 = (*(a21) - *(a31));
    a41 = (src + 5);
    a51 = (src + 21);
    t91 = (*(a41) + *(a51));
    a61 = (src + 13);
    a71 = (src + 29);
    t02 = (*(a61) + *(a71));
    t12 = (t51 + t71);
    t22 = (t51 - t71);
    t32 = (t91 + t02);
    t42 = (t91 - t02);
    a81 = (0.70710678118654757*(*(a41) - *(a51)));
    a91 = (0.70710678118654757*(*(a61) - *(a71)));
    s3 = (a81 - a91);
    s4 = (a81 + a91);
    t52 = (t61 + s3);
    t62 = (t81 + s4);
    t72 = (t61 - s3);
    t82 = (s4 - t81);
    a02 = (src + 2);
    a12 = (src + 18);
    t92 = (*(a02) + *(a12));
    t03 = (*(a02) - *(a12));
    a22 = (src + 10);
    a32 = (src + 26);
    t13 = (*(a22) + *(a32));
    t23 = (*(a22) - *(a32));
    a42 = (src + 6);
    a52 = (src + 22);
    t33 = (*(a42) + *(a52));
    a62 = (src + 14);
    a72 = (src + 30);
    t43 = (*(a62) + *(a72));
    t53 = (t92 + t13);
    t63 = (t33 + t43);
    a82 = (0.70710678118654757*(*(a42) - *(a52)));
    a92 = (0.70710678118654757*(*(a62) - *(a72)));
    s5 = (a82 - a92);
    s6 = (a82 + a92);
    t73 = (t03 + s5);
    t83 = (t23 + s6);
    t93 = (t03 - s5);
    t04 = (s6 - t23);
    a03 = (src + 3);
    a13 = (src + 19);
    t14 = (*(a03) + *(a13));
    t24 = (*(a03) - *(a13));
    a23 = (src + 11);
    a33 = (src + 27);
    t34 = (*(a23) + *(a33));
    t44 = (*(a23) - *(a33));
    a43 = (src + 7);
    a53 = (src + 23);
    t54 = (*(a43) + *(a53));
    a63 = (src + 15);
    a73 = (src + 31);
    t64 = (*(a63) + *(a73));
    t74 = (t14 + t34);
    t84 = (t14 - t34);
    t94 = (t54 + t64);
    t05 = (t54 - t64);
    a83 = (0.70710678118654757*(*(a43) - *(a53)));
    a93 = (0.70710678118654757*(*(a63) - *(a73)));
    s7 = (a83 - a93);
    s8 = (a83 + a93);
    t15 = (t24 + s7);
    t25 = (t44 + s8);
    t35 = (t24 - s7);
    t45 = (s8 - t44);
    t55 = (t7 + t9);
    t65 = (t7 - t9);
    t75 = (t53 + t63);
    t85 = (t53 - t63);
    t95 = (t12 + t32);
    t06 = (t74 + t94);
    t16 = (t55 + t75);
    t26 = (t95 + t06);
    *(dst) = (t16 + t26);
    *((dst + 1)) = (t16 - t26);
    *((dst + 16)) = (t55 - t75);
    *((dst + 17)) = (t06 - t95);
    a04 = (0.70710678118654757*(t12 - t32));
    a14 = (0.70710678118654757*(t74 - t94));
    s9 = (a04 - a14);
    s01 = (a04 + a14);
    *((dst + 8)) = (t65 + s9);
    *((dst + 9)) = -((t85 + s01));
    *((dst + 24)) = (t65 - s9);
    *((dst + 25)) = (t85 - s01);
    s11 = ((0.98078528040323043*t52) - (0.19509032201612828*t62));
    s21 = ((0.19509032201612828*t52) + (0.98078528040323043*t62));
    s31 = ((0.92387953251128674*t73) - (0.38268343236508978*t83));
    s41 = ((0.38268343236508978*t73) + (0.92387953251128674*t83));
    s51 = ((0.83146961230254524*t15) - (0.55557023301960218*t25));
    s61 = ((0.55557023301960218*t15) + (0.83146961230254524*t25));
    t36 = (t11 + s31);
    t46 = (t21 + s41);
    t56 = (t11 - s31);
    t66 = (s41 - t21);
    t76 = (s11 + s51);
    t86 = (s21 + s61);
    t96 = (s11 - s51);
    t07 = (s61 - s21);
    *((dst + 2)) = (t36 + t76);
    *((dst + 3)) = -((t46 + t86));
    *((dst + 30)) = (t36 - t76);
    *((dst + 31)) = (t46 - t86);
    *((dst + 18)) = (t56 + t07);
    *((dst + 19)) = (t66 - t96);
    *((dst + 14)) = (t56 - t07);
    *((dst + 15)) = -((t66 + t96));
    s71 = ((0.92387953251128674*t22) - (0.38268343236508978*t42));
    s81 = ((0.38268343236508978*t22) + (0.92387953251128674*t42));
    a24 = (0.70710678118654757*(t92 - t13));
    a34 = (0.70710678118654757*(t33 - t43));
    s91 = (a24 - a34);
    s02 = (a24 + a34);
    s12 = ((0.38268343236508978*t84) - (0.92387953251128674*t05));
    s22 = ((0.92387953251128674*t84) + (0.38268343236508978*t05));
    t17 = (t8 + s91);
    t27 = (t01 + s02);
    t37 = (t8 - s91);
    t47 = (s02 - t01);
    t57 = (s71 + s12);
    t67 = (s81 + s22);
    t77 = (s71 - s12);
    t87 = (s22 - s81);
    *((dst + 4)) = (t17 + t57);
    *((dst + 5)) = -((t27 + t67));
    *((dst + 28)) = (t17 - t57);
    *((dst + 29)) = (t27 - t67);
    *((dst + 20)) = (t37 + t87);
    *((dst + 21)) = (t47 - t77);
    *((dst + 12)) = (t37 - t87);
    *((dst + 13)) = -((t47 + t77));
    s32 = ((0.83146961230254524*t72) - (0.55557023301960218*t82));
    s42 = ((0.55557023301960218*t72) + (0.83146961230254524*t82));
    s52 = ((0.38268343236508978*t93) - (0.92387953251128674*t04));
    s62 = ((0.92387953251128674*t93) + (0.38268343236508978*t04));
    s72 = ((0.19509032201612828*t35) + (0.98078528040323043*t45));
    s82 = ((0.19509032201612828*t45) - (0.98078528040323043*t35));
    t97 = (t31 + s52);
    t08 = (t41 + s62);
    t18 = (t31 - s52);
    t28 = (s62 - t41);
    t38 = (s32 - s72);
    t48 = (s82 - s42);
    t58 = (s32 + s72);
    t68 = (s42 + s82);
    *((dst + 6)) = (t97 + t38);
    *((dst + 7)) = (t48 - t08);
    *((dst + 26)) = (t97 - t38);
    *((dst + 27)) = (t08 + t48);
    *((dst + 22)) = (t18 - t68);
    *((dst + 23)) = (t28 - t58);
    *((dst + 10)) = (t18 + t68);
    *((dst + 11)) = -((t28 + t58));
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_64)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a34, *a35, *a36, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a46, *a47, *a5, *a51, *a52, *a53, *a54
            , *a55, *a56, *a57, *a6, *a62, *a64, *a66, *a7, *a72, *a74, *a76, *a8, *a82, *a84, *a86, *a9, *a92, *a94, *a96;
    double a08, a18, a28, a38, a61, a63, a65, a67, a71, a73, a75, a77, a81, a83, a85, a87, a91, a93, a95, a97, s, s01
            , s02, s03, s04, s05, s06, s07, s11, s12, s13, s14, s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3
            , s31, s32, s33, s34, s35, s36, s37, s4, s41, s42, s43, s44, s45, s46, s47, s5, s51, s52, s53, s54, s55, s56
            , s57, s6, s61, s62, s63, s64, s65, s66, s67, s7, s71, s72, s73, s74, s75, s76, s8, s81, s82, s83, s84, s85
            , s86, s9, s91, s92, s93, s94, s95, s96, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d
            , t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c
            , t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a
            , t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t3, t31, t32, t33, t34, t35, t36, t37, t38
            , t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t4, t41, t42, t43, t44, t45, t46
            , t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t5, t51, t52, t53, t54
            , t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t6, t61, t62
            , t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t7
            , t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m
            , t7n, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k
            , t8l, t8m, t8n, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i
            , t9j, t9k, t9l, t9m;
    a = (src + 32);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    a2 = (src + 16);
    a3 = (src + 48);
    t3 = (*(a2) + *(a3));
    t4 = (*(a2) - *(a3));
    a4 = (src + 4);
    a5 = (src + 36);
    t5 = (*(a4) + *(a5));
    t6 = (*(a4) - *(a5));
    a6 = (src + 20);
    a7 = (src + 52);
    t7 = (*(a6) + *(a7));
    t8 = (*(a6) - *(a7));
    a8 = (src + 8);
    a9 = (src + 40);
    t9 = (*(a8) + *(a9));
    a01 = (src + 24);
    a11 = (src + 56);
    t01 = (*(a01) + *(a11));
    a21 = (src + 12);
    a31 = (src + 44);
    t11 = (*(a21) + *(a31));
    t21 = (*(a21) - *(a31));
    a41 = (src + 28);
    a51 = (src + 60);
    t31 = (*(a41) + *(a51));
    t41 = (*(a41) - *(a51));
    t51 = (t + t3);
    t61 = (t - t3);
    t71 = (t9 + t01);
    t81 = (t9 - t01);
    t91 = (t5 + t7);
    t02 = (t11 + t31);
    t12 = (t51 + t71);
    t22 = (t51 - t71);
    t32 = (t91 + t02);
    t42 = (t91 - t02);
    a61 = (0.70710678118654757*(t5 - t7));
    a71 = (0.70710678118654757*(t11 - t31));
    s = (a61 - a71);
    s2 = (a61 + a71);
    t52 = (t61 + s);
    t62 = (t81 + s2);
    t72 = (t61 - s);
    t82 = (s2 - t81);
    s3 = ((0.92387953251128674*t6) - (0.38268343236508978*t8));
    s4 = ((0.38268343236508978*t6) + (0.92387953251128674*t8));
    a81 = (0.70710678118654757*(*(a8) - *(a9)));
    a91 = (0.70710678118654757*(*(a01) - *(a11)));
    s5 = (a81 - a91);
    s6 = (a81 + a91);
    s7 = ((0.38268343236508978*t21) - (0.92387953251128674*t41));
    s8 = ((0.92387953251128674*t21) + (0.38268343236508978*t41));
    t92 = (t2 + s5);
    t03 = (t4 + s6);
    t13 = (t2 - s5);
    t23 = (s6 - t4);
    t33 = (s3 + s7);
    t43 = (s4 + s8);
    t53 = (s3 - s7);
    t63 = (s8 - s4);
    t73 = (t92 + t33);
    t83 = (t03 + t43);
    t93 = (t92 - t33);
    t04 = (t43 - t03);
    t14 = (t13 + t63);
    t24 = (t23 - t53);
    t34 = (t13 - t63);
    t44 = (t23 + t53);
    a02 = (src + 1);
    a12 = (src + 33);
    t54 = (*(a02) + *(a12));
    t64 = (*(a02) - *(a12));
    a22 = (src + 17);
    a32 = (src + 49);
    t74 = (*(a22) + *(a32));
    t84 = (*(a22) - *(a32));
    a42 = (src + 5);
    a52 = (src + 37);
    t94 = (*(a42) + *(a52));
    t05 = (*(a42) - *(a52));
    a62 = (src + 21);
    a72 = (src + 53);
    t15 = (*(a62) + *(a72));
    t25 = (*(a62) - *(a72));
    a82 = (src + 9);
    a92 = (src + 41);
    t35 = (*(a82) + *(a92));
    a03 = (src + 25);
    a13 = (src + 57);
    t45 = (*(a03) + *(a13));
    a23 = (src + 13);
    a33 = (src + 45);
    t55 = (*(a23) + *(a33));
    t65 = (*(a23) - *(a33));
    a43 = (src + 29);
    a53 = (src + 61);
    t75 = (*(a43) + *(a53));
    t85 = (*(a43) - *(a53));
    t95 = (t54 + t74);
    t06 = (t54 - t74);
    t16 = (t35 + t45);
    t26 = (t35 - t45);
    t36 = (t94 + t15);
    t46 = (t55 + t75);
    t56 = (t95 + t16);
    t66 = (t95 - t16);
    t76 = (t36 + t46);
    t86 = (t36 - t46);
    a63 = (0.70710678118654757*(t94 - t15));
    a73 = (0.70710678118654757*(t55 - t75));
    s9 = (a63 - a73);
    s01 = (a63 + a73);
    t96 = (t06 + s9);
    t07 = (t26 + s01);
    t17 = (t06 - s9);
    t27 = (s01 - t26);
    s11 = ((0.92387953251128674*t05) - (0.38268343236508978*t25));
    s21 = ((0.38268343236508978*t05) + (0.92387953251128674*t25));
    a83 = (0.70710678118654757*(*(a82) - *(a92)));
    a93 = (0.70710678118654757*(*(a03) - *(a13)));
    s31 = (a83 - a93);
    s41 = (a83 + a93);
    s51 = ((0.38268343236508978*t65) - (0.92387953251128674*t85));
    s61 = ((0.92387953251128674*t65) + (0.38268343236508978*t85));
    t37 = (t64 + s31);
    t47 = (t84 + s41);
    t57 = (t64 - s31);
    t67 = (s41 - t84);
    t77 = (s11 + s51);
    t87 = (s21 + s61);
    t97 = (s11 - s51);
    t08 = (s61 - s21);
    t18 = (t37 + t77);
    t28 = (t47 + t87);
    t38 = (t37 - t77);
    t48 = (t87 - t47);
    t58 = (t57 + t08);
    t68 = (t67 - t97);
    t78 = (t57 - t08);
    t88 = (t67 + t97);
    a04 = (src + 2);
    a14 = (src + 34);
    t98 = (*(a04) + *(a14));
    t09 = (*(a04) - *(a14));
    a24 = (src + 18);
    a34 = (src + 50);
    t19 = (*(a24) + *(a34));
    t29 = (*(a24) - *(a34));
    a44 = (src + 6);
    a54 = (src + 38);
    t39 = (*(a44) + *(a54));
    t49 = (*(a44) - *(a54));
    a64 = (src + 22);
    a74 = (src + 54);
    t59 = (*(a64) + *(a74));
    t69 = (*(a64) - *(a74));
    a84 = (src + 10);
    a94 = (src + 42);
    t79 = (*(a84) + *(a94));
    a05 = (src + 26);
    a15 = (src + 58);
    t89 = (*(a05) + *(a15));
    a25 = (src + 14);
    a35 = (src + 46);
    t99 = (*(a25) + *(a35));
    t0a = (*(a25) - *(a35));
    a45 = (src + 30);
    a55 = (src + 62);
    t1a = (*(a45) + *(a55));
    t2a = (*(a45) - *(a55));
    t3a = (t98 + t19);
    t4a = (t98 - t19);
    t5a = (t79 + t89);
    t6a = (t79 - t89);
    t7a = (t39 + t59);
    t8a = (t99 + t1a);
    t9a = (t3a + t5a);
    t0b = (t7a + t8a);
    a65 = (0.70710678118654757*(t39 - t59));
    a75 = (0.70710678118654757*(t99 - t1a));
    s71 = (a65 - a75);
    s81 = (a65 + a75);
    t1b = (t4a + s71);
    t2b = (t6a + s81);
    t3b = (t4a - s71);
    t4b = (s81 - t6a);
    s91 = ((0.92387953251128674*t49) - (0.38268343236508978*t69));
    s02 = ((0.38268343236508978*t49) + (0.92387953251128674*t69));
    a85 = (0.70710678118654757*(*(a84) - *(a94)));
    a95 = (0.70710678118654757*(*(a05) - *(a15)));
    s12 = (a85 - a95);
    s22 = (a85 + a95);
    s32 = ((0.38268343236508978*t0a) - (0.92387953251128674*t2a));
    s42 = ((0.92387953251128674*t0a) + (0.38268343236508978*t2a));
    t5b = (t09 + s12);
    t6b = (t29 + s22);
    t7b = (t09 - s12);
    t8b = (s22 - t29);
    t9b = (s91 + s32);
    t0c = (s02 + s42);
    t1c = (s91 - s32);
    t2c = (s42 - s02);
    t3c = (t5b + t9b);
    t4c = (t6b + t0c);
    t5c = (t5b - t9b);
    t6c = (t0c - t6b);
    t7c = (t7b + t2c);
    t8c = (t8b - t1c);
    t9c = (t7b - t2c);
    t0d = (t8b + t1c);
    a06 = (src + 3);
    a16 = (src + 35);
    t1d = (*(a06) + *(a16));
    t2d = (*(a06) - *(a16));
    a26 = (src + 19);
    a36 = (src + 51);
    t3d = (*(a26) + *(a36));
    t4d = (*(a26) - *(a36));
    a46 = (src + 7);
    a56 = (src + 39);
    t5d = (*(a46) + *(a56));
    t6d = (*(a46) - *(a56));
    a66 = (src + 23);
    a76 = (src + 55);
    t7d = (*(a66) + *(a76));
    t8d = (*(a66) - *(a76));
    a86 = (src + 11);
    a96 = (src + 43);
    t9d = (*(a86) + *(a96));
    a07 = (src + 27);
    a17 = (src + 59);
    t0e = (*(a07) + *(a17));
    a27 = (src + 15);
    a37 = (src + 47);
    t1e = (*(a27) + *(a37));
    t2e = (*(a27) - *(a37));
    a47 = (src + 31);
    a57 = (src + 63);
    t3e = (*(a47) + *(a57));
    t4e = (*(a47) - *(a57));
    t5e = (t1d + t3d);
    t6e = (t1d - t3d);
    t7e = (t9d + t0e);
    t8e = (t9d - t0e);
    t9e = (t5d + t7d);
    t0f = (t1e + t3e);
    t1f = (t5e + t7e);
    t2f = (t5e - t7e);
    t3f = (t9e + t0f);
    t4f = (t9e - t0f);
    a67 = (0.70710678118654757*(t5d - t7d));
    a77 = (0.70710678118654757*(t1e - t3e));
    s52 = (a67 - a77);
    s62 = (a67 + a77);
    t5f = (t6e + s52);
    t6f = (t8e + s62);
    t7f = (t6e - s52);
    t8f = (s62 - t8e);
    s72 = ((0.92387953251128674*t6d) - (0.38268343236508978*t8d));
    s82 = ((0.38268343236508978*t6d) + (0.92387953251128674*t8d));
    a87 = (0.70710678118654757*(*(a86) - *(a96)));
    a97 = (0.70710678118654757*(*(a07) - *(a17)));
    s92 = (a87 - a97);
    s03 = (a87 + a97);
    s13 = ((0.38268343236508978*t2e) - (0.92387953251128674*t4e));
    s23 = ((0.92387953251128674*t2e) + (0.38268343236508978*t4e));
    t9f = (t2d + s92);
    t0g = (t4d + s03);
    t1g = (t2d - s92);
    t2g = (s03 - t4d);
    t3g = (s72 + s13);
    t4g = (s82 + s23);
    t5g = (s72 - s13);
    t6g = (s23 - s82);
    t7g = (t9f + t3g);
    t8g = (t0g + t4g);
    t9g = (t9f - t3g);
    t0h = (t4g - t0g);
    t1h = (t1g + t6g);
    t2h = (t2g - t5g);
    t3h = (t1g - t6g);
    t4h = (t2g + t5g);
    t5h = (t12 + t32);
    t6h = (t12 - t32);
    t7h = (t9a + t0b);
    t8h = (t9a - t0b);
    t9h = (t56 + t76);
    t0i = (t1f + t3f);
    t1i = (t5h + t7h);
    t2i = (t9h + t0i);
    *(dst) = (t1i + t2i);
    *((dst + 1)) = (t1i - t2i);
    *((dst + 32)) = (t5h - t7h);
    *((dst + 33)) = (t0i - t9h);
    a08 = (0.70710678118654757*(t56 - t76));
    a18 = (0.70710678118654757*(t1f - t3f));
    s33 = (a08 - a18);
    s43 = (a08 + a18);
    *((dst + 16)) = (t6h + s33);
    *((dst + 17)) = -((t8h + s43));
    *((dst + 48)) = (t6h - s33);
    *((dst + 49)) = (t8h - s43);
    s53 = ((0.99518472667219693*t18) - (0.098017140329560604*t28));
    s63 = ((0.098017140329560604*t18) + (0.99518472667219693*t28));
    s73 = ((0.98078528040323043*t3c) - (0.19509032201612828*t4c));
    s83 = ((0.19509032201612828*t3c) + (0.98078528040323043*t4c));
    s93 = ((0.95694033573220882*t7g) - (0.29028467725446239*t8g));
    s04 = ((0.29028467725446239*t7g) + (0.95694033573220882*t8g));
    t3i = (t73 + s73);
    t4i = (t83 + s83);
    t5i = (t73 - s73);
    t6i = (s83 - t83);
    t7i = (s53 + s93);
    t8i = (s63 + s04);
    t9i = (s53 - s93);
    t0j = (s04 - s63);
    *((dst + 2)) = (t3i + t7i);
    *((dst + 3)) = -((t4i + t8i));
    *((dst + 62)) = (t3i - t7i);
    *((dst + 63)) = (t4i - t8i);
    *((dst + 34)) = (t5i + t0j);
    *((dst + 35)) = (t6i - t9i);
    *((dst + 30)) = (t5i - t0j);
    *((dst + 31)) = -((t6i + t9i));
    s14 = ((0.98078528040323043*t96) - (0.19509032201612828*t07));
    s24 = ((0.19509032201612828*t96) + (0.98078528040323043*t07));
    s34 = ((0.92387953251128674*t1b) - (0.38268343236508978*t2b));
    s44 = ((0.38268343236508978*t1b) + (0.92387953251128674*t2b));
    s54 = ((0.83146961230254524*t5f) - (0.55557023301960218*t6f));
    s64 = ((0.55557023301960218*t5f) + (0.83146961230254524*t6f));
    t1j = (t52 + s34);
    t2j = (t62 + s44);
    t3j = (t52 - s34);
    t4j = (s44 - t62);
    t5j = (s14 + s54);
    t6j = (s24 + s64);
    t7j = (s14 - s54);
    t8j = (s64 - s24);
    *((dst + 4)) = (t1j + t5j);
    *((dst + 5)) = -((t2j + t6j));
    *((dst + 60)) = (t1j - t5j);
    *((dst + 61)) = (t2j - t6j);
    *((dst + 36)) = (t3j + t8j);
    *((dst + 37)) = (t4j - t7j);
    *((dst + 28)) = (t3j - t8j);
    *((dst + 29)) = -((t4j + t7j));
    s74 = ((0.95694033573220882*t78) - (0.29028467725446239*t88));
    s84 = ((0.29028467725446239*t78) + (0.95694033573220882*t88));
    s94 = ((0.83146961230254524*t9c) - (0.55557023301960218*t0d));
    s05 = ((0.55557023301960218*t9c) + (0.83146961230254524*t0d));
    s15 = ((0.63439328416364549*t3h) - (0.77301045336273699*t4h));
    s25 = ((0.77301045336273699*t3h) + (0.63439328416364549*t4h));
    t9j = (t34 + s94);
    t0k = (t44 + s05);
    t1k = (t34 - s94);
    t2k = (s05 - t44);
    t3k = (s74 + s15);
    t4k = (s84 + s25);
    t5k = (s74 - s15);
    t6k = (s25 - s84);
    *((dst + 6)) = (t9j + t3k);
    *((dst + 7)) = -((t0k + t4k));
    *((dst + 58)) = (t9j - t3k);
    *((dst + 59)) = (t0k - t4k);
    *((dst + 38)) = (t1k + t6k);
    *((dst + 39)) = (t2k - t5k);
    *((dst + 26)) = (t1k - t6k);
    *((dst + 27)) = -((t2k + t5k));
    s35 = ((0.92387953251128674*t66) - (0.38268343236508978*t86));
    s45 = ((0.38268343236508978*t66) + (0.92387953251128674*t86));
    a28 = (0.70710678118654757*(t3a - t5a));
    a38 = (0.70710678118654757*(t7a - t8a));
    s55 = (a28 - a38);
    s65 = (a28 + a38);
    s75 = ((0.38268343236508978*t2f) - (0.92387953251128674*t4f));
    s85 = ((0.92387953251128674*t2f) + (0.38268343236508978*t4f));
    t7k = (t22 + s55);
    t8k = (t42 + s65);
    t9k = (t22 - s55);
    t0l = (s65 - t42);
    t1l = (s35 + s75);
    t2l = (s45 + s85);
    t3l = (s35 - s75);
    t4l = (s85 - s45);
    *((dst + 8)) = (t7k + t1l);
    *((dst + 9)) = -((t8k + t2l));
    *((dst + 56)) = (t7k - t1l);
    *((dst + 57)) = (t8k - t2l);
    *((dst + 40)) = (t9k + t4l);
    *((dst + 41)) = (t0l - t3l);
    *((dst + 24)) = (t9k - t4l);
    *((dst + 25)) = -((t0l + t3l));
    s95 = ((0.88192126434835505*t58) + (0.47139673682599764*t68));
    s06 = ((0.88192126434835505*t68) - (0.47139673682599764*t58));
    s16 = ((0.55557023301960218*t7c) + (0.83146961230254524*t8c));
    s26 = ((0.55557023301960218*t8c) - (0.83146961230254524*t7c));
    s36 = ((0.098017140329560604*t1h) + (0.99518472667219693*t2h));
    s46 = ((0.098017140329560604*t2h) - (0.99518472667219693*t1h));
    t5l = (t14 + s16);
    t6l = (t24 + s26);
    t7l = (t14 - s16);
    t8l = (t24 - s26);
    t9l = (s95 + s36);
    t0m = (s06 + s46);
    t1m = (s95 - s36);
    t2m = (s06 - s46);
    *((dst + 10)) = (t5l + t9l);
    *((dst + 11)) = (t6l + t0m);
    *((dst + 54)) = (t5l - t9l);
    *((dst + 55)) = (t0m - t6l);
    *((dst + 42)) = (t7l + t2m);
    *((dst + 43)) = (t8l - t1m);
    *((dst + 22)) = (t7l - t2m);
    *((dst + 23)) = -((t8l + t1m));
    s56 = ((0.83146961230254524*t17) - (0.55557023301960218*t27));
    s66 = ((0.55557023301960218*t17) + (0.83146961230254524*t27));
    s76 = ((0.38268343236508978*t3b) - (0.92387953251128674*t4b));
    s86 = ((0.92387953251128674*t3b) + (0.38268343236508978*t4b));
    s96 = ((0.19509032201612828*t7f) + (0.98078528040323043*t8f));
    s07 = ((0.19509032201612828*t8f) - (0.98078528040323043*t7f));
    t3m = (t72 + s76);
    t4m = (t82 + s86);
    t5m = (t72 - s76);
    t6m = (s86 - t82);
    t7m = (s56 - s96);
    t8m = (s07 - s66);
    t9m = (s56 + s96);
    t0n = (s66 + s07);
    *((dst + 12)) = (t3m + t7m);
    *((dst + 13)) = (t8m - t4m);
    *((dst + 52)) = (t3m - t7m);
    *((dst + 53)) = (t4m + t8m);
    *((dst + 44)) = (t5m - t0n);
    *((dst + 45)) = (t6m - t9m);
    *((dst + 20)) = (t5m + t0n);
    *((dst + 21)) = -((t6m + t9m));
    s17 = ((0.77301045336273699*t38) - (0.63439328416364549*t48));
    s27 = ((0.63439328416364549*t38) + (0.77301045336273699*t48));
    s37 = ((0.19509032201612828*t5c) - (0.98078528040323043*t6c));
    s47 = ((0.98078528040323043*t5c) + (0.19509032201612828*t6c));
    s57 = ((0.47139673682599764*t9g) + (0.88192126434835505*t0h));
    s67 = ((0.47139673682599764*t0h) - (0.88192126434835505*t9g));
    t1n = (t93 + s37);
    t2n = (t04 + s47);
    t3n = (t93 - s37);
    t4n = (s47 - t04);
    t5n = (s17 - s57);
    t6n = (s67 - s27);
    t7n = (s17 + s57);
    t8n = (s27 + s67);
    *((dst + 14)) = (t1n + t5n);
    *((dst + 15)) = (t6n - t2n);
    *((dst + 50)) = (t1n - t5n);
    *((dst + 51)) = (t2n + t6n);
    *((dst + 46)) = (t3n - t8n);
    *((dst + 47)) = (t4n - t7n);
    *((dst + 18)) = (t3n + t8n);
    *((dst + 19)) = -((t4n + t7n));
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_128)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[128];
    double  *a05, *a06, *a07, *a13, *a15, *a16, *a17, *a22, *a23, *a25, *a26, *a27, *a32, *a33, *a35, *a36, *a37, *a42, *a43, *a44, *a45, *a46
            , *a47, *a52, *a53, *a54, *a55, *a56, *a57, *a62, *a63, *a64, *a65, *a66, *a71, *a72, *a73, *a74, *a75, *a76, *a82, *a83, *a84, *a85
            , *a86, *a94, *a95, *a96, *b, *b2, *b3;
    const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a8, *a9;
    int a08, a34;
    double a02, a03, a04, a12, a14, a24, a67, a77, a81, a87, a91, a92, a93, a97, s, s01, s02, s03, s11, s12, s13, s2
            , s21, s22, s23, s3, s31, s32, s33, s4, s41, s42, s43, s5, s51, s52, s53, s6, s61, s62, s63, s7, s71, s72
            , s73, s8, s81, s82, s83, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t08, t11, t12, t13, t14, t15
            , t16, t17, t18, t2, t21, t22, t23, t24, t25, t26, t27, t28, t3, t31, t32, t33, t34, t35, t36, t37, t38, t4
            , t41, t42, t43, t44, t45, t46, t47, t48, t5, t51, t52, t53, t54, t55, t56, t57, t6, t61, t62, t63, t64, t65
            , t66, t67, t7, t71, t72, t73, t74, t75, t76, t77, t8, t81, t82, t83, t84, t85, t86, t87, t9, t91, t92, t93
            , t94, t95, t96, t97;
    {long i; for(i = 0; i <= 7; i++) {
        a = (src + i);
        a2 = (a + 64);
        t = (*(a) + *(a2));
        t2 = (*(a) - *(a2));
        a3 = (a + 32);
        a4 = (a + 96);
        t3 = (*(a3) + *(a4));
        t4 = (*(a3) - *(a4));
        a5 = (a + 8);
        a6 = (a + 72);
        t5 = (*(a5) + *(a6));
        t6 = (*(a5) - *(a6));
        a7 = (a + 40);
        a8 = (a + 104);
        t7 = (*(a7) + *(a8));
        t8 = (*(a7) - *(a8));
        a9 = (a + 16);
        a01 = (a + 80);
        t9 = (*(a9) + *(a01));
        a11 = (a + 48);
        a21 = (a + 112);
        t01 = (*(a11) + *(a21));
        a31 = (a + 24);
        a41 = (a + 88);
        t11 = (*(a31) + *(a41));
        t21 = (*(a31) - *(a41));
        a51 = (a + 56);
        a61 = (a + 120);
        t31 = (*(a51) + *(a61));
        t41 = (*(a51) - *(a61));
        t51 = (t + t3);
        t61 = (t - t3);
        t71 = (t9 + t01);
        t81 = (t9 - t01);
        t91 = (t5 + t7);
        t02 = (t11 + t31);
        a71 = (T + i);
        *(a71) = (t51 + t71);
        *((a71 + 64)) = (t51 - t71);
        *((a71 + 8)) = (t91 + t02);
        *((a71 + 72)) = (t02 - t91);
        a81 = (0.70710678118654757*(t5 - t7));
        a91 = (0.70710678118654757*(t11 - t31));
        s = (a81 - a91);
        s2 = (a81 + a91);
        *((a71 + 32)) = (t61 + s);
        *((a71 + 40)) = -((t81 + s2));
        *((a71 + 96)) = (t61 - s);
        *((a71 + 104)) = (t81 - s2);
        s3 = ((0.92387953251128674*t6) - (0.38268343236508978*t8));
        s4 = ((0.38268343236508978*t6) + (0.92387953251128674*t8));
        a02 = (0.70710678118654757*(*(a9) - *(a01)));
        a12 = (0.70710678118654757*(*(a11) - *(a21)));
        s5 = (a02 - a12);
        s6 = (a02 + a12);
        s7 = ((0.38268343236508978*t21) - (0.92387953251128674*t41));
        s8 = ((0.92387953251128674*t21) + (0.38268343236508978*t41));
        t12 = (t2 + s5);
        t22 = (t4 + s6);
        t32 = (t2 - s5);
        t42 = (s6 - t4);
        t52 = (s3 + s7);
        t62 = (s4 + s8);
        t72 = (s3 - s7);
        t82 = (s8 - s4);
        *((a71 + 16)) = (t12 + t52);
        *((a71 + 24)) = -((t22 + t62));
        *((a71 + 112)) = (t12 - t52);
        *((a71 + 120)) = (t22 - t62);
        *((a71 + 80)) = (t32 + t82);
        *((a71 + 88)) = (t42 - t72);
        *((a71 + 48)) = (t32 - t82);
        *((a71 + 56)) = -((t42 + t72));
    }}
    a22 = (T + 8);
    t92 = (*(T) + *(a22));
    t03 = (*(T) - *(a22));
    a32 = (T + 4);
    a42 = (T + 12);
    t13 = (*(a32) + *(a42));
    t23 = (*(a32) - *(a42));
    a52 = (T + 2);
    a62 = (T + 10);
    t33 = (*(a52) + *(a62));
    a72 = (T + 6);
    a82 = (T + 14);
    t43 = (*(a72) + *(a82));
    t53 = (t92 + t13);
    t63 = (t92 - t13);
    t73 = (t33 + t43);
    t83 = (t33 - t43);
    a92 = (0.70710678118654757*(*(a52) - *(a62)));
    a03 = (0.70710678118654757*(*(a72) - *(a82)));
    s9 = (a92 - a03);
    s01 = (a92 + a03);
    t93 = (t03 + s9);
    t04 = (t23 + s01);
    t14 = (t03 - s9);
    t24 = (s01 - t23);
    a13 = (T + 1);
    a23 = (T + 9);
    t34 = (*(a13) + *(a23));
    t44 = (*(a13) - *(a23));
    a33 = (T + 5);
    a43 = (T + 13);
    t54 = (*(a33) + *(a43));
    t64 = (*(a33) - *(a43));
    a53 = (T + 3);
    a63 = (T + 11);
    t74 = (*(a53) + *(a63));
    a73 = (T + 7);
    a83 = (T + 15);
    t84 = (*(a73) + *(a83));
    t94 = (t34 + t54);
    t05 = (t74 + t84);
    a93 = (0.70710678118654757*(*(a53) - *(a63)));
    a04 = (0.70710678118654757*(*(a73) - *(a83)));
    s11 = (a93 - a04);
    s21 = (a93 + a04);
    t15 = (t44 + s11);
    t25 = (t64 + s21);
    t35 = (t44 - s11);
    t45 = (s21 - t64);
    t55 = (t53 + t73);
    t65 = (t94 + t05);
    *(dst) = (t55 + t65);
    *((dst + 1)) = (t55 - t65);
    *((dst + 64)) = (t53 - t73);
    *((dst + 65)) = (t05 - t94);
    s31 = ((0.92387953251128674*t15) - (0.38268343236508978*t25));
    s41 = ((0.38268343236508978*t15) + (0.92387953251128674*t25));
    *((dst + 16)) = (t93 + s31);
    *((dst + 17)) = -((t04 + s41));
    *((dst + 112)) = (t93 - s31);
    *((dst + 113)) = (t04 - s41);
    a14 = (0.70710678118654757*(t34 - t54));
    a24 = (0.70710678118654757*(t74 - t84));
    s51 = (a14 - a24);
    s61 = (a14 + a24);
    *((dst + 32)) = (t63 + s51);
    *((dst + 33)) = -((t83 + s61));
    *((dst + 96)) = (t63 - s51);
    *((dst + 97)) = (t83 - s61);
    s71 = ((0.38268343236508978*t35) - (0.92387953251128674*t45));
    s81 = ((0.92387953251128674*t35) + (0.38268343236508978*t45));
    *((dst + 48)) = (t14 + s71);
    *((dst + 49)) = -((t24 + s81));
    *((dst + 80)) = (t14 - s71);
    *((dst + 81)) = (t24 - s81);
    {long i2; for(i2 = 0; i2 <= 6; i2++) {
        a34 = (16*i2);
        b = (T + a34);
        a44 = (b + 16);
        a54 = (b + 24);
        a64 = (b + 17);
        a74 = (b + 25);
        a84 = (b + 18);
        a94 = (b + 26);
        a05 = (b + 19);
        a15 = (b + 27);
        a25 = (b + 20);
        a35 = (b + 28);
        a45 = (b + 21);
        a55 = (b + 29);
        a65 = (b + 22);
        a75 = (b + 30);
        a85 = (b + 23);
        a95 = (b + 31);
        a06 = (D268 + a34);
        a16 = (a06 + 1);
        s91 = ((*(a06)**(a44)) - (*(a16)**(a54)));
        s02 = ((*(a16)**(a44)) + (*(a06)**(a54)));
        a26 = (a06 + 2);
        a36 = (a06 + 3);
        s12 = ((*(a26)**(a64)) - (*(a36)**(a74)));
        s22 = ((*(a36)**(a64)) + (*(a26)**(a74)));
        a46 = (a06 + 4);
        a56 = (a06 + 5);
        s32 = ((*(a46)**(a84)) - (*(a56)**(a94)));
        s42 = ((*(a56)**(a84)) + (*(a46)**(a94)));
        a66 = (a06 + 6);
        a76 = (a06 + 7);
        s52 = ((*(a66)**(a05)) - (*(a76)**(a15)));
        s62 = ((*(a76)**(a05)) + (*(a66)**(a15)));
        a86 = (a06 + 8);
        a96 = (a06 + 9);
        s72 = ((*(a86)**(a25)) - (*(a96)**(a35)));
        s82 = ((*(a96)**(a25)) + (*(a86)**(a35)));
        a07 = (a06 + 10);
        a17 = (a06 + 11);
        s92 = ((*(a07)**(a45)) - (*(a17)**(a55)));
        s03 = ((*(a17)**(a45)) + (*(a07)**(a55)));
        a27 = (a06 + 12);
        a37 = (a06 + 13);
        s13 = ((*(a27)**(a65)) - (*(a37)**(a75)));
        s23 = ((*(a37)**(a65)) + (*(a27)**(a75)));
        a47 = (a06 + 14);
        a57 = (a06 + 15);
        s33 = ((*(a47)**(a85)) - (*(a57)**(a95)));
        s43 = ((*(a57)**(a85)) + (*(a47)**(a95)));
        t75 = (s91 + s72);
        t85 = (s02 + s82);
        t95 = (s91 - s72);
        t06 = (s02 - s82);
        t16 = (s32 + s13);
        t26 = (s42 + s23);
        t36 = (s32 - s13);
        t46 = (s42 - s23);
        t56 = (t75 + t16);
        t66 = (t85 + t26);
        t76 = (t75 - t16);
        t86 = (t85 - t26);
        t96 = (t95 + t46);
        t07 = (t06 - t36);
        t17 = (t95 - t46);
        t27 = (t06 + t36);
        t37 = (s12 + s92);
        t47 = (s22 + s03);
        t57 = (s12 - s92);
        t67 = (s22 - s03);
        t77 = (s52 + s33);
        t87 = (s62 + s43);
        t97 = (s52 - s33);
        t08 = (s62 - s43);
        t18 = (t37 + t77);
        t28 = (t47 + t87);
        t38 = (t37 - t77);
        t48 = (t47 - t87);
        a67 = (0.70710678118654757*(t57 + t08));
        a77 = (0.70710678118654757*(t67 - t97));
        s53 = (a67 + a77);
        s63 = (a77 - a67);
        a87 = (0.70710678118654757*(t67 + t97));
        a97 = (0.70710678118654757*(t57 - t08));
        s73 = (a87 - a97);
        s83 = (a97 + a87);
        a08 = (2*i2);
        b2 = (dst + a08);
        *((b2 + 2)) = (t56 + t18);
        *((b2 + 3)) = (t66 + t28);
        b3 = (dst - a08);
        *((b3 + 126)) = (t56 - t18);
        *((b3 + 127)) = (t28 - t66);
        *((b2 + 34)) = (t96 + s53);
        *((b2 + 35)) = (t07 + s63);
        *((b3 + 94)) = (t96 - s53);
        *((b3 + 95)) = (s63 - t07);
        *((b2 + 66)) = (t76 + t48);
        *((b2 + 67)) = (t86 - t38);
        *((b3 + 62)) = (t76 - t48);
        *((b3 + 63)) = -((t86 + t38));
        *((b2 + 98)) = (t17 + s73);
        *((b2 + 99)) = (t27 - s83);
        *((b3 + 30)) = (t17 - s73);
        *((b3 + 31)) = -((t27 + s83));
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_256)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[256];
    double  *a07, *a08, *a09, *a0a, *a0b, *a0c, *a13, *a14, *a15, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a22, *a23, *a24, *a25, *a27, *a28, *a29
            , *a2a, *a2b, *a2c, *a32, *a33, *a34, *a35, *a37, *a38, *a39, *a3a, *a3b, *a3c, *a42, *a43, *a44, *a45, *a47, *a48, *a49, *a4a, *a4b
            , *a4c, *a52, *a53, *a54, *a55, *a57, *a58, *a59, *a5a, *a5b, *a5c, *a62, *a63, *a64, *a65, *a66, *a67, *a68, *a69, *a6a, *a6b, *a6c
            , *a71, *a72, *a73, *a74, *a75, *a76, *a77, *a78, *a79, *a7a, *a7b, *a7c, *a82, *a83, *a84, *a85, *a86, *a87, *a88, *a89, *a8a, *a8b
            , *a8c, *a96, *a97, *a98, *a99, *a9a, *a9b, *a9c, *b, *b2, *b3;
    const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a8, *a9;
    int a56, a8d;
    double a02, a03, a04, a05, a06, a0d, a12, a16, a1d, a26, a2d, a36, a3d, a46, a4d, a5d, a6d, a7d, a81, a91, a92, a93
            , a94, a95, s, s01, s02, s03, s04, s05, s06, s07, s08, s11, s12, s13, s14, s15, s16, s17, s18, s2, s21, s22
            , s23, s24, s25, s26, s27, s28, s3, s31, s32, s33, s34, s35, s36, s37, s38, s4, s41, s42, s43, s44, s45, s46
            , s47, s48, s5, s51, s52, s53, s54, s55, s56, s57, s6, s61, s62, s63, s64, s65, s66, s67, s7, s71, s72, s73
            , s74, s75, s76, s77, s8, s81, s82, s83, s84, s85, s86, s87, s9, s91, s92, s93, s94, s95, s96, s97, t, t01
            , t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t11, t12, t13
            , t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t3, t31, t32, t33, t34, t35
            , t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t4, t41, t42, t43, t44, t45, t46, t47
            , t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59
            , t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b
            , t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d
            , t7e, t7f, t7g, t7h, t7i, t7j, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f
            , t8g, t8h, t8i, t8j, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h
            , t9i, t9j;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + i);
        a2 = (a + 128);
        t = (*(a) + *(a2));
        t2 = (*(a) - *(a2));
        a3 = (a + 64);
        a4 = (a + 192);
        t3 = (*(a3) + *(a4));
        t4 = (*(a3) - *(a4));
        a5 = (a + 16);
        a6 = (a + 144);
        t5 = (*(a5) + *(a6));
        t6 = (*(a5) - *(a6));
        a7 = (a + 80);
        a8 = (a + 208);
        t7 = (*(a7) + *(a8));
        t8 = (*(a7) - *(a8));
        a9 = (a + 32);
        a01 = (a + 160);
        t9 = (*(a9) + *(a01));
        a11 = (a + 96);
        a21 = (a + 224);
        t01 = (*(a11) + *(a21));
        a31 = (a + 48);
        a41 = (a + 176);
        t11 = (*(a31) + *(a41));
        t21 = (*(a31) - *(a41));
        a51 = (a + 112);
        a61 = (a + 240);
        t31 = (*(a51) + *(a61));
        t41 = (*(a51) - *(a61));
        t51 = (t + t3);
        t61 = (t - t3);
        t71 = (t9 + t01);
        t81 = (t9 - t01);
        t91 = (t5 + t7);
        t02 = (t11 + t31);
        a71 = (T + i);
        *(a71) = (t51 + t71);
        *((a71 + 128)) = (t51 - t71);
        *((a71 + 16)) = (t91 + t02);
        *((a71 + 144)) = (t02 - t91);
        a81 = (0.70710678118654757*(t5 - t7));
        a91 = (0.70710678118654757*(t11 - t31));
        s = (a81 - a91);
        s2 = (a81 + a91);
        *((a71 + 64)) = (t61 + s);
        *((a71 + 80)) = -((t81 + s2));
        *((a71 + 192)) = (t61 - s);
        *((a71 + 208)) = (t81 - s2);
        s3 = ((0.92387953251128674*t6) - (0.38268343236508978*t8));
        s4 = ((0.38268343236508978*t6) + (0.92387953251128674*t8));
        a02 = (0.70710678118654757*(*(a9) - *(a01)));
        a12 = (0.70710678118654757*(*(a11) - *(a21)));
        s5 = (a02 - a12);
        s6 = (a02 + a12);
        s7 = ((0.38268343236508978*t21) - (0.92387953251128674*t41));
        s8 = ((0.92387953251128674*t21) + (0.38268343236508978*t41));
        t12 = (t2 + s5);
        t22 = (t4 + s6);
        t32 = (t2 - s5);
        t42 = (s6 - t4);
        t52 = (s3 + s7);
        t62 = (s4 + s8);
        t72 = (s3 - s7);
        t82 = (s8 - s4);
        *((a71 + 32)) = (t12 + t52);
        *((a71 + 48)) = -((t22 + t62));
        *((a71 + 224)) = (t12 - t52);
        *((a71 + 240)) = (t22 - t62);
        *((a71 + 160)) = (t32 + t82);
        *((a71 + 176)) = (t42 - t72);
        *((a71 + 96)) = (t32 - t82);
        *((a71 + 112)) = -((t42 + t72));
    }}
    a22 = (T + 16);
    t92 = (*(T) + *(a22));
    t03 = (*(T) - *(a22));
    a32 = (T + 8);
    a42 = (T + 24);
    t13 = (*(a32) + *(a42));
    t23 = (*(a32) - *(a42));
    a52 = (T + 4);
    a62 = (T + 20);
    t33 = (*(a52) + *(a62));
    a72 = (T + 12);
    a82 = (T + 28);
    t43 = (*(a72) + *(a82));
    t53 = (t92 + t13);
    t63 = (t92 - t13);
    t73 = (t33 + t43);
    t83 = (t33 - t43);
    a92 = (0.70710678118654757*(*(a52) - *(a62)));
    a03 = (0.70710678118654757*(*(a72) - *(a82)));
    s9 = (a92 - a03);
    s01 = (a92 + a03);
    t93 = (t03 + s9);
    t04 = (t23 + s01);
    t14 = (t03 - s9);
    t24 = (s01 - t23);
    a13 = (T + 1);
    a23 = (T + 17);
    t34 = (*(a13) + *(a23));
    t44 = (*(a13) - *(a23));
    a33 = (T + 9);
    a43 = (T + 25);
    t54 = (*(a33) + *(a43));
    t64 = (*(a33) - *(a43));
    a53 = (T + 5);
    a63 = (T + 21);
    t74 = (*(a53) + *(a63));
    a73 = (T + 13);
    a83 = (T + 29);
    t84 = (*(a73) + *(a83));
    t94 = (t34 + t54);
    t05 = (t34 - t54);
    t15 = (t74 + t84);
    t25 = (t74 - t84);
    a93 = (0.70710678118654757*(*(a53) - *(a63)));
    a04 = (0.70710678118654757*(*(a73) - *(a83)));
    s11 = (a93 - a04);
    s21 = (a93 + a04);
    t35 = (t44 + s11);
    t45 = (t64 + s21);
    t55 = (t44 - s11);
    t65 = (s21 - t64);
    a14 = (T + 2);
    a24 = (T + 18);
    t75 = (*(a14) + *(a24));
    t85 = (*(a14) - *(a24));
    a34 = (T + 10);
    a44 = (T + 26);
    t95 = (*(a34) + *(a44));
    t06 = (*(a34) - *(a44));
    a54 = (T + 6);
    a64 = (T + 22);
    t16 = (*(a54) + *(a64));
    a74 = (T + 14);
    a84 = (T + 30);
    t26 = (*(a74) + *(a84));
    t36 = (t75 + t95);
    t46 = (t16 + t26);
    a94 = (0.70710678118654757*(*(a54) - *(a64)));
    a05 = (0.70710678118654757*(*(a74) - *(a84)));
    s31 = (a94 - a05);
    s41 = (a94 + a05);
    t56 = (t85 + s31);
    t66 = (t06 + s41);
    t76 = (t85 - s31);
    t86 = (s41 - t06);
    a15 = (T + 3);
    a25 = (T + 19);
    t96 = (*(a15) + *(a25));
    t07 = (*(a15) - *(a25));
    a35 = (T + 11);
    a45 = (T + 27);
    t17 = (*(a35) + *(a45));
    t27 = (*(a35) - *(a45));
    a55 = (T + 7);
    a65 = (T + 23);
    t37 = (*(a55) + *(a65));
    a75 = (T + 15);
    a85 = (T + 31);
    t47 = (*(a75) + *(a85));
    t57 = (t96 + t17);
    t67 = (t96 - t17);
    t77 = (t37 + t47);
    t87 = (t37 - t47);
    a95 = (0.70710678118654757*(*(a55) - *(a65)));
    a06 = (0.70710678118654757*(*(a75) - *(a85)));
    s51 = (a95 - a06);
    s61 = (a95 + a06);
    t97 = (t07 + s51);
    t08 = (t27 + s61);
    t18 = (t07 - s51);
    t28 = (s61 - t27);
    t38 = (t53 + t73);
    t48 = (t53 - t73);
    t58 = (t36 + t46);
    t68 = (t36 - t46);
    t78 = (t94 + t15);
    t88 = (t57 + t77);
    t98 = (t38 + t58);
    t09 = (t78 + t88);
    *(dst) = (t98 + t09);
    *((dst + 1)) = (t98 - t09);
    *((dst + 128)) = (t38 - t58);
    *((dst + 129)) = (t88 - t78);
    a16 = (0.70710678118654757*(t94 - t15));
    a26 = (0.70710678118654757*(t57 - t77));
    s71 = (a16 - a26);
    s81 = (a16 + a26);
    *((dst + 64)) = (t48 + s71);
    *((dst + 65)) = -((t68 + s81));
    *((dst + 192)) = (t48 - s71);
    *((dst + 193)) = (t68 - s81);
    s91 = ((0.98078528040323043*t35) - (0.19509032201612828*t45));
    s02 = ((0.19509032201612828*t35) + (0.98078528040323043*t45));
    s12 = ((0.92387953251128674*t56) - (0.38268343236508978*t66));
    s22 = ((0.38268343236508978*t56) + (0.92387953251128674*t66));
    s32 = ((0.83146961230254524*t97) - (0.55557023301960218*t08));
    s42 = ((0.55557023301960218*t97) + (0.83146961230254524*t08));
    t19 = (t93 + s12);
    t29 = (t04 + s22);
    t39 = (t93 - s12);
    t49 = (s22 - t04);
    t59 = (s91 + s32);
    t69 = (s02 + s42);
    t79 = (s91 - s32);
    t89 = (s42 - s02);
    *((dst + 16)) = (t19 + t59);
    *((dst + 17)) = -((t29 + t69));
    *((dst + 240)) = (t19 - t59);
    *((dst + 241)) = (t29 - t69);
    *((dst + 144)) = (t39 + t89);
    *((dst + 145)) = (t49 - t79);
    *((dst + 112)) = (t39 - t89);
    *((dst + 113)) = -((t49 + t79));
    s52 = ((0.92387953251128674*t05) - (0.38268343236508978*t25));
    s62 = ((0.38268343236508978*t05) + (0.92387953251128674*t25));
    a36 = (0.70710678118654757*(t75 - t95));
    a46 = (0.70710678118654757*(t16 - t26));
    s72 = (a36 - a46);
    s82 = (a36 + a46);
    s92 = ((0.38268343236508978*t67) - (0.92387953251128674*t87));
    s03 = ((0.92387953251128674*t67) + (0.38268343236508978*t87));
    t99 = (t63 + s72);
    t0a = (t83 + s82);
    t1a = (t63 - s72);
    t2a = (s82 - t83);
    t3a = (s52 + s92);
    t4a = (s62 + s03);
    t5a = (s52 - s92);
    t6a = (s03 - s62);
    *((dst + 32)) = (t99 + t3a);
    *((dst + 33)) = -((t0a + t4a));
    *((dst + 224)) = (t99 - t3a);
    *((dst + 225)) = (t0a - t4a);
    *((dst + 160)) = (t1a + t6a);
    *((dst + 161)) = (t2a - t5a);
    *((dst + 96)) = (t1a - t6a);
    *((dst + 97)) = -((t2a + t5a));
    s13 = ((0.83146961230254524*t55) - (0.55557023301960218*t65));
    s23 = ((0.55557023301960218*t55) + (0.83146961230254524*t65));
    s33 = ((0.38268343236508978*t76) - (0.92387953251128674*t86));
    s43 = ((0.92387953251128674*t76) + (0.38268343236508978*t86));
    s53 = ((0.19509032201612828*t18) + (0.98078528040323043*t28));
    s63 = ((0.19509032201612828*t28) - (0.98078528040323043*t18));
    t7a = (t14 + s33);
    t8a = (t24 + s43);
    t9a = (t14 - s33);
    t0b = (s43 - t24);
    t1b = (s13 - s53);
    t2b = (s63 - s23);
    t3b = (s13 + s53);
    t4b = (s23 + s63);
    *((dst + 48)) = (t7a + t1b);
    *((dst + 49)) = (t2b - t8a);
    *((dst + 208)) = (t7a - t1b);
    *((dst + 209)) = (t8a + t2b);
    *((dst + 176)) = (t9a - t4b);
    *((dst + 177)) = (t0b - t3b);
    *((dst + 80)) = (t9a + t4b);
    *((dst + 81)) = -((t0b + t3b));
    {long i2; for(i2 = 0; i2 <= 6; i2++) {
        a56 = (32*i2);
        b = (T + a56);
        a66 = (b + 32);
        a76 = (b + 48);
        a86 = (b + 33);
        a96 = (b + 49);
        a07 = (b + 34);
        a17 = (b + 50);
        a27 = (b + 35);
        a37 = (b + 51);
        a47 = (b + 36);
        a57 = (b + 52);
        a67 = (b + 37);
        a77 = (b + 53);
        a87 = (b + 38);
        a97 = (b + 54);
        a08 = (b + 39);
        a18 = (b + 55);
        a28 = (b + 40);
        a38 = (b + 56);
        a48 = (b + 41);
        a58 = (b + 57);
        a68 = (b + 42);
        a78 = (b + 58);
        a88 = (b + 43);
        a98 = (b + 59);
        a09 = (b + 44);
        a19 = (b + 60);
        a29 = (b + 45);
        a39 = (b + 61);
        a49 = (b + 46);
        a59 = (b + 62);
        a69 = (b + 47);
        a79 = (b + 63);
        a89 = (D269 + a56);
        a99 = (a89 + 1);
        s73 = ((*(a89)**(a66)) - (*(a99)**(a76)));
        s83 = ((*(a99)**(a66)) + (*(a89)**(a76)));
        a0a = (a89 + 2);
        a1a = (a89 + 3);
        s93 = ((*(a0a)**(a86)) - (*(a1a)**(a96)));
        s04 = ((*(a1a)**(a86)) + (*(a0a)**(a96)));
        a2a = (a89 + 4);
        a3a = (a89 + 5);
        s14 = ((*(a2a)**(a07)) - (*(a3a)**(a17)));
        s24 = ((*(a3a)**(a07)) + (*(a2a)**(a17)));
        a4a = (a89 + 6);
        a5a = (a89 + 7);
        s34 = ((*(a4a)**(a27)) - (*(a5a)**(a37)));
        s44 = ((*(a5a)**(a27)) + (*(a4a)**(a37)));
        a6a = (a89 + 8);
        a7a = (a89 + 9);
        s54 = ((*(a6a)**(a47)) - (*(a7a)**(a57)));
        s64 = ((*(a7a)**(a47)) + (*(a6a)**(a57)));
        a8a = (a89 + 10);
        a9a = (a89 + 11);
        s74 = ((*(a8a)**(a67)) - (*(a9a)**(a77)));
        s84 = ((*(a9a)**(a67)) + (*(a8a)**(a77)));
        a0b = (a89 + 12);
        a1b = (a89 + 13);
        s94 = ((*(a0b)**(a87)) - (*(a1b)**(a97)));
        s05 = ((*(a1b)**(a87)) + (*(a0b)**(a97)));
        a2b = (a89 + 14);
        a3b = (a89 + 15);
        s15 = ((*(a2b)**(a08)) - (*(a3b)**(a18)));
        s25 = ((*(a3b)**(a08)) + (*(a2b)**(a18)));
        a4b = (a89 + 16);
        a5b = (a89 + 17);
        s35 = ((*(a4b)**(a28)) - (*(a5b)**(a38)));
        s45 = ((*(a5b)**(a28)) + (*(a4b)**(a38)));
        a6b = (a89 + 18);
        a7b = (a89 + 19);
        s55 = ((*(a6b)**(a48)) - (*(a7b)**(a58)));
        s65 = ((*(a7b)**(a48)) + (*(a6b)**(a58)));
        a8b = (a89 + 20);
        a9b = (a89 + 21);
        s75 = ((*(a8b)**(a68)) - (*(a9b)**(a78)));
        s85 = ((*(a9b)**(a68)) + (*(a8b)**(a78)));
        a0c = (a89 + 22);
        a1c = (a89 + 23);
        s95 = ((*(a0c)**(a88)) - (*(a1c)**(a98)));
        s06 = ((*(a1c)**(a88)) + (*(a0c)**(a98)));
        a2c = (a89 + 24);
        a3c = (a89 + 25);
        s16 = ((*(a2c)**(a09)) - (*(a3c)**(a19)));
        s26 = ((*(a3c)**(a09)) + (*(a2c)**(a19)));
        a4c = (a89 + 26);
        a5c = (a89 + 27);
        s36 = ((*(a4c)**(a29)) - (*(a5c)**(a39)));
        s46 = ((*(a5c)**(a29)) + (*(a4c)**(a39)));
        a6c = (a89 + 28);
        a7c = (a89 + 29);
        s56 = ((*(a6c)**(a49)) - (*(a7c)**(a59)));
        s66 = ((*(a7c)**(a49)) + (*(a6c)**(a59)));
        a8c = (a89 + 30);
        a9c = (a89 + 31);
        s76 = ((*(a8c)**(a69)) - (*(a9c)**(a79)));
        s86 = ((*(a9c)**(a69)) + (*(a8c)**(a79)));
        t5b = (s73 + s35);
        t6b = (s83 + s45);
        t7b = (s73 - s35);
        t8b = (s83 - s45);
        t9b = (s54 + s16);
        t0c = (s64 + s26);
        t1c = (s54 - s16);
        t2c = (s64 - s26);
        t3c = (t5b + t9b);
        t4c = (t6b + t0c);
        t5c = (t5b - t9b);
        t6c = (t6b - t0c);
        t7c = (t7b + t2c);
        t8c = (t8b - t1c);
        t9c = (t7b - t2c);
        t0d = (t8b + t1c);
        t1d = (s93 + s55);
        t2d = (s04 + s65);
        t3d = (s93 - s55);
        t4d = (s04 - s65);
        t5d = (s74 + s36);
        t6d = (s84 + s46);
        t7d = (s74 - s36);
        t8d = (s84 - s46);
        t9d = (t1d + t5d);
        t0e = (t2d + t6d);
        a0d = (0.70710678118654757*(t1d - t5d));
        a1d = (0.70710678118654757*(t2d - t6d));
        s96 = (a0d + a1d);
        s07 = (a1d - a0d);
        t1e = (t3d + t8d);
        t2e = (t4d - t7d);
        t3e = (t3d - t8d);
        t4e = (t4d + t7d);
        s17 = ((0.92387953251128674*t1e) + (0.38268343236508978*t2e));
        s27 = ((0.92387953251128674*t2e) - (0.38268343236508978*t1e));
        s37 = ((0.38268343236508978*t3e) + (0.92387953251128674*t4e));
        s47 = ((0.38268343236508978*t4e) - (0.92387953251128674*t3e));
        t5e = (s14 + s75);
        t6e = (s24 + s85);
        t7e = (s14 - s75);
        t8e = (s24 - s85);
        t9e = (s94 + s56);
        t0f = (s05 + s66);
        t1f = (s94 - s56);
        t2f = (s05 - s66);
        t3f = (t5e + t9e);
        t4f = (t6e + t0f);
        t5f = (t5e - t9e);
        t6f = (t6e - t0f);
        a2d = (0.70710678118654757*(t7e + t2f));
        a3d = (0.70710678118654757*(t8e - t1f));
        s57 = (a2d + a3d);
        s67 = (a3d - a2d);
        a4d = (0.70710678118654757*(t8e + t1f));
        a5d = (0.70710678118654757*(t7e - t2f));
        s77 = (a4d - a5d);
        s87 = (a5d + a4d);
        t7f = (s34 + s95);
        t8f = (s44 + s06);
        t9f = (s34 - s95);
        t0g = (s44 - s06);
        t1g = (s15 + s76);
        t2g = (s25 + s86);
        t3g = (s15 - s76);
        t4g = (s25 - s86);
        t5g = (t7f + t1g);
        t6g = (t8f + t2g);
        a6d = (0.70710678118654757*(t8f - t2g));
        a7d = (0.70710678118654757*(t7f - t1g));
        s97 = (a6d - a7d);
        s08 = (a7d + a6d);
        t7g = (t9f + t4g);
        t8g = (t0g - t3g);
        t9g = (t9f - t4g);
        t0h = (t0g + t3g);
        s18 = ((0.38268343236508978*t7g) + (0.92387953251128674*t8g));
        s28 = ((0.38268343236508978*t8g) - (0.92387953251128674*t7g));
        s38 = ((0.92387953251128674*t9g) + (0.38268343236508978*t0h));
        s48 = ((0.38268343236508978*t9g) - (0.92387953251128674*t0h));
        t1h = (t3c + t3f);
        t2h = (t4c + t4f);
        t3h = (t3c - t3f);
        t4h = (t4c - t4f);
        t5h = (t9d + t5g);
        t6h = (t0e + t6g);
        t7h = (t9d - t5g);
        t8h = (t0e - t6g);
        a8d = (2*i2);
        b2 = (dst + a8d);
        *((b2 + 2)) = (t1h + t5h);
        *((b2 + 3)) = (t2h + t6h);
        b3 = (dst - a8d);
        *((b3 + 254)) = (t1h - t5h);
        *((b3 + 255)) = (t6h - t2h);
        *((b2 + 130)) = (t3h + t8h);
        *((b2 + 131)) = (t4h - t7h);
        *((b3 + 126)) = (t3h - t8h);
        *((b3 + 127)) = -((t4h + t7h));
        t9h = (t7c + s57);
        t0i = (t8c + s67);
        t1i = (t7c - s57);
        t2i = (t8c - s67);
        t3i = (s17 + s18);
        t4i = (s27 + s28);
        t5i = (s17 - s18);
        t6i = (s27 - s28);
        *((b2 + 34)) = (t9h + t3i);
        *((b2 + 35)) = (t0i + t4i);
        *((b3 + 222)) = (t9h - t3i);
        *((b3 + 223)) = (t4i - t0i);
        *((b2 + 162)) = (t1i + t6i);
        *((b2 + 163)) = (t2i - t5i);
        *((b3 + 94)) = (t1i - t6i);
        *((b3 + 95)) = -((t2i + t5i));
        t7i = (t5c + t6f);
        t8i = (t6c - t5f);
        t9i = (t5c - t6f);
        t0j = (t6c + t5f);
        t1j = (s96 + s97);
        t2j = (s07 - s08);
        t3j = (s96 - s97);
        t4j = (s07 + s08);
        *((b2 + 66)) = (t7i + t1j);
        *((b2 + 67)) = (t8i + t2j);
        *((b3 + 190)) = (t7i - t1j);
        *((b3 + 191)) = (t2j - t8i);
        *((b2 + 194)) = (t9i + t4j);
        *((b2 + 195)) = (t0j - t3j);
        *((b3 + 62)) = (t9i - t4j);
        *((b3 + 63)) = -((t0j + t3j));
        t5j = (t9c + s77);
        t6j = (t0d - s87);
        t7j = (t9c - s77);
        t8j = (t0d + s87);
        t9j = (s37 - s38);
        t0k = (s47 + s48);
        t1k = (s37 + s38);
        t2k = (s47 - s48);
        *((b2 + 98)) = (t5j + t9j);
        *((b2 + 99)) = (t6j + t0k);
        *((b3 + 158)) = (t5j - t9j);
        *((b3 + 159)) = (t0k - t6j);
        *((b2 + 226)) = (t7j + t2k);
        *((b2 + 227)) = (t8j - t1k);
        *((b3 + 30)) = (t7j - t2k);
        *((b3 + 31)) = -((t8j + t1k));
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_512)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[512];
    double  *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a14, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b, *a1c, *a1d, *a1e
            , *a1f, *a25, *a26, *a27, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a49, *a4a, *a4b
            , *a4c, *a4d, *a4e, *a55, *a56, *a57, *a59, *a5a, *a5b, *a5c, *a5d, *a5e, *a64, *a65, *a66, *a67, *a69, *a6a, *a6b, *a6c, *a6d, *a6e
            , *a74, *a75, *a76, *a77, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a84, *a85, *a86, *a87, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a94, *a95
            , *a96, *a97, *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *b, *b2, *b3;
    const double  *a, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53, *a6, *a61
            , *a62, *a63, *a7, *a71, *a72, *a73, *a8, *a81, *a82, *a83;
    int a2g, a98;
    double a01, a02, a03, a04, a0g, a1g, a24, a34, a35, a36, a37, a38, a44, a45, a46, a47, a48, a4f, a54, a58, a5f, a68
            , a6f, a78, a7f, a88, a8f, a9, a91, a92, a93, a9f, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s11
            , s12, s13, s14, s15, s16, s17, s18, s19, s1a, s2, s21, s22, s23, s24, s25, s26, s27, s28, s29, s2a, s3, s31
            , s32, s33, s34, s35, s36, s37, s38, s39, s3a, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a, s5, s51
            , s52, s53, s54, s55, s56, s57, s58, s59, s6, s61, s62, s63, s64, s65, s66, s67, s68, s69, s7, s71, s72, s73
            , s74, s75, s76, s77, s78, s79, s8, s81, s82, s83, s84, s85, s86, s87, s88, s89, s9, s91, s92, s93, s94, s95
            , s96, s97, s98, s99, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e
            , t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a
            , t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t3, t31, t32, t33, t34, t35, t36
            , t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t4, t41, t42
            , t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o
            , t4p, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k
            , t5l, t5m, t5n, t5o, t5p, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g
            , t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c
            , t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t8, t81, t82, t83, t84, t85, t86, t87, t88
            , t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t9, t91, t92, t93, t94
            , t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + i);
        a2 = (a + 256);
        t = (*(a) + *(a2));
        t2 = (*(a) - *(a2));
        a3 = (a + 128);
        a4 = (a + 384);
        t3 = (*(a3) + *(a4));
        t4 = (*(a3) - *(a4));
        a5 = (a + 64);
        a6 = (a + 320);
        t5 = (*(a5) + *(a6));
        a7 = (a + 192);
        a8 = (a + 448);
        t6 = (*(a7) + *(a8));
        t7 = (t + t3);
        t8 = (t - t3);
        t9 = (t5 + t6);
        t01 = (t5 - t6);
        a9 = (0.70710678118654757*(*(a5) - *(a6)));
        a01 = (0.70710678118654757*(*(a7) - *(a8)));
        s = (a9 - a01);
        s2 = (a9 + a01);
        t11 = (t2 + s);
        t21 = (t4 + s2);
        t31 = (t2 - s);
        t41 = (s2 - t4);
        a11 = (a + 16);
        a21 = (a + 272);
        t51 = (*(a11) + *(a21));
        t61 = (*(a11) - *(a21));
        a31 = (a + 144);
        a41 = (a + 400);
        t71 = (*(a31) + *(a41));
        t81 = (*(a31) - *(a41));
        a51 = (a + 80);
        a61 = (a + 336);
        t91 = (*(a51) + *(a61));
        a71 = (a + 208);
        a81 = (a + 464);
        t02 = (*(a71) + *(a81));
        t12 = (t51 + t71);
        t22 = (t51 - t71);
        t32 = (t91 + t02);
        t42 = (t91 - t02);
        a91 = (0.70710678118654757*(*(a51) - *(a61)));
        a02 = (0.70710678118654757*(*(a71) - *(a81)));
        s3 = (a91 - a02);
        s4 = (a91 + a02);
        t52 = (t61 + s3);
        t62 = (t81 + s4);
        t72 = (t61 - s3);
        t82 = (s4 - t81);
        a12 = (a + 32);
        a22 = (a + 288);
        t92 = (*(a12) + *(a22));
        t03 = (*(a12) - *(a22));
        a32 = (a + 160);
        a42 = (a + 416);
        t13 = (*(a32) + *(a42));
        t23 = (*(a32) - *(a42));
        a52 = (a + 96);
        a62 = (a + 352);
        t33 = (*(a52) + *(a62));
        a72 = (a + 224);
        a82 = (a + 480);
        t43 = (*(a72) + *(a82));
        t53 = (t92 + t13);
        t63 = (t33 + t43);
        a92 = (0.70710678118654757*(*(a52) - *(a62)));
        a03 = (0.70710678118654757*(*(a72) - *(a82)));
        s5 = (a92 - a03);
        s6 = (a92 + a03);
        t73 = (t03 + s5);
        t83 = (t23 + s6);
        t93 = (t03 - s5);
        t04 = (s6 - t23);
        a13 = (a + 48);
        a23 = (a + 304);
        t14 = (*(a13) + *(a23));
        t24 = (*(a13) - *(a23));
        a33 = (a + 176);
        a43 = (a + 432);
        t34 = (*(a33) + *(a43));
        t44 = (*(a33) - *(a43));
        a53 = (a + 112);
        a63 = (a + 368);
        t54 = (*(a53) + *(a63));
        a73 = (a + 240);
        a83 = (a + 496);
        t64 = (*(a73) + *(a83));
        t74 = (t14 + t34);
        t84 = (t14 - t34);
        t94 = (t54 + t64);
        t05 = (t54 - t64);
        a93 = (0.70710678118654757*(*(a53) - *(a63)));
        a04 = (0.70710678118654757*(*(a73) - *(a83)));
        s7 = (a93 - a04);
        s8 = (a93 + a04);
        t15 = (t24 + s7);
        t25 = (t44 + s8);
        t35 = (t24 - s7);
        t45 = (s8 - t44);
        t55 = (t7 + t9);
        t65 = (t7 - t9);
        t75 = (t53 + t63);
        t85 = (t53 - t63);
        t95 = (t12 + t32);
        t06 = (t74 + t94);
        a14 = (T + i);
        *(a14) = (t55 + t75);
        *((a14 + 256)) = (t55 - t75);
        *((a14 + 16)) = (t95 + t06);
        *((a14 + 272)) = (t06 - t95);
        a24 = (0.70710678118654757*(t12 - t32));
        a34 = (0.70710678118654757*(t74 - t94));
        s9 = (a24 - a34);
        s01 = (a24 + a34);
        *((a14 + 128)) = (t65 + s9);
        *((a14 + 144)) = -((t85 + s01));
        *((a14 + 384)) = (t65 - s9);
        *((a14 + 400)) = (t85 - s01);
        s11 = ((0.98078528040323043*t52) - (0.19509032201612828*t62));
        s21 = ((0.19509032201612828*t52) + (0.98078528040323043*t62));
        s31 = ((0.92387953251128674*t73) - (0.38268343236508978*t83));
        s41 = ((0.38268343236508978*t73) + (0.92387953251128674*t83));
        s51 = ((0.83146961230254524*t15) - (0.55557023301960218*t25));
        s61 = ((0.55557023301960218*t15) + (0.83146961230254524*t25));
        t16 = (t11 + s31);
        t26 = (t21 + s41);
        t36 = (t11 - s31);
        t46 = (s41 - t21);
        t56 = (s11 + s51);
        t66 = (s21 + s61);
        t76 = (s11 - s51);
        t86 = (s61 - s21);
        *((a14 + 32)) = (t16 + t56);
        *((a14 + 48)) = -((t26 + t66));
        *((a14 + 480)) = (t16 - t56);
        *((a14 + 496)) = (t26 - t66);
        *((a14 + 288)) = (t36 + t86);
        *((a14 + 304)) = (t46 - t76);
        *((a14 + 224)) = (t36 - t86);
        *((a14 + 240)) = -((t46 + t76));
        s71 = ((0.92387953251128674*t22) - (0.38268343236508978*t42));
        s81 = ((0.38268343236508978*t22) + (0.92387953251128674*t42));
        a44 = (0.70710678118654757*(t92 - t13));
        a54 = (0.70710678118654757*(t33 - t43));
        s91 = (a44 - a54);
        s02 = (a44 + a54);
        s12 = ((0.38268343236508978*t84) - (0.92387953251128674*t05));
        s22 = ((0.92387953251128674*t84) + (0.38268343236508978*t05));
        t96 = (t8 + s91);
        t07 = (t01 + s02);
        t17 = (t8 - s91);
        t27 = (s02 - t01);
        t37 = (s71 + s12);
        t47 = (s81 + s22);
        t57 = (s71 - s12);
        t67 = (s22 - s81);
        *((a14 + 64)) = (t96 + t37);
        *((a14 + 80)) = -((t07 + t47));
        *((a14 + 448)) = (t96 - t37);
        *((a14 + 464)) = (t07 - t47);
        *((a14 + 320)) = (t17 + t67);
        *((a14 + 336)) = (t27 - t57);
        *((a14 + 192)) = (t17 - t67);
        *((a14 + 208)) = -((t27 + t57));
        s32 = ((0.83146961230254524*t72) - (0.55557023301960218*t82));
        s42 = ((0.55557023301960218*t72) + (0.83146961230254524*t82));
        s52 = ((0.38268343236508978*t93) - (0.92387953251128674*t04));
        s62 = ((0.92387953251128674*t93) + (0.38268343236508978*t04));
        s72 = ((0.19509032201612828*t35) + (0.98078528040323043*t45));
        s82 = ((0.19509032201612828*t45) - (0.98078528040323043*t35));
        t77 = (t31 + s52);
        t87 = (t41 + s62);
        t97 = (t31 - s52);
        t08 = (s62 - t41);
        t18 = (s32 - s72);
        t28 = (s82 - s42);
        t38 = (s32 + s72);
        t48 = (s42 + s82);
        *((a14 + 96)) = (t77 + t18);
        *((a14 + 112)) = (t28 - t87);
        *((a14 + 416)) = (t77 - t18);
        *((a14 + 432)) = (t87 + t28);
        *((a14 + 352)) = (t97 - t48);
        *((a14 + 368)) = (t08 - t38);
        *((a14 + 160)) = (t97 + t48);
        *((a14 + 176)) = -((t08 + t38));
    }}
    a64 = (T + 16);
    t58 = (*(T) + *(a64));
    t68 = (*(T) - *(a64));
    a74 = (T + 8);
    a84 = (T + 24);
    t78 = (*(a74) + *(a84));
    t88 = (*(a74) - *(a84));
    a94 = (T + 4);
    a05 = (T + 20);
    t98 = (*(a94) + *(a05));
    a15 = (T + 12);
    a25 = (T + 28);
    t09 = (*(a15) + *(a25));
    t19 = (t58 + t78);
    t29 = (t58 - t78);
    t39 = (t98 + t09);
    t49 = (t98 - t09);
    a35 = (0.70710678118654757*(*(a94) - *(a05)));
    a45 = (0.70710678118654757*(*(a15) - *(a25)));
    s92 = (a35 - a45);
    s03 = (a35 + a45);
    t59 = (t68 + s92);
    t69 = (t88 + s03);
    t79 = (t68 - s92);
    t89 = (s03 - t88);
    a55 = (T + 1);
    a65 = (T + 17);
    t99 = (*(a55) + *(a65));
    t0a = (*(a55) - *(a65));
    a75 = (T + 9);
    a85 = (T + 25);
    t1a = (*(a75) + *(a85));
    t2a = (*(a75) - *(a85));
    a95 = (T + 5);
    a06 = (T + 21);
    t3a = (*(a95) + *(a06));
    a16 = (T + 13);
    a26 = (T + 29);
    t4a = (*(a16) + *(a26));
    t5a = (t99 + t1a);
    t6a = (t99 - t1a);
    t7a = (t3a + t4a);
    t8a = (t3a - t4a);
    a36 = (0.70710678118654757*(*(a95) - *(a06)));
    a46 = (0.70710678118654757*(*(a16) - *(a26)));
    s13 = (a36 - a46);
    s23 = (a36 + a46);
    t9a = (t0a + s13);
    t0b = (t2a + s23);
    t1b = (t0a - s13);
    t2b = (s23 - t2a);
    a56 = (T + 2);
    a66 = (T + 18);
    t3b = (*(a56) + *(a66));
    t4b = (*(a56) - *(a66));
    a76 = (T + 10);
    a86 = (T + 26);
    t5b = (*(a76) + *(a86));
    t6b = (*(a76) - *(a86));
    a96 = (T + 6);
    a07 = (T + 22);
    t7b = (*(a96) + *(a07));
    a17 = (T + 14);
    a27 = (T + 30);
    t8b = (*(a17) + *(a27));
    t9b = (t3b + t5b);
    t0c = (t7b + t8b);
    a37 = (0.70710678118654757*(*(a96) - *(a07)));
    a47 = (0.70710678118654757*(*(a17) - *(a27)));
    s33 = (a37 - a47);
    s43 = (a37 + a47);
    t1c = (t4b + s33);
    t2c = (t6b + s43);
    t3c = (t4b - s33);
    t4c = (s43 - t6b);
    a57 = (T + 3);
    a67 = (T + 19);
    t5c = (*(a57) + *(a67));
    t6c = (*(a57) - *(a67));
    a77 = (T + 11);
    a87 = (T + 27);
    t7c = (*(a77) + *(a87));
    t8c = (*(a77) - *(a87));
    a97 = (T + 7);
    a08 = (T + 23);
    t9c = (*(a97) + *(a08));
    a18 = (T + 15);
    a28 = (T + 31);
    t0d = (*(a18) + *(a28));
    t1d = (t5c + t7c);
    t2d = (t5c - t7c);
    t3d = (t9c + t0d);
    t4d = (t9c - t0d);
    a38 = (0.70710678118654757*(*(a97) - *(a08)));
    a48 = (0.70710678118654757*(*(a18) - *(a28)));
    s53 = (a38 - a48);
    s63 = (a38 + a48);
    t5d = (t6c + s53);
    t6d = (t8c + s63);
    t7d = (t6c - s53);
    t8d = (s63 - t8c);
    t9d = (t19 + t39);
    t0e = (t19 - t39);
    t1e = (t9b + t0c);
    t2e = (t9b - t0c);
    t3e = (t5a + t7a);
    t4e = (t1d + t3d);
    t5e = (t9d + t1e);
    t6e = (t3e + t4e);
    *(dst) = (t5e + t6e);
    *((dst + 1)) = (t5e - t6e);
    *((dst + 256)) = (t9d - t1e);
    *((dst + 257)) = (t4e - t3e);
    a58 = (0.70710678118654757*(t5a - t7a));
    a68 = (0.70710678118654757*(t1d - t3d));
    s73 = (a58 - a68);
    s83 = (a58 + a68);
    *((dst + 128)) = (t0e + s73);
    *((dst + 129)) = -((t2e + s83));
    *((dst + 384)) = (t0e - s73);
    *((dst + 385)) = (t2e - s83);
    s93 = ((0.98078528040323043*t9a) - (0.19509032201612828*t0b));
    s04 = ((0.19509032201612828*t9a) + (0.98078528040323043*t0b));
    s14 = ((0.92387953251128674*t1c) - (0.38268343236508978*t2c));
    s24 = ((0.38268343236508978*t1c) + (0.92387953251128674*t2c));
    s34 = ((0.83146961230254524*t5d) - (0.55557023301960218*t6d));
    s44 = ((0.55557023301960218*t5d) + (0.83146961230254524*t6d));
    t7e = (t59 + s14);
    t8e = (t69 + s24);
    t9e = (t59 - s14);
    t0f = (s24 - t69);
    t1f = (s93 + s34);
    t2f = (s04 + s44);
    t3f = (s93 - s34);
    t4f = (s44 - s04);
    *((dst + 32)) = (t7e + t1f);
    *((dst + 33)) = -((t8e + t2f));
    *((dst + 480)) = (t7e - t1f);
    *((dst + 481)) = (t8e - t2f);
    *((dst + 288)) = (t9e + t4f);
    *((dst + 289)) = (t0f - t3f);
    *((dst + 224)) = (t9e - t4f);
    *((dst + 225)) = -((t0f + t3f));
    s54 = ((0.92387953251128674*t6a) - (0.38268343236508978*t8a));
    s64 = ((0.38268343236508978*t6a) + (0.92387953251128674*t8a));
    a78 = (0.70710678118654757*(t3b - t5b));
    a88 = (0.70710678118654757*(t7b - t8b));
    s74 = (a78 - a88);
    s84 = (a78 + a88);
    s94 = ((0.38268343236508978*t2d) - (0.92387953251128674*t4d));
    s05 = ((0.92387953251128674*t2d) + (0.38268343236508978*t4d));
    t5f = (t29 + s74);
    t6f = (t49 + s84);
    t7f = (t29 - s74);
    t8f = (s84 - t49);
    t9f = (s54 + s94);
    t0g = (s64 + s05);
    t1g = (s54 - s94);
    t2g = (s05 - s64);
    *((dst + 64)) = (t5f + t9f);
    *((dst + 65)) = -((t6f + t0g));
    *((dst + 448)) = (t5f - t9f);
    *((dst + 449)) = (t6f - t0g);
    *((dst + 320)) = (t7f + t2g);
    *((dst + 321)) = (t8f - t1g);
    *((dst + 192)) = (t7f - t2g);
    *((dst + 193)) = -((t8f + t1g));
    s15 = ((0.83146961230254524*t1b) - (0.55557023301960218*t2b));
    s25 = ((0.55557023301960218*t1b) + (0.83146961230254524*t2b));
    s35 = ((0.38268343236508978*t3c) - (0.92387953251128674*t4c));
    s45 = ((0.92387953251128674*t3c) + (0.38268343236508978*t4c));
    s55 = ((0.19509032201612828*t7d) + (0.98078528040323043*t8d));
    s65 = ((0.19509032201612828*t8d) - (0.98078528040323043*t7d));
    t3g = (t79 + s35);
    t4g = (t89 + s45);
    t5g = (t79 - s35);
    t6g = (s45 - t89);
    t7g = (s15 - s55);
    t8g = (s65 - s25);
    t9g = (s15 + s55);
    t0h = (s25 + s65);
    *((dst + 96)) = (t3g + t7g);
    *((dst + 97)) = (t8g - t4g);
    *((dst + 416)) = (t3g - t7g);
    *((dst + 417)) = (t4g + t8g);
    *((dst + 352)) = (t5g - t0h);
    *((dst + 353)) = (t6g - t9g);
    *((dst + 160)) = (t5g + t0h);
    *((dst + 161)) = -((t6g + t9g));
    {long i2; for(i2 = 0; i2 <= 14; i2++) {
        a98 = (32*i2);
        b = (T + a98);
        a09 = (b + 32);
        a19 = (b + 48);
        a29 = (b + 33);
        a39 = (b + 49);
        a49 = (b + 34);
        a59 = (b + 50);
        a69 = (b + 35);
        a79 = (b + 51);
        a89 = (b + 36);
        a99 = (b + 52);
        a0a = (b + 37);
        a1a = (b + 53);
        a2a = (b + 38);
        a3a = (b + 54);
        a4a = (b + 39);
        a5a = (b + 55);
        a6a = (b + 40);
        a7a = (b + 56);
        a8a = (b + 41);
        a9a = (b + 57);
        a0b = (b + 42);
        a1b = (b + 58);
        a2b = (b + 43);
        a3b = (b + 59);
        a4b = (b + 44);
        a5b = (b + 60);
        a6b = (b + 45);
        a7b = (b + 61);
        a8b = (b + 46);
        a9b = (b + 62);
        a0c = (b + 47);
        a1c = (b + 63);
        a2c = (D270 + a98);
        a3c = (a2c + 1);
        s75 = ((*(a2c)**(a09)) - (*(a3c)**(a19)));
        s85 = ((*(a3c)**(a09)) + (*(a2c)**(a19)));
        a4c = (a2c + 2);
        a5c = (a2c + 3);
        s95 = ((*(a4c)**(a29)) - (*(a5c)**(a39)));
        s06 = ((*(a5c)**(a29)) + (*(a4c)**(a39)));
        a6c = (a2c + 4);
        a7c = (a2c + 5);
        s16 = ((*(a6c)**(a49)) - (*(a7c)**(a59)));
        s26 = ((*(a7c)**(a49)) + (*(a6c)**(a59)));
        a8c = (a2c + 6);
        a9c = (a2c + 7);
        s36 = ((*(a8c)**(a69)) - (*(a9c)**(a79)));
        s46 = ((*(a9c)**(a69)) + (*(a8c)**(a79)));
        a0d = (a2c + 8);
        a1d = (a2c + 9);
        s56 = ((*(a0d)**(a89)) - (*(a1d)**(a99)));
        s66 = ((*(a1d)**(a89)) + (*(a0d)**(a99)));
        a2d = (a2c + 10);
        a3d = (a2c + 11);
        s76 = ((*(a2d)**(a0a)) - (*(a3d)**(a1a)));
        s86 = ((*(a3d)**(a0a)) + (*(a2d)**(a1a)));
        a4d = (a2c + 12);
        a5d = (a2c + 13);
        s96 = ((*(a4d)**(a2a)) - (*(a5d)**(a3a)));
        s07 = ((*(a5d)**(a2a)) + (*(a4d)**(a3a)));
        a6d = (a2c + 14);
        a7d = (a2c + 15);
        s17 = ((*(a6d)**(a4a)) - (*(a7d)**(a5a)));
        s27 = ((*(a7d)**(a4a)) + (*(a6d)**(a5a)));
        a8d = (a2c + 16);
        a9d = (a2c + 17);
        s37 = ((*(a8d)**(a6a)) - (*(a9d)**(a7a)));
        s47 = ((*(a9d)**(a6a)) + (*(a8d)**(a7a)));
        a0e = (a2c + 18);
        a1e = (a2c + 19);
        s57 = ((*(a0e)**(a8a)) - (*(a1e)**(a9a)));
        s67 = ((*(a1e)**(a8a)) + (*(a0e)**(a9a)));
        a2e = (a2c + 20);
        a3e = (a2c + 21);
        s77 = ((*(a2e)**(a0b)) - (*(a3e)**(a1b)));
        s87 = ((*(a3e)**(a0b)) + (*(a2e)**(a1b)));
        a4e = (a2c + 22);
        a5e = (a2c + 23);
        s97 = ((*(a4e)**(a2b)) - (*(a5e)**(a3b)));
        s08 = ((*(a5e)**(a2b)) + (*(a4e)**(a3b)));
        a6e = (a2c + 24);
        a7e = (a2c + 25);
        s18 = ((*(a6e)**(a4b)) - (*(a7e)**(a5b)));
        s28 = ((*(a7e)**(a4b)) + (*(a6e)**(a5b)));
        a8e = (a2c + 26);
        a9e = (a2c + 27);
        s38 = ((*(a8e)**(a6b)) - (*(a9e)**(a7b)));
        s48 = ((*(a9e)**(a6b)) + (*(a8e)**(a7b)));
        a0f = (a2c + 28);
        a1f = (a2c + 29);
        s58 = ((*(a0f)**(a8b)) - (*(a1f)**(a9b)));
        s68 = ((*(a1f)**(a8b)) + (*(a0f)**(a9b)));
        a2f = (a2c + 30);
        a3f = (a2c + 31);
        s78 = ((*(a2f)**(a0c)) - (*(a3f)**(a1c)));
        s88 = ((*(a3f)**(a0c)) + (*(a2f)**(a1c)));
        t1h = (s75 + s37);
        t2h = (s85 + s47);
        t3h = (s75 - s37);
        t4h = (s85 - s47);
        t5h = (s56 + s18);
        t6h = (s66 + s28);
        t7h = (s56 - s18);
        t8h = (s66 - s28);
        t9h = (t1h + t5h);
        t0i = (t2h + t6h);
        t1i = (t1h - t5h);
        t2i = (t2h - t6h);
        t3i = (t3h + t8h);
        t4i = (t4h - t7h);
        t5i = (t3h - t8h);
        t6i = (t4h + t7h);
        t7i = (s95 + s57);
        t8i = (s06 + s67);
        t9i = (s95 - s57);
        t0j = (s06 - s67);
        t1j = (s76 + s38);
        t2j = (s86 + s48);
        t3j = (s76 - s38);
        t4j = (s86 - s48);
        t5j = (t7i + t1j);
        t6j = (t8i + t2j);
        a4f = (0.70710678118654757*(t7i - t1j));
        a5f = (0.70710678118654757*(t8i - t2j));
        s98 = (a4f + a5f);
        s09 = (a5f - a4f);
        t7j = (t9i + t4j);
        t8j = (t0j - t3j);
        t9j = (t9i - t4j);
        t0k = (t0j + t3j);
        s19 = ((0.92387953251128674*t7j) + (0.38268343236508978*t8j));
        s29 = ((0.92387953251128674*t8j) - (0.38268343236508978*t7j));
        s39 = ((0.38268343236508978*t9j) + (0.92387953251128674*t0k));
        s49 = ((0.38268343236508978*t0k) - (0.92387953251128674*t9j));
        t1k = (s16 + s77);
        t2k = (s26 + s87);
        t3k = (s16 - s77);
        t4k = (s26 - s87);
        t5k = (s96 + s58);
        t6k = (s07 + s68);
        t7k = (s96 - s58);
        t8k = (s07 - s68);
        t9k = (t1k + t5k);
        t0l = (t2k + t6k);
        t1l = (t1k - t5k);
        t2l = (t2k - t6k);
        a6f = (0.70710678118654757*(t3k + t8k));
        a7f = (0.70710678118654757*(t4k - t7k));
        s59 = (a6f + a7f);
        s69 = (a7f - a6f);
        a8f = (0.70710678118654757*(t4k + t7k));
        a9f = (0.70710678118654757*(t3k - t8k));
        s79 = (a8f - a9f);
        s89 = (a9f + a8f);
        t3l = (s36 + s97);
        t4l = (s46 + s08);
        t5l = (s36 - s97);
        t6l = (s46 - s08);
        t7l = (s17 + s78);
        t8l = (s27 + s88);
        t9l = (s17 - s78);
        t0m = (s27 - s88);
        t1m = (t3l + t7l);
        t2m = (t4l + t8l);
        a0g = (0.70710678118654757*(t4l - t8l));
        a1g = (0.70710678118654757*(t3l - t7l));
        s99 = (a0g - a1g);
        s0a = (a1g + a0g);
        t3m = (t5l + t0m);
        t4m = (t6l - t9l);
        t5m = (t5l - t0m);
        t6m = (t6l + t9l);
        s1a = ((0.38268343236508978*t3m) + (0.92387953251128674*t4m));
        s2a = ((0.38268343236508978*t4m) - (0.92387953251128674*t3m));
        s3a = ((0.92387953251128674*t5m) + (0.38268343236508978*t6m));
        s4a = ((0.38268343236508978*t5m) - (0.92387953251128674*t6m));
        t7m = (t9h + t9k);
        t8m = (t0i + t0l);
        t9m = (t9h - t9k);
        t0n = (t0i - t0l);
        t1n = (t5j + t1m);
        t2n = (t6j + t2m);
        t3n = (t5j - t1m);
        t4n = (t6j - t2m);
        a2g = (2*i2);
        b2 = (dst + a2g);
        *((b2 + 2)) = (t7m + t1n);
        *((b2 + 3)) = (t8m + t2n);
        b3 = (dst - a2g);
        *((b3 + 510)) = (t7m - t1n);
        *((b3 + 511)) = (t2n - t8m);
        *((b2 + 258)) = (t9m + t4n);
        *((b2 + 259)) = (t0n - t3n);
        *((b3 + 254)) = (t9m - t4n);
        *((b3 + 255)) = -((t0n + t3n));
        t5n = (t3i + s59);
        t6n = (t4i + s69);
        t7n = (t3i - s59);
        t8n = (t4i - s69);
        t9n = (s19 + s1a);
        t0o = (s29 + s2a);
        t1o = (s19 - s1a);
        t2o = (s29 - s2a);
        *((b2 + 66)) = (t5n + t9n);
        *((b2 + 67)) = (t6n + t0o);
        *((b3 + 446)) = (t5n - t9n);
        *((b3 + 447)) = (t0o - t6n);
        *((b2 + 322)) = (t7n + t2o);
        *((b2 + 323)) = (t8n - t1o);
        *((b3 + 190)) = (t7n - t2o);
        *((b3 + 191)) = -((t8n + t1o));
        t3o = (t1i + t2l);
        t4o = (t2i - t1l);
        t5o = (t1i - t2l);
        t6o = (t2i + t1l);
        t7o = (s98 + s99);
        t8o = (s09 - s0a);
        t9o = (s98 - s99);
        t0p = (s09 + s0a);
        *((b2 + 130)) = (t3o + t7o);
        *((b2 + 131)) = (t4o + t8o);
        *((b3 + 382)) = (t3o - t7o);
        *((b3 + 383)) = (t8o - t4o);
        *((b2 + 386)) = (t5o + t0p);
        *((b2 + 387)) = (t6o - t9o);
        *((b3 + 126)) = (t5o - t0p);
        *((b3 + 127)) = -((t6o + t9o));
        t1p = (t5i + s79);
        t2p = (t6i - s89);
        t3p = (t5i - s79);
        t4p = (t6i + s89);
        t5p = (s39 - s3a);
        t6p = (s49 + s4a);
        t7p = (s39 + s3a);
        t8p = (s49 - s4a);
        *((b2 + 194)) = (t1p + t5p);
        *((b2 + 195)) = (t2p + t6p);
        *((b3 + 318)) = (t1p - t5p);
        *((b3 + 319)) = (t6p - t2p);
        *((b2 + 450)) = (t3p + t8p);
        *((b2 + 451)) = (t4p - t7p);
        *((b3 + 62)) = (t3p - t8p);
        *((b3 + 63)) = -((t4p + t7p));
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_1024)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[1024];
    double  *a0a, *a0b, *a0c, *a0d, *a0f, *a0g, *a0h, *a0i, *a0j, *a0k, *a18, *a1a, *a1b, *a1c, *a1d, *a1f, *a1g, *a1h, *a1i, *a1j, *a1k, *a2a
            , *a2b, *a2c, *a2d, *a2f, *a2g, *a2h, *a2i, *a2j, *a2k, *a3a, *a3b, *a3c, *a3d, *a3f, *a3g, *a3h, *a3i, *a3j, *a3k, *a4a, *a4b, *a4c
            , *a4d, *a4e, *a4f, *a4g, *a4h, *a4i, *a4j, *a4k, *a5a, *a5b, *a5c, *a5d, *a5e, *a5f, *a5g, *a5h, *a5i, *a5j, *a5k, *a6a, *a6b, *a6c
            , *a6d, *a6e, *a6f, *a6g, *a6h, *a6i, *a6j, *a6k, *a7e, *a7f, *a7g, *a7h, *a7i, *a7j, *a7k, *a8e, *a8f, *a8g, *a8h, *a8i, *a8j, *a9a
            , *a9b, *a9c, *a9e, *a9f, *a9g, *a9h, *a9i, *a9j, *b, *b2, *b3;
    const double  *a, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26, *a27, *a3, *a31, *a32, *a33, *a34, *a35
            , *a36, *a37, *a4, *a41, *a42, *a43, *a44, *a45, *a46, *a47, *a5, *a51, *a52, *a53, *a54, *a55, *a56, *a57, *a6, *a61, *a62, *a63
            , *a64, *a65, *a66, *a67, *a7, *a71, *a72, *a73, *a74, *a75, *a76, *a77, *a8, *a81, *a82, *a83, *a84, *a85, *a86, *a87;
    int a3e, a6l;
    double a01, a02, a03, a04, a05, a06, a07, a08, a09, a0e, a0l, a19, a1e, a1l, a28, a29, a2e, a2l, a38, a39, a3l, a48
            , a49, a4l, a58, a59, a5l, a68, a69, a78, a79, a7a, a7b, a7c, a7d, a88, a89, a8a, a8b, a8c, a8d, a8k, a9, a91
            , a92, a93, a94, a95, a96, a97, a98, a99, a9d, a9k, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b
            , s0c, s0d, s0e, s0f, s11, s12, s13, s14, s15, s16, s17, s18, s19, s1a, s1b, s1c, s1d, s1e, s1f, s2, s21, s22
            , s23, s24, s25, s26, s27, s28, s29, s2a, s2b, s2c, s2d, s2e, s2f, s3, s31, s32, s33, s34, s35, s36, s37, s38
            , s39, s3a, s3b, s3c, s3d, s3e, s3f, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a, s4b, s4c, s4d, s4e
            , s4f, s5, s51, s52, s53, s54, s55, s56, s57, s58, s59, s5a, s5b, s5c, s5d, s5e, s6, s61, s62, s63, s64, s65
            , s66, s67, s68, s69, s6a, s6b, s6c, s6d, s6e, s7, s71, s72, s73, s74, s75, s76, s77, s78, s79, s7a, s7b, s7c
            , s7d, s7e, s8, s81, s82, s83, s84, s85, s86, s87, s88, s89, s8a, s8b, s8c, s8d, s8e, s9, s91, s92, s93, s94
            , s95, s96, s97, s98, s99, s9a, s9b, s9c, s9d, s9e, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B
            , t0C, t0D, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t
            , t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B, t1C, t1D, t1a, t1b, t1c
            , t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t1w, t1x, t1y
            , t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2a, t2b, t2c, t2d, t2e, t2f, t2g
            , t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y, t2z, t3, t31, t32
            , t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3D, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k
            , t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43, t44, t45, t46
            , t47, t48, t49, t4A, t4B, t4C, t4D, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o
            , t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A
            , t5B, t5C, t5D, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s
            , t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6C, t6D, t6a
            , t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w
            , t6x, t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7a, t7b, t7c, t7d, t7e, t7f
            , t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81
            , t82, t83, t84, t85, t86, t87, t88, t89, t8A, t8B, t8C, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k
            , t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96
            , t97, t98, t99, t9A, t9B, t9C, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p
            , t9q, t9r, t9s, t9t, t9u, t9v, t9w, t9x, t9y, t9z;
    {long i; for(i = 0; i <= 15; i++) {
        a = (src + i);
        a2 = (a + 512);
        t = (*(a) + *(a2));
        t2 = (*(a) - *(a2));
        a3 = (a + 256);
        a4 = (a + 768);
        t3 = (*(a3) + *(a4));
        t4 = (*(a3) - *(a4));
        a5 = (a + 128);
        a6 = (a + 640);
        t5 = (*(a5) + *(a6));
        a7 = (a + 384);
        a8 = (a + 896);
        t6 = (*(a7) + *(a8));
        t7 = (t + t3);
        t8 = (t - t3);
        t9 = (t5 + t6);
        t01 = (t5 - t6);
        a9 = (0.70710678118654757*(*(a5) - *(a6)));
        a01 = (0.70710678118654757*(*(a7) - *(a8)));
        s = (a9 - a01);
        s2 = (a9 + a01);
        t11 = (t2 + s);
        t21 = (t4 + s2);
        t31 = (t2 - s);
        t41 = (s2 - t4);
        a11 = (a + 16);
        a21 = (a + 528);
        t51 = (*(a11) + *(a21));
        t61 = (*(a11) - *(a21));
        a31 = (a + 272);
        a41 = (a + 784);
        t71 = (*(a31) + *(a41));
        t81 = (*(a31) - *(a41));
        a51 = (a + 144);
        a61 = (a + 656);
        t91 = (*(a51) + *(a61));
        a71 = (a + 400);
        a81 = (a + 912);
        t02 = (*(a71) + *(a81));
        t12 = (t51 + t71);
        t22 = (t51 - t71);
        t32 = (t91 + t02);
        t42 = (t91 - t02);
        a91 = (0.70710678118654757*(*(a51) - *(a61)));
        a02 = (0.70710678118654757*(*(a71) - *(a81)));
        s3 = (a91 - a02);
        s4 = (a91 + a02);
        t52 = (t61 + s3);
        t62 = (t81 + s4);
        t72 = (t61 - s3);
        t82 = (s4 - t81);
        a12 = (a + 32);
        a22 = (a + 544);
        t92 = (*(a12) + *(a22));
        t03 = (*(a12) - *(a22));
        a32 = (a + 288);
        a42 = (a + 800);
        t13 = (*(a32) + *(a42));
        t23 = (*(a32) - *(a42));
        a52 = (a + 160);
        a62 = (a + 672);
        t33 = (*(a52) + *(a62));
        a72 = (a + 416);
        a82 = (a + 928);
        t43 = (*(a72) + *(a82));
        t53 = (t92 + t13);
        t63 = (t92 - t13);
        t73 = (t33 + t43);
        t83 = (t33 - t43);
        a92 = (0.70710678118654757*(*(a52) - *(a62)));
        a03 = (0.70710678118654757*(*(a72) - *(a82)));
        s5 = (a92 - a03);
        s6 = (a92 + a03);
        t93 = (t03 + s5);
        t04 = (t23 + s6);
        t14 = (t03 - s5);
        t24 = (s6 - t23);
        a13 = (a + 48);
        a23 = (a + 560);
        t34 = (*(a13) + *(a23));
        t44 = (*(a13) - *(a23));
        a33 = (a + 304);
        a43 = (a + 816);
        t54 = (*(a33) + *(a43));
        t64 = (*(a33) - *(a43));
        a53 = (a + 176);
        a63 = (a + 688);
        t74 = (*(a53) + *(a63));
        a73 = (a + 432);
        a83 = (a + 944);
        t84 = (*(a73) + *(a83));
        t94 = (t34 + t54);
        t05 = (t34 - t54);
        t15 = (t74 + t84);
        t25 = (t74 - t84);
        a93 = (0.70710678118654757*(*(a53) - *(a63)));
        a04 = (0.70710678118654757*(*(a73) - *(a83)));
        s7 = (a93 - a04);
        s8 = (a93 + a04);
        t35 = (t44 + s7);
        t45 = (t64 + s8);
        t55 = (t44 - s7);
        t65 = (s8 - t64);
        a14 = (a + 64);
        a24 = (a + 576);
        t75 = (*(a14) + *(a24));
        t85 = (*(a14) - *(a24));
        a34 = (a + 320);
        a44 = (a + 832);
        t95 = (*(a34) + *(a44));
        t06 = (*(a34) - *(a44));
        a54 = (a + 192);
        a64 = (a + 704);
        t16 = (*(a54) + *(a64));
        a74 = (a + 448);
        a84 = (a + 960);
        t26 = (*(a74) + *(a84));
        t36 = (t75 + t95);
        t46 = (t16 + t26);
        a94 = (0.70710678118654757*(*(a54) - *(a64)));
        a05 = (0.70710678118654757*(*(a74) - *(a84)));
        s9 = (a94 - a05);
        s01 = (a94 + a05);
        t56 = (t85 + s9);
        t66 = (t06 + s01);
        t76 = (t85 - s9);
        t86 = (s01 - t06);
        a15 = (a + 80);
        a25 = (a + 592);
        t96 = (*(a15) + *(a25));
        t07 = (*(a15) - *(a25));
        a35 = (a + 336);
        a45 = (a + 848);
        t17 = (*(a35) + *(a45));
        t27 = (*(a35) - *(a45));
        a55 = (a + 208);
        a65 = (a + 720);
        t37 = (*(a55) + *(a65));
        a75 = (a + 464);
        a85 = (a + 976);
        t47 = (*(a75) + *(a85));
        t57 = (t96 + t17);
        t67 = (t96 - t17);
        t77 = (t37 + t47);
        t87 = (t37 - t47);
        a95 = (0.70710678118654757*(*(a55) - *(a65)));
        a06 = (0.70710678118654757*(*(a75) - *(a85)));
        s11 = (a95 - a06);
        s21 = (a95 + a06);
        t97 = (t07 + s11);
        t08 = (t27 + s21);
        t18 = (t07 - s11);
        t28 = (s21 - t27);
        a16 = (a + 96);
        a26 = (a + 608);
        t38 = (*(a16) + *(a26));
        t48 = (*(a16) - *(a26));
        a36 = (a + 352);
        a46 = (a + 864);
        t58 = (*(a36) + *(a46));
        t68 = (*(a36) - *(a46));
        a56 = (a + 224);
        a66 = (a + 736);
        t78 = (*(a56) + *(a66));
        a76 = (a + 480);
        a86 = (a + 992);
        t88 = (*(a76) + *(a86));
        t98 = (t38 + t58);
        t09 = (t38 - t58);
        t19 = (t78 + t88);
        t29 = (t78 - t88);
        a96 = (0.70710678118654757*(*(a56) - *(a66)));
        a07 = (0.70710678118654757*(*(a76) - *(a86)));
        s31 = (a96 - a07);
        s41 = (a96 + a07);
        t39 = (t48 + s31);
        t49 = (t68 + s41);
        t59 = (t48 - s31);
        t69 = (s41 - t68);
        a17 = (a + 112);
        a27 = (a + 624);
        t79 = (*(a17) + *(a27));
        t89 = (*(a17) - *(a27));
        a37 = (a + 368);
        a47 = (a + 880);
        t99 = (*(a37) + *(a47));
        t0a = (*(a37) - *(a47));
        a57 = (a + 240);
        a67 = (a + 752);
        t1a = (*(a57) + *(a67));
        a77 = (a + 496);
        a87 = (a + 1008);
        t2a = (*(a77) + *(a87));
        t3a = (t79 + t99);
        t4a = (t79 - t99);
        t5a = (t1a + t2a);
        t6a = (t1a - t2a);
        a97 = (0.70710678118654757*(*(a57) - *(a67)));
        a08 = (0.70710678118654757*(*(a77) - *(a87)));
        s51 = (a97 - a08);
        s61 = (a97 + a08);
        t7a = (t89 + s51);
        t8a = (t0a + s61);
        t9a = (t89 - s51);
        t0b = (s61 - t0a);
        t1b = (t7 + t9);
        t2b = (t7 - t9);
        t3b = (t36 + t46);
        t4b = (t36 - t46);
        t5b = (t12 + t32);
        t6b = (t12 - t32);
        t7b = (t57 + t77);
        t8b = (t57 - t77);
        t9b = (t53 + t73);
        t0c = (t98 + t19);
        t1c = (t94 + t15);
        t2c = (t94 - t15);
        t3c = (t3a + t5a);
        t4c = (t3a - t5a);
        t5c = (t1b + t3b);
        t6c = (t1b - t3b);
        t7c = (t9b + t0c);
        t8c = (t9b - t0c);
        t9c = (t5b + t7b);
        t0d = (t1c + t3c);
        a18 = (T + i);
        *(a18) = (t5c + t7c);
        *((a18 + 512)) = (t5c - t7c);
        *((a18 + 16)) = (t9c + t0d);
        *((a18 + 528)) = (t0d - t9c);
        a28 = (0.70710678118654757*(t5b - t7b));
        a38 = (0.70710678118654757*(t1c - t3c));
        s71 = (a28 - a38);
        s81 = (a28 + a38);
        *((a18 + 256)) = (t6c + s71);
        *((a18 + 272)) = -((t8c + s81));
        *((a18 + 768)) = (t6c - s71);
        *((a18 + 784)) = (t8c - s81);
        s91 = ((0.92387953251128674*t6b) - (0.38268343236508978*t8b));
        s02 = ((0.38268343236508978*t6b) + (0.92387953251128674*t8b));
        a48 = (0.70710678118654757*(t53 - t73));
        a58 = (0.70710678118654757*(t98 - t19));
        s12 = (a48 - a58);
        s22 = (a48 + a58);
        s32 = ((0.38268343236508978*t2c) - (0.92387953251128674*t4c));
        s42 = ((0.92387953251128674*t2c) + (0.38268343236508978*t4c));
        t1d = (t2b + s12);
        t2d = (t4b + s22);
        t3d = (t2b - s12);
        t4d = (s22 - t4b);
        t5d = (s91 + s32);
        t6d = (s02 + s42);
        t7d = (s91 - s32);
        t8d = (s42 - s02);
        *((a18 + 128)) = (t1d + t5d);
        *((a18 + 144)) = -((t2d + t6d));
        *((a18 + 896)) = (t1d - t5d);
        *((a18 + 912)) = (t2d - t6d);
        *((a18 + 640)) = (t3d + t8d);
        *((a18 + 656)) = (t4d - t7d);
        *((a18 + 384)) = (t3d - t8d);
        *((a18 + 400)) = -((t4d + t7d));
        s52 = ((0.99518472667219693*t52) - (0.098017140329560604*t62));
        s62 = ((0.098017140329560604*t52) + (0.99518472667219693*t62));
        s72 = ((0.98078528040323043*t93) - (0.19509032201612828*t04));
        s82 = ((0.19509032201612828*t93) + (0.98078528040323043*t04));
        s92 = ((0.95694033573220882*t35) - (0.29028467725446239*t45));
        s03 = ((0.29028467725446239*t35) + (0.95694033573220882*t45));
        s13 = ((0.92387953251128674*t56) - (0.38268343236508978*t66));
        s23 = ((0.38268343236508978*t56) + (0.92387953251128674*t66));
        s33 = ((0.88192126434835505*t97) - (0.47139673682599764*t08));
        s43 = ((0.47139673682599764*t97) + (0.88192126434835505*t08));
        s53 = ((0.83146961230254524*t39) - (0.55557023301960218*t49));
        s63 = ((0.55557023301960218*t39) + (0.83146961230254524*t49));
        s73 = ((0.77301045336273699*t7a) - (0.63439328416364549*t8a));
        s83 = ((0.63439328416364549*t7a) + (0.77301045336273699*t8a));
        t9d = (t11 + s13);
        t0e = (t21 + s23);
        t1e = (t11 - s13);
        t2e = (s23 - t21);
        t3e = (s72 + s53);
        t4e = (s82 + s63);
        t5e = (s72 - s53);
        t6e = (s63 - s82);
        t7e = (t9d + t3e);
        t8e = (t0e + t4e);
        t9e = (t9d - t3e);
        t0f = (t4e - t0e);
        t1f = (t1e + t6e);
        t2f = (t2e - t5e);
        t3f = (t1e - t6e);
        t4f = (t2e + t5e);
        t5f = (s52 + s33);
        t6f = (s62 + s43);
        t7f = (s52 - s33);
        t8f = (s43 - s62);
        t9f = (s92 + s73);
        t0g = (s03 + s83);
        t1g = (s92 - s73);
        t2g = (s83 - s03);
        t3g = (t5f + t9f);
        t4g = (t6f + t0g);
        t5g = (t5f - t9f);
        t6g = (t0g - t6f);
        a68 = (0.70710678118654757*(t7f + t2g));
        a78 = (0.70710678118654757*(t8f - t1g));
        s93 = (a68 + a78);
        s04 = (a78 - a68);
        a88 = (0.70710678118654757*(t8f + t1g));
        a98 = (0.70710678118654757*(t7f - t2g));
        s14 = (a88 - a98);
        s24 = (a98 + a88);
        *((a18 + 32)) = (t7e + t3g);
        *((a18 + 48)) = -((t8e + t4g));
        *((a18 + 992)) = (t7e - t3g);
        *((a18 + 1008)) = (t8e - t4g);
        *((a18 + 288)) = (t1f + s93);
        *((a18 + 304)) = (t2f + s04);
        *((a18 + 736)) = (t1f - s93);
        *((a18 + 752)) = (s04 - t2f);
        *((a18 + 544)) = (t9e + t6g);
        *((a18 + 560)) = (t0f - t5g);
        *((a18 + 480)) = (t9e - t6g);
        *((a18 + 496)) = -((t0f + t5g));
        *((a18 + 800)) = (t3f + s14);
        *((a18 + 816)) = (t4f - s24);
        *((a18 + 224)) = (t3f - s14);
        *((a18 + 240)) = -((t4f + s24));
        s34 = ((0.98078528040323043*t22) - (0.19509032201612828*t42));
        s44 = ((0.19509032201612828*t22) + (0.98078528040323043*t42));
        s54 = ((0.92387953251128674*t63) - (0.38268343236508978*t83));
        s64 = ((0.38268343236508978*t63) + (0.92387953251128674*t83));
        s74 = ((0.83146961230254524*t05) - (0.55557023301960218*t25));
        s84 = ((0.55557023301960218*t05) + (0.83146961230254524*t25));
        a09 = (0.70710678118654757*(t75 - t95));
        a19 = (0.70710678118654757*(t16 - t26));
        s94 = (a09 - a19);
        s05 = (a09 + a19);
        s15 = ((0.55557023301960218*t67) - (0.83146961230254524*t87));
        s25 = ((0.83146961230254524*t67) + (0.55557023301960218*t87));
        s35 = ((0.38268343236508978*t09) - (0.92387953251128674*t29));
        s45 = ((0.92387953251128674*t09) + (0.38268343236508978*t29));
        s55 = ((0.19509032201612828*t4a) - (0.98078528040323043*t6a));
        s65 = ((0.98078528040323043*t4a) + (0.19509032201612828*t6a));
        t7g = (t8 + s94);
        t8g = (t01 + s05);
        t9g = (t8 - s94);
        t0h = (s05 - t01);
        t1h = (s54 + s35);
        t2h = (s64 + s45);
        t3h = (s54 - s35);
        t4h = (s45 - s64);
        t5h = (t7g + t1h);
        t6h = (t8g + t2h);
        t7h = (t7g - t1h);
        t8h = (t2h - t8g);
        t9h = (t9g + t4h);
        t0i = (t0h - t3h);
        t1i = (t9g - t4h);
        t2i = (t0h + t3h);
        t3i = (s34 + s15);
        t4i = (s44 + s25);
        t5i = (s34 - s15);
        t6i = (s25 - s44);
        t7i = (s74 + s55);
        t8i = (s84 + s65);
        t9i = (s74 - s55);
        t0j = (s65 - s84);
        t1j = (t3i + t7i);
        t2j = (t4i + t8i);
        t3j = (t3i - t7i);
        t4j = (t8i - t4i);
        a29 = (0.70710678118654757*(t5i + t0j));
        a39 = (0.70710678118654757*(t6i - t9i));
        s75 = (a29 + a39);
        s85 = (a39 - a29);
        a49 = (0.70710678118654757*(t6i + t9i));
        a59 = (0.70710678118654757*(t5i - t0j));
        s95 = (a49 - a59);
        s06 = (a59 + a49);
        *((a18 + 64)) = (t5h + t1j);
        *((a18 + 80)) = -((t6h + t2j));
        *((a18 + 960)) = (t5h - t1j);
        *((a18 + 976)) = (t6h - t2j);
        *((a18 + 320)) = (t9h + s75);
        *((a18 + 336)) = (t0i + s85);
        *((a18 + 704)) = (t9h - s75);
        *((a18 + 720)) = (s85 - t0i);
        *((a18 + 576)) = (t7h + t4j);
        *((a18 + 592)) = (t8h - t3j);
        *((a18 + 448)) = (t7h - t4j);
        *((a18 + 464)) = -((t8h + t3j));
        *((a18 + 832)) = (t1i + s95);
        *((a18 + 848)) = (t2i - s06);
        *((a18 + 192)) = (t1i - s95);
        *((a18 + 208)) = -((t2i + s06));
        s16 = ((0.95694033573220882*t72) - (0.29028467725446239*t82));
        s26 = ((0.29028467725446239*t72) + (0.95694033573220882*t82));
        s36 = ((0.83146961230254524*t14) - (0.55557023301960218*t24));
        s46 = ((0.55557023301960218*t14) + (0.83146961230254524*t24));
        s56 = ((0.63439328416364549*t55) - (0.77301045336273699*t65));
        s66 = ((0.77301045336273699*t55) + (0.63439328416364549*t65));
        s76 = ((0.38268343236508978*t76) - (0.92387953251128674*t86));
        s86 = ((0.92387953251128674*t76) + (0.38268343236508978*t86));
        s96 = ((0.098017140329560604*t18) - (0.99518472667219693*t28));
        s07 = ((0.99518472667219693*t18) + (0.098017140329560604*t28));
        s17 = ((0.19509032201612828*t59) + (0.98078528040323043*t69));
        s27 = ((0.19509032201612828*t69) - (0.98078528040323043*t59));
        s37 = ((0.47139673682599764*t9a) + (0.88192126434835505*t0b));
        s47 = ((0.47139673682599764*t0b) - (0.88192126434835505*t9a));
        t5j = (t31 + s76);
        t6j = (t41 + s86);
        t7j = (t31 - s76);
        t8j = (s86 - t41);
        t9j = (s36 - s17);
        t0k = (s27 - s46);
        t1k = (s36 + s17);
        t2k = (s46 + s27);
        t3k = (t5j + t9j);
        t4k = (t0k - t6j);
        t5k = (t5j - t9j);
        t6k = (t6j + t0k);
        t7k = (t7j - t2k);
        t8k = (t8j - t1k);
        t9k = (t7j + t2k);
        t0l = (t8j + t1k);
        t1l = (s16 + s96);
        t2l = (s26 + s07);
        t3l = (s16 - s96);
        t4l = (s07 - s26);
        t5l = (s56 - s37);
        t6l = (s47 - s66);
        t7l = (s56 + s37);
        t8l = (s66 + s47);
        t9l = (t1l + t5l);
        t0m = (t6l - t2l);
        t1m = (t1l - t5l);
        t2m = (t2l + t6l);
        a69 = (0.70710678118654757*(t3l - t8l));
        a79 = (0.70710678118654757*(t4l - t7l));
        s57 = (a69 + a79);
        s67 = (a79 - a69);
        a89 = (0.70710678118654757*(t4l + t7l));
        a99 = (0.70710678118654757*(t3l + t8l));
        s77 = (a89 - a99);
        s87 = (a99 + a89);
        *((a18 + 96)) = (t3k + t9l);
        *((a18 + 112)) = (t4k + t0m);
        *((a18 + 928)) = (t3k - t9l);
        *((a18 + 944)) = (t0m - t4k);
        *((a18 + 352)) = (t7k + s57);
        *((a18 + 368)) = (t8k + s67);
        *((a18 + 672)) = (t7k - s57);
        *((a18 + 688)) = (s67 - t8k);
        *((a18 + 608)) = (t5k - t2m);
        *((a18 + 624)) = -((t6k + t1m));
        *((a18 + 416)) = (t5k + t2m);
        *((a18 + 432)) = (t6k - t1m);
        *((a18 + 864)) = (t9k + s77);
        *((a18 + 880)) = (t0l - s87);
        *((a18 + 160)) = (t9k - s77);
        *((a18 + 176)) = -((t0l + s87));
    }}
    a0a = (T + 16);
    t3m = (*(T) + *(a0a));
    t4m = (*(T) - *(a0a));
    a1a = (T + 8);
    a2a = (T + 24);
    t5m = (*(a1a) + *(a2a));
    t6m = (*(a1a) - *(a2a));
    a3a = (T + 4);
    a4a = (T + 20);
    t7m = (*(a3a) + *(a4a));
    a5a = (T + 12);
    a6a = (T + 28);
    t8m = (*(a5a) + *(a6a));
    t9m = (t3m + t5m);
    t0n = (t3m - t5m);
    t1n = (t7m + t8m);
    t2n = (t7m - t8m);
    a7a = (0.70710678118654757*(*(a3a) - *(a4a)));
    a8a = (0.70710678118654757*(*(a5a) - *(a6a)));
    s97 = (a7a - a8a);
    s08 = (a7a + a8a);
    t3n = (t4m + s97);
    t4n = (t6m + s08);
    t5n = (t4m - s97);
    t6n = (s08 - t6m);
    a9a = (T + 1);
    a0b = (T + 17);
    t7n = (*(a9a) + *(a0b));
    t8n = (*(a9a) - *(a0b));
    a1b = (T + 9);
    a2b = (T + 25);
    t9n = (*(a1b) + *(a2b));
    t0o = (*(a1b) - *(a2b));
    a3b = (T + 5);
    a4b = (T + 21);
    t1o = (*(a3b) + *(a4b));
    a5b = (T + 13);
    a6b = (T + 29);
    t2o = (*(a5b) + *(a6b));
    t3o = (t7n + t9n);
    t4o = (t7n - t9n);
    t5o = (t1o + t2o);
    t6o = (t1o - t2o);
    a7b = (0.70710678118654757*(*(a3b) - *(a4b)));
    a8b = (0.70710678118654757*(*(a5b) - *(a6b)));
    s18 = (a7b - a8b);
    s28 = (a7b + a8b);
    t7o = (t8n + s18);
    t8o = (t0o + s28);
    t9o = (t8n - s18);
    t0p = (s28 - t0o);
    a9b = (T + 2);
    a0c = (T + 18);
    t1p = (*(a9b) + *(a0c));
    t2p = (*(a9b) - *(a0c));
    a1c = (T + 10);
    a2c = (T + 26);
    t3p = (*(a1c) + *(a2c));
    t4p = (*(a1c) - *(a2c));
    a3c = (T + 6);
    a4c = (T + 22);
    t5p = (*(a3c) + *(a4c));
    a5c = (T + 14);
    a6c = (T + 30);
    t6p = (*(a5c) + *(a6c));
    t7p = (t1p + t3p);
    t8p = (t5p + t6p);
    a7c = (0.70710678118654757*(*(a3c) - *(a4c)));
    a8c = (0.70710678118654757*(*(a5c) - *(a6c)));
    s38 = (a7c - a8c);
    s48 = (a7c + a8c);
    t9p = (t2p + s38);
    t0q = (t4p + s48);
    t1q = (t2p - s38);
    t2q = (s48 - t4p);
    a9c = (T + 3);
    a0d = (T + 19);
    t3q = (*(a9c) + *(a0d));
    t4q = (*(a9c) - *(a0d));
    a1d = (T + 11);
    a2d = (T + 27);
    t5q = (*(a1d) + *(a2d));
    t6q = (*(a1d) - *(a2d));
    a3d = (T + 7);
    a4d = (T + 23);
    t7q = (*(a3d) + *(a4d));
    a5d = (T + 15);
    a6d = (T + 31);
    t8q = (*(a5d) + *(a6d));
    t9q = (t3q + t5q);
    t0r = (t3q - t5q);
    t1r = (t7q + t8q);
    t2r = (t7q - t8q);
    a7d = (0.70710678118654757*(*(a3d) - *(a4d)));
    a8d = (0.70710678118654757*(*(a5d) - *(a6d)));
    s58 = (a7d - a8d);
    s68 = (a7d + a8d);
    t3r = (t4q + s58);
    t4r = (t6q + s68);
    t5r = (t4q - s58);
    t6r = (s68 - t6q);
    t7r = (t9m + t1n);
    t8r = (t9m - t1n);
    t9r = (t7p + t8p);
    t0s = (t7p - t8p);
    t1s = (t3o + t5o);
    t2s = (t9q + t1r);
    t3s = (t7r + t9r);
    t4s = (t1s + t2s);
    *(dst) = (t3s + t4s);
    *((dst + 1)) = (t3s - t4s);
    *((dst + 512)) = (t7r - t9r);
    *((dst + 513)) = (t2s - t1s);
    a9d = (0.70710678118654757*(t3o - t5o));
    a0e = (0.70710678118654757*(t9q - t1r));
    s78 = (a9d - a0e);
    s88 = (a9d + a0e);
    *((dst + 256)) = (t8r + s78);
    *((dst + 257)) = -((t0s + s88));
    *((dst + 768)) = (t8r - s78);
    *((dst + 769)) = (t0s - s88);
    s98 = ((0.98078528040323043*t7o) - (0.19509032201612828*t8o));
    s09 = ((0.19509032201612828*t7o) + (0.98078528040323043*t8o));
    s19 = ((0.92387953251128674*t9p) - (0.38268343236508978*t0q));
    s29 = ((0.38268343236508978*t9p) + (0.92387953251128674*t0q));
    s39 = ((0.83146961230254524*t3r) - (0.55557023301960218*t4r));
    s49 = ((0.55557023301960218*t3r) + (0.83146961230254524*t4r));
    t5s = (t3n + s19);
    t6s = (t4n + s29);
    t7s = (t3n - s19);
    t8s = (s29 - t4n);
    t9s = (s98 + s39);
    t0t = (s09 + s49);
    t1t = (s98 - s39);
    t2t = (s49 - s09);
    *((dst + 64)) = (t5s + t9s);
    *((dst + 65)) = -((t6s + t0t));
    *((dst + 960)) = (t5s - t9s);
    *((dst + 961)) = (t6s - t0t);
    *((dst + 576)) = (t7s + t2t);
    *((dst + 577)) = (t8s - t1t);
    *((dst + 448)) = (t7s - t2t);
    *((dst + 449)) = -((t8s + t1t));
    s59 = ((0.92387953251128674*t4o) - (0.38268343236508978*t6o));
    s69 = ((0.38268343236508978*t4o) + (0.92387953251128674*t6o));
    a1e = (0.70710678118654757*(t1p - t3p));
    a2e = (0.70710678118654757*(t5p - t6p));
    s79 = (a1e - a2e);
    s89 = (a1e + a2e);
    s99 = ((0.38268343236508978*t0r) - (0.92387953251128674*t2r));
    s0a = ((0.92387953251128674*t0r) + (0.38268343236508978*t2r));
    t3t = (t0n + s79);
    t4t = (t2n + s89);
    t5t = (t0n - s79);
    t6t = (s89 - t2n);
    t7t = (s59 + s99);
    t8t = (s69 + s0a);
    t9t = (s59 - s99);
    t0u = (s0a - s69);
    *((dst + 128)) = (t3t + t7t);
    *((dst + 129)) = -((t4t + t8t));
    *((dst + 896)) = (t3t - t7t);
    *((dst + 897)) = (t4t - t8t);
    *((dst + 640)) = (t5t + t0u);
    *((dst + 641)) = (t6t - t9t);
    *((dst + 384)) = (t5t - t0u);
    *((dst + 385)) = -((t6t + t9t));
    s1a = ((0.83146961230254524*t9o) - (0.55557023301960218*t0p));
    s2a = ((0.55557023301960218*t9o) + (0.83146961230254524*t0p));
    s3a = ((0.38268343236508978*t1q) - (0.92387953251128674*t2q));
    s4a = ((0.92387953251128674*t1q) + (0.38268343236508978*t2q));
    s5a = ((0.19509032201612828*t5r) + (0.98078528040323043*t6r));
    s6a = ((0.19509032201612828*t6r) - (0.98078528040323043*t5r));
    t1u = (t5n + s3a);
    t2u = (t6n + s4a);
    t3u = (t5n - s3a);
    t4u = (s4a - t6n);
    t5u = (s1a - s5a);
    t6u = (s6a - s2a);
    t7u = (s1a + s5a);
    t8u = (s2a + s6a);
    *((dst + 192)) = (t1u + t5u);
    *((dst + 193)) = (t6u - t2u);
    *((dst + 832)) = (t1u - t5u);
    *((dst + 833)) = (t2u + t6u);
    *((dst + 704)) = (t3u - t8u);
    *((dst + 705)) = (t4u - t7u);
    *((dst + 320)) = (t3u + t8u);
    *((dst + 321)) = -((t4u + t7u));
    {long i2; for(i2 = 0; i2 <= 30; i2++) {
        a3e = (32*i2);
        b = (T + a3e);
        a4e = (b + 32);
        a5e = (b + 48);
        a6e = (b + 33);
        a7e = (b + 49);
        a8e = (b + 34);
        a9e = (b + 50);
        a0f = (b + 35);
        a1f = (b + 51);
        a2f = (b + 36);
        a3f = (b + 52);
        a4f = (b + 37);
        a5f = (b + 53);
        a6f = (b + 38);
        a7f = (b + 54);
        a8f = (b + 39);
        a9f = (b + 55);
        a0g = (b + 40);
        a1g = (b + 56);
        a2g = (b + 41);
        a3g = (b + 57);
        a4g = (b + 42);
        a5g = (b + 58);
        a6g = (b + 43);
        a7g = (b + 59);
        a8g = (b + 44);
        a9g = (b + 60);
        a0h = (b + 45);
        a1h = (b + 61);
        a2h = (b + 46);
        a3h = (b + 62);
        a4h = (b + 47);
        a5h = (b + 63);
        a6h = (D271 + a3e);
        a7h = (a6h + 1);
        s7a = ((*(a6h)**(a4e)) - (*(a7h)**(a5e)));
        s8a = ((*(a7h)**(a4e)) + (*(a6h)**(a5e)));
        a8h = (a6h + 2);
        a9h = (a6h + 3);
        s9a = ((*(a8h)**(a6e)) - (*(a9h)**(a7e)));
        s0b = ((*(a9h)**(a6e)) + (*(a8h)**(a7e)));
        a0i = (a6h + 4);
        a1i = (a6h + 5);
        s1b = ((*(a0i)**(a8e)) - (*(a1i)**(a9e)));
        s2b = ((*(a1i)**(a8e)) + (*(a0i)**(a9e)));
        a2i = (a6h + 6);
        a3i = (a6h + 7);
        s3b = ((*(a2i)**(a0f)) - (*(a3i)**(a1f)));
        s4b = ((*(a3i)**(a0f)) + (*(a2i)**(a1f)));
        a4i = (a6h + 8);
        a5i = (a6h + 9);
        s5b = ((*(a4i)**(a2f)) - (*(a5i)**(a3f)));
        s6b = ((*(a5i)**(a2f)) + (*(a4i)**(a3f)));
        a6i = (a6h + 10);
        a7i = (a6h + 11);
        s7b = ((*(a6i)**(a4f)) - (*(a7i)**(a5f)));
        s8b = ((*(a7i)**(a4f)) + (*(a6i)**(a5f)));
        a8i = (a6h + 12);
        a9i = (a6h + 13);
        s9b = ((*(a8i)**(a6f)) - (*(a9i)**(a7f)));
        s0c = ((*(a9i)**(a6f)) + (*(a8i)**(a7f)));
        a0j = (a6h + 14);
        a1j = (a6h + 15);
        s1c = ((*(a0j)**(a8f)) - (*(a1j)**(a9f)));
        s2c = ((*(a1j)**(a8f)) + (*(a0j)**(a9f)));
        a2j = (a6h + 16);
        a3j = (a6h + 17);
        s3c = ((*(a2j)**(a0g)) - (*(a3j)**(a1g)));
        s4c = ((*(a3j)**(a0g)) + (*(a2j)**(a1g)));
        a4j = (a6h + 18);
        a5j = (a6h + 19);
        s5c = ((*(a4j)**(a2g)) - (*(a5j)**(a3g)));
        s6c = ((*(a5j)**(a2g)) + (*(a4j)**(a3g)));
        a6j = (a6h + 20);
        a7j = (a6h + 21);
        s7c = ((*(a6j)**(a4g)) - (*(a7j)**(a5g)));
        s8c = ((*(a7j)**(a4g)) + (*(a6j)**(a5g)));
        a8j = (a6h + 22);
        a9j = (a6h + 23);
        s9c = ((*(a8j)**(a6g)) - (*(a9j)**(a7g)));
        s0d = ((*(a9j)**(a6g)) + (*(a8j)**(a7g)));
        a0k = (a6h + 24);
        a1k = (a6h + 25);
        s1d = ((*(a0k)**(a8g)) - (*(a1k)**(a9g)));
        s2d = ((*(a1k)**(a8g)) + (*(a0k)**(a9g)));
        a2k = (a6h + 26);
        a3k = (a6h + 27);
        s3d = ((*(a2k)**(a0h)) - (*(a3k)**(a1h)));
        s4d = ((*(a3k)**(a0h)) + (*(a2k)**(a1h)));
        a4k = (a6h + 28);
        a5k = (a6h + 29);
        s5d = ((*(a4k)**(a2h)) - (*(a5k)**(a3h)));
        s6d = ((*(a5k)**(a2h)) + (*(a4k)**(a3h)));
        a6k = (a6h + 30);
        a7k = (a6h + 31);
        s7d = ((*(a6k)**(a4h)) - (*(a7k)**(a5h)));
        s8d = ((*(a7k)**(a4h)) + (*(a6k)**(a5h)));
        t9u = (s7a + s3c);
        t0v = (s8a + s4c);
        t1v = (s7a - s3c);
        t2v = (s8a - s4c);
        t3v = (s5b + s1d);
        t4v = (s6b + s2d);
        t5v = (s5b - s1d);
        t6v = (s6b - s2d);
        t7v = (t9u + t3v);
        t8v = (t0v + t4v);
        t9v = (t9u - t3v);
        t0w = (t0v - t4v);
        t1w = (t1v + t6v);
        t2w = (t2v - t5v);
        t3w = (t1v - t6v);
        t4w = (t2v + t5v);
        t5w = (s9a + s5c);
        t6w = (s0b + s6c);
        t7w = (s9a - s5c);
        t8w = (s0b - s6c);
        t9w = (s7b + s3d);
        t0x = (s8b + s4d);
        t1x = (s7b - s3d);
        t2x = (s8b - s4d);
        t3x = (t5w + t9w);
        t4x = (t6w + t0x);
        a8k = (0.70710678118654757*(t5w - t9w));
        a9k = (0.70710678118654757*(t6w - t0x));
        s9d = (a8k + a9k);
        s0e = (a9k - a8k);
        t5x = (t7w + t2x);
        t6x = (t8w - t1x);
        t7x = (t7w - t2x);
        t8x = (t8w + t1x);
        s1e = ((0.92387953251128674*t5x) + (0.38268343236508978*t6x));
        s2e = ((0.92387953251128674*t6x) - (0.38268343236508978*t5x));
        s3e = ((0.38268343236508978*t7x) + (0.92387953251128674*t8x));
        s4e = ((0.38268343236508978*t8x) - (0.92387953251128674*t7x));
        t9x = (s1b + s7c);
        t0y = (s2b + s8c);
        t1y = (s1b - s7c);
        t2y = (s2b - s8c);
        t3y = (s9b + s5d);
        t4y = (s0c + s6d);
        t5y = (s9b - s5d);
        t6y = (s0c - s6d);
        t7y = (t9x + t3y);
        t8y = (t0y + t4y);
        t9y = (t9x - t3y);
        t0z = (t0y - t4y);
        a0l = (0.70710678118654757*(t1y + t6y));
        a1l = (0.70710678118654757*(t2y - t5y));
        s5e = (a0l + a1l);
        s6e = (a1l - a0l);
        a2l = (0.70710678118654757*(t2y + t5y));
        a3l = (0.70710678118654757*(t1y - t6y));
        s7e = (a2l - a3l);
        s8e = (a3l + a2l);
        t1z = (s3b + s9c);
        t2z = (s4b + s0d);
        t3z = (s3b - s9c);
        t4z = (s4b - s0d);
        t5z = (s1c + s7d);
        t6z = (s2c + s8d);
        t7z = (s1c - s7d);
        t8z = (s2c - s8d);
        t9z = (t1z + t5z);
        t0A = (t2z + t6z);
        a4l = (0.70710678118654757*(t2z - t6z));
        a5l = (0.70710678118654757*(t1z - t5z));
        s9e = (a4l - a5l);
        s0f = (a5l + a4l);
        t1A = (t3z + t8z);
        t2A = (t4z - t7z);
        t3A = (t3z - t8z);
        t4A = (t4z + t7z);
        s1f = ((0.38268343236508978*t1A) + (0.92387953251128674*t2A));
        s2f = ((0.38268343236508978*t2A) - (0.92387953251128674*t1A));
        s3f = ((0.92387953251128674*t3A) + (0.38268343236508978*t4A));
        s4f = ((0.38268343236508978*t3A) - (0.92387953251128674*t4A));
        t5A = (t7v + t7y);
        t6A = (t8v + t8y);
        t7A = (t7v - t7y);
        t8A = (t8v - t8y);
        t9A = (t3x + t9z);
        t0B = (t4x + t0A);
        t1B = (t3x - t9z);
        t2B = (t4x - t0A);
        a6l = (2*i2);
        b2 = (dst + a6l);
        *((b2 + 2)) = (t5A + t9A);
        *((b2 + 3)) = (t6A + t0B);
        b3 = (dst - a6l);
        *((b3 + 1022)) = (t5A - t9A);
        *((b3 + 1023)) = (t0B - t6A);
        *((b2 + 514)) = (t7A + t2B);
        *((b2 + 515)) = (t8A - t1B);
        *((b3 + 510)) = (t7A - t2B);
        *((b3 + 511)) = -((t8A + t1B));
        t3B = (t1w + s5e);
        t4B = (t2w + s6e);
        t5B = (t1w - s5e);
        t6B = (t2w - s6e);
        t7B = (s1e + s1f);
        t8B = (s2e + s2f);
        t9B = (s1e - s1f);
        t0C = (s2e - s2f);
        *((b2 + 130)) = (t3B + t7B);
        *((b2 + 131)) = (t4B + t8B);
        *((b3 + 894)) = (t3B - t7B);
        *((b3 + 895)) = (t8B - t4B);
        *((b2 + 642)) = (t5B + t0C);
        *((b2 + 643)) = (t6B - t9B);
        *((b3 + 382)) = (t5B - t0C);
        *((b3 + 383)) = -((t6B + t9B));
        t1C = (t9v + t0z);
        t2C = (t0w - t9y);
        t3C = (t9v - t0z);
        t4C = (t0w + t9y);
        t5C = (s9d + s9e);
        t6C = (s0e - s0f);
        t7C = (s9d - s9e);
        t8C = (s0e + s0f);
        *((b2 + 258)) = (t1C + t5C);
        *((b2 + 259)) = (t2C + t6C);
        *((b3 + 766)) = (t1C - t5C);
        *((b3 + 767)) = (t6C - t2C);
        *((b2 + 770)) = (t3C + t8C);
        *((b2 + 771)) = (t4C - t7C);
        *((b3 + 254)) = (t3C - t8C);
        *((b3 + 255)) = -((t4C + t7C));
        t9C = (t3w + s7e);
        t0D = (t4w - s8e);
        t1D = (t3w - s7e);
        t2D = (t4w + s8e);
        t3D = (s3e - s3f);
        t4D = (s4e + s4f);
        t5D = (s3e + s3f);
        t6D = (s4e - s4f);
        *((b2 + 386)) = (t9C + t3D);
        *((b2 + 387)) = (t0D + t4D);
        *((b3 + 638)) = (t9C - t3D);
        *((b3 + 639)) = (t4D - t0D);
        *((b2 + 898)) = (t1D + t6D);
        *((b2 + 899)) = (t2D - t5D);
        *((b3 + 126)) = (t1D - t6D);
        *((b3 + 127)) = -((t2D + t5D));
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_2048)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[2048];
     double T2[128];
    double  *a03, *a05, *a06, *a07, *a08, *a09, *a0a, *a0b, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a13, *a15, *a16, *a17, *a18, *a19, *a1a, *a1b
            , *a1d, *a1e, *a1f, *a1g, *a1h, *a1i, *a22, *a23, *a25, *a26, *a27, *a28, *a29, *a2a, *a2b, *a2d, *a2e, *a2f, *a2g, *a2h, *a2i, *a32
            , *a33, *a34, *a35, *a36, *a37, *a38, *a39, *a3a, *a3b, *a3d, *a3e, *a3f, *a3g, *a3h, *a3i, *a42, *a43, *a44, *a45, *a46, *a47, *a48
            , *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g, *a4h, *a4i, *a52, *a53, *a54, *a55, *a56, *a58, *a59, *a5a, *a5b, *a5c, *a5d, *a5e
            , *a5f, *a5g, *a5h, *a5i, *a62, *a63, *a64, *a65, *a66, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a6h, *a6i, *a71, *a72
            , *a73, *a74, *a75, *a76, *a7c, *a7d, *a7e, *a7f, *a7g, *a7h, *a7i, *a82, *a84, *a85, *a86, *a8c, *a8d, *a8e, *a8f, *a8g, *a8h, *a92
            , *a94, *a95, *a96, *a98, *a99, *a9a, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *b, *b2, *b3, *b4, *b5, *b6, *b7;
    const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a6, *a61, *a7, *a8, *a9;
    int a24, a3c, a6j, a97;
    double a02, a04, a0c, a0j, a12, a14, a1c, a1j, a2c, a2j, a3j, a4j, a57, a5j, a67, a77, a78, a79, a7a, a7b, a81, a83
            , a87, a88, a89, a8a, a8b, a8i, a91, a93, a9b, a9i, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b
            , s11, s12, s13, s14, s15, s16, s17, s18, s19, s1a, s1b, s2, s21, s22, s23, s24, s25, s26, s27, s28, s29, s2a
            , s2b, s3, s31, s32, s33, s34, s35, s36, s37, s38, s39, s3a, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49
            , s4a, s5, s51, s52, s53, s54, s55, s56, s57, s58, s59, s5a, s6, s61, s62, s63, s64, s65, s66, s67, s68, s69
            , s6a, s7, s71, s72, s73, s74, s75, s76, s77, s78, s79, s7a, s8, s81, s82, s83, s84, s85, s86, s87, s88, s89
            , s8a, s9, s91, s92, s93, s94, s95, s96, s97, s98, s99, s9a, t, t01, t02, t03, t04, t05, t06, t07, t08, t09
            , t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t11, t12, t13, t14, t15, t16
            , t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o
            , t2p, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k
            , t3l, t3m, t3n, t3o, t3p, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g
            , t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c
            , t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t6, t61, t62, t63, t64, t65, t66, t67, t68
            , t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t7, t71, t72, t73, t74
            , t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t8
            , t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m
            , t8n, t8o, t8p, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i
            , t9j, t9k, t9l, t9m, t9n, t9o;
    {long i; for(i = 0; i <= 15; i++) {
        {long i2; for(i2 = 0; i2 <= 7; i2++) {
            a = (src + i + (16*i2));
            a2 = (a + 1024);
            t = (*(a) + *(a2));
            t2 = (*(a) - *(a2));
            a3 = (a + 512);
            a4 = (a + 1536);
            t3 = (*(a3) + *(a4));
            t4 = (*(a3) - *(a4));
            a5 = (a + 128);
            a6 = (a + 1152);
            t5 = (*(a5) + *(a6));
            t6 = (*(a5) - *(a6));
            a7 = (a + 640);
            a8 = (a + 1664);
            t7 = (*(a7) + *(a8));
            t8 = (*(a7) - *(a8));
            a9 = (a + 256);
            a01 = (a + 1280);
            t9 = (*(a9) + *(a01));
            a11 = (a + 768);
            a21 = (a + 1792);
            t01 = (*(a11) + *(a21));
            a31 = (a + 384);
            a41 = (a + 1408);
            t11 = (*(a31) + *(a41));
            t21 = (*(a31) - *(a41));
            a51 = (a + 896);
            a61 = (a + 1920);
            t31 = (*(a51) + *(a61));
            t41 = (*(a51) - *(a61));
            t51 = (t + t3);
            t61 = (t - t3);
            t71 = (t9 + t01);
            t81 = (t9 - t01);
            t91 = (t5 + t7);
            t02 = (t11 + t31);
            a71 = (T2 + i2);
            *(a71) = (t51 + t71);
            *((a71 + 64)) = (t51 - t71);
            *((a71 + 8)) = (t91 + t02);
            *((a71 + 72)) = (t02 - t91);
            a81 = (0.70710678118654757*(t5 - t7));
            a91 = (0.70710678118654757*(t11 - t31));
            s = (a81 - a91);
            s2 = (a81 + a91);
            *((a71 + 32)) = (t61 + s);
            *((a71 + 40)) = -((t81 + s2));
            *((a71 + 96)) = (t61 - s);
            *((a71 + 104)) = (t81 - s2);
            s3 = ((0.92387953251128674*t6) - (0.38268343236508978*t8));
            s4 = ((0.38268343236508978*t6) + (0.92387953251128674*t8));
            a02 = (0.70710678118654757*(*(a9) - *(a01)));
            a12 = (0.70710678118654757*(*(a11) - *(a21)));
            s5 = (a02 - a12);
            s6 = (a02 + a12);
            s7 = ((0.38268343236508978*t21) - (0.92387953251128674*t41));
            s8 = ((0.92387953251128674*t21) + (0.38268343236508978*t41));
            t12 = (t2 + s5);
            t22 = (t4 + s6);
            t32 = (t2 - s5);
            t42 = (s6 - t4);
            t52 = (s3 + s7);
            t62 = (s4 + s8);
            t72 = (s3 - s7);
            t82 = (s8 - s4);
            *((a71 + 16)) = (t12 + t52);
            *((a71 + 24)) = -((t22 + t62));
            *((a71 + 112)) = (t12 - t52);
            *((a71 + 120)) = (t22 - t62);
            *((a71 + 80)) = (t32 + t82);
            *((a71 + 88)) = (t42 - t72);
            *((a71 + 48)) = (t32 - t82);
            *((a71 + 56)) = -((t42 + t72));
        }}
        a22 = (T2 + 8);
        t92 = (*(T2) + *(a22));
        t03 = (*(T2) - *(a22));
        a32 = (T2 + 4);
        a42 = (T2 + 12);
        t13 = (*(a32) + *(a42));
        t23 = (*(a32) - *(a42));
        a52 = (T2 + 1);
        a62 = (T2 + 9);
        t33 = (*(a52) + *(a62));
        t43 = (*(a52) - *(a62));
        a72 = (T2 + 5);
        a82 = (T2 + 13);
        t53 = (*(a72) + *(a82));
        t63 = (*(a72) - *(a82));
        a92 = (T2 + 2);
        a03 = (T2 + 10);
        t73 = (*(a92) + *(a03));
        a13 = (T2 + 6);
        a23 = (T2 + 14);
        t83 = (*(a13) + *(a23));
        a33 = (T2 + 3);
        a43 = (T2 + 11);
        t93 = (*(a33) + *(a43));
        t04 = (*(a33) - *(a43));
        a53 = (T2 + 7);
        a63 = (T2 + 15);
        t14 = (*(a53) + *(a63));
        t24 = (*(a53) - *(a63));
        t34 = (t92 + t13);
        t44 = (t92 - t13);
        t54 = (t73 + t83);
        t64 = (t73 - t83);
        t74 = (t33 + t53);
        t84 = (t93 + t14);
        a73 = (T + i);
        *(a73) = (t34 + t54);
        *((a73 + 1024)) = (t34 - t54);
        *((a73 + 16)) = (t74 + t84);
        *((a73 + 1040)) = (t84 - t74);
        a83 = (0.70710678118654757*(t33 - t53));
        a93 = (0.70710678118654757*(t93 - t14));
        s9 = (a83 - a93);
        s01 = (a83 + a93);
        *((a73 + 512)) = (t44 + s9);
        *((a73 + 528)) = -((t64 + s01));
        *((a73 + 1536)) = (t44 - s9);
        *((a73 + 1552)) = (t64 - s01);
        s11 = ((0.92387953251128674*t43) - (0.38268343236508978*t63));
        s21 = ((0.38268343236508978*t43) + (0.92387953251128674*t63));
        a04 = (0.70710678118654757*(*(a92) - *(a03)));
        a14 = (0.70710678118654757*(*(a13) - *(a23)));
        s31 = (a04 - a14);
        s41 = (a04 + a14);
        s51 = ((0.38268343236508978*t04) - (0.92387953251128674*t24));
        s61 = ((0.92387953251128674*t04) + (0.38268343236508978*t24));
        t94 = (t03 + s31);
        t05 = (t23 + s41);
        t15 = (t03 - s31);
        t25 = (s41 - t23);
        t35 = (s11 + s51);
        t45 = (s21 + s61);
        t55 = (s11 - s51);
        t65 = (s61 - s21);
        *((a73 + 256)) = (t94 + t35);
        *((a73 + 272)) = -((t05 + t45));
        *((a73 + 1792)) = (t94 - t35);
        *((a73 + 1808)) = (t05 - t45);
        *((a73 + 1280)) = (t15 + t65);
        *((a73 + 1296)) = (t25 - t55);
        *((a73 + 768)) = (t15 - t65);
        *((a73 + 784)) = -((t25 + t55));
        {long i3; for(i3 = 0; i3 <= 6; i3++) {
            a24 = (16*i3);
            b = (T2 + a24);
            a34 = (b + 16);
            a44 = (b + 24);
            a54 = (b + 17);
            a64 = (b + 25);
            a74 = (b + 18);
            a84 = (b + 26);
            a94 = (b + 19);
            a05 = (b + 27);
            a15 = (b + 20);
            a25 = (b + 28);
            a35 = (b + 21);
            a45 = (b + 29);
            a55 = (b + 22);
            a65 = (b + 30);
            a75 = (b + 23);
            a85 = (b + 31);
            a95 = (D273 + a24);
            a06 = (a95 + 1);
            s71 = ((*(a95)**(a34)) - (*(a06)**(a44)));
            s81 = ((*(a06)**(a34)) + (*(a95)**(a44)));
            a16 = (a95 + 2);
            a26 = (a95 + 3);
            s91 = ((*(a16)**(a54)) - (*(a26)**(a64)));
            s02 = ((*(a26)**(a54)) + (*(a16)**(a64)));
            a36 = (a95 + 4);
            a46 = (a95 + 5);
            s12 = ((*(a36)**(a74)) - (*(a46)**(a84)));
            s22 = ((*(a46)**(a74)) + (*(a36)**(a84)));
            a56 = (a95 + 6);
            a66 = (a95 + 7);
            s32 = ((*(a56)**(a94)) - (*(a66)**(a05)));
            s42 = ((*(a66)**(a94)) + (*(a56)**(a05)));
            a76 = (a95 + 8);
            a86 = (a95 + 9);
            s52 = ((*(a76)**(a15)) - (*(a86)**(a25)));
            s62 = ((*(a86)**(a15)) + (*(a76)**(a25)));
            a96 = (a95 + 10);
            a07 = (a95 + 11);
            s72 = ((*(a96)**(a35)) - (*(a07)**(a45)));
            s82 = ((*(a07)**(a35)) + (*(a96)**(a45)));
            a17 = (a95 + 12);
            a27 = (a95 + 13);
            s92 = ((*(a17)**(a55)) - (*(a27)**(a65)));
            s03 = ((*(a27)**(a55)) + (*(a17)**(a65)));
            a37 = (a95 + 14);
            a47 = (a95 + 15);
            s13 = ((*(a37)**(a75)) - (*(a47)**(a85)));
            s23 = ((*(a47)**(a75)) + (*(a37)**(a85)));
            t75 = (s71 + s52);
            t85 = (s81 + s62);
            t95 = (s71 - s52);
            t06 = (s81 - s62);
            t16 = (s12 + s92);
            t26 = (s22 + s03);
            t36 = (s12 - s92);
            t46 = (s22 - s03);
            t56 = (t75 + t16);
            t66 = (t85 + t26);
            t76 = (t75 - t16);
            t86 = (t85 - t26);
            t96 = (t95 + t46);
            t07 = (t06 - t36);
            t17 = (t95 - t46);
            t27 = (t06 + t36);
            t37 = (s91 + s72);
            t47 = (s02 + s82);
            t57 = (s91 - s72);
            t67 = (s02 - s82);
            t77 = (s32 + s13);
            t87 = (s42 + s23);
            t97 = (s32 - s13);
            t08 = (s42 - s23);
            t18 = (t37 + t77);
            t28 = (t47 + t87);
            t38 = (t37 - t77);
            t48 = (t47 - t87);
            a57 = (0.70710678118654757*(t57 + t08));
            a67 = (0.70710678118654757*(t67 - t97));
            s33 = (a57 + a67);
            s43 = (a67 - a57);
            a77 = (0.70710678118654757*(t67 + t97));
            a87 = (0.70710678118654757*(t57 - t08));
            s53 = (a77 - a87);
            s63 = (a87 + a77);
            a97 = (32*i3);
            b2 = (T + i);
            b3 = (b2 + a97);
            *((b3 + 32)) = (t56 + t18);
            *((b3 + 48)) = (t66 + t28);
            b4 = (b2 - a97);
            *((b4 + 2016)) = (t56 - t18);
            *((b4 + 2032)) = (t28 - t66);
            *((b3 + 544)) = (t96 + s33);
            *((b3 + 560)) = (t07 + s43);
            *((b4 + 1504)) = (t96 - s33);
            *((b4 + 1520)) = (s43 - t07);
            *((b3 + 1056)) = (t76 + t48);
            *((b3 + 1072)) = (t86 - t38);
            *((b4 + 992)) = (t76 - t48);
            *((b4 + 1008)) = -((t86 + t38));
            *((b3 + 1568)) = (t17 + s53);
            *((b3 + 1584)) = (t27 - s63);
            *((b4 + 480)) = (t17 - s53);
            *((b4 + 496)) = -((t27 + s63));
        }}
    }}
    a08 = (T + 16);
    t58 = (*(T) + *(a08));
    t68 = (*(T) - *(a08));
    a18 = (T + 8);
    a28 = (T + 24);
    t78 = (*(a18) + *(a28));
    t88 = (*(a18) - *(a28));
    a38 = (T + 4);
    a48 = (T + 20);
    t98 = (*(a38) + *(a48));
    a58 = (T + 12);
    a68 = (T + 28);
    t09 = (*(a58) + *(a68));
    t19 = (t58 + t78);
    t29 = (t58 - t78);
    t39 = (t98 + t09);
    t49 = (t98 - t09);
    a78 = (0.70710678118654757*(*(a38) - *(a48)));
    a88 = (0.70710678118654757*(*(a58) - *(a68)));
    s73 = (a78 - a88);
    s83 = (a78 + a88);
    t59 = (t68 + s73);
    t69 = (t88 + s83);
    t79 = (t68 - s73);
    t89 = (s83 - t88);
    a98 = (T + 1);
    a09 = (T + 17);
    t99 = (*(a98) + *(a09));
    t0a = (*(a98) - *(a09));
    a19 = (T + 9);
    a29 = (T + 25);
    t1a = (*(a19) + *(a29));
    t2a = (*(a19) - *(a29));
    a39 = (T + 5);
    a49 = (T + 21);
    t3a = (*(a39) + *(a49));
    a59 = (T + 13);
    a69 = (T + 29);
    t4a = (*(a59) + *(a69));
    t5a = (t99 + t1a);
    t6a = (t99 - t1a);
    t7a = (t3a + t4a);
    t8a = (t3a - t4a);
    a79 = (0.70710678118654757*(*(a39) - *(a49)));
    a89 = (0.70710678118654757*(*(a59) - *(a69)));
    s93 = (a79 - a89);
    s04 = (a79 + a89);
    t9a = (t0a + s93);
    t0b = (t2a + s04);
    t1b = (t0a - s93);
    t2b = (s04 - t2a);
    a99 = (T + 2);
    a0a = (T + 18);
    t3b = (*(a99) + *(a0a));
    t4b = (*(a99) - *(a0a));
    a1a = (T + 10);
    a2a = (T + 26);
    t5b = (*(a1a) + *(a2a));
    t6b = (*(a1a) - *(a2a));
    a3a = (T + 6);
    a4a = (T + 22);
    t7b = (*(a3a) + *(a4a));
    a5a = (T + 14);
    a6a = (T + 30);
    t8b = (*(a5a) + *(a6a));
    t9b = (t3b + t5b);
    t0c = (t7b + t8b);
    a7a = (0.70710678118654757*(*(a3a) - *(a4a)));
    a8a = (0.70710678118654757*(*(a5a) - *(a6a)));
    s14 = (a7a - a8a);
    s24 = (a7a + a8a);
    t1c = (t4b + s14);
    t2c = (t6b + s24);
    t3c = (t4b - s14);
    t4c = (s24 - t6b);
    a9a = (T + 3);
    a0b = (T + 19);
    t5c = (*(a9a) + *(a0b));
    t6c = (*(a9a) - *(a0b));
    a1b = (T + 11);
    a2b = (T + 27);
    t7c = (*(a1b) + *(a2b));
    t8c = (*(a1b) - *(a2b));
    a3b = (T + 7);
    a4b = (T + 23);
    t9c = (*(a3b) + *(a4b));
    a5b = (T + 15);
    a6b = (T + 31);
    t0d = (*(a5b) + *(a6b));
    t1d = (t5c + t7c);
    t2d = (t5c - t7c);
    t3d = (t9c + t0d);
    t4d = (t9c - t0d);
    a7b = (0.70710678118654757*(*(a3b) - *(a4b)));
    a8b = (0.70710678118654757*(*(a5b) - *(a6b)));
    s34 = (a7b - a8b);
    s44 = (a7b + a8b);
    t5d = (t6c + s34);
    t6d = (t8c + s44);
    t7d = (t6c - s34);
    t8d = (s44 - t8c);
    t9d = (t19 + t39);
    t0e = (t19 - t39);
    t1e = (t9b + t0c);
    t2e = (t9b - t0c);
    t3e = (t5a + t7a);
    t4e = (t1d + t3d);
    t5e = (t9d + t1e);
    t6e = (t3e + t4e);
    *(dst) = (t5e + t6e);
    *((dst + 1)) = (t5e - t6e);
    *((dst + 1024)) = (t9d - t1e);
    *((dst + 1025)) = (t4e - t3e);
    a9b = (0.70710678118654757*(t5a - t7a));
    a0c = (0.70710678118654757*(t1d - t3d));
    s54 = (a9b - a0c);
    s64 = (a9b + a0c);
    *((dst + 512)) = (t0e + s54);
    *((dst + 513)) = -((t2e + s64));
    *((dst + 1536)) = (t0e - s54);
    *((dst + 1537)) = (t2e - s64);
    s74 = ((0.98078528040323043*t9a) - (0.19509032201612828*t0b));
    s84 = ((0.19509032201612828*t9a) + (0.98078528040323043*t0b));
    s94 = ((0.92387953251128674*t1c) - (0.38268343236508978*t2c));
    s05 = ((0.38268343236508978*t1c) + (0.92387953251128674*t2c));
    s15 = ((0.83146961230254524*t5d) - (0.55557023301960218*t6d));
    s25 = ((0.55557023301960218*t5d) + (0.83146961230254524*t6d));
    t7e = (t59 + s94);
    t8e = (t69 + s05);
    t9e = (t59 - s94);
    t0f = (s05 - t69);
    t1f = (s74 + s15);
    t2f = (s84 + s25);
    t3f = (s74 - s15);
    t4f = (s25 - s84);
    *((dst + 128)) = (t7e + t1f);
    *((dst + 129)) = -((t8e + t2f));
    *((dst + 1920)) = (t7e - t1f);
    *((dst + 1921)) = (t8e - t2f);
    *((dst + 1152)) = (t9e + t4f);
    *((dst + 1153)) = (t0f - t3f);
    *((dst + 896)) = (t9e - t4f);
    *((dst + 897)) = -((t0f + t3f));
    s35 = ((0.92387953251128674*t6a) - (0.38268343236508978*t8a));
    s45 = ((0.38268343236508978*t6a) + (0.92387953251128674*t8a));
    a1c = (0.70710678118654757*(t3b - t5b));
    a2c = (0.70710678118654757*(t7b - t8b));
    s55 = (a1c - a2c);
    s65 = (a1c + a2c);
    s75 = ((0.38268343236508978*t2d) - (0.92387953251128674*t4d));
    s85 = ((0.92387953251128674*t2d) + (0.38268343236508978*t4d));
    t5f = (t29 + s55);
    t6f = (t49 + s65);
    t7f = (t29 - s55);
    t8f = (s65 - t49);
    t9f = (s35 + s75);
    t0g = (s45 + s85);
    t1g = (s35 - s75);
    t2g = (s85 - s45);
    *((dst + 256)) = (t5f + t9f);
    *((dst + 257)) = -((t6f + t0g));
    *((dst + 1792)) = (t5f - t9f);
    *((dst + 1793)) = (t6f - t0g);
    *((dst + 1280)) = (t7f + t2g);
    *((dst + 1281)) = (t8f - t1g);
    *((dst + 768)) = (t7f - t2g);
    *((dst + 769)) = -((t8f + t1g));
    s95 = ((0.83146961230254524*t1b) - (0.55557023301960218*t2b));
    s06 = ((0.55557023301960218*t1b) + (0.83146961230254524*t2b));
    s16 = ((0.38268343236508978*t3c) - (0.92387953251128674*t4c));
    s26 = ((0.92387953251128674*t3c) + (0.38268343236508978*t4c));
    s36 = ((0.19509032201612828*t7d) + (0.98078528040323043*t8d));
    s46 = ((0.19509032201612828*t8d) - (0.98078528040323043*t7d));
    t3g = (t79 + s16);
    t4g = (t89 + s26);
    t5g = (t79 - s16);
    t6g = (s26 - t89);
    t7g = (s95 - s36);
    t8g = (s46 - s06);
    t9g = (s95 + s36);
    t0h = (s06 + s46);
    *((dst + 384)) = (t3g + t7g);
    *((dst + 385)) = (t8g - t4g);
    *((dst + 1664)) = (t3g - t7g);
    *((dst + 1665)) = (t4g + t8g);
    *((dst + 1408)) = (t5g - t0h);
    *((dst + 1409)) = (t6g - t9g);
    *((dst + 640)) = (t5g + t0h);
    *((dst + 641)) = -((t6g + t9g));
    {long i4; for(i4 = 0; i4 <= 62; i4++) {
        a3c = (32*i4);
        b5 = (T + a3c);
        a4c = (b5 + 32);
        a5c = (b5 + 48);
        a6c = (b5 + 33);
        a7c = (b5 + 49);
        a8c = (b5 + 34);
        a9c = (b5 + 50);
        a0d = (b5 + 35);
        a1d = (b5 + 51);
        a2d = (b5 + 36);
        a3d = (b5 + 52);
        a4d = (b5 + 37);
        a5d = (b5 + 53);
        a6d = (b5 + 38);
        a7d = (b5 + 54);
        a8d = (b5 + 39);
        a9d = (b5 + 55);
        a0e = (b5 + 40);
        a1e = (b5 + 56);
        a2e = (b5 + 41);
        a3e = (b5 + 57);
        a4e = (b5 + 42);
        a5e = (b5 + 58);
        a6e = (b5 + 43);
        a7e = (b5 + 59);
        a8e = (b5 + 44);
        a9e = (b5 + 60);
        a0f = (b5 + 45);
        a1f = (b5 + 61);
        a2f = (b5 + 46);
        a3f = (b5 + 62);
        a4f = (b5 + 47);
        a5f = (b5 + 63);
        a6f = (D272 + a3c);
        a7f = (a6f + 1);
        s56 = ((*(a6f)**(a4c)) - (*(a7f)**(a5c)));
        s66 = ((*(a7f)**(a4c)) + (*(a6f)**(a5c)));
        a8f = (a6f + 2);
        a9f = (a6f + 3);
        s76 = ((*(a8f)**(a6c)) - (*(a9f)**(a7c)));
        s86 = ((*(a9f)**(a6c)) + (*(a8f)**(a7c)));
        a0g = (a6f + 4);
        a1g = (a6f + 5);
        s96 = ((*(a0g)**(a8c)) - (*(a1g)**(a9c)));
        s07 = ((*(a1g)**(a8c)) + (*(a0g)**(a9c)));
        a2g = (a6f + 6);
        a3g = (a6f + 7);
        s17 = ((*(a2g)**(a0d)) - (*(a3g)**(a1d)));
        s27 = ((*(a3g)**(a0d)) + (*(a2g)**(a1d)));
        a4g = (a6f + 8);
        a5g = (a6f + 9);
        s37 = ((*(a4g)**(a2d)) - (*(a5g)**(a3d)));
        s47 = ((*(a5g)**(a2d)) + (*(a4g)**(a3d)));
        a6g = (a6f + 10);
        a7g = (a6f + 11);
        s57 = ((*(a6g)**(a4d)) - (*(a7g)**(a5d)));
        s67 = ((*(a7g)**(a4d)) + (*(a6g)**(a5d)));
        a8g = (a6f + 12);
        a9g = (a6f + 13);
        s77 = ((*(a8g)**(a6d)) - (*(a9g)**(a7d)));
        s87 = ((*(a9g)**(a6d)) + (*(a8g)**(a7d)));
        a0h = (a6f + 14);
        a1h = (a6f + 15);
        s97 = ((*(a0h)**(a8d)) - (*(a1h)**(a9d)));
        s08 = ((*(a1h)**(a8d)) + (*(a0h)**(a9d)));
        a2h = (a6f + 16);
        a3h = (a6f + 17);
        s18 = ((*(a2h)**(a0e)) - (*(a3h)**(a1e)));
        s28 = ((*(a3h)**(a0e)) + (*(a2h)**(a1e)));
        a4h = (a6f + 18);
        a5h = (a6f + 19);
        s38 = ((*(a4h)**(a2e)) - (*(a5h)**(a3e)));
        s48 = ((*(a5h)**(a2e)) + (*(a4h)**(a3e)));
        a6h = (a6f + 20);
        a7h = (a6f + 21);
        s58 = ((*(a6h)**(a4e)) - (*(a7h)**(a5e)));
        s68 = ((*(a7h)**(a4e)) + (*(a6h)**(a5e)));
        a8h = (a6f + 22);
        a9h = (a6f + 23);
        s78 = ((*(a8h)**(a6e)) - (*(a9h)**(a7e)));
        s88 = ((*(a9h)**(a6e)) + (*(a8h)**(a7e)));
        a0i = (a6f + 24);
        a1i = (a6f + 25);
        s98 = ((*(a0i)**(a8e)) - (*(a1i)**(a9e)));
        s09 = ((*(a1i)**(a8e)) + (*(a0i)**(a9e)));
        a2i = (a6f + 26);
        a3i = (a6f + 27);
        s19 = ((*(a2i)**(a0f)) - (*(a3i)**(a1f)));
        s29 = ((*(a3i)**(a0f)) + (*(a2i)**(a1f)));
        a4i = (a6f + 28);
        a5i = (a6f + 29);
        s39 = ((*(a4i)**(a2f)) - (*(a5i)**(a3f)));
        s49 = ((*(a5i)**(a2f)) + (*(a4i)**(a3f)));
        a6i = (a6f + 30);
        a7i = (a6f + 31);
        s59 = ((*(a6i)**(a4f)) - (*(a7i)**(a5f)));
        s69 = ((*(a7i)**(a4f)) + (*(a6i)**(a5f)));
        t1h = (s56 + s18);
        t2h = (s66 + s28);
        t3h = (s56 - s18);
        t4h = (s66 - s28);
        t5h = (s37 + s98);
        t6h = (s47 + s09);
        t7h = (s37 - s98);
        t8h = (s47 - s09);
        t9h = (t1h + t5h);
        t0i = (t2h + t6h);
        t1i = (t1h - t5h);
        t2i = (t2h - t6h);
        t3i = (t3h + t8h);
        t4i = (t4h - t7h);
        t5i = (t3h - t8h);
        t6i = (t4h + t7h);
        t7i = (s76 + s38);
        t8i = (s86 + s48);
        t9i = (s76 - s38);
        t0j = (s86 - s48);
        t1j = (s57 + s19);
        t2j = (s67 + s29);
        t3j = (s57 - s19);
        t4j = (s67 - s29);
        t5j = (t7i + t1j);
        t6j = (t8i + t2j);
        a8i = (0.70710678118654757*(t7i - t1j));
        a9i = (0.70710678118654757*(t8i - t2j));
        s79 = (a8i + a9i);
        s89 = (a9i - a8i);
        t7j = (t9i + t4j);
        t8j = (t0j - t3j);
        t9j = (t9i - t4j);
        t0k = (t0j + t3j);
        s99 = ((0.92387953251128674*t7j) + (0.38268343236508978*t8j));
        s0a = ((0.92387953251128674*t8j) - (0.38268343236508978*t7j));
        s1a = ((0.38268343236508978*t9j) + (0.92387953251128674*t0k));
        s2a = ((0.38268343236508978*t0k) - (0.92387953251128674*t9j));
        t1k = (s96 + s58);
        t2k = (s07 + s68);
        t3k = (s96 - s58);
        t4k = (s07 - s68);
        t5k = (s77 + s39);
        t6k = (s87 + s49);
        t7k = (s77 - s39);
        t8k = (s87 - s49);
        t9k = (t1k + t5k);
        t0l = (t2k + t6k);
        t1l = (t1k - t5k);
        t2l = (t2k - t6k);
        a0j = (0.70710678118654757*(t3k + t8k));
        a1j = (0.70710678118654757*(t4k - t7k));
        s3a = (a0j + a1j);
        s4a = (a1j - a0j);
        a2j = (0.70710678118654757*(t4k + t7k));
        a3j = (0.70710678118654757*(t3k - t8k));
        s5a = (a2j - a3j);
        s6a = (a3j + a2j);
        t3l = (s17 + s78);
        t4l = (s27 + s88);
        t5l = (s17 - s78);
        t6l = (s27 - s88);
        t7l = (s97 + s59);
        t8l = (s08 + s69);
        t9l = (s97 - s59);
        t0m = (s08 - s69);
        t1m = (t3l + t7l);
        t2m = (t4l + t8l);
        a4j = (0.70710678118654757*(t4l - t8l));
        a5j = (0.70710678118654757*(t3l - t7l));
        s7a = (a4j - a5j);
        s8a = (a5j + a4j);
        t3m = (t5l + t0m);
        t4m = (t6l - t9l);
        t5m = (t5l - t0m);
        t6m = (t6l + t9l);
        s9a = ((0.38268343236508978*t3m) + (0.92387953251128674*t4m));
        s0b = ((0.38268343236508978*t4m) - (0.92387953251128674*t3m));
        s1b = ((0.92387953251128674*t5m) + (0.38268343236508978*t6m));
        s2b = ((0.38268343236508978*t5m) - (0.92387953251128674*t6m));
        t7m = (t9h + t9k);
        t8m = (t0i + t0l);
        t9m = (t9h - t9k);
        t0n = (t0i - t0l);
        t1n = (t5j + t1m);
        t2n = (t6j + t2m);
        t3n = (t5j - t1m);
        t4n = (t6j - t2m);
        a6j = (2*i4);
        b6 = (dst + a6j);
        *((b6 + 2)) = (t7m + t1n);
        *((b6 + 3)) = (t8m + t2n);
        b7 = (dst - a6j);
        *((b7 + 2046)) = (t7m - t1n);
        *((b7 + 2047)) = (t2n - t8m);
        *((b6 + 1026)) = (t9m + t4n);
        *((b6 + 1027)) = (t0n - t3n);
        *((b7 + 1022)) = (t9m - t4n);
        *((b7 + 1023)) = -((t0n + t3n));
        t5n = (t3i + s3a);
        t6n = (t4i + s4a);
        t7n = (t3i - s3a);
        t8n = (t4i - s4a);
        t9n = (s99 + s9a);
        t0o = (s0a + s0b);
        t1o = (s99 - s9a);
        t2o = (s0a - s0b);
        *((b6 + 258)) = (t5n + t9n);
        *((b6 + 259)) = (t6n + t0o);
        *((b7 + 1790)) = (t5n - t9n);
        *((b7 + 1791)) = (t0o - t6n);
        *((b6 + 1282)) = (t7n + t2o);
        *((b6 + 1283)) = (t8n - t1o);
        *((b7 + 766)) = (t7n - t2o);
        *((b7 + 767)) = -((t8n + t1o));
        t3o = (t1i + t2l);
        t4o = (t2i - t1l);
        t5o = (t1i - t2l);
        t6o = (t2i + t1l);
        t7o = (s79 + s7a);
        t8o = (s89 - s8a);
        t9o = (s79 - s7a);
        t0p = (s89 + s8a);
        *((b6 + 514)) = (t3o + t7o);
        *((b6 + 515)) = (t4o + t8o);
        *((b7 + 1534)) = (t3o - t7o);
        *((b7 + 1535)) = (t8o - t4o);
        *((b6 + 1538)) = (t5o + t0p);
        *((b6 + 1539)) = (t6o - t9o);
        *((b7 + 510)) = (t5o - t0p);
        *((b7 + 511)) = -((t6o + t9o));
        t1p = (t5i + s5a);
        t2p = (t6i - s6a);
        t3p = (t5i - s5a);
        t4p = (t6i + s6a);
        t5p = (s1a - s1b);
        t6p = (s2a + s2b);
        t7p = (s1a + s1b);
        t8p = (s2a - s2b);
        *((b6 + 770)) = (t1p + t5p);
        *((b6 + 771)) = (t2p + t6p);
        *((b7 + 1278)) = (t1p - t5p);
        *((b7 + 1279)) = (t6p - t2p);
        *((b6 + 1794)) = (t3p + t8p);
        *((b6 + 1795)) = (t4p - t7p);
        *((b7 + 254)) = (t3p - t8p);
        *((b7 + 255)) = -((t4p + t7p));
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftfwd_double_4096)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[4096];
     double T2[512];
    double  *a05, *a06, *a07, *a08, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0h, *a0i, *a0j, *a0k, *a0l, *a14, *a15, *a16, *a17, *a18, *a19, *a1a
            , *a1b, *a1c, *a1d, *a1e, *a1f, *a1j, *a1k, *a1l, *a25, *a26, *a27, *a28, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2j, *a2k, *a2l
            , *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3f, *a3h, *a3j, *a3k, *a3l, *a49, *a4a, *a4b, *a4c, *a4d, *a4e, *a4f, *a4g, *a4h, *a4j, *a4k
            , *a4l, *a55, *a56, *a57, *a58, *a59, *a5a, *a5b, *a5c, *a5d, *a5e, *a5g, *a5h, *a5j, *a5k, *a5l, *a64, *a65, *a66, *a67, *a69, *a6a
            , *a6b, *a6c, *a6d, *a6e, *a6g, *a6h, *a6i, *a6j, *a6k, *a6l, *a74, *a75, *a76, *a77, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7g, *a7h
            , *a7i, *a7j, *a7k, *a7l, *a84, *a85, *a86, *a87, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8g, *a8h, *a8i, *a8j, *a8k, *a94, *a95, *a96
            , *a97, *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9g, *a9h, *a9i, *a9j, *a9k, *b, *b2, *b3, *b4, *b5, *b6, *b7;
    const double  *a, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52, *a53, *a6, *a61
            , *a62, *a63, *a7, *a71, *a72, *a73, *a8, *a81, *a82, *a83;
    int a09, a2m, a3g, a5i;
    double a01, a02, a03, a04, a0g, a0m, a1g, a1h, a1i, a1m, a24, a2g, a2h, a2i, a34, a35, a36, a37, a38, a3i, a44, a45
            , a46, a47, a48, a4i, a54, a5f, a68, a6f, a78, a7f, a88, a8f, a8l, a9, a91, a92, a93, a98, a9f, a9l, s, s01
            , s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b, s0c, s0d, s11, s12, s13, s14, s15, s16, s17, s18, s19, s1a
            , s1b, s1c, s1d, s2, s21, s22, s23, s24, s25, s26, s27, s28, s29, s2a, s2b, s2c, s2d, s3, s31, s32, s33, s34
            , s35, s36, s37, s38, s39, s3a, s3b, s3c, s3d, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a, s4b, s4c
            , s4d, s5, s51, s52, s53, s54, s55, s56, s57, s58, s59, s5a, s5b, s5c, s6, s61, s62, s63, s64, s65, s66, s67
            , s68, s69, s6a, s6b, s6c, s7, s71, s72, s73, s74, s75, s76, s77, s78, s79, s7a, s7b, s7c, s8, s81, s82, s83
            , s84, s85, s86, s87, s88, s89, s8a, s8b, s8c, s9, s91, s92, s93, s94, s95, s96, s97, s98, s99, s9a, s9b, s9c
            , t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l
            , t0m, t0n, t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c
            , t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t1u, t1v, t2, t21, t22
            , t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o
            , t2p, t2q, t2r, t2s, t2t, t2u, t2v, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e
            , t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t4, t41, t42, t43, t44, t45
            , t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r
            , t4s, t4t, t4u, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i
            , t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t, t5u, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69
            , t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t7
            , t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m
            , t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d
            , t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t9, t91, t92, t93, t94
            , t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q
            , t9r, t9s, t9t, t9u;
    {long i; for(i = 0; i <= 7; i++) {
        {long i2; for(i2 = 0; i2 <= 15; i2++) {
            a = (src + i + (8*i2));
            a2 = (a + 2048);
            t = (*(a) + *(a2));
            t2 = (*(a) - *(a2));
            a3 = (a + 1024);
            a4 = (a + 3072);
            t3 = (*(a3) + *(a4));
            t4 = (*(a3) - *(a4));
            a5 = (a + 512);
            a6 = (a + 2560);
            t5 = (*(a5) + *(a6));
            a7 = (a + 1536);
            a8 = (a + 3584);
            t6 = (*(a7) + *(a8));
            t7 = (t + t3);
            t8 = (t - t3);
            t9 = (t5 + t6);
            t01 = (t5 - t6);
            a9 = (0.70710678118654757*(*(a5) - *(a6)));
            a01 = (0.70710678118654757*(*(a7) - *(a8)));
            s = (a9 - a01);
            s2 = (a9 + a01);
            t11 = (t2 + s);
            t21 = (t4 + s2);
            t31 = (t2 - s);
            t41 = (s2 - t4);
            a11 = (a + 128);
            a21 = (a + 2176);
            t51 = (*(a11) + *(a21));
            t61 = (*(a11) - *(a21));
            a31 = (a + 1152);
            a41 = (a + 3200);
            t71 = (*(a31) + *(a41));
            t81 = (*(a31) - *(a41));
            a51 = (a + 640);
            a61 = (a + 2688);
            t91 = (*(a51) + *(a61));
            a71 = (a + 1664);
            a81 = (a + 3712);
            t02 = (*(a71) + *(a81));
            t12 = (t51 + t71);
            t22 = (t51 - t71);
            t32 = (t91 + t02);
            t42 = (t91 - t02);
            a91 = (0.70710678118654757*(*(a51) - *(a61)));
            a02 = (0.70710678118654757*(*(a71) - *(a81)));
            s3 = (a91 - a02);
            s4 = (a91 + a02);
            t52 = (t61 + s3);
            t62 = (t81 + s4);
            t72 = (t61 - s3);
            t82 = (s4 - t81);
            a12 = (a + 256);
            a22 = (a + 2304);
            t92 = (*(a12) + *(a22));
            t03 = (*(a12) - *(a22));
            a32 = (a + 1280);
            a42 = (a + 3328);
            t13 = (*(a32) + *(a42));
            t23 = (*(a32) - *(a42));
            a52 = (a + 768);
            a62 = (a + 2816);
            t33 = (*(a52) + *(a62));
            a72 = (a + 1792);
            a82 = (a + 3840);
            t43 = (*(a72) + *(a82));
            t53 = (t92 + t13);
            t63 = (t33 + t43);
            a92 = (0.70710678118654757*(*(a52) - *(a62)));
            a03 = (0.70710678118654757*(*(a72) - *(a82)));
            s5 = (a92 - a03);
            s6 = (a92 + a03);
            t73 = (t03 + s5);
            t83 = (t23 + s6);
            t93 = (t03 - s5);
            t04 = (s6 - t23);
            a13 = (a + 384);
            a23 = (a + 2432);
            t14 = (*(a13) + *(a23));
            t24 = (*(a13) - *(a23));
            a33 = (a + 1408);
            a43 = (a + 3456);
            t34 = (*(a33) + *(a43));
            t44 = (*(a33) - *(a43));
            a53 = (a + 896);
            a63 = (a + 2944);
            t54 = (*(a53) + *(a63));
            a73 = (a + 1920);
            a83 = (a + 3968);
            t64 = (*(a73) + *(a83));
            t74 = (t14 + t34);
            t84 = (t14 - t34);
            t94 = (t54 + t64);
            t05 = (t54 - t64);
            a93 = (0.70710678118654757*(*(a53) - *(a63)));
            a04 = (0.70710678118654757*(*(a73) - *(a83)));
            s7 = (a93 - a04);
            s8 = (a93 + a04);
            t15 = (t24 + s7);
            t25 = (t44 + s8);
            t35 = (t24 - s7);
            t45 = (s8 - t44);
            t55 = (t7 + t9);
            t65 = (t7 - t9);
            t75 = (t53 + t63);
            t85 = (t53 - t63);
            t95 = (t12 + t32);
            t06 = (t74 + t94);
            a14 = (T2 + i2);
            *(a14) = (t55 + t75);
            *((a14 + 256)) = (t55 - t75);
            *((a14 + 16)) = (t95 + t06);
            *((a14 + 272)) = (t06 - t95);
            a24 = (0.70710678118654757*(t12 - t32));
            a34 = (0.70710678118654757*(t74 - t94));
            s9 = (a24 - a34);
            s01 = (a24 + a34);
            *((a14 + 128)) = (t65 + s9);
            *((a14 + 144)) = -((t85 + s01));
            *((a14 + 384)) = (t65 - s9);
            *((a14 + 400)) = (t85 - s01);
            s11 = ((0.98078528040323043*t52) - (0.19509032201612828*t62));
            s21 = ((0.19509032201612828*t52) + (0.98078528040323043*t62));
            s31 = ((0.92387953251128674*t73) - (0.38268343236508978*t83));
            s41 = ((0.38268343236508978*t73) + (0.92387953251128674*t83));
            s51 = ((0.83146961230254524*t15) - (0.55557023301960218*t25));
            s61 = ((0.55557023301960218*t15) + (0.83146961230254524*t25));
            t16 = (t11 + s31);
            t26 = (t21 + s41);
            t36 = (t11 - s31);
            t46 = (s41 - t21);
            t56 = (s11 + s51);
            t66 = (s21 + s61);
            t76 = (s11 - s51);
            t86 = (s61 - s21);
            *((a14 + 32)) = (t16 + t56);
            *((a14 + 48)) = -((t26 + t66));
            *((a14 + 480)) = (t16 - t56);
            *((a14 + 496)) = (t26 - t66);
            *((a14 + 288)) = (t36 + t86);
            *((a14 + 304)) = (t46 - t76);
            *((a14 + 224)) = (t36 - t86);
            *((a14 + 240)) = -((t46 + t76));
            s71 = ((0.92387953251128674*t22) - (0.38268343236508978*t42));
            s81 = ((0.38268343236508978*t22) + (0.92387953251128674*t42));
            a44 = (0.70710678118654757*(t92 - t13));
            a54 = (0.70710678118654757*(t33 - t43));
            s91 = (a44 - a54);
            s02 = (a44 + a54);
            s12 = ((0.38268343236508978*t84) - (0.92387953251128674*t05));
            s22 = ((0.92387953251128674*t84) + (0.38268343236508978*t05));
            t96 = (t8 + s91);
            t07 = (t01 + s02);
            t17 = (t8 - s91);
            t27 = (s02 - t01);
            t37 = (s71 + s12);
            t47 = (s81 + s22);
            t57 = (s71 - s12);
            t67 = (s22 - s81);
            *((a14 + 64)) = (t96 + t37);
            *((a14 + 80)) = -((t07 + t47));
            *((a14 + 448)) = (t96 - t37);
            *((a14 + 464)) = (t07 - t47);
            *((a14 + 320)) = (t17 + t67);
            *((a14 + 336)) = (t27 - t57);
            *((a14 + 192)) = (t17 - t67);
            *((a14 + 208)) = -((t27 + t57));
            s32 = ((0.83146961230254524*t72) - (0.55557023301960218*t82));
            s42 = ((0.55557023301960218*t72) + (0.83146961230254524*t82));
            s52 = ((0.38268343236508978*t93) - (0.92387953251128674*t04));
            s62 = ((0.92387953251128674*t93) + (0.38268343236508978*t04));
            s72 = ((0.19509032201612828*t35) + (0.98078528040323043*t45));
            s82 = ((0.19509032201612828*t45) - (0.98078528040323043*t35));
            t77 = (t31 + s52);
            t87 = (t41 + s62);
            t97 = (t31 - s52);
            t08 = (s62 - t41);
            t18 = (s32 - s72);
            t28 = (s82 - s42);
            t38 = (s32 + s72);
            t48 = (s42 + s82);
            *((a14 + 96)) = (t77 + t18);
            *((a14 + 112)) = (t28 - t87);
            *((a14 + 416)) = (t77 - t18);
            *((a14 + 432)) = (t87 + t28);
            *((a14 + 352)) = (t97 - t48);
            *((a14 + 368)) = (t08 - t38);
            *((a14 + 160)) = (t97 + t48);
            *((a14 + 176)) = -((t08 + t38));
        }}
        a64 = (T2 + 16);
        t58 = (*(T2) + *(a64));
        t68 = (*(T2) - *(a64));
        a74 = (T2 + 8);
        a84 = (T2 + 24);
        t78 = (*(a74) + *(a84));
        t88 = (*(a74) - *(a84));
        a94 = (T2 + 4);
        a05 = (T2 + 20);
        t98 = (*(a94) + *(a05));
        a15 = (T2 + 12);
        a25 = (T2 + 28);
        t09 = (*(a15) + *(a25));
        t19 = (t58 + t78);
        t29 = (t58 - t78);
        t39 = (t98 + t09);
        t49 = (t98 - t09);
        a35 = (0.70710678118654757*(*(a94) - *(a05)));
        a45 = (0.70710678118654757*(*(a15) - *(a25)));
        s92 = (a35 - a45);
        s03 = (a35 + a45);
        t59 = (t68 + s92);
        t69 = (t88 + s03);
        t79 = (t68 - s92);
        t89 = (s03 - t88);
        a55 = (T2 + 1);
        a65 = (T2 + 17);
        t99 = (*(a55) + *(a65));
        t0a = (*(a55) - *(a65));
        a75 = (T2 + 9);
        a85 = (T2 + 25);
        t1a = (*(a75) + *(a85));
        t2a = (*(a75) - *(a85));
        a95 = (T2 + 5);
        a06 = (T2 + 21);
        t3a = (*(a95) + *(a06));
        a16 = (T2 + 13);
        a26 = (T2 + 29);
        t4a = (*(a16) + *(a26));
        t5a = (t99 + t1a);
        t6a = (t99 - t1a);
        t7a = (t3a + t4a);
        t8a = (t3a - t4a);
        a36 = (0.70710678118654757*(*(a95) - *(a06)));
        a46 = (0.70710678118654757*(*(a16) - *(a26)));
        s13 = (a36 - a46);
        s23 = (a36 + a46);
        t9a = (t0a + s13);
        t0b = (t2a + s23);
        t1b = (t0a - s13);
        t2b = (s23 - t2a);
        a56 = (T2 + 2);
        a66 = (T2 + 18);
        t3b = (*(a56) + *(a66));
        t4b = (*(a56) - *(a66));
        a76 = (T2 + 10);
        a86 = (T2 + 26);
        t5b = (*(a76) + *(a86));
        t6b = (*(a76) - *(a86));
        a96 = (T2 + 6);
        a07 = (T2 + 22);
        t7b = (*(a96) + *(a07));
        a17 = (T2 + 14);
        a27 = (T2 + 30);
        t8b = (*(a17) + *(a27));
        t9b = (t3b + t5b);
        t0c = (t7b + t8b);
        a37 = (0.70710678118654757*(*(a96) - *(a07)));
        a47 = (0.70710678118654757*(*(a17) - *(a27)));
        s33 = (a37 - a47);
        s43 = (a37 + a47);
        t1c = (t4b + s33);
        t2c = (t6b + s43);
        t3c = (t4b - s33);
        t4c = (s43 - t6b);
        a57 = (T2 + 3);
        a67 = (T2 + 19);
        t5c = (*(a57) + *(a67));
        t6c = (*(a57) - *(a67));
        a77 = (T2 + 11);
        a87 = (T2 + 27);
        t7c = (*(a77) + *(a87));
        t8c = (*(a77) - *(a87));
        a97 = (T2 + 7);
        a08 = (T2 + 23);
        t9c = (*(a97) + *(a08));
        a18 = (T2 + 15);
        a28 = (T2 + 31);
        t0d = (*(a18) + *(a28));
        t1d = (t5c + t7c);
        t2d = (t5c - t7c);
        t3d = (t9c + t0d);
        t4d = (t9c - t0d);
        a38 = (0.70710678118654757*(*(a97) - *(a08)));
        a48 = (0.70710678118654757*(*(a18) - *(a28)));
        s53 = (a38 - a48);
        s63 = (a38 + a48);
        t5d = (t6c + s53);
        t6d = (t8c + s63);
        t7d = (t6c - s53);
        t8d = (s63 - t8c);
        t9d = (t19 + t39);
        t0e = (t19 - t39);
        t1e = (t9b + t0c);
        t2e = (t9b - t0c);
        t3e = (t5a + t7a);
        t4e = (t1d + t3d);
        a58 = (T + i);
        *(a58) = (t9d + t1e);
        *((a58 + 2048)) = (t9d - t1e);
        *((a58 + 8)) = (t3e + t4e);
        *((a58 + 2056)) = (t4e - t3e);
        a68 = (0.70710678118654757*(t5a - t7a));
        a78 = (0.70710678118654757*(t1d - t3d));
        s73 = (a68 - a78);
        s83 = (a68 + a78);
        *((a58 + 1024)) = (t0e + s73);
        *((a58 + 1032)) = -((t2e + s83));
        *((a58 + 3072)) = (t0e - s73);
        *((a58 + 3080)) = (t2e - s83);
        s93 = ((0.98078528040323043*t9a) - (0.19509032201612828*t0b));
        s04 = ((0.19509032201612828*t9a) + (0.98078528040323043*t0b));
        s14 = ((0.92387953251128674*t1c) - (0.38268343236508978*t2c));
        s24 = ((0.38268343236508978*t1c) + (0.92387953251128674*t2c));
        s34 = ((0.83146961230254524*t5d) - (0.55557023301960218*t6d));
        s44 = ((0.55557023301960218*t5d) + (0.83146961230254524*t6d));
        t5e = (t59 + s14);
        t6e = (t69 + s24);
        t7e = (t59 - s14);
        t8e = (s24 - t69);
        t9e = (s93 + s34);
        t0f = (s04 + s44);
        t1f = (s93 - s34);
        t2f = (s44 - s04);
        *((a58 + 256)) = (t5e + t9e);
        *((a58 + 264)) = -((t6e + t0f));
        *((a58 + 3840)) = (t5e - t9e);
        *((a58 + 3848)) = (t6e - t0f);
        *((a58 + 2304)) = (t7e + t2f);
        *((a58 + 2312)) = (t8e - t1f);
        *((a58 + 1792)) = (t7e - t2f);
        *((a58 + 1800)) = -((t8e + t1f));
        s54 = ((0.92387953251128674*t6a) - (0.38268343236508978*t8a));
        s64 = ((0.38268343236508978*t6a) + (0.92387953251128674*t8a));
        a88 = (0.70710678118654757*(t3b - t5b));
        a98 = (0.70710678118654757*(t7b - t8b));
        s74 = (a88 - a98);
        s84 = (a88 + a98);
        s94 = ((0.38268343236508978*t2d) - (0.92387953251128674*t4d));
        s05 = ((0.92387953251128674*t2d) + (0.38268343236508978*t4d));
        t3f = (t29 + s74);
        t4f = (t49 + s84);
        t5f = (t29 - s74);
        t6f = (s84 - t49);
        t7f = (s54 + s94);
        t8f = (s64 + s05);
        t9f = (s54 - s94);
        t0g = (s05 - s64);
        *((a58 + 512)) = (t3f + t7f);
        *((a58 + 520)) = -((t4f + t8f));
        *((a58 + 3584)) = (t3f - t7f);
        *((a58 + 3592)) = (t4f - t8f);
        *((a58 + 2560)) = (t5f + t0g);
        *((a58 + 2568)) = (t6f - t9f);
        *((a58 + 1536)) = (t5f - t0g);
        *((a58 + 1544)) = -((t6f + t9f));
        s15 = ((0.83146961230254524*t1b) - (0.55557023301960218*t2b));
        s25 = ((0.55557023301960218*t1b) + (0.83146961230254524*t2b));
        s35 = ((0.38268343236508978*t3c) - (0.92387953251128674*t4c));
        s45 = ((0.92387953251128674*t3c) + (0.38268343236508978*t4c));
        s55 = ((0.19509032201612828*t7d) + (0.98078528040323043*t8d));
        s65 = ((0.19509032201612828*t8d) - (0.98078528040323043*t7d));
        t1g = (t79 + s35);
        t2g = (t89 + s45);
        t3g = (t79 - s35);
        t4g = (s45 - t89);
        t5g = (s15 - s55);
        t6g = (s65 - s25);
        t7g = (s15 + s55);
        t8g = (s25 + s65);
        *((a58 + 768)) = (t1g + t5g);
        *((a58 + 776)) = (t6g - t2g);
        *((a58 + 3328)) = (t1g - t5g);
        *((a58 + 3336)) = (t2g + t6g);
        *((a58 + 2816)) = (t3g - t8g);
        *((a58 + 2824)) = (t4g - t7g);
        *((a58 + 1280)) = (t3g + t8g);
        *((a58 + 1288)) = -((t4g + t7g));
        {long i3; for(i3 = 0; i3 <= 14; i3++) {
            a09 = (32*i3);
            b = (T2 + a09);
            a19 = (b + 32);
            a29 = (b + 48);
            a39 = (b + 33);
            a49 = (b + 49);
            a59 = (b + 34);
            a69 = (b + 50);
            a79 = (b + 35);
            a89 = (b + 51);
            a99 = (b + 36);
            a0a = (b + 52);
            a1a = (b + 37);
            a2a = (b + 53);
            a3a = (b + 38);
            a4a = (b + 54);
            a5a = (b + 39);
            a6a = (b + 55);
            a7a = (b + 40);
            a8a = (b + 56);
            a9a = (b + 41);
            a0b = (b + 57);
            a1b = (b + 42);
            a2b = (b + 58);
            a3b = (b + 43);
            a4b = (b + 59);
            a5b = (b + 44);
            a6b = (b + 60);
            a7b = (b + 45);
            a8b = (b + 61);
            a9b = (b + 46);
            a0c = (b + 62);
            a1c = (b + 47);
            a2c = (b + 63);
            a3c = (D275 + a09);
            a4c = (a3c + 1);
            s75 = ((*(a3c)**(a19)) - (*(a4c)**(a29)));
            s85 = ((*(a4c)**(a19)) + (*(a3c)**(a29)));
            a5c = (a3c + 2);
            a6c = (a3c + 3);
            s95 = ((*(a5c)**(a39)) - (*(a6c)**(a49)));
            s06 = ((*(a6c)**(a39)) + (*(a5c)**(a49)));
            a7c = (a3c + 4);
            a8c = (a3c + 5);
            s16 = ((*(a7c)**(a59)) - (*(a8c)**(a69)));
            s26 = ((*(a8c)**(a59)) + (*(a7c)**(a69)));
            a9c = (a3c + 6);
            a0d = (a3c + 7);
            s36 = ((*(a9c)**(a79)) - (*(a0d)**(a89)));
            s46 = ((*(a0d)**(a79)) + (*(a9c)**(a89)));
            a1d = (a3c + 8);
            a2d = (a3c + 9);
            s56 = ((*(a1d)**(a99)) - (*(a2d)**(a0a)));
            s66 = ((*(a2d)**(a99)) + (*(a1d)**(a0a)));
            a3d = (a3c + 10);
            a4d = (a3c + 11);
            s76 = ((*(a3d)**(a1a)) - (*(a4d)**(a2a)));
            s86 = ((*(a4d)**(a1a)) + (*(a3d)**(a2a)));
            a5d = (a3c + 12);
            a6d = (a3c + 13);
            s96 = ((*(a5d)**(a3a)) - (*(a6d)**(a4a)));
            s07 = ((*(a6d)**(a3a)) + (*(a5d)**(a4a)));
            a7d = (a3c + 14);
            a8d = (a3c + 15);
            s17 = ((*(a7d)**(a5a)) - (*(a8d)**(a6a)));
            s27 = ((*(a8d)**(a5a)) + (*(a7d)**(a6a)));
            a9d = (a3c + 16);
            a0e = (a3c + 17);
            s37 = ((*(a9d)**(a7a)) - (*(a0e)**(a8a)));
            s47 = ((*(a0e)**(a7a)) + (*(a9d)**(a8a)));
            a1e = (a3c + 18);
            a2e = (a3c + 19);
            s57 = ((*(a1e)**(a9a)) - (*(a2e)**(a0b)));
            s67 = ((*(a2e)**(a9a)) + (*(a1e)**(a0b)));
            a3e = (a3c + 20);
            a4e = (a3c + 21);
            s77 = ((*(a3e)**(a1b)) - (*(a4e)**(a2b)));
            s87 = ((*(a4e)**(a1b)) + (*(a3e)**(a2b)));
            a5e = (a3c + 22);
            a6e = (a3c + 23);
            s97 = ((*(a5e)**(a3b)) - (*(a6e)**(a4b)));
            s08 = ((*(a6e)**(a3b)) + (*(a5e)**(a4b)));
            a7e = (a3c + 24);
            a8e = (a3c + 25);
            s18 = ((*(a7e)**(a5b)) - (*(a8e)**(a6b)));
            s28 = ((*(a8e)**(a5b)) + (*(a7e)**(a6b)));
            a9e = (a3c + 26);
            a0f = (a3c + 27);
            s38 = ((*(a9e)**(a7b)) - (*(a0f)**(a8b)));
            s48 = ((*(a0f)**(a7b)) + (*(a9e)**(a8b)));
            a1f = (a3c + 28);
            a2f = (a3c + 29);
            s58 = ((*(a1f)**(a9b)) - (*(a2f)**(a0c)));
            s68 = ((*(a2f)**(a9b)) + (*(a1f)**(a0c)));
            a3f = (a3c + 30);
            a4f = (a3c + 31);
            s78 = ((*(a3f)**(a1c)) - (*(a4f)**(a2c)));
            s88 = ((*(a4f)**(a1c)) + (*(a3f)**(a2c)));
            t9g = (s75 + s37);
            t0h = (s85 + s47);
            t1h = (s75 - s37);
            t2h = (s85 - s47);
            t3h = (s56 + s18);
            t4h = (s66 + s28);
            t5h = (s56 - s18);
            t6h = (s66 - s28);
            t7h = (t9g + t3h);
            t8h = (t0h + t4h);
            t9h = (t9g - t3h);
            t0i = (t0h - t4h);
            t1i = (t1h + t6h);
            t2i = (t2h - t5h);
            t3i = (t1h - t6h);
            t4i = (t2h + t5h);
            t5i = (s95 + s57);
            t6i = (s06 + s67);
            t7i = (s95 - s57);
            t8i = (s06 - s67);
            t9i = (s76 + s38);
            t0j = (s86 + s48);
            t1j = (s76 - s38);
            t2j = (s86 - s48);
            t3j = (t5i + t9i);
            t4j = (t6i + t0j);
            a5f = (0.70710678118654757*(t5i - t9i));
            a6f = (0.70710678118654757*(t6i - t0j));
            s98 = (a5f + a6f);
            s09 = (a6f - a5f);
            t5j = (t7i + t2j);
            t6j = (t8i - t1j);
            t7j = (t7i - t2j);
            t8j = (t8i + t1j);
            s19 = ((0.92387953251128674*t5j) + (0.38268343236508978*t6j));
            s29 = ((0.92387953251128674*t6j) - (0.38268343236508978*t5j));
            s39 = ((0.38268343236508978*t7j) + (0.92387953251128674*t8j));
            s49 = ((0.38268343236508978*t8j) - (0.92387953251128674*t7j));
            t9j = (s16 + s77);
            t0k = (s26 + s87);
            t1k = (s16 - s77);
            t2k = (s26 - s87);
            t3k = (s96 + s58);
            t4k = (s07 + s68);
            t5k = (s96 - s58);
            t6k = (s07 - s68);
            t7k = (t9j + t3k);
            t8k = (t0k + t4k);
            t9k = (t9j - t3k);
            t0l = (t0k - t4k);
            a7f = (0.70710678118654757*(t1k + t6k));
            a8f = (0.70710678118654757*(t2k - t5k));
            s59 = (a7f + a8f);
            s69 = (a8f - a7f);
            a9f = (0.70710678118654757*(t2k + t5k));
            a0g = (0.70710678118654757*(t1k - t6k));
            s79 = (a9f - a0g);
            s89 = (a0g + a9f);
            t1l = (s36 + s97);
            t2l = (s46 + s08);
            t3l = (s36 - s97);
            t4l = (s46 - s08);
            t5l = (s17 + s78);
            t6l = (s27 + s88);
            t7l = (s17 - s78);
            t8l = (s27 - s88);
            t9l = (t1l + t5l);
            t0m = (t2l + t6l);
            a1g = (0.70710678118654757*(t2l - t6l));
            a2g = (0.70710678118654757*(t1l - t5l));
            s99 = (a1g - a2g);
            s0a = (a2g + a1g);
            t1m = (t3l + t8l);
            t2m = (t4l - t7l);
            t3m = (t3l - t8l);
            t4m = (t4l + t7l);
            s1a = ((0.38268343236508978*t1m) + (0.92387953251128674*t2m));
            s2a = ((0.38268343236508978*t2m) - (0.92387953251128674*t1m));
            s3a = ((0.92387953251128674*t3m) + (0.38268343236508978*t4m));
            s4a = ((0.38268343236508978*t3m) - (0.92387953251128674*t4m));
            t5m = (t7h + t7k);
            t6m = (t8h + t8k);
            t7m = (t7h - t7k);
            t8m = (t8h - t8k);
            t9m = (t3j + t9l);
            t0n = (t4j + t0m);
            t1n = (t3j - t9l);
            t2n = (t4j - t0m);
            a3g = (16*i3);
            b2 = (T + i);
            b3 = (b2 + a3g);
            *((b3 + 16)) = (t5m + t9m);
            *((b3 + 24)) = (t6m + t0n);
            b4 = (b2 - a3g);
            *((b4 + 4080)) = (t5m - t9m);
            *((b4 + 4088)) = (t0n - t6m);
            *((b3 + 2064)) = (t7m + t2n);
            *((b3 + 2072)) = (t8m - t1n);
            *((b4 + 2032)) = (t7m - t2n);
            *((b4 + 2040)) = -((t8m + t1n));
            t3n = (t1i + s59);
            t4n = (t2i + s69);
            t5n = (t1i - s59);
            t6n = (t2i - s69);
            t7n = (s19 + s1a);
            t8n = (s29 + s2a);
            t9n = (s19 - s1a);
            t0o = (s29 - s2a);
            *((b3 + 528)) = (t3n + t7n);
            *((b3 + 536)) = (t4n + t8n);
            *((b4 + 3568)) = (t3n - t7n);
            *((b4 + 3576)) = (t8n - t4n);
            *((b3 + 2576)) = (t5n + t0o);
            *((b3 + 2584)) = (t6n - t9n);
            *((b4 + 1520)) = (t5n - t0o);
            *((b4 + 1528)) = -((t6n + t9n));
            t1o = (t9h + t0l);
            t2o = (t0i - t9k);
            t3o = (t9h - t0l);
            t4o = (t0i + t9k);
            t5o = (s98 + s99);
            t6o = (s09 - s0a);
            t7o = (s98 - s99);
            t8o = (s09 + s0a);
            *((b3 + 1040)) = (t1o + t5o);
            *((b3 + 1048)) = (t2o + t6o);
            *((b4 + 3056)) = (t1o - t5o);
            *((b4 + 3064)) = (t6o - t2o);
            *((b3 + 3088)) = (t3o + t8o);
            *((b3 + 3096)) = (t4o - t7o);
            *((b4 + 1008)) = (t3o - t8o);
            *((b4 + 1016)) = -((t4o + t7o));
            t9o = (t3i + s79);
            t0p = (t4i - s89);
            t1p = (t3i - s79);
            t2p = (t4i + s89);
            t3p = (s39 - s3a);
            t4p = (s49 + s4a);
            t5p = (s39 + s3a);
            t6p = (s49 - s4a);
            *((b3 + 1552)) = (t9o + t3p);
            *((b3 + 1560)) = (t0p + t4p);
            *((b4 + 2544)) = (t9o - t3p);
            *((b4 + 2552)) = (t4p - t0p);
            *((b3 + 3600)) = (t1p + t6p);
            *((b3 + 3608)) = (t2p - t5p);
            *((b4 + 496)) = (t1p - t6p);
            *((b4 + 504)) = -((t2p + t5p));
        }}
    }}
    a4g = (T + 8);
    t7p = (*(T) + *(a4g));
    t8p = (*(T) - *(a4g));
    a5g = (T + 4);
    a6g = (T + 12);
    t9p = (*(a5g) + *(a6g));
    t0q = (*(a5g) - *(a6g));
    a7g = (T + 2);
    a8g = (T + 10);
    t1q = (*(a7g) + *(a8g));
    a9g = (T + 6);
    a0h = (T + 14);
    t2q = (*(a9g) + *(a0h));
    t3q = (t7p + t9p);
    t4q = (t7p - t9p);
    t5q = (t1q + t2q);
    t6q = (t1q - t2q);
    a1h = (0.70710678118654757*(*(a7g) - *(a8g)));
    a2h = (0.70710678118654757*(*(a9g) - *(a0h)));
    s5a = (a1h - a2h);
    s6a = (a1h + a2h);
    t7q = (t8p + s5a);
    t8q = (t0q + s6a);
    t9q = (t8p - s5a);
    t0r = (s6a - t0q);
    a3h = (T + 1);
    a4h = (T + 9);
    t1r = (*(a3h) + *(a4h));
    t2r = (*(a3h) - *(a4h));
    a5h = (T + 5);
    a6h = (T + 13);
    t3r = (*(a5h) + *(a6h));
    t4r = (*(a5h) - *(a6h));
    a7h = (T + 3);
    a8h = (T + 11);
    t5r = (*(a7h) + *(a8h));
    a9h = (T + 7);
    a0i = (T + 15);
    t6r = (*(a9h) + *(a0i));
    t7r = (t1r + t3r);
    t8r = (t5r + t6r);
    a1i = (0.70710678118654757*(*(a7h) - *(a8h)));
    a2i = (0.70710678118654757*(*(a9h) - *(a0i)));
    s7a = (a1i - a2i);
    s8a = (a1i + a2i);
    t9r = (t2r + s7a);
    t0s = (t4r + s8a);
    t1s = (t2r - s7a);
    t2s = (s8a - t4r);
    t3s = (t3q + t5q);
    t4s = (t7r + t8r);
    *(dst) = (t3s + t4s);
    *((dst + 1)) = (t3s - t4s);
    *((dst + 2048)) = (t3q - t5q);
    *((dst + 2049)) = (t8r - t7r);
    s9a = ((0.92387953251128674*t9r) - (0.38268343236508978*t0s));
    s0b = ((0.38268343236508978*t9r) + (0.92387953251128674*t0s));
    *((dst + 512)) = (t7q + s9a);
    *((dst + 513)) = -((t8q + s0b));
    *((dst + 3584)) = (t7q - s9a);
    *((dst + 3585)) = (t8q - s0b);
    a3i = (0.70710678118654757*(t1r - t3r));
    a4i = (0.70710678118654757*(t5r - t6r));
    s1b = (a3i - a4i);
    s2b = (a3i + a4i);
    *((dst + 1024)) = (t4q + s1b);
    *((dst + 1025)) = -((t6q + s2b));
    *((dst + 3072)) = (t4q - s1b);
    *((dst + 3073)) = (t6q - s2b);
    s3b = ((0.38268343236508978*t1s) - (0.92387953251128674*t2s));
    s4b = ((0.92387953251128674*t1s) + (0.38268343236508978*t2s));
    *((dst + 1536)) = (t9q + s3b);
    *((dst + 1537)) = -((t0r + s4b));
    *((dst + 2560)) = (t9q - s3b);
    *((dst + 2561)) = (t0r - s4b);
    {long i4; for(i4 = 0; i4 <= 254; i4++) {
        a5i = (16*i4);
        b5 = (T + a5i);
        a6i = (b5 + 16);
        a7i = (b5 + 24);
        a8i = (b5 + 17);
        a9i = (b5 + 25);
        a0j = (b5 + 18);
        a1j = (b5 + 26);
        a2j = (b5 + 19);
        a3j = (b5 + 27);
        a4j = (b5 + 20);
        a5j = (b5 + 28);
        a6j = (b5 + 21);
        a7j = (b5 + 29);
        a8j = (b5 + 22);
        a9j = (b5 + 30);
        a0k = (b5 + 23);
        a1k = (b5 + 31);
        a2k = (D274 + a5i);
        a3k = (a2k + 1);
        s5b = ((*(a2k)**(a6i)) - (*(a3k)**(a7i)));
        s6b = ((*(a3k)**(a6i)) + (*(a2k)**(a7i)));
        a4k = (a2k + 2);
        a5k = (a2k + 3);
        s7b = ((*(a4k)**(a8i)) - (*(a5k)**(a9i)));
        s8b = ((*(a5k)**(a8i)) + (*(a4k)**(a9i)));
        a6k = (a2k + 4);
        a7k = (a2k + 5);
        s9b = ((*(a6k)**(a0j)) - (*(a7k)**(a1j)));
        s0c = ((*(a7k)**(a0j)) + (*(a6k)**(a1j)));
        a8k = (a2k + 6);
        a9k = (a2k + 7);
        s1c = ((*(a8k)**(a2j)) - (*(a9k)**(a3j)));
        s2c = ((*(a9k)**(a2j)) + (*(a8k)**(a3j)));
        a0l = (a2k + 8);
        a1l = (a2k + 9);
        s3c = ((*(a0l)**(a4j)) - (*(a1l)**(a5j)));
        s4c = ((*(a1l)**(a4j)) + (*(a0l)**(a5j)));
        a2l = (a2k + 10);
        a3l = (a2k + 11);
        s5c = ((*(a2l)**(a6j)) - (*(a3l)**(a7j)));
        s6c = ((*(a3l)**(a6j)) + (*(a2l)**(a7j)));
        a4l = (a2k + 12);
        a5l = (a2k + 13);
        s7c = ((*(a4l)**(a8j)) - (*(a5l)**(a9j)));
        s8c = ((*(a5l)**(a8j)) + (*(a4l)**(a9j)));
        a6l = (a2k + 14);
        a7l = (a2k + 15);
        s9c = ((*(a6l)**(a0k)) - (*(a7l)**(a1k)));
        s0d = ((*(a7l)**(a0k)) + (*(a6l)**(a1k)));
        t5s = (s5b + s3c);
        t6s = (s6b + s4c);
        t7s = (s5b - s3c);
        t8s = (s6b - s4c);
        t9s = (s9b + s7c);
        t0t = (s0c + s8c);
        t1t = (s9b - s7c);
        t2t = (s0c - s8c);
        t3t = (t5s + t9s);
        t4t = (t6s + t0t);
        t5t = (t5s - t9s);
        t6t = (t6s - t0t);
        t7t = (t7s + t2t);
        t8t = (t8s - t1t);
        t9t = (t7s - t2t);
        t0u = (t8s + t1t);
        t1u = (s7b + s5c);
        t2u = (s8b + s6c);
        t3u = (s7b - s5c);
        t4u = (s8b - s6c);
        t5u = (s1c + s9c);
        t6u = (s2c + s0d);
        t7u = (s1c - s9c);
        t8u = (s2c - s0d);
        t9u = (t1u + t5u);
        t0v = (t2u + t6u);
        t1v = (t1u - t5u);
        t2v = (t2u - t6u);
        a8l = (0.70710678118654757*(t3u + t8u));
        a9l = (0.70710678118654757*(t4u - t7u));
        s1d = (a8l + a9l);
        s2d = (a9l - a8l);
        a0m = (0.70710678118654757*(t4u + t7u));
        a1m = (0.70710678118654757*(t3u - t8u));
        s3d = (a0m - a1m);
        s4d = (a1m + a0m);
        a2m = (2*i4);
        b6 = (dst + a2m);
        *((b6 + 2)) = (t3t + t9u);
        *((b6 + 3)) = (t4t + t0v);
        b7 = (dst - a2m);
        *((b7 + 4094)) = (t3t - t9u);
        *((b7 + 4095)) = (t0v - t4t);
        *((b6 + 1026)) = (t7t + s1d);
        *((b6 + 1027)) = (t8t + s2d);
        *((b7 + 3070)) = (t7t - s1d);
        *((b7 + 3071)) = (s2d - t8t);
        *((b6 + 2050)) = (t5t + t2v);
        *((b6 + 2051)) = (t6t - t1v);
        *((b7 + 2046)) = (t5t - t2v);
        *((b7 + 2047)) = -((t6t + t1v));
        *((b6 + 3074)) = (t9t + s3d);
        *((b6 + 3075)) = (t0u - s4d);
        *((b7 + 1022)) = (t9t - s3d);
        *((b7 + 1023)) = -((t0u + s4d));
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_4)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a;
    double s, s2, t, t2;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 2)));
    s2 = (2**((src + 3)));
    *(dst) = (t + s);
    *((dst + 1)) = (t2 - s2);
    *((dst + 2)) = (t - s);
    *((dst + 3)) = (t2 + s2);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_8)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a2, *a3, *a4, *a5;
    double a6, a7, s, s2, s3, s4, s5, s6, t, t2, t3, t4, t5, t6;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 4)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 5)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 2);
    a3 = (src + 6);
    a4 = (src + 3);
    a5 = (src + 7);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    *(dst) = (t3 + s3);
    *((dst + 4)) = (t3 - s3);
    *((dst + 2)) = (t4 - s4);
    *((dst + 6)) = (t4 + s4);
    *((dst + 1)) = (t5 + s5);
    *((dst + 5)) = (t5 - s5);
    *((dst + 3)) = (t6 - s6);
    *((dst + 7)) = (t6 + s6);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_16)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a01, *a11, *a2, *a21, *a3, *a31, *a4, *a41, *a5, *a51, *a8, *a9;
    double a6, a61, a7, a71, s, s01, s11, s2, s21, s3, s31, s4, s41, s5, s6, s7, s8, s9, t, t01, t02, t11
            , t12, t2, t21, t22, t3, t31, t32, t4, t41, t42, t5, t51, t52, t6, t61, t62, t7, t71, t8, t81, t9, t91;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 8)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 9)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 4);
    a3 = (src + 12);
    a4 = (src + 5);
    a5 = (src + 13);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 2);
    a9 = (src + 14);
    t51 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 15);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 10);
    a31 = (src + 6);
    t91 = (*(a21) + *(a31));
    a41 = (src + 11);
    a51 = (src + 7);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t71 - t22);
    t42 = (t81 + t12);
    t52 = (t71 + t22);
    t62 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s01 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    a61 = (1.4142135623730951*(t51 - t91));
    a71 = (1.4142135623730951*(t61 - t02));
    s11 = (a61 - a71);
    s21 = (a61 + a71);
    s31 = ((0.76536686473017956*t52) - (1.8477590650225735*t62));
    s41 = ((1.8477590650225735*t52) + (0.76536686473017956*t62));
    *(dst) = (t7 + s7);
    *((dst + 8)) = (t7 - s7);
    *((dst + 4)) = (t8 - s8);
    *((dst + 12)) = (t8 + s8);
    *((dst + 1)) = (t11 + s9);
    *((dst + 9)) = (t11 - s9);
    *((dst + 5)) = (t21 - s01);
    *((dst + 13)) = (t21 + s01);
    *((dst + 2)) = (t9 + s11);
    *((dst + 10)) = (t9 - s11);
    *((dst + 6)) = (t01 - s21);
    *((dst + 14)) = (t01 + s21);
    *((dst + 3)) = (t31 + s31);
    *((dst + 11)) = (t31 - s31);
    *((dst + 7)) = (t41 - s41);
    *((dst + 15)) = (t41 + s41);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_32)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a01, *a02, *a03, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a5, *a51, *a61, *a62, *a71
            , *a72, *a8, *a81, *a82, *a9, *a91, *a92;
    double a04, a14, a42, a43, a52, a53, a6, a63, a7, a73, a83, a93, s, s01, s02, s03, s11, s12, s13, s2, s21, s22
            , s23, s3, s31, s32, s33, s4, s41, s42, s43, s5, s51, s52, s53, s6, s61, s62, s63, s7, s71, s72, s73, s8
            , s81, s82, s83, s9, s91, s92, t, t01, t02, t03, t04, t05, t06, t07, t11, t12, t13, t14, t15, t16, t17, t2
            , t21, t22, t23, t24, t25, t26, t27, t3, t31, t32, t33, t34, t35, t36, t37, t4, t41, t42, t43, t44, t45, t46
            , t47, t5, t51, t52, t53, t54, t55, t56, t57, t6, t61, t62, t63, t64, t65, t66, t67, t7, t71, t72, t73, t74
            , t75, t76, t77, t8, t81, t82, t83, t84, t85, t86, t87, t9, t91, t92, t93, t94, t95, t96;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 16)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 17)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 8);
    a3 = (src + 24);
    a4 = (src + 9);
    a5 = (src + 25);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 2);
    a9 = (src + 30);
    t51 = (*(a8) + *(a9));
    a01 = (src + 3);
    a11 = (src + 31);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 18);
    a31 = (src + 14);
    t91 = (*(a21) + *(a31));
    a41 = (src + 19);
    a51 = (src + 15);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t51 - t91);
    t42 = (t61 - t02);
    t52 = (t71 - t22);
    t62 = (t81 + t12);
    t72 = (t71 + t22);
    t82 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.9615705608064609*t52) - (0.39018064403225655*t62));
    s01 = ((0.39018064403225655*t52) + (1.9615705608064609*t62));
    s11 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s21 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    s31 = ((1.6629392246050905*t72) - (1.1111404660392044*t82));
    s41 = ((1.1111404660392044*t72) + (1.6629392246050905*t82));
    a61 = (src + 4);
    a71 = (src + 28);
    t92 = (*(a61) + *(a71));
    a81 = (src + 5);
    a91 = (src + 29);
    t03 = (*(a81) - *(a91));
    t13 = (*(a61) - *(a71));
    t23 = (*(a81) + *(a91));
    a02 = (src + 20);
    a12 = (src + 12);
    t33 = (*(a02) + *(a12));
    a22 = (src + 21);
    a32 = (src + 13);
    t43 = (*(a22) - *(a32));
    t53 = (*(a02) - *(a12));
    t63 = (*(a22) + *(a32));
    t73 = (t13 - t63);
    t83 = (t23 + t53);
    t93 = (t13 + t63);
    t04 = (t23 - t53);
    s51 = (2.0*(t92 + t33));
    s61 = (2.0*(t03 + t43));
    s71 = ((1.8477590650225735*t73) - (0.76536686473017956*t83));
    s81 = ((0.76536686473017956*t73) + (1.8477590650225735*t83));
    a42 = (1.4142135623730951*(t92 - t33));
    a52 = (1.4142135623730951*(t03 - t43));
    s91 = (a42 - a52);
    s02 = (a42 + a52);
    s12 = ((0.76536686473017956*t93) - (1.8477590650225735*t04));
    s22 = ((1.8477590650225735*t93) + (0.76536686473017956*t04));
    a62 = (src + 6);
    a72 = (src + 26);
    t14 = (*(a62) + *(a72));
    a82 = (src + 7);
    a92 = (src + 27);
    t24 = (*(a82) - *(a92));
    t34 = (*(a62) - *(a72));
    t44 = (*(a82) + *(a92));
    a03 = (src + 22);
    a13 = (src + 10);
    t54 = (*(a03) + *(a13));
    a23 = (src + 23);
    a33 = (src + 11);
    t64 = (*(a23) - *(a33));
    t74 = (*(a03) - *(a13));
    t84 = (*(a23) + *(a33));
    t94 = (t14 - t54);
    t05 = (t24 - t64);
    t15 = (t34 - t84);
    t25 = (t44 + t74);
    t35 = (t34 + t84);
    t45 = (t44 - t74);
    s32 = (2.0*(t14 + t54));
    s42 = (2.0*(t24 + t64));
    s52 = ((1.6629392246050905*t15) - (1.1111404660392044*t25));
    s62 = ((1.1111404660392044*t15) + (1.6629392246050905*t25));
    s72 = ((0.76536686473017956*t94) - (1.8477590650225735*t05));
    s82 = ((1.8477590650225735*t94) + (0.76536686473017956*t05));
    s92 = ((0.39018064403225655*t35) + (1.9615705608064609*t45));
    s03 = ((1.9615705608064609*t35) - (0.39018064403225655*t45));
    t55 = (t7 + s51);
    t65 = (t7 - s51);
    t75 = (t8 - s61);
    t85 = (t8 + s61);
    t95 = (s7 + s32);
    t06 = (s8 - s42);
    a43 = (0.70710678118654757*(s7 - s32));
    a53 = (0.70710678118654757*(s8 + s42));
    s13 = (a43 - a53);
    s23 = (a43 + a53);
    *(dst) = (t55 + t95);
    *((dst + 16)) = (t55 - t95);
    *((dst + 8)) = (t65 - t06);
    *((dst + 24)) = (t65 + t06);
    *((dst + 4)) = (t75 + s13);
    *((dst + 20)) = (t75 - s13);
    *((dst + 12)) = (t85 - s23);
    *((dst + 28)) = (t85 + s23);
    t16 = (t11 + s71);
    t26 = (t11 - s71);
    t36 = (t21 - s81);
    t46 = (t21 + s81);
    t56 = (s9 + s52);
    t66 = (s01 - s62);
    a63 = (0.70710678118654757*(s9 - s52));
    a73 = (0.70710678118654757*(s01 + s62));
    s33 = (a63 - a73);
    s43 = (a63 + a73);
    *((dst + 1)) = (t16 + t56);
    *((dst + 17)) = (t16 - t56);
    *((dst + 9)) = (t26 - t66);
    *((dst + 25)) = (t26 + t66);
    *((dst + 5)) = (t36 + s33);
    *((dst + 21)) = (t36 - s33);
    *((dst + 13)) = (t46 - s43);
    *((dst + 29)) = (t46 + s43);
    t76 = (t9 + s91);
    t86 = (t9 - s91);
    t96 = (t01 - s02);
    t07 = (t01 + s02);
    t17 = (s11 + s72);
    t27 = (s21 - s82);
    a83 = (0.70710678118654757*(s11 - s72));
    a93 = (0.70710678118654757*(s21 + s82));
    s53 = (a83 - a93);
    s63 = (a83 + a93);
    *((dst + 2)) = (t76 + t17);
    *((dst + 18)) = (t76 - t17);
    *((dst + 10)) = (t86 - t27);
    *((dst + 26)) = (t86 + t27);
    *((dst + 6)) = (t96 + s53);
    *((dst + 22)) = (t96 - s53);
    *((dst + 14)) = (t07 - s63);
    *((dst + 30)) = (t07 + s63);
    t37 = (t31 + s12);
    t47 = (t31 - s12);
    t57 = (t41 - s22);
    t67 = (t41 + s22);
    t77 = (s31 - s92);
    t87 = (s41 - s03);
    a04 = (0.70710678118654757*(s31 + s92));
    a14 = (0.70710678118654757*(s41 + s03));
    s73 = (a04 - a14);
    s83 = (a04 + a14);
    *((dst + 3)) = (t37 + t77);
    *((dst + 19)) = (t37 - t77);
    *((dst + 11)) = (t47 - t87);
    *((dst + 27)) = (t47 + t87);
    *((dst + 7)) = (t57 + s73);
    *((dst + 23)) = (t57 - s73);
    *((dst + 15)) = (t67 - s83);
    *((dst + 31)) = (t67 + s83);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_64)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    {const double  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a11, *a12, *a13, *a14, *a15, *a16, *a17, *a2, *a21, *a22, *a23, *a24, *a25, *a26
            , *a27, *a3, *a31, *a32, *a33, *a34, *a35, *a36, *a37, *a4, *a41, *a42, *a44, *a46, *a47, *a5, *a51, *a52, *a54, *a56, *a57, *a62
            , *a64, *a66, *a72, *a74, *a76, *a8, *a81, *a82, *a83, *a84, *a86, *a9, *a91, *a92, *a93, *a94, *a96;
    double a08, a09, a18, a19, a28, a29, a38, a39, a43, a45, a48, a49, a53, a55, a58, a59, a6, a61, a63, a65, a67, a68
            , a7, a71, a73, a75, a77, a78, a85, a87, a88, a95, a97, a98, s, s01, s02, s03, s04, s05, s06, s07, s08, s09
            , s11, s12, s13, s14, s15, s16, s17, s18, s2, s21, s22, s23, s24, s25, s26, s27, s28, s3, s31, s32, s33, s34
            , s35, s36, s37, s38, s4, s41, s42, s43, s44, s45, s46, s47, s48, s5, s51, s52, s53, s54, s55, s56, s57, s58
            , s6, s61, s62, s63, s64, s65, s66, s67, s68, s7, s71, s72, s73, s74, s75, s76, s77, s78, s8, s81, s82, s83
            , s84, s85, s86, s87, s88, s9, s91, s92, s93, s94, s95, s96, s97, s98, t, t01, t02, t03, t04, t05, t06, t07
            , t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t11, t12, t13, t14, t15, t16, t17, t18
            , t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t2, t21, t22, t23, t24, t25, t26, t27, t28
            , t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t3, t31, t32, t33, t34, t35, t36, t37, t38
            , t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t4, t41, t42, t43, t44, t45, t46, t47, t48
            , t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t5, t51, t52, t53, t54, t55, t56, t57, t58
            , t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69
            , t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a
            , t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j, t7k, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b
            , t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c
            , t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 32)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 33)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 16);
    a3 = (src + 48);
    a4 = (src + 17);
    a5 = (src + 49);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 8);
    a9 = (src + 56);
    t51 = (*(a8) + *(a9));
    a01 = (src + 9);
    a11 = (src + 57);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 40);
    a31 = (src + 24);
    t91 = (*(a21) + *(a31));
    a41 = (src + 41);
    a51 = (src + 25);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t71 - t22);
    t42 = (t81 + t12);
    t52 = (t71 + t22);
    t62 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s01 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    a61 = (1.4142135623730951*(t51 - t91));
    a71 = (1.4142135623730951*(t61 - t02));
    s11 = (a61 - a71);
    s21 = (a61 + a71);
    s31 = ((0.76536686473017956*t52) - (1.8477590650225735*t62));
    s41 = ((1.8477590650225735*t52) + (0.76536686473017956*t62));
    t72 = (t7 + s7);
    t82 = (t7 - s7);
    t92 = (t8 - s8);
    t03 = (t8 + s8);
    t13 = (t11 + s9);
    t23 = (t11 - s9);
    t33 = (t21 - s01);
    t43 = (t21 + s01);
    t53 = (t9 + s11);
    t63 = (t9 - s11);
    t73 = (t01 - s21);
    t83 = (t01 + s21);
    t93 = (t31 + s31);
    t04 = (t31 - s31);
    t14 = (t41 - s41);
    t24 = (t41 + s41);
    a81 = (src + 2);
    a91 = (src + 62);
    t34 = (*(a81) + *(a91));
    a02 = (src + 3);
    a12 = (src + 63);
    t44 = (*(a02) - *(a12));
    t54 = (*(a81) - *(a91));
    t64 = (*(a02) + *(a12));
    a22 = (src + 34);
    a32 = (src + 30);
    t74 = (*(a22) + *(a32));
    a42 = (src + 35);
    a52 = (src + 31);
    t84 = (*(a42) - *(a52));
    t94 = (*(a22) - *(a32));
    t05 = (*(a42) + *(a52));
    t15 = (t34 + t74);
    t25 = (t44 + t84);
    t35 = (t34 - t74);
    t45 = (t44 - t84);
    t55 = (t54 - t05);
    t65 = (t64 + t94);
    t75 = (t54 + t05);
    t85 = (t64 - t94);
    a62 = (src + 18);
    a72 = (src + 46);
    t95 = (*(a62) + *(a72));
    a82 = (src + 19);
    a92 = (src + 47);
    t06 = (*(a82) - *(a92));
    t16 = (*(a62) - *(a72));
    t26 = (*(a82) + *(a92));
    a03 = (src + 50);
    a13 = (src + 14);
    t36 = (*(a03) + *(a13));
    a23 = (src + 51);
    a33 = (src + 15);
    t46 = (*(a23) - *(a33));
    t56 = (*(a03) - *(a13));
    t66 = (*(a23) + *(a33));
    t76 = (t95 + t36);
    t86 = (t06 + t46);
    t96 = (t95 - t36);
    t07 = (t06 - t46);
    a43 = (0.70710678118654757*(t16 - t66));
    a53 = (0.70710678118654757*(t26 + t56));
    s51 = (a43 - a53);
    s61 = (a43 + a53);
    a63 = (0.70710678118654757*(t16 + t66));
    a73 = (0.70710678118654757*(t26 - t56));
    s71 = (a63 + a73);
    s81 = (a63 - a73);
    t17 = (t15 - t76);
    t27 = (t25 - t86);
    t37 = (t55 + s51);
    t47 = (t65 + s61);
    t57 = (t55 - s51);
    t67 = (t65 - s61);
    t77 = (t35 - t07);
    t87 = (t45 + t96);
    t97 = (t35 + t07);
    t08 = (t45 - t96);
    t18 = (t75 - s71);
    t28 = (t85 + s81);
    t38 = (t75 + s71);
    t48 = (t85 - s81);
    s91 = (2.0*(t15 + t76));
    s02 = (2.0*(t25 + t86));
    s12 = ((1.9903694533443939*t37) - (0.19603428065912121*t47));
    s22 = ((0.19603428065912121*t37) + (1.9903694533443939*t47));
    s32 = ((1.9615705608064609*t77) - (0.39018064403225655*t87));
    s42 = ((0.39018064403225655*t77) + (1.9615705608064609*t87));
    s52 = ((1.9138806714644176*t18) - (0.58056935450892477*t28));
    s62 = ((0.58056935450892477*t18) + (1.9138806714644176*t28));
    s72 = ((1.8477590650225735*t17) - (0.76536686473017956*t27));
    s82 = ((0.76536686473017956*t17) + (1.8477590650225735*t27));
    s92 = ((1.7638425286967101*t57) - (0.94279347365199528*t67));
    s03 = ((0.94279347365199528*t57) + (1.7638425286967101*t67));
    s13 = ((1.6629392246050905*t97) - (1.1111404660392044*t08));
    s23 = ((1.1111404660392044*t97) + (1.6629392246050905*t08));
    s33 = ((1.546020906725474*t38) - (1.268786568327291*t48));
    s43 = ((1.268786568327291*t38) + (1.546020906725474*t48));
    a83 = (src + 4);
    a93 = (src + 60);
    t58 = (*(a83) + *(a93));
    a04 = (src + 5);
    a14 = (src + 61);
    t68 = (*(a04) - *(a14));
    t78 = (*(a83) - *(a93));
    t88 = (*(a04) + *(a14));
    a24 = (src + 36);
    a34 = (src + 28);
    t98 = (*(a24) + *(a34));
    a44 = (src + 37);
    a54 = (src + 29);
    t09 = (*(a44) - *(a54));
    t19 = (*(a24) - *(a34));
    t29 = (*(a44) + *(a54));
    t39 = (t58 + t98);
    t49 = (t68 + t09);
    t59 = (t58 - t98);
    t69 = (t68 - t09);
    t79 = (t78 - t29);
    t89 = (t88 + t19);
    t99 = (t78 + t29);
    t0a = (t88 - t19);
    a64 = (src + 20);
    a74 = (src + 44);
    t1a = (*(a64) + *(a74));
    a84 = (src + 21);
    a94 = (src + 45);
    t2a = (*(a84) - *(a94));
    t3a = (*(a64) - *(a74));
    t4a = (*(a84) + *(a94));
    a05 = (src + 52);
    a15 = (src + 12);
    t5a = (*(a05) + *(a15));
    a25 = (src + 53);
    a35 = (src + 13);
    t6a = (*(a25) - *(a35));
    t7a = (*(a05) - *(a15));
    t8a = (*(a25) + *(a35));
    t9a = (t1a + t5a);
    t0b = (t2a + t6a);
    t1b = (t1a - t5a);
    t2b = (t2a - t6a);
    a45 = (0.70710678118654757*(t3a - t8a));
    a55 = (0.70710678118654757*(t4a + t7a));
    s53 = (a45 - a55);
    s63 = (a45 + a55);
    a65 = (0.70710678118654757*(t3a + t8a));
    a75 = (0.70710678118654757*(t4a - t7a));
    s73 = (a65 + a75);
    s83 = (a65 - a75);
    t3b = (t79 + s53);
    t4b = (t89 + s63);
    t5b = (t79 - s53);
    t6b = (t89 - s63);
    t7b = (t59 - t2b);
    t8b = (t69 + t1b);
    t9b = (t59 + t2b);
    t0c = (t69 - t1b);
    t1c = (t99 - s73);
    t2c = (t0a + s83);
    t3c = (t99 + s73);
    t4c = (t0a - s83);
    s93 = (2.0*(t39 + t9a));
    s04 = (2.0*(t49 + t0b));
    s14 = ((1.9615705608064609*t3b) - (0.39018064403225655*t4b));
    s24 = ((0.39018064403225655*t3b) + (1.9615705608064609*t4b));
    s34 = ((1.8477590650225735*t7b) - (0.76536686473017956*t8b));
    s44 = ((0.76536686473017956*t7b) + (1.8477590650225735*t8b));
    s54 = ((1.6629392246050905*t1c) - (1.1111404660392044*t2c));
    s64 = ((1.1111404660392044*t1c) + (1.6629392246050905*t2c));
    a85 = (1.4142135623730951*(t39 - t9a));
    a95 = (1.4142135623730951*(t49 - t0b));
    s74 = (a85 - a95);
    s84 = (a85 + a95);
    s94 = ((1.1111404660392044*t5b) - (1.6629392246050905*t6b));
    s05 = ((1.6629392246050905*t5b) + (1.1111404660392044*t6b));
    s15 = ((0.76536686473017956*t9b) - (1.8477590650225735*t0c));
    s25 = ((1.8477590650225735*t9b) + (0.76536686473017956*t0c));
    s35 = ((0.39018064403225655*t3c) - (1.9615705608064609*t4c));
    s45 = ((1.9615705608064609*t3c) + (0.39018064403225655*t4c));
    a06 = (src + 6);
    a16 = (src + 58);
    t5c = (*(a06) + *(a16));
    a26 = (src + 7);
    a36 = (src + 59);
    t6c = (*(a26) - *(a36));
    t7c = (*(a06) - *(a16));
    t8c = (*(a26) + *(a36));
    a46 = (src + 38);
    a56 = (src + 26);
    t9c = (*(a46) + *(a56));
    a66 = (src + 39);
    a76 = (src + 27);
    t0d = (*(a66) - *(a76));
    t1d = (*(a46) - *(a56));
    t2d = (*(a66) + *(a76));
    t3d = (t5c + t9c);
    t4d = (t6c + t0d);
    t5d = (t5c - t9c);
    t6d = (t6c - t0d);
    t7d = (t7c - t2d);
    t8d = (t8c + t1d);
    t9d = (t7c + t2d);
    t0e = (t8c - t1d);
    a86 = (src + 22);
    a96 = (src + 42);
    t1e = (*(a86) + *(a96));
    a07 = (src + 23);
    a17 = (src + 43);
    t2e = (*(a07) - *(a17));
    t3e = (*(a86) - *(a96));
    t4e = (*(a07) + *(a17));
    a27 = (src + 54);
    a37 = (src + 10);
    t5e = (*(a27) + *(a37));
    a47 = (src + 55);
    a57 = (src + 11);
    t6e = (*(a47) - *(a57));
    t7e = (*(a27) - *(a37));
    t8e = (*(a47) + *(a57));
    t9e = (t1e + t5e);
    t0f = (t2e + t6e);
    t1f = (t1e - t5e);
    t2f = (t2e - t6e);
    a67 = (0.70710678118654757*(t3e - t8e));
    a77 = (0.70710678118654757*(t4e + t7e));
    s55 = (a67 - a77);
    s65 = (a67 + a77);
    a87 = (0.70710678118654757*(t3e + t8e));
    a97 = (0.70710678118654757*(t4e - t7e));
    s75 = (a87 + a97);
    s85 = (a87 - a97);
    t3f = (t3d - t9e);
    t4f = (t4d - t0f);
    t5f = (t7d + s55);
    t6f = (t8d + s65);
    t7f = (t7d - s55);
    t8f = (t8d - s65);
    t9f = (t5d - t2f);
    t0g = (t6d + t1f);
    t1g = (t5d + t2f);
    t2g = (t6d - t1f);
    t3g = (t9d - s75);
    t4g = (t0e + s85);
    t5g = (t9d + s75);
    t6g = (t0e - s85);
    s95 = (2.0*(t3d + t9e));
    s06 = (2.0*(t4d + t0f));
    s16 = ((1.9138806714644176*t5f) - (0.58056935450892477*t6f));
    s26 = ((0.58056935450892477*t5f) + (1.9138806714644176*t6f));
    s36 = ((1.6629392246050905*t9f) - (1.1111404660392044*t0g));
    s46 = ((1.1111404660392044*t9f) + (1.6629392246050905*t0g));
    s56 = ((1.268786568327291*t3g) - (1.546020906725474*t4g));
    s66 = ((1.546020906725474*t3g) + (1.268786568327291*t4g));
    s76 = ((0.76536686473017956*t3f) - (1.8477590650225735*t4f));
    s86 = ((1.8477590650225735*t3f) + (0.76536686473017956*t4f));
    s96 = ((0.19603428065912121*t7f) - (1.9903694533443939*t8f));
    s07 = ((1.9903694533443939*t7f) + (0.19603428065912121*t8f));
    s17 = ((0.39018064403225655*t1g) + (1.9615705608064609*t2g));
    s27 = ((1.9615705608064609*t1g) - (0.39018064403225655*t2g));
    s37 = ((0.94279347365199528*t5g) + (1.7638425286967101*t6g));
    s47 = ((1.7638425286967101*t5g) - (0.94279347365199528*t6g));
    t7g = (t72 + s93);
    t8g = (t72 - s93);
    t9g = (t82 - s04);
    t0h = (t82 + s04);
    t1h = (s91 + s95);
    t2h = (s02 - s06);
    a08 = (0.70710678118654757*(s91 - s95));
    a18 = (0.70710678118654757*(s02 + s06));
    s57 = (a08 - a18);
    s67 = (a08 + a18);
    *(dst) = (t7g + t1h);
    *((dst + 32)) = (t7g - t1h);
    *((dst + 16)) = (t8g - t2h);
    *((dst + 48)) = (t8g + t2h);
    *((dst + 8)) = (t9g + s57);
    *((dst + 40)) = (t9g - s57);
    *((dst + 24)) = (t0h - s67);
    *((dst + 56)) = (t0h + s67);
    t3h = (t13 + s14);
    t4h = (t13 - s14);
    t5h = (t23 - s24);
    t6h = (t23 + s24);
    t7h = (s12 + s16);
    t8h = (s22 - s26);
    a28 = (0.70710678118654757*(s12 - s16));
    a38 = (0.70710678118654757*(s22 + s26));
    s77 = (a28 - a38);
    s87 = (a28 + a38);
    *((dst + 1)) = (t3h + t7h);
    *((dst + 33)) = (t3h - t7h);
    *((dst + 17)) = (t4h - t8h);
    *((dst + 49)) = (t4h + t8h);
    *((dst + 9)) = (t5h + s77);
    *((dst + 41)) = (t5h - s77);
    *((dst + 25)) = (t6h - s87);
    *((dst + 57)) = (t6h + s87);
    t9h = (t53 + s34);
    t0i = (t53 - s34);
    t1i = (t63 - s44);
    t2i = (t63 + s44);
    t3i = (s32 + s36);
    t4i = (s42 - s46);
    a48 = (0.70710678118654757*(s32 - s36));
    a58 = (0.70710678118654757*(s42 + s46));
    s97 = (a48 - a58);
    s08 = (a48 + a58);
    *((dst + 2)) = (t9h + t3i);
    *((dst + 34)) = (t9h - t3i);
    *((dst + 18)) = (t0i - t4i);
    *((dst + 50)) = (t0i + t4i);
    *((dst + 10)) = (t1i + s97);
    *((dst + 42)) = (t1i - s97);
    *((dst + 26)) = (t2i - s08);
    *((dst + 58)) = (t2i + s08);
    t5i = (t93 + s54);
    t6i = (t93 - s54);
    t7i = (t04 - s64);
    t8i = (t04 + s64);
    t9i = (s52 + s56);
    t0j = (s62 - s66);
    a68 = (0.70710678118654757*(s52 - s56));
    a78 = (0.70710678118654757*(s62 + s66));
    s18 = (a68 - a78);
    s28 = (a68 + a78);
    *((dst + 3)) = (t5i + t9i);
    *((dst + 35)) = (t5i - t9i);
    *((dst + 19)) = (t6i - t0j);
    *((dst + 51)) = (t6i + t0j);
    *((dst + 11)) = (t7i + s18);
    *((dst + 43)) = (t7i - s18);
    *((dst + 27)) = (t8i - s28);
    *((dst + 59)) = (t8i + s28);
    t1j = (t92 + s74);
    t2j = (t92 - s74);
    t3j = (t03 - s84);
    t4j = (t03 + s84);
    t5j = (s72 + s76);
    t6j = (s82 - s86);
    a88 = (0.70710678118654757*(s72 - s76));
    a98 = (0.70710678118654757*(s82 + s86));
    s38 = (a88 - a98);
    s48 = (a88 + a98);
    *((dst + 4)) = (t1j + t5j);
    *((dst + 36)) = (t1j - t5j);
    *((dst + 20)) = (t2j - t6j);
    *((dst + 52)) = (t2j + t6j);
    *((dst + 12)) = (t3j + s38);
    *((dst + 44)) = (t3j - s38);
    *((dst + 28)) = (t4j - s48);
    *((dst + 60)) = (t4j + s48);
    t7j = (t33 + s94);
    t8j = (t33 - s94);
    t9j = (t43 - s05);
    t0k = (t43 + s05);
    t1k = (s92 + s96);
    t2k = (s03 - s07);
    a09 = (0.70710678118654757*(s92 - s96));
    a19 = (0.70710678118654757*(s03 + s07));
    s58 = (a09 - a19);
    s68 = (a09 + a19);
    *((dst + 5)) = (t7j + t1k);
    *((dst + 37)) = (t7j - t1k);
    *((dst + 21)) = (t8j - t2k);
    *((dst + 53)) = (t8j + t2k);
    *((dst + 13)) = (t9j + s58);
    *((dst + 45)) = (t9j - s58);
    *((dst + 29)) = (t0k - s68);
    *((dst + 61)) = (t0k + s68);
    t3k = (t73 + s15);
    t4k = (t73 - s15);
    t5k = (t83 - s25);
    t6k = (t83 + s25);
    t7k = (s13 - s17);
    t8k = (s23 - s27);
    a29 = (0.70710678118654757*(s13 + s17));
    a39 = (0.70710678118654757*(s23 + s27));
    s78 = (a29 - a39);
    s88 = (a29 + a39);
    *((dst + 6)) = (t3k + t7k);
    *((dst + 38)) = (t3k - t7k);
    *((dst + 22)) = (t4k - t8k);
    *((dst + 54)) = (t4k + t8k);
    *((dst + 14)) = (t5k + s78);
    *((dst + 46)) = (t5k - s78);
    *((dst + 30)) = (t6k - s88);
    *((dst + 62)) = (t6k + s88);
    t9k = (t14 + s35);
    t0l = (t14 - s35);
    t1l = (t24 - s45);
    t2l = (t24 + s45);
    t3l = (s33 - s37);
    t4l = (s43 - s47);
    a49 = (0.70710678118654757*(s33 + s37));
    a59 = (0.70710678118654757*(s43 + s47));
    s98 = (a49 - a59);
    s09 = (a49 + a59);
    *((dst + 7)) = (t9k + t3l);
    *((dst + 39)) = (t9k - t3l);
    *((dst + 23)) = (t0l - t4l);
    *((dst + 55)) = (t0l + t4l);
    *((dst + 15)) = (t1l + s98);
    *((dst + 47)) = (t1l - s98);
    *((dst + 31)) = (t2l - s09);
    *((dst + 63)) = (t2l + s09);
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_128)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[128];
    double  *a04, *a05, *a06, *a07, *a14, *a15, *a16, *a17, *a24, *a25, *a26, *a27, *a34, *a35, *a36, *a37, *a44, *a45, *a54, *a55, *a64, *a65
            , *a66, *a67, *a74, *a75, *a76, *a84, *a85, *a86, *a94, *a95, *a96, *b3;
    const double  *a, *a01, *a02, *a03, *a11, *a12, *a13, *a2, *a21, *a22, *a23, *a3, *a31, *a32, *a33, *a4, *a41, *a42, *a43, *a5, *a51, *a52
            , *a62, *a72, *a8, *a82, *a9, *a91, *a92, *b, *b2;
    int a81, a93;
    double a46, a47, a53, a56, a57, a6, a61, a63, a7, a71, a73, a83, s, s01, s02, s11, s12, s2, s21, s22, s3, s31
            , s32, s4, s41, s42, s5, s51, s52, s6, s61, s62, s7, s71, s8, s81, s9, s91, t, t01, t02, t03, t04, t05
            , t06, t07, t08, t09, t11, t12, t13, t14, t15, t16, t17, t18, t19, t2, t21, t22, t23, t24, t25, t26, t27, t28
            , t29, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t5
            , t51, t52, t53, t54, t55, t56, t57, t58, t59, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t7, t71, t72
            , t73, t74, t75, t76, t77, t78, t79, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t9, t91, t92, t93, t94
            , t95, t96, t97, t98;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 64)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 65)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 32);
    a3 = (src + 96);
    a4 = (src + 33);
    a5 = (src + 97);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 16);
    a9 = (src + 112);
    t51 = (*(a8) + *(a9));
    a01 = (src + 17);
    a11 = (src + 113);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 80);
    a31 = (src + 48);
    t91 = (*(a21) + *(a31));
    a41 = (src + 81);
    a51 = (src + 49);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t71 - t22);
    t42 = (t81 + t12);
    t52 = (t71 + t22);
    t62 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s01 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    a61 = (1.4142135623730951*(t51 - t91));
    a71 = (1.4142135623730951*(t61 - t02));
    s11 = (a61 - a71);
    s21 = (a61 + a71);
    s31 = ((0.76536686473017956*t52) - (1.8477590650225735*t62));
    s41 = ((1.8477590650225735*t52) + (0.76536686473017956*t62));
    *(T) = (t7 + s7);
    *((T + 8)) = (t7 - s7);
    *((T + 4)) = (t8 - s8);
    *((T + 12)) = (t8 + s8);
    *((T + 1)) = (t11 + s9);
    *((T + 9)) = (t11 - s9);
    *((T + 5)) = (t21 - s01);
    *((T + 13)) = (t21 + s01);
    *((T + 2)) = (t9 + s11);
    *((T + 10)) = (t9 - s11);
    *((T + 6)) = (t01 - s21);
    *((T + 14)) = (t01 + s21);
    *((T + 3)) = (t31 + s31);
    *((T + 11)) = (t31 - s31);
    *((T + 7)) = (t41 - s41);
    *((T + 15)) = (t41 + s41);
    {long i; for(i = 0; i <= 6; i++) {
        a81 = (2*i);
        b = (src + a81);
        a91 = (b + 2);
        a02 = (b + 3);
        b2 = (src - a81);
        a12 = (b2 + 126);
        a22 = (b2 + 127);
        t72 = (*(a91) + *(a12));
        t82 = (*(a02) - *(a22));
        t92 = (*(a91) - *(a12));
        t03 = (*(a02) + *(a22));
        a32 = (b + 66);
        a42 = (b + 67);
        a52 = (b2 + 62);
        a62 = (b2 + 63);
        t13 = (*(a32) + *(a52));
        t23 = (*(a42) - *(a62));
        t33 = (*(a32) - *(a52));
        t43 = (*(a42) + *(a62));
        t53 = (t72 + t13);
        t63 = (t82 + t23);
        t73 = (t72 - t13);
        t83 = (t82 - t23);
        t93 = (t92 - t43);
        t04 = (t03 + t33);
        t14 = (t92 + t43);
        t24 = (t03 - t33);
        a72 = (b + 34);
        a82 = (b + 35);
        a92 = (b2 + 94);
        a03 = (b2 + 95);
        t34 = (*(a72) + *(a92));
        t44 = (*(a82) - *(a03));
        t54 = (*(a72) - *(a92));
        t64 = (*(a82) + *(a03));
        a13 = (b + 98);
        a23 = (b + 99);
        a33 = (b2 + 30);
        a43 = (b2 + 31);
        t74 = (*(a13) + *(a33));
        t84 = (*(a23) - *(a43));
        t94 = (*(a13) - *(a33));
        t05 = (*(a23) + *(a43));
        t15 = (t34 + t74);
        t25 = (t44 + t84);
        t35 = (t34 - t74);
        t45 = (t44 - t84);
        a53 = (0.70710678118654757*(t54 - t05));
        a63 = (0.70710678118654757*(t64 + t94));
        s51 = (a53 - a63);
        s61 = (a53 + a63);
        a73 = (0.70710678118654757*(t54 + t05));
        a83 = (0.70710678118654757*(t64 - t94));
        s71 = (a73 + a83);
        s81 = (a73 - a83);
        t55 = (t53 + t15);
        t65 = (t63 + t25);
        t75 = (t53 - t15);
        t85 = (t63 - t25);
        t95 = (t93 + s51);
        t06 = (t04 + s61);
        t16 = (t93 - s51);
        t26 = (t04 - s61);
        t36 = (t73 - t45);
        t46 = (t83 + t35);
        t56 = (t73 + t45);
        t66 = (t83 - t35);
        t76 = (t14 - s71);
        t86 = (t24 + s81);
        t96 = (t14 + s71);
        t07 = (t24 - s81);
        a93 = (16*i);
        a04 = (D276 + a93);
        a14 = (a04 + 1);
        a24 = (a04 + 2);
        a34 = (a04 + 3);
        a44 = (a04 + 4);
        a54 = (a04 + 5);
        a64 = (a04 + 6);
        a74 = (a04 + 7);
        a84 = (a04 + 8);
        a94 = (a04 + 9);
        a05 = (a04 + 10);
        a15 = (a04 + 11);
        a25 = (a04 + 12);
        a35 = (a04 + 13);
        a45 = (a04 + 14);
        a55 = (a04 + 15);
        b3 = (T + a93);
        *((b3 + 16)) = ((*(a04)*t55) + (*(a14)*t65));
        *((b3 + 24)) = ((*(a04)*t65) - (*(a14)*t55));
        *((b3 + 17)) = ((*(a24)*t95) + (*(a34)*t06));
        *((b3 + 25)) = ((*(a24)*t06) - (*(a34)*t95));
        *((b3 + 18)) = ((*(a44)*t36) + (*(a54)*t46));
        *((b3 + 26)) = ((*(a44)*t46) - (*(a54)*t36));
        *((b3 + 19)) = ((*(a64)*t76) + (*(a74)*t86));
        *((b3 + 27)) = ((*(a64)*t86) - (*(a74)*t76));
        *((b3 + 20)) = ((*(a84)*t75) + (*(a94)*t85));
        *((b3 + 28)) = ((*(a84)*t85) - (*(a94)*t75));
        *((b3 + 21)) = ((*(a05)*t16) + (*(a15)*t26));
        *((b3 + 29)) = ((*(a05)*t26) - (*(a15)*t16));
        *((b3 + 22)) = ((*(a25)*t56) + (*(a35)*t66));
        *((b3 + 30)) = ((*(a25)*t66) - (*(a35)*t56));
        *((b3 + 23)) = ((*(a45)*t96) + (*(a55)*t07));
        *((b3 + 31)) = ((*(a45)*t07) - (*(a55)*t96));
    }}
    {long i2; for(i2 = 0; i2 <= 7; i2++) {
        a65 = (T + i2);
        a75 = (a65 + 64);
        t17 = (*(a65) + *(a75));
        t27 = (*(a65) - *(a75));
        a85 = (a65 + 8);
        a95 = (a65 + 72);
        t37 = (*(a85) - *(a95));
        t47 = (*(a85) + *(a95));
        a06 = (a65 + 32);
        a16 = (a65 + 40);
        a26 = (a65 + 96);
        a36 = (a65 + 104);
        t57 = (*(a06) + *(a26));
        t67 = (*(a16) - *(a36));
        a46 = (0.70710678118654757*(*(a06) - *(a26)));
        a56 = (0.70710678118654757*(*(a16) + *(a36)));
        s91 = (a46 - a56);
        s02 = (a46 + a56);
        t77 = (t17 + t57);
        t87 = (t17 - t57);
        t97 = (t27 - t67);
        t08 = (t27 + t67);
        t18 = (t37 + s91);
        t28 = (t37 - s91);
        t38 = (t47 - s02);
        t48 = (t47 + s02);
        a66 = (a65 + 16);
        a76 = (a65 + 24);
        a86 = (a65 + 112);
        a96 = (a65 + 120);
        t58 = (*(a66) + *(a86));
        t68 = (*(a76) - *(a96));
        t78 = (*(a66) - *(a86));
        t88 = (*(a76) + *(a96));
        a07 = (a65 + 80);
        a17 = (a65 + 88);
        a27 = (a65 + 48);
        a37 = (a65 + 56);
        t98 = (*(a07) + *(a27));
        t09 = (*(a17) - *(a37));
        t19 = (*(a07) - *(a27));
        t29 = (*(a17) + *(a37));
        t39 = (t58 + t98);
        t49 = (t68 + t09);
        t59 = (t78 - t29);
        t69 = (t88 + t19);
        t79 = (t78 + t29);
        t89 = (t88 - t19);
        s12 = ((0.92387953251128674*t59) - (0.38268343236508978*t69));
        s22 = ((0.38268343236508978*t59) + (0.92387953251128674*t69));
        a47 = (0.70710678118654757*(t58 - t98));
        a57 = (0.70710678118654757*(t68 - t09));
        s32 = (a47 - a57);
        s42 = (a47 + a57);
        s52 = ((0.38268343236508978*t79) - (0.92387953251128674*t89));
        s62 = ((0.92387953251128674*t79) + (0.38268343236508978*t89));
        a67 = (dst + i2);
        *(a67) = (t77 + t39);
        *((a67 + 64)) = (t77 - t39);
        *((a67 + 32)) = (t87 - t49);
        *((a67 + 96)) = (t87 + t49);
        *((a67 + 8)) = (t18 + s12);
        *((a67 + 72)) = (t18 - s12);
        *((a67 + 40)) = (t28 - s22);
        *((a67 + 104)) = (t28 + s22);
        *((a67 + 16)) = (t97 + s32);
        *((a67 + 80)) = (t97 - s32);
        *((a67 + 48)) = (t08 - s42);
        *((a67 + 112)) = (t08 + s42);
        *((a67 + 24)) = (t38 + s52);
        *((a67 + 88)) = (t38 - s52);
        *((a67 + 56)) = (t48 - s62);
        *((a67 + 120)) = (t48 + s62);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_256)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[256];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a19, *a1a, *a1b, *a1c, *a1d, *a29, *a2a, *a2b, *a2c, *a2d, *a39, *a3a, *a3b, *a3c, *a3d, *a48, *a49
            , *a4a, *a4b, *a58, *a59, *a5a, *a5b, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a78, *a79, *a7a, *a7b, *a7c, *a88, *a89, *a8a, *a8b, *a8c
            , *a98, *a99, *a9a, *a9b, *a9c, *b3;
    const double  *a, *a01, *a02, *a03, *a05, *a08, *a11, *a12, *a13, *a15, *a16, *a2, *a21, *a22, *a23, *a25, *a26, *a3, *a31, *a32, *a33, *a34
            , *a35, *a36, *a37, *a4, *a41, *a44, *a45, *a46, *a47, *a5, *a51, *a54, *a55, *a56, *a57, *a61, *a62, *a64, *a65, *a66, *a67, *a71
            , *a72, *a74, *a75, *a76, *a77, *a8, *a81, *a82, *a84, *a85, *a86, *a87, *a9, *a91, *a92, *a94, *a97, *b, *b2;
    int a24, a38;
    double a04, a06, a07, a14, a17, a18, a27, a28, a42, a43, a4c, a4d, a52, a53, a5c, a5d, a6, a63, a7, a73, a83, a93
            , a95, a96, s, s01, s02, s03, s04, s05, s06, s11, s12, s13, s14, s15, s16, s2, s21, s22, s23, s24, s25, s26
            , s3, s31, s32, s33, s34, s35, s4, s41, s42, s43, s44, s45, s5, s51, s52, s53, s54, s55, s6, s61, s62, s63
            , s64, s65, s7, s71, s72, s73, s74, s75, s8, s81, s82, s83, s84, s85, s9, s91, s92, s93, s94, s95, t, t01
            , t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t11
            , t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t2
            , t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m
            , t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l
            , t3m, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k
            , t4l, t4m, t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j
            , t5k, t5l, t5m, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i
            , t6j, t6k, t6l, t6m, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h
            , t7i, t7j, t7k, t7l, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h
            , t8i, t8j, t8k, t8l, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h
            , t9i, t9j, t9k, t9l;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 128)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 129)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 64);
    a3 = (src + 192);
    a4 = (src + 65);
    a5 = (src + 193);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 16);
    a9 = (src + 240);
    t51 = (*(a8) + *(a9));
    a01 = (src + 17);
    a11 = (src + 241);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 144);
    a31 = (src + 112);
    t91 = (*(a21) + *(a31));
    a41 = (src + 145);
    a51 = (src + 113);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t51 - t91);
    t42 = (t61 - t02);
    t52 = (t71 - t22);
    t62 = (t81 + t12);
    t72 = (t71 + t22);
    t82 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.9615705608064609*t52) - (0.39018064403225655*t62));
    s01 = ((0.39018064403225655*t52) + (1.9615705608064609*t62));
    s11 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s21 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    s31 = ((1.6629392246050905*t72) - (1.1111404660392044*t82));
    s41 = ((1.1111404660392044*t72) + (1.6629392246050905*t82));
    a61 = (src + 32);
    a71 = (src + 224);
    t92 = (*(a61) + *(a71));
    a81 = (src + 33);
    a91 = (src + 225);
    t03 = (*(a81) - *(a91));
    t13 = (*(a61) - *(a71));
    t23 = (*(a81) + *(a91));
    a02 = (src + 160);
    a12 = (src + 96);
    t33 = (*(a02) + *(a12));
    a22 = (src + 161);
    a32 = (src + 97);
    t43 = (*(a22) - *(a32));
    t53 = (*(a02) - *(a12));
    t63 = (*(a22) + *(a32));
    t73 = (t13 - t63);
    t83 = (t23 + t53);
    t93 = (t13 + t63);
    t04 = (t23 - t53);
    s51 = (2.0*(t92 + t33));
    s61 = (2.0*(t03 + t43));
    s71 = ((1.8477590650225735*t73) - (0.76536686473017956*t83));
    s81 = ((0.76536686473017956*t73) + (1.8477590650225735*t83));
    a42 = (1.4142135623730951*(t92 - t33));
    a52 = (1.4142135623730951*(t03 - t43));
    s91 = (a42 - a52);
    s02 = (a42 + a52);
    s12 = ((0.76536686473017956*t93) - (1.8477590650225735*t04));
    s22 = ((1.8477590650225735*t93) + (0.76536686473017956*t04));
    a62 = (src + 48);
    a72 = (src + 208);
    t14 = (*(a62) + *(a72));
    a82 = (src + 49);
    a92 = (src + 209);
    t24 = (*(a82) - *(a92));
    t34 = (*(a62) - *(a72));
    t44 = (*(a82) + *(a92));
    a03 = (src + 176);
    a13 = (src + 80);
    t54 = (*(a03) + *(a13));
    a23 = (src + 177);
    a33 = (src + 81);
    t64 = (*(a23) - *(a33));
    t74 = (*(a03) - *(a13));
    t84 = (*(a23) + *(a33));
    t94 = (t14 - t54);
    t05 = (t24 - t64);
    t15 = (t34 - t84);
    t25 = (t44 + t74);
    t35 = (t34 + t84);
    t45 = (t44 - t74);
    s32 = (2.0*(t14 + t54));
    s42 = (2.0*(t24 + t64));
    s52 = ((1.6629392246050905*t15) - (1.1111404660392044*t25));
    s62 = ((1.1111404660392044*t15) + (1.6629392246050905*t25));
    s72 = ((0.76536686473017956*t94) - (1.8477590650225735*t05));
    s82 = ((1.8477590650225735*t94) + (0.76536686473017956*t05));
    s92 = ((0.39018064403225655*t35) + (1.9615705608064609*t45));
    s03 = ((1.9615705608064609*t35) - (0.39018064403225655*t45));
    t55 = (t7 + s51);
    t65 = (t7 - s51);
    t75 = (t8 - s61);
    t85 = (t8 + s61);
    t95 = (s7 + s32);
    t06 = (s8 - s42);
    a43 = (0.70710678118654757*(s7 - s32));
    a53 = (0.70710678118654757*(s8 + s42));
    s13 = (a43 - a53);
    s23 = (a43 + a53);
    *(T) = (t55 + t95);
    *((T + 16)) = (t55 - t95);
    *((T + 8)) = (t65 - t06);
    *((T + 24)) = (t65 + t06);
    *((T + 4)) = (t75 + s13);
    *((T + 20)) = (t75 - s13);
    *((T + 12)) = (t85 - s23);
    *((T + 28)) = (t85 + s23);
    t16 = (t11 + s71);
    t26 = (t11 - s71);
    t36 = (t21 - s81);
    t46 = (t21 + s81);
    t56 = (s9 + s52);
    t66 = (s01 - s62);
    a63 = (0.70710678118654757*(s9 - s52));
    a73 = (0.70710678118654757*(s01 + s62));
    s33 = (a63 - a73);
    s43 = (a63 + a73);
    *((T + 1)) = (t16 + t56);
    *((T + 17)) = (t16 - t56);
    *((T + 9)) = (t26 - t66);
    *((T + 25)) = (t26 + t66);
    *((T + 5)) = (t36 + s33);
    *((T + 21)) = (t36 - s33);
    *((T + 13)) = (t46 - s43);
    *((T + 29)) = (t46 + s43);
    t76 = (t9 + s91);
    t86 = (t9 - s91);
    t96 = (t01 - s02);
    t07 = (t01 + s02);
    t17 = (s11 + s72);
    t27 = (s21 - s82);
    a83 = (0.70710678118654757*(s11 - s72));
    a93 = (0.70710678118654757*(s21 + s82));
    s53 = (a83 - a93);
    s63 = (a83 + a93);
    *((T + 2)) = (t76 + t17);
    *((T + 18)) = (t76 - t17);
    *((T + 10)) = (t86 - t27);
    *((T + 26)) = (t86 + t27);
    *((T + 6)) = (t96 + s53);
    *((T + 22)) = (t96 - s53);
    *((T + 14)) = (t07 - s63);
    *((T + 30)) = (t07 + s63);
    t37 = (t31 + s12);
    t47 = (t31 - s12);
    t57 = (t41 - s22);
    t67 = (t41 + s22);
    t77 = (s31 - s92);
    t87 = (s41 - s03);
    a04 = (0.70710678118654757*(s31 + s92));
    a14 = (0.70710678118654757*(s41 + s03));
    s73 = (a04 - a14);
    s83 = (a04 + a14);
    *((T + 3)) = (t37 + t77);
    *((T + 19)) = (t37 - t77);
    *((T + 11)) = (t47 - t87);
    *((T + 27)) = (t47 + t87);
    *((T + 7)) = (t57 + s73);
    *((T + 23)) = (t57 - s73);
    *((T + 15)) = (t67 - s83);
    *((T + 31)) = (t67 + s83);
    {long i; for(i = 0; i <= 6; i++) {
        a24 = (2*i);
        b = (src + a24);
        a34 = (b + 2);
        a44 = (b + 3);
        b2 = (src - a24);
        a54 = (b2 + 254);
        a64 = (b2 + 255);
        t97 = (*(a34) + *(a54));
        t08 = (*(a44) - *(a64));
        t18 = (*(a34) - *(a54));
        t28 = (*(a44) + *(a64));
        a74 = (b + 130);
        a84 = (b + 131);
        a94 = (b2 + 126);
        a05 = (b2 + 127);
        t38 = (*(a74) + *(a94));
        t48 = (*(a84) - *(a05));
        t58 = (*(a74) - *(a94));
        t68 = (*(a84) + *(a05));
        t78 = (t97 + t38);
        t88 = (t08 + t48);
        t98 = (t97 - t38);
        t09 = (t08 - t48);
        t19 = (t18 - t68);
        t29 = (t28 + t58);
        t39 = (t18 + t68);
        t49 = (t28 - t58);
        a15 = (b + 34);
        a25 = (b + 35);
        a35 = (b2 + 222);
        a45 = (b2 + 223);
        t59 = (*(a15) + *(a35));
        t69 = (*(a25) - *(a45));
        t79 = (*(a15) - *(a35));
        t89 = (*(a25) + *(a45));
        a55 = (b + 162);
        a65 = (b + 163);
        a75 = (b2 + 94);
        a85 = (b2 + 95);
        t99 = (*(a55) + *(a75));
        t0a = (*(a65) - *(a85));
        t1a = (*(a55) - *(a75));
        t2a = (*(a65) + *(a85));
        t3a = (t59 + t99);
        t4a = (t69 + t0a);
        a95 = (0.70710678118654757*(t59 - t99));
        a06 = (0.70710678118654757*(t69 - t0a));
        s93 = (a95 - a06);
        s04 = (a95 + a06);
        t5a = (t79 - t2a);
        t6a = (t89 + t1a);
        t7a = (t79 + t2a);
        t8a = (t89 - t1a);
        s14 = ((0.92387953251128674*t5a) - (0.38268343236508978*t6a));
        s24 = ((0.38268343236508978*t5a) + (0.92387953251128674*t6a));
        s34 = ((0.38268343236508978*t7a) - (0.92387953251128674*t8a));
        s44 = ((0.92387953251128674*t7a) + (0.38268343236508978*t8a));
        a16 = (b + 66);
        a26 = (b + 67);
        a36 = (b2 + 190);
        a46 = (b2 + 191);
        t9a = (*(a16) + *(a36));
        t0b = (*(a26) - *(a46));
        t1b = (*(a16) - *(a36));
        t2b = (*(a26) + *(a46));
        a56 = (b + 194);
        a66 = (b + 195);
        a76 = (b2 + 62);
        a86 = (b2 + 63);
        t3b = (*(a56) + *(a76));
        t4b = (*(a66) - *(a86));
        t5b = (*(a56) - *(a76));
        t6b = (*(a66) + *(a86));
        t7b = (t9a + t3b);
        t8b = (t0b + t4b);
        t9b = (t9a - t3b);
        t0c = (t0b - t4b);
        a96 = (0.70710678118654757*(t1b - t6b));
        a07 = (0.70710678118654757*(t2b + t5b));
        s54 = (a96 - a07);
        s64 = (a96 + a07);
        a17 = (0.70710678118654757*(t1b + t6b));
        a27 = (0.70710678118654757*(t2b - t5b));
        s74 = (a17 + a27);
        s84 = (a17 - a27);
        a37 = (b + 98);
        a47 = (b + 99);
        a57 = (b2 + 158);
        a67 = (b2 + 159);
        t1c = (*(a37) + *(a57));
        t2c = (*(a47) - *(a67));
        t3c = (*(a37) - *(a57));
        t4c = (*(a47) + *(a67));
        a77 = (b + 226);
        a87 = (b + 227);
        a97 = (b2 + 30);
        a08 = (b2 + 31);
        t5c = (*(a77) + *(a97));
        t6c = (*(a87) - *(a08));
        t7c = (*(a77) - *(a97));
        t8c = (*(a87) + *(a08));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        a18 = (0.70710678118654757*(t1c - t5c));
        a28 = (0.70710678118654757*(t2c - t6c));
        s94 = (a18 + a28);
        s05 = (a18 - a28);
        t1d = (t3c - t8c);
        t2d = (t4c + t7c);
        t3d = (t3c + t8c);
        t4d = (t4c - t7c);
        s15 = ((0.38268343236508978*t1d) - (0.92387953251128674*t2d));
        s25 = ((0.92387953251128674*t1d) + (0.38268343236508978*t2d));
        s35 = ((0.38268343236508978*t4d) - (0.92387953251128674*t3d));
        s45 = ((0.38268343236508978*t3d) + (0.92387953251128674*t4d));
        t5d = (t78 + t7b);
        t6d = (t88 + t8b);
        t7d = (t78 - t7b);
        t8d = (t88 - t8b);
        t9d = (t3a + t9c);
        t0e = (t4a + t0d);
        t1e = (t3a - t9c);
        t2e = (t4a - t0d);
        t3e = (t5d + t9d);
        t4e = (t6d + t0e);
        t5e = (t5d - t9d);
        t6e = (t6d - t0e);
        t7e = (t7d - t2e);
        t8e = (t8d + t1e);
        t9e = (t7d + t2e);
        t0f = (t8d - t1e);
        t1f = (t19 + s54);
        t2f = (t29 + s64);
        t3f = (t19 - s54);
        t4f = (t29 - s64);
        t5f = (s14 + s15);
        t6f = (s24 + s25);
        t7f = (s14 - s15);
        t8f = (s24 - s25);
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        t3g = (t3f - t8f);
        t4g = (t4f + t7f);
        t5g = (t3f + t8f);
        t6g = (t4f - t7f);
        t7g = (t98 - t0c);
        t8g = (t09 + t9b);
        t9g = (t98 + t0c);
        t0h = (t09 - t9b);
        t1h = (s93 - s94);
        t2h = (s04 + s05);
        t3h = (s93 + s94);
        t4h = (s04 - s05);
        t5h = (t7g + t1h);
        t6h = (t8g + t2h);
        t7h = (t7g - t1h);
        t8h = (t8g - t2h);
        t9h = (t9g - t4h);
        t0i = (t0h + t3h);
        t1i = (t9g + t4h);
        t2i = (t0h - t3h);
        t3i = (t39 - s74);
        t4i = (t49 + s84);
        t5i = (t39 + s74);
        t6i = (t49 - s84);
        t7i = (s34 + s35);
        t8i = (s44 - s45);
        t9i = (s34 - s35);
        t0j = (s44 + s45);
        t1j = (t3i + t7i);
        t2j = (t4i + t8i);
        t3j = (t3i - t7i);
        t4j = (t4i - t8i);
        t5j = (t5i - t0j);
        t6j = (t6i + t9i);
        t7j = (t5i + t0j);
        t8j = (t6i - t9i);
        a38 = (32*i);
        a48 = (D277 + a38);
        a58 = (a48 + 1);
        a68 = (a48 + 2);
        a78 = (a48 + 3);
        a88 = (a48 + 4);
        a98 = (a48 + 5);
        a09 = (a48 + 6);
        a19 = (a48 + 7);
        a29 = (a48 + 8);
        a39 = (a48 + 9);
        a49 = (a48 + 10);
        a59 = (a48 + 11);
        a69 = (a48 + 12);
        a79 = (a48 + 13);
        a89 = (a48 + 14);
        a99 = (a48 + 15);
        a0a = (a48 + 16);
        a1a = (a48 + 17);
        a2a = (a48 + 18);
        a3a = (a48 + 19);
        a4a = (a48 + 20);
        a5a = (a48 + 21);
        a6a = (a48 + 22);
        a7a = (a48 + 23);
        a8a = (a48 + 24);
        a9a = (a48 + 25);
        a0b = (a48 + 26);
        a1b = (a48 + 27);
        a2b = (a48 + 28);
        a3b = (a48 + 29);
        a4b = (a48 + 30);
        a5b = (a48 + 31);
        b3 = (T + a38);
        *((b3 + 32)) = ((*(a48)*t3e) + (*(a58)*t4e));
        *((b3 + 48)) = ((*(a48)*t4e) - (*(a58)*t3e));
        *((b3 + 33)) = ((*(a68)*t9f) + (*(a78)*t0g));
        *((b3 + 49)) = ((*(a68)*t0g) - (*(a78)*t9f));
        *((b3 + 34)) = ((*(a88)*t5h) + (*(a98)*t6h));
        *((b3 + 50)) = ((*(a88)*t6h) - (*(a98)*t5h));
        *((b3 + 35)) = ((*(a09)*t1j) + (*(a19)*t2j));
        *((b3 + 51)) = ((*(a09)*t2j) - (*(a19)*t1j));
        *((b3 + 36)) = ((*(a29)*t7e) + (*(a39)*t8e));
        *((b3 + 52)) = ((*(a29)*t8e) - (*(a39)*t7e));
        *((b3 + 37)) = ((*(a49)*t3g) + (*(a59)*t4g));
        *((b3 + 53)) = ((*(a49)*t4g) - (*(a59)*t3g));
        *((b3 + 38)) = ((*(a69)*t9h) + (*(a79)*t0i));
        *((b3 + 54)) = ((*(a69)*t0i) - (*(a79)*t9h));
        *((b3 + 39)) = ((*(a89)*t5j) + (*(a99)*t6j));
        *((b3 + 55)) = ((*(a89)*t6j) - (*(a99)*t5j));
        *((b3 + 40)) = ((*(a0a)*t5e) + (*(a1a)*t6e));
        *((b3 + 56)) = ((*(a0a)*t6e) - (*(a1a)*t5e));
        *((b3 + 41)) = ((*(a2a)*t1g) + (*(a3a)*t2g));
        *((b3 + 57)) = ((*(a2a)*t2g) - (*(a3a)*t1g));
        *((b3 + 42)) = ((*(a4a)*t7h) + (*(a5a)*t8h));
        *((b3 + 58)) = ((*(a4a)*t8h) - (*(a5a)*t7h));
        *((b3 + 43)) = ((*(a6a)*t3j) + (*(a7a)*t4j));
        *((b3 + 59)) = ((*(a6a)*t4j) - (*(a7a)*t3j));
        *((b3 + 44)) = ((*(a8a)*t9e) + (*(a9a)*t0f));
        *((b3 + 60)) = ((*(a8a)*t0f) - (*(a9a)*t9e));
        *((b3 + 45)) = ((*(a0b)*t5g) + (*(a1b)*t6g));
        *((b3 + 61)) = ((*(a0b)*t6g) - (*(a1b)*t5g));
        *((b3 + 46)) = ((*(a2b)*t1i) + (*(a3b)*t2i));
        *((b3 + 62)) = ((*(a2b)*t2i) - (*(a3b)*t1i));
        *((b3 + 47)) = ((*(a4b)*t7j) + (*(a5b)*t8j));
        *((b3 + 63)) = ((*(a4b)*t8j) - (*(a5b)*t7j));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a6b = (T + i2);
        a7b = (a6b + 128);
        t9j = (*(a6b) + *(a7b));
        t0k = (*(a6b) - *(a7b));
        a8b = (a6b + 16);
        a9b = (a6b + 144);
        t1k = (*(a8b) - *(a9b));
        t2k = (*(a8b) + *(a9b));
        a0c = (a6b + 64);
        a1c = (a6b + 80);
        a2c = (a6b + 192);
        a3c = (a6b + 208);
        t3k = (*(a0c) + *(a2c));
        t4k = (*(a1c) - *(a3c));
        a4c = (0.70710678118654757*(*(a0c) - *(a2c)));
        a5c = (0.70710678118654757*(*(a1c) + *(a3c)));
        s55 = (a4c - a5c);
        s65 = (a4c + a5c);
        t5k = (t9j + t3k);
        t6k = (t9j - t3k);
        t7k = (t0k - t4k);
        t8k = (t0k + t4k);
        t9k = (t1k + s55);
        t0l = (t1k - s55);
        t1l = (t2k - s65);
        t2l = (t2k + s65);
        a6c = (a6b + 32);
        a7c = (a6b + 48);
        a8c = (a6b + 224);
        a9c = (a6b + 240);
        t3l = (*(a6c) + *(a8c));
        t4l = (*(a7c) - *(a9c));
        t5l = (*(a6c) - *(a8c));
        t6l = (*(a7c) + *(a9c));
        a0d = (a6b + 160);
        a1d = (a6b + 176);
        a2d = (a6b + 96);
        a3d = (a6b + 112);
        t7l = (*(a0d) + *(a2d));
        t8l = (*(a1d) - *(a3d));
        t9l = (*(a0d) - *(a2d));
        t0m = (*(a1d) + *(a3d));
        t1m = (t3l + t7l);
        t2m = (t4l + t8l);
        t3m = (t5l - t0m);
        t4m = (t6l + t9l);
        t5m = (t5l + t0m);
        t6m = (t6l - t9l);
        s75 = ((0.92387953251128674*t3m) - (0.38268343236508978*t4m));
        s85 = ((0.38268343236508978*t3m) + (0.92387953251128674*t4m));
        a4d = (0.70710678118654757*(t3l - t7l));
        a5d = (0.70710678118654757*(t4l - t8l));
        s95 = (a4d - a5d);
        s06 = (a4d + a5d);
        s16 = ((0.38268343236508978*t5m) - (0.92387953251128674*t6m));
        s26 = ((0.92387953251128674*t5m) + (0.38268343236508978*t6m));
        a6d = (dst + i2);
        *(a6d) = (t5k + t1m);
        *((a6d + 128)) = (t5k - t1m);
        *((a6d + 64)) = (t6k - t2m);
        *((a6d + 192)) = (t6k + t2m);
        *((a6d + 16)) = (t9k + s75);
        *((a6d + 144)) = (t9k - s75);
        *((a6d + 80)) = (t0l - s85);
        *((a6d + 208)) = (t0l + s85);
        *((a6d + 32)) = (t7k + s95);
        *((a6d + 160)) = (t7k - s95);
        *((a6d + 96)) = (t8k - s06);
        *((a6d + 224)) = (t8k + s06);
        *((a6d + 48)) = (t1l + s16);
        *((a6d + 176)) = (t1l - s16);
        *((a6d + 112)) = (t2l - s26);
        *((a6d + 240)) = (t2l + s26);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_512)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[512];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a29, *a2a, *a2b, *a2c, *a2d, *a39, *a3a, *a3b
            , *a3c, *a3d, *a48, *a49, *a4a, *a4b, *a4d, *a4e, *a4f, *a58, *a59, *a5a, *a5b, *a5d, *a5e, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a6e
            , *a78, *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a98, *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *b3;
    const double  *a, *a01, *a02, *a03, *a05, *a08, *a11, *a12, *a13, *a15, *a16, *a2, *a21, *a22, *a23, *a25, *a26, *a3, *a31, *a32, *a33, *a34
            , *a35, *a36, *a37, *a4, *a41, *a44, *a45, *a46, *a47, *a5, *a51, *a54, *a55, *a56, *a57, *a61, *a62, *a64, *a65, *a66, *a67, *a71
            , *a72, *a74, *a75, *a76, *a77, *a8, *a81, *a82, *a84, *a85, *a86, *a87, *a9, *a91, *a92, *a94, *a97, *b, *b2;
    int a24, a38;
    double a04, a06, a07, a0g, a14, a17, a18, a27, a28, a2e, a2f, a3e, a3f, a42, a43, a4c, a52, a53, a5c, a5f, a6, a63
            , a6f, a7, a73, a7f, a83, a8f, a93, a95, a96, a9f, s, s01, s02, s03, s04, s05, s06, s07, s08, s11, s12, s13
            , s14, s15, s16, s17, s18, s2, s21, s22, s23, s24, s25, s26, s27, s28, s3, s31, s32, s33, s34, s35, s36, s37
            , s4, s41, s42, s43, s44, s45, s46, s47, s5, s51, s52, s53, s54, s55, s56, s57, s6, s61, s62, s63, s64, s65
            , s66, s67, s7, s71, s72, s73, s74, s75, s76, s77, s8, s81, s82, s83, s84, s85, s86, s87, s9, s91, s92, s93
            , s94, s95, s96, s97, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h
            , t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q, t0r, t0s, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b
            , t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t2, t21, t22, t23, t24
            , t25, t26, t27, t28, t29, t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q
            , t2r, t2s, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j
            , t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d
            , t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t5, t51, t52, t53, t54, t55, t56, t57
            , t58, t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t6, t61
            , t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n
            , t6o, t6p, t6q, t6r, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h
            , t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t8, t81, t82, t83, t84, t85, t86, t87, t88, t89, t8a, t8b
            , t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t9, t91, t92, t93, t94, t95
            , t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p, t9q, t9r;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 256)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 257)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 128);
    a3 = (src + 384);
    a4 = (src + 129);
    a5 = (src + 385);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 32);
    a9 = (src + 480);
    t51 = (*(a8) + *(a9));
    a01 = (src + 33);
    a11 = (src + 481);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 288);
    a31 = (src + 224);
    t91 = (*(a21) + *(a31));
    a41 = (src + 289);
    a51 = (src + 225);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t51 - t91);
    t42 = (t61 - t02);
    t52 = (t71 - t22);
    t62 = (t81 + t12);
    t72 = (t71 + t22);
    t82 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.9615705608064609*t52) - (0.39018064403225655*t62));
    s01 = ((0.39018064403225655*t52) + (1.9615705608064609*t62));
    s11 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s21 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    s31 = ((1.6629392246050905*t72) - (1.1111404660392044*t82));
    s41 = ((1.1111404660392044*t72) + (1.6629392246050905*t82));
    a61 = (src + 64);
    a71 = (src + 448);
    t92 = (*(a61) + *(a71));
    a81 = (src + 65);
    a91 = (src + 449);
    t03 = (*(a81) - *(a91));
    t13 = (*(a61) - *(a71));
    t23 = (*(a81) + *(a91));
    a02 = (src + 320);
    a12 = (src + 192);
    t33 = (*(a02) + *(a12));
    a22 = (src + 321);
    a32 = (src + 193);
    t43 = (*(a22) - *(a32));
    t53 = (*(a02) - *(a12));
    t63 = (*(a22) + *(a32));
    t73 = (t13 - t63);
    t83 = (t23 + t53);
    t93 = (t13 + t63);
    t04 = (t23 - t53);
    s51 = (2.0*(t92 + t33));
    s61 = (2.0*(t03 + t43));
    s71 = ((1.8477590650225735*t73) - (0.76536686473017956*t83));
    s81 = ((0.76536686473017956*t73) + (1.8477590650225735*t83));
    a42 = (1.4142135623730951*(t92 - t33));
    a52 = (1.4142135623730951*(t03 - t43));
    s91 = (a42 - a52);
    s02 = (a42 + a52);
    s12 = ((0.76536686473017956*t93) - (1.8477590650225735*t04));
    s22 = ((1.8477590650225735*t93) + (0.76536686473017956*t04));
    a62 = (src + 96);
    a72 = (src + 416);
    t14 = (*(a62) + *(a72));
    a82 = (src + 97);
    a92 = (src + 417);
    t24 = (*(a82) - *(a92));
    t34 = (*(a62) - *(a72));
    t44 = (*(a82) + *(a92));
    a03 = (src + 352);
    a13 = (src + 160);
    t54 = (*(a03) + *(a13));
    a23 = (src + 353);
    a33 = (src + 161);
    t64 = (*(a23) - *(a33));
    t74 = (*(a03) - *(a13));
    t84 = (*(a23) + *(a33));
    t94 = (t14 - t54);
    t05 = (t24 - t64);
    t15 = (t34 - t84);
    t25 = (t44 + t74);
    t35 = (t34 + t84);
    t45 = (t44 - t74);
    s32 = (2.0*(t14 + t54));
    s42 = (2.0*(t24 + t64));
    s52 = ((1.6629392246050905*t15) - (1.1111404660392044*t25));
    s62 = ((1.1111404660392044*t15) + (1.6629392246050905*t25));
    s72 = ((0.76536686473017956*t94) - (1.8477590650225735*t05));
    s82 = ((1.8477590650225735*t94) + (0.76536686473017956*t05));
    s92 = ((0.39018064403225655*t35) + (1.9615705608064609*t45));
    s03 = ((1.9615705608064609*t35) - (0.39018064403225655*t45));
    t55 = (t7 + s51);
    t65 = (t7 - s51);
    t75 = (t8 - s61);
    t85 = (t8 + s61);
    t95 = (s7 + s32);
    t06 = (s8 - s42);
    a43 = (0.70710678118654757*(s7 - s32));
    a53 = (0.70710678118654757*(s8 + s42));
    s13 = (a43 - a53);
    s23 = (a43 + a53);
    *(T) = (t55 + t95);
    *((T + 16)) = (t55 - t95);
    *((T + 8)) = (t65 - t06);
    *((T + 24)) = (t65 + t06);
    *((T + 4)) = (t75 + s13);
    *((T + 20)) = (t75 - s13);
    *((T + 12)) = (t85 - s23);
    *((T + 28)) = (t85 + s23);
    t16 = (t11 + s71);
    t26 = (t11 - s71);
    t36 = (t21 - s81);
    t46 = (t21 + s81);
    t56 = (s9 + s52);
    t66 = (s01 - s62);
    a63 = (0.70710678118654757*(s9 - s52));
    a73 = (0.70710678118654757*(s01 + s62));
    s33 = (a63 - a73);
    s43 = (a63 + a73);
    *((T + 1)) = (t16 + t56);
    *((T + 17)) = (t16 - t56);
    *((T + 9)) = (t26 - t66);
    *((T + 25)) = (t26 + t66);
    *((T + 5)) = (t36 + s33);
    *((T + 21)) = (t36 - s33);
    *((T + 13)) = (t46 - s43);
    *((T + 29)) = (t46 + s43);
    t76 = (t9 + s91);
    t86 = (t9 - s91);
    t96 = (t01 - s02);
    t07 = (t01 + s02);
    t17 = (s11 + s72);
    t27 = (s21 - s82);
    a83 = (0.70710678118654757*(s11 - s72));
    a93 = (0.70710678118654757*(s21 + s82));
    s53 = (a83 - a93);
    s63 = (a83 + a93);
    *((T + 2)) = (t76 + t17);
    *((T + 18)) = (t76 - t17);
    *((T + 10)) = (t86 - t27);
    *((T + 26)) = (t86 + t27);
    *((T + 6)) = (t96 + s53);
    *((T + 22)) = (t96 - s53);
    *((T + 14)) = (t07 - s63);
    *((T + 30)) = (t07 + s63);
    t37 = (t31 + s12);
    t47 = (t31 - s12);
    t57 = (t41 - s22);
    t67 = (t41 + s22);
    t77 = (s31 - s92);
    t87 = (s41 - s03);
    a04 = (0.70710678118654757*(s31 + s92));
    a14 = (0.70710678118654757*(s41 + s03));
    s73 = (a04 - a14);
    s83 = (a04 + a14);
    *((T + 3)) = (t37 + t77);
    *((T + 19)) = (t37 - t77);
    *((T + 11)) = (t47 - t87);
    *((T + 27)) = (t47 + t87);
    *((T + 7)) = (t57 + s73);
    *((T + 23)) = (t57 - s73);
    *((T + 15)) = (t67 - s83);
    *((T + 31)) = (t67 + s83);
    {long i; for(i = 0; i <= 14; i++) {
        a24 = (2*i);
        b = (src + a24);
        a34 = (b + 2);
        a44 = (b + 3);
        b2 = (src - a24);
        a54 = (b2 + 510);
        a64 = (b2 + 511);
        t97 = (*(a34) + *(a54));
        t08 = (*(a44) - *(a64));
        t18 = (*(a34) - *(a54));
        t28 = (*(a44) + *(a64));
        a74 = (b + 258);
        a84 = (b + 259);
        a94 = (b2 + 254);
        a05 = (b2 + 255);
        t38 = (*(a74) + *(a94));
        t48 = (*(a84) - *(a05));
        t58 = (*(a74) - *(a94));
        t68 = (*(a84) + *(a05));
        t78 = (t97 + t38);
        t88 = (t08 + t48);
        t98 = (t97 - t38);
        t09 = (t08 - t48);
        t19 = (t18 - t68);
        t29 = (t28 + t58);
        t39 = (t18 + t68);
        t49 = (t28 - t58);
        a15 = (b + 66);
        a25 = (b + 67);
        a35 = (b2 + 446);
        a45 = (b2 + 447);
        t59 = (*(a15) + *(a35));
        t69 = (*(a25) - *(a45));
        t79 = (*(a15) - *(a35));
        t89 = (*(a25) + *(a45));
        a55 = (b + 322);
        a65 = (b + 323);
        a75 = (b2 + 190);
        a85 = (b2 + 191);
        t99 = (*(a55) + *(a75));
        t0a = (*(a65) - *(a85));
        t1a = (*(a55) - *(a75));
        t2a = (*(a65) + *(a85));
        t3a = (t59 + t99);
        t4a = (t69 + t0a);
        a95 = (0.70710678118654757*(t59 - t99));
        a06 = (0.70710678118654757*(t69 - t0a));
        s93 = (a95 - a06);
        s04 = (a95 + a06);
        t5a = (t79 - t2a);
        t6a = (t89 + t1a);
        t7a = (t79 + t2a);
        t8a = (t89 - t1a);
        s14 = ((0.92387953251128674*t5a) - (0.38268343236508978*t6a));
        s24 = ((0.38268343236508978*t5a) + (0.92387953251128674*t6a));
        s34 = ((0.38268343236508978*t7a) - (0.92387953251128674*t8a));
        s44 = ((0.92387953251128674*t7a) + (0.38268343236508978*t8a));
        a16 = (b + 130);
        a26 = (b + 131);
        a36 = (b2 + 382);
        a46 = (b2 + 383);
        t9a = (*(a16) + *(a36));
        t0b = (*(a26) - *(a46));
        t1b = (*(a16) - *(a36));
        t2b = (*(a26) + *(a46));
        a56 = (b + 386);
        a66 = (b + 387);
        a76 = (b2 + 126);
        a86 = (b2 + 127);
        t3b = (*(a56) + *(a76));
        t4b = (*(a66) - *(a86));
        t5b = (*(a56) - *(a76));
        t6b = (*(a66) + *(a86));
        t7b = (t9a + t3b);
        t8b = (t0b + t4b);
        t9b = (t9a - t3b);
        t0c = (t0b - t4b);
        a96 = (0.70710678118654757*(t1b - t6b));
        a07 = (0.70710678118654757*(t2b + t5b));
        s54 = (a96 - a07);
        s64 = (a96 + a07);
        a17 = (0.70710678118654757*(t1b + t6b));
        a27 = (0.70710678118654757*(t2b - t5b));
        s74 = (a17 + a27);
        s84 = (a17 - a27);
        a37 = (b + 194);
        a47 = (b + 195);
        a57 = (b2 + 318);
        a67 = (b2 + 319);
        t1c = (*(a37) + *(a57));
        t2c = (*(a47) - *(a67));
        t3c = (*(a37) - *(a57));
        t4c = (*(a47) + *(a67));
        a77 = (b + 450);
        a87 = (b + 451);
        a97 = (b2 + 62);
        a08 = (b2 + 63);
        t5c = (*(a77) + *(a97));
        t6c = (*(a87) - *(a08));
        t7c = (*(a77) - *(a97));
        t8c = (*(a87) + *(a08));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        a18 = (0.70710678118654757*(t1c - t5c));
        a28 = (0.70710678118654757*(t2c - t6c));
        s94 = (a18 + a28);
        s05 = (a18 - a28);
        t1d = (t3c - t8c);
        t2d = (t4c + t7c);
        t3d = (t3c + t8c);
        t4d = (t4c - t7c);
        s15 = ((0.38268343236508978*t1d) - (0.92387953251128674*t2d));
        s25 = ((0.92387953251128674*t1d) + (0.38268343236508978*t2d));
        s35 = ((0.38268343236508978*t4d) - (0.92387953251128674*t3d));
        s45 = ((0.38268343236508978*t3d) + (0.92387953251128674*t4d));
        t5d = (t78 + t7b);
        t6d = (t88 + t8b);
        t7d = (t78 - t7b);
        t8d = (t88 - t8b);
        t9d = (t3a + t9c);
        t0e = (t4a + t0d);
        t1e = (t3a - t9c);
        t2e = (t4a - t0d);
        t3e = (t5d + t9d);
        t4e = (t6d + t0e);
        t5e = (t5d - t9d);
        t6e = (t6d - t0e);
        t7e = (t7d - t2e);
        t8e = (t8d + t1e);
        t9e = (t7d + t2e);
        t0f = (t8d - t1e);
        t1f = (t19 + s54);
        t2f = (t29 + s64);
        t3f = (t19 - s54);
        t4f = (t29 - s64);
        t5f = (s14 + s15);
        t6f = (s24 + s25);
        t7f = (s14 - s15);
        t8f = (s24 - s25);
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        t3g = (t3f - t8f);
        t4g = (t4f + t7f);
        t5g = (t3f + t8f);
        t6g = (t4f - t7f);
        t7g = (t98 - t0c);
        t8g = (t09 + t9b);
        t9g = (t98 + t0c);
        t0h = (t09 - t9b);
        t1h = (s93 - s94);
        t2h = (s04 + s05);
        t3h = (s93 + s94);
        t4h = (s04 - s05);
        t5h = (t7g + t1h);
        t6h = (t8g + t2h);
        t7h = (t7g - t1h);
        t8h = (t8g - t2h);
        t9h = (t9g - t4h);
        t0i = (t0h + t3h);
        t1i = (t9g + t4h);
        t2i = (t0h - t3h);
        t3i = (t39 - s74);
        t4i = (t49 + s84);
        t5i = (t39 + s74);
        t6i = (t49 - s84);
        t7i = (s34 + s35);
        t8i = (s44 - s45);
        t9i = (s34 - s35);
        t0j = (s44 + s45);
        t1j = (t3i + t7i);
        t2j = (t4i + t8i);
        t3j = (t3i - t7i);
        t4j = (t4i - t8i);
        t5j = (t5i - t0j);
        t6j = (t6i + t9i);
        t7j = (t5i + t0j);
        t8j = (t6i - t9i);
        a38 = (32*i);
        a48 = (D278 + a38);
        a58 = (a48 + 1);
        a68 = (a48 + 2);
        a78 = (a48 + 3);
        a88 = (a48 + 4);
        a98 = (a48 + 5);
        a09 = (a48 + 6);
        a19 = (a48 + 7);
        a29 = (a48 + 8);
        a39 = (a48 + 9);
        a49 = (a48 + 10);
        a59 = (a48 + 11);
        a69 = (a48 + 12);
        a79 = (a48 + 13);
        a89 = (a48 + 14);
        a99 = (a48 + 15);
        a0a = (a48 + 16);
        a1a = (a48 + 17);
        a2a = (a48 + 18);
        a3a = (a48 + 19);
        a4a = (a48 + 20);
        a5a = (a48 + 21);
        a6a = (a48 + 22);
        a7a = (a48 + 23);
        a8a = (a48 + 24);
        a9a = (a48 + 25);
        a0b = (a48 + 26);
        a1b = (a48 + 27);
        a2b = (a48 + 28);
        a3b = (a48 + 29);
        a4b = (a48 + 30);
        a5b = (a48 + 31);
        b3 = (T + a38);
        *((b3 + 32)) = ((*(a48)*t3e) + (*(a58)*t4e));
        *((b3 + 48)) = ((*(a48)*t4e) - (*(a58)*t3e));
        *((b3 + 33)) = ((*(a68)*t9f) + (*(a78)*t0g));
        *((b3 + 49)) = ((*(a68)*t0g) - (*(a78)*t9f));
        *((b3 + 34)) = ((*(a88)*t5h) + (*(a98)*t6h));
        *((b3 + 50)) = ((*(a88)*t6h) - (*(a98)*t5h));
        *((b3 + 35)) = ((*(a09)*t1j) + (*(a19)*t2j));
        *((b3 + 51)) = ((*(a09)*t2j) - (*(a19)*t1j));
        *((b3 + 36)) = ((*(a29)*t7e) + (*(a39)*t8e));
        *((b3 + 52)) = ((*(a29)*t8e) - (*(a39)*t7e));
        *((b3 + 37)) = ((*(a49)*t3g) + (*(a59)*t4g));
        *((b3 + 53)) = ((*(a49)*t4g) - (*(a59)*t3g));
        *((b3 + 38)) = ((*(a69)*t9h) + (*(a79)*t0i));
        *((b3 + 54)) = ((*(a69)*t0i) - (*(a79)*t9h));
        *((b3 + 39)) = ((*(a89)*t5j) + (*(a99)*t6j));
        *((b3 + 55)) = ((*(a89)*t6j) - (*(a99)*t5j));
        *((b3 + 40)) = ((*(a0a)*t5e) + (*(a1a)*t6e));
        *((b3 + 56)) = ((*(a0a)*t6e) - (*(a1a)*t5e));
        *((b3 + 41)) = ((*(a2a)*t1g) + (*(a3a)*t2g));
        *((b3 + 57)) = ((*(a2a)*t2g) - (*(a3a)*t1g));
        *((b3 + 42)) = ((*(a4a)*t7h) + (*(a5a)*t8h));
        *((b3 + 58)) = ((*(a4a)*t8h) - (*(a5a)*t7h));
        *((b3 + 43)) = ((*(a6a)*t3j) + (*(a7a)*t4j));
        *((b3 + 59)) = ((*(a6a)*t4j) - (*(a7a)*t3j));
        *((b3 + 44)) = ((*(a8a)*t9e) + (*(a9a)*t0f));
        *((b3 + 60)) = ((*(a8a)*t0f) - (*(a9a)*t9e));
        *((b3 + 45)) = ((*(a0b)*t5g) + (*(a1b)*t6g));
        *((b3 + 61)) = ((*(a0b)*t6g) - (*(a1b)*t5g));
        *((b3 + 46)) = ((*(a2b)*t1i) + (*(a3b)*t2i));
        *((b3 + 62)) = ((*(a2b)*t2i) - (*(a3b)*t1i));
        *((b3 + 47)) = ((*(a4b)*t7j) + (*(a5b)*t8j));
        *((b3 + 63)) = ((*(a4b)*t8j) - (*(a5b)*t7j));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a6b = (T + i2);
        a7b = (a6b + 256);
        t9j = (*(a6b) + *(a7b));
        t0k = (*(a6b) - *(a7b));
        a8b = (a6b + 16);
        a9b = (a6b + 272);
        t1k = (*(a8b) - *(a9b));
        t2k = (*(a8b) + *(a9b));
        a0c = (a6b + 128);
        a1c = (a6b + 144);
        a2c = (a6b + 384);
        a3c = (a6b + 400);
        t3k = (*(a0c) + *(a2c));
        t4k = (*(a1c) - *(a3c));
        a4c = (0.70710678118654757*(*(a0c) - *(a2c)));
        a5c = (0.70710678118654757*(*(a1c) + *(a3c)));
        s55 = (a4c - a5c);
        s65 = (a4c + a5c);
        t5k = (t9j + t3k);
        t6k = (t9j - t3k);
        t7k = (t0k - t4k);
        t8k = (t0k + t4k);
        t9k = (t1k + s55);
        t0l = (t1k - s55);
        t1l = (t2k - s65);
        t2l = (t2k + s65);
        a6c = (a6b + 32);
        a7c = (a6b + 48);
        a8c = (a6b + 480);
        a9c = (a6b + 496);
        t3l = (*(a6c) + *(a8c));
        t4l = (*(a7c) - *(a9c));
        t5l = (*(a6c) - *(a8c));
        t6l = (*(a7c) + *(a9c));
        a0d = (a6b + 288);
        a1d = (a6b + 304);
        a2d = (a6b + 224);
        a3d = (a6b + 240);
        t7l = (*(a0d) + *(a2d));
        t8l = (*(a1d) - *(a3d));
        t9l = (*(a0d) - *(a2d));
        t0m = (*(a1d) + *(a3d));
        t1m = (t3l + t7l);
        t2m = (t4l + t8l);
        t3m = (t3l - t7l);
        t4m = (t4l - t8l);
        t5m = (t5l - t0m);
        t6m = (t6l + t9l);
        t7m = (t5l + t0m);
        t8m = (t6l - t9l);
        s75 = ((0.98078528040323043*t5m) - (0.19509032201612828*t6m));
        s85 = ((0.19509032201612828*t5m) + (0.98078528040323043*t6m));
        s95 = ((0.92387953251128674*t3m) - (0.38268343236508978*t4m));
        s06 = ((0.38268343236508978*t3m) + (0.92387953251128674*t4m));
        s16 = ((0.83146961230254524*t7m) - (0.55557023301960218*t8m));
        s26 = ((0.55557023301960218*t7m) + (0.83146961230254524*t8m));
        a4d = (a6b + 64);
        a5d = (a6b + 80);
        a6d = (a6b + 448);
        a7d = (a6b + 464);
        t9m = (*(a4d) + *(a6d));
        t0n = (*(a5d) - *(a7d));
        t1n = (*(a4d) - *(a6d));
        t2n = (*(a5d) + *(a7d));
        a8d = (a6b + 320);
        a9d = (a6b + 336);
        a0e = (a6b + 192);
        a1e = (a6b + 208);
        t3n = (*(a8d) + *(a0e));
        t4n = (*(a9d) - *(a1e));
        t5n = (*(a8d) - *(a0e));
        t6n = (*(a9d) + *(a1e));
        t7n = (t9m + t3n);
        t8n = (t0n + t4n);
        t9n = (t1n - t6n);
        t0o = (t2n + t5n);
        t1o = (t1n + t6n);
        t2o = (t2n - t5n);
        s36 = ((0.92387953251128674*t9n) - (0.38268343236508978*t0o));
        s46 = ((0.38268343236508978*t9n) + (0.92387953251128674*t0o));
        a2e = (0.70710678118654757*(t9m - t3n));
        a3e = (0.70710678118654757*(t0n - t4n));
        s56 = (a2e - a3e);
        s66 = (a2e + a3e);
        s76 = ((0.38268343236508978*t1o) - (0.92387953251128674*t2o));
        s86 = ((0.92387953251128674*t1o) + (0.38268343236508978*t2o));
        a4e = (a6b + 96);
        a5e = (a6b + 112);
        a6e = (a6b + 416);
        a7e = (a6b + 432);
        t3o = (*(a4e) + *(a6e));
        t4o = (*(a5e) - *(a7e));
        t5o = (*(a4e) - *(a6e));
        t6o = (*(a5e) + *(a7e));
        a8e = (a6b + 352);
        a9e = (a6b + 368);
        a0f = (a6b + 160);
        a1f = (a6b + 176);
        t7o = (*(a8e) + *(a0f));
        t8o = (*(a9e) - *(a1f));
        t9o = (*(a8e) - *(a0f));
        t0p = (*(a9e) + *(a1f));
        t1p = (t3o + t7o);
        t2p = (t4o + t8o);
        t3p = (t3o - t7o);
        t4p = (t4o - t8o);
        t5p = (t5o - t0p);
        t6p = (t6o + t9o);
        t7p = (t5o + t0p);
        t8p = (t6o - t9o);
        s96 = ((0.83146961230254524*t5p) - (0.55557023301960218*t6p));
        s07 = ((0.55557023301960218*t5p) + (0.83146961230254524*t6p));
        s17 = ((0.38268343236508978*t3p) - (0.92387953251128674*t4p));
        s27 = ((0.92387953251128674*t3p) + (0.38268343236508978*t4p));
        s37 = ((0.19509032201612828*t7p) + (0.98078528040323043*t8p));
        s47 = ((0.98078528040323043*t7p) - (0.19509032201612828*t8p));
        t9p = (t5k + t7n);
        t0q = (t5k - t7n);
        t1q = (t6k - t8n);
        t2q = (t6k + t8n);
        t3q = (t1m + t1p);
        t4q = (t2m - t2p);
        a2f = (0.70710678118654757*(t1m - t1p));
        a3f = (0.70710678118654757*(t2m + t2p));
        s57 = (a2f - a3f);
        s67 = (a2f + a3f);
        a4f = (dst + i2);
        *(a4f) = (t9p + t3q);
        *((a4f + 256)) = (t9p - t3q);
        *((a4f + 128)) = (t0q - t4q);
        *((a4f + 384)) = (t0q + t4q);
        *((a4f + 64)) = (t1q + s57);
        *((a4f + 320)) = (t1q - s57);
        *((a4f + 192)) = (t2q - s67);
        *((a4f + 448)) = (t2q + s67);
        t5q = (t9k + s36);
        t6q = (t9k - s36);
        t7q = (t0l - s46);
        t8q = (t0l + s46);
        t9q = (s75 + s96);
        t0r = (s85 - s07);
        a5f = (0.70710678118654757*(s75 - s96));
        a6f = (0.70710678118654757*(s85 + s07));
        s77 = (a5f - a6f);
        s87 = (a5f + a6f);
        *((a4f + 16)) = (t5q + t9q);
        *((a4f + 272)) = (t5q - t9q);
        *((a4f + 144)) = (t6q - t0r);
        *((a4f + 400)) = (t6q + t0r);
        *((a4f + 80)) = (t7q + s77);
        *((a4f + 336)) = (t7q - s77);
        *((a4f + 208)) = (t8q - s87);
        *((a4f + 464)) = (t8q + s87);
        t1r = (t7k + s56);
        t2r = (t7k - s56);
        t3r = (t8k - s66);
        t4r = (t8k + s66);
        t5r = (s95 + s17);
        t6r = (s06 - s27);
        a7f = (0.70710678118654757*(s95 - s17));
        a8f = (0.70710678118654757*(s06 + s27));
        s97 = (a7f - a8f);
        s08 = (a7f + a8f);
        *((a4f + 32)) = (t1r + t5r);
        *((a4f + 288)) = (t1r - t5r);
        *((a4f + 160)) = (t2r - t6r);
        *((a4f + 416)) = (t2r + t6r);
        *((a4f + 96)) = (t3r + s97);
        *((a4f + 352)) = (t3r - s97);
        *((a4f + 224)) = (t4r - s08);
        *((a4f + 480)) = (t4r + s08);
        t7r = (t1l + s76);
        t8r = (t1l - s76);
        t9r = (t2l - s86);
        t0s = (t2l + s86);
        t1s = (s16 - s37);
        t2s = (s26 - s47);
        a9f = (0.70710678118654757*(s16 + s37));
        a0g = (0.70710678118654757*(s26 + s47));
        s18 = (a9f - a0g);
        s28 = (a9f + a0g);
        *((a4f + 48)) = (t7r + t1s);
        *((a4f + 304)) = (t7r - t1s);
        *((a4f + 176)) = (t8r - t2s);
        *((a4f + 432)) = (t8r + t2s);
        *((a4f + 112)) = (t9r + s18);
        *((a4f + 368)) = (t9r - s18);
        *((a4f + 240)) = (t0s - s28);
        *((a4f + 496)) = (t0s + s28);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_1024)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[1024];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a0k, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g, *a1h, *a1i
            , *a1j, *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2g, *a2i, *a2j, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3g, *a3i, *a3j, *a48, *a49, *a4a
            , *a4b, *a4e, *a4g, *a4i, *a58, *a59, *a5a, *a5b, *a5e, *a5g, *a5i, *a68, *a69, *a6a, *a6b, *a6c, *a6d, *a6e, *a6f, *a6g, *a6i, *a78
            , *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7f, *a7g, *a7i, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a8g, *a8h, *a8i, *a98, *a99
            , *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i, *b3;
    const double  *a, *a01, *a02, *a03, *a05, *a08, *a11, *a12, *a13, *a15, *a16, *a2, *a21, *a22, *a23, *a25, *a26, *a3, *a31, *a32, *a33, *a34
            , *a35, *a36, *a37, *a4, *a41, *a44, *a45, *a46, *a47, *a5, *a51, *a54, *a55, *a56, *a57, *a61, *a62, *a64, *a65, *a66, *a67, *a71
            , *a72, *a74, *a75, *a76, *a77, *a8, *a81, *a82, *a84, *a85, *a86, *a87, *a9, *a91, *a92, *a94, *a97, *b, *b2;
    int a24, a38;
    double a04, a06, a07, a0l, a14, a17, a18, a1k, a1l, a27, a28, a2f, a2h, a2k, a2l, a3f, a3h, a3k, a3l, a42, a43, a4c
            , a4d, a4f, a4h, a4j, a4k, a4l, a52, a53, a5c, a5d, a5f, a5h, a5j, a5k, a6, a63, a6h, a6j, a6k, a7, a73, a7h
            , a7j, a7k, a83, a8j, a8k, a93, a95, a96, a9j, a9k, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b
            , s0c, s0d, s11, s12, s13, s14, s15, s16, s17, s18, s19, s1a, s1b, s1c, s1d, s2, s21, s22, s23, s24, s25, s26
            , s27, s28, s29, s2a, s2b, s2c, s2d, s3, s31, s32, s33, s34, s35, s36, s37, s38, s39, s3a, s3b, s3c, s4, s41
            , s42, s43, s44, s45, s46, s47, s48, s49, s4a, s4b, s4c, s5, s51, s52, s53, s54, s55, s56, s57, s58, s59, s5a
            , s5b, s5c, s6, s61, s62, s63, s64, s65, s66, s67, s68, s69, s6a, s6b, s6c, s7, s71, s72, s73, s74, s75, s76
            , s77, s78, s79, s7a, s7b, s7c, s8, s81, s82, s83, s84, s85, s86, s87, s88, s89, s8a, s8b, s8c, s9, s91, s92
            , s93, s94, s95, s96, s97, s98, s99, s9a, s9b, s9c, t, t01, t02, t03, t04, t05, t06, t07, t08, t09, t0A, t0B
            , t0C, t0D, t0E, t0F, t0G, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p, t0q
            , t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A, t1B, t1C, t1D
            , t1E, t1F, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t
            , t1u, t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F
            , t2a, t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v
            , t2w, t2x, t2y, t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3D, t3E, t3F, t3a, t3b
            , t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x
            , t3y, t3z, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4a, t4b, t4c, t4d
            , t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z
            , t5, t51, t52, t53, t54, t55, t56, t57, t58, t59, t5A, t5B, t5C, t5D, t5E, t5F, t5a, t5b, t5c, t5d, t5e, t5f
            , t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6, t61
            , t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6C, t6D, t6E, t6F, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h
            , t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w, t6x, t6y, t6z, t7, t71, t72, t73
            , t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D, t7E, t7F, t7a, t7b, t7c, t7d, t7e, t7f, t7g, t7h, t7i, t7j
            , t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81, t82, t83, t84, t85
            , t86, t87, t88, t89, t8A, t8B, t8C, t8D, t8E, t8F, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l
            , t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96, t97
            , t98, t99, t9A, t9B, t9C, t9D, t9E, t9F, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n
            , t9o, t9p, t9q, t9r, t9s, t9t, t9u, t9v, t9w, t9x, t9y, t9z;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 512)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 513)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 256);
    a3 = (src + 768);
    a4 = (src + 257);
    a5 = (src + 769);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 64);
    a9 = (src + 960);
    t51 = (*(a8) + *(a9));
    a01 = (src + 65);
    a11 = (src + 961);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 576);
    a31 = (src + 448);
    t91 = (*(a21) + *(a31));
    a41 = (src + 577);
    a51 = (src + 449);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t51 - t91);
    t42 = (t61 - t02);
    t52 = (t71 - t22);
    t62 = (t81 + t12);
    t72 = (t71 + t22);
    t82 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.9615705608064609*t52) - (0.39018064403225655*t62));
    s01 = ((0.39018064403225655*t52) + (1.9615705608064609*t62));
    s11 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s21 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    s31 = ((1.6629392246050905*t72) - (1.1111404660392044*t82));
    s41 = ((1.1111404660392044*t72) + (1.6629392246050905*t82));
    a61 = (src + 128);
    a71 = (src + 896);
    t92 = (*(a61) + *(a71));
    a81 = (src + 129);
    a91 = (src + 897);
    t03 = (*(a81) - *(a91));
    t13 = (*(a61) - *(a71));
    t23 = (*(a81) + *(a91));
    a02 = (src + 640);
    a12 = (src + 384);
    t33 = (*(a02) + *(a12));
    a22 = (src + 641);
    a32 = (src + 385);
    t43 = (*(a22) - *(a32));
    t53 = (*(a02) - *(a12));
    t63 = (*(a22) + *(a32));
    t73 = (t13 - t63);
    t83 = (t23 + t53);
    t93 = (t13 + t63);
    t04 = (t23 - t53);
    s51 = (2.0*(t92 + t33));
    s61 = (2.0*(t03 + t43));
    s71 = ((1.8477590650225735*t73) - (0.76536686473017956*t83));
    s81 = ((0.76536686473017956*t73) + (1.8477590650225735*t83));
    a42 = (1.4142135623730951*(t92 - t33));
    a52 = (1.4142135623730951*(t03 - t43));
    s91 = (a42 - a52);
    s02 = (a42 + a52);
    s12 = ((0.76536686473017956*t93) - (1.8477590650225735*t04));
    s22 = ((1.8477590650225735*t93) + (0.76536686473017956*t04));
    a62 = (src + 192);
    a72 = (src + 832);
    t14 = (*(a62) + *(a72));
    a82 = (src + 193);
    a92 = (src + 833);
    t24 = (*(a82) - *(a92));
    t34 = (*(a62) - *(a72));
    t44 = (*(a82) + *(a92));
    a03 = (src + 704);
    a13 = (src + 320);
    t54 = (*(a03) + *(a13));
    a23 = (src + 705);
    a33 = (src + 321);
    t64 = (*(a23) - *(a33));
    t74 = (*(a03) - *(a13));
    t84 = (*(a23) + *(a33));
    t94 = (t14 - t54);
    t05 = (t24 - t64);
    t15 = (t34 - t84);
    t25 = (t44 + t74);
    t35 = (t34 + t84);
    t45 = (t44 - t74);
    s32 = (2.0*(t14 + t54));
    s42 = (2.0*(t24 + t64));
    s52 = ((1.6629392246050905*t15) - (1.1111404660392044*t25));
    s62 = ((1.1111404660392044*t15) + (1.6629392246050905*t25));
    s72 = ((0.76536686473017956*t94) - (1.8477590650225735*t05));
    s82 = ((1.8477590650225735*t94) + (0.76536686473017956*t05));
    s92 = ((0.39018064403225655*t35) + (1.9615705608064609*t45));
    s03 = ((1.9615705608064609*t35) - (0.39018064403225655*t45));
    t55 = (t7 + s51);
    t65 = (t7 - s51);
    t75 = (t8 - s61);
    t85 = (t8 + s61);
    t95 = (s7 + s32);
    t06 = (s8 - s42);
    a43 = (0.70710678118654757*(s7 - s32));
    a53 = (0.70710678118654757*(s8 + s42));
    s13 = (a43 - a53);
    s23 = (a43 + a53);
    *(T) = (t55 + t95);
    *((T + 16)) = (t55 - t95);
    *((T + 8)) = (t65 - t06);
    *((T + 24)) = (t65 + t06);
    *((T + 4)) = (t75 + s13);
    *((T + 20)) = (t75 - s13);
    *((T + 12)) = (t85 - s23);
    *((T + 28)) = (t85 + s23);
    t16 = (t11 + s71);
    t26 = (t11 - s71);
    t36 = (t21 - s81);
    t46 = (t21 + s81);
    t56 = (s9 + s52);
    t66 = (s01 - s62);
    a63 = (0.70710678118654757*(s9 - s52));
    a73 = (0.70710678118654757*(s01 + s62));
    s33 = (a63 - a73);
    s43 = (a63 + a73);
    *((T + 1)) = (t16 + t56);
    *((T + 17)) = (t16 - t56);
    *((T + 9)) = (t26 - t66);
    *((T + 25)) = (t26 + t66);
    *((T + 5)) = (t36 + s33);
    *((T + 21)) = (t36 - s33);
    *((T + 13)) = (t46 - s43);
    *((T + 29)) = (t46 + s43);
    t76 = (t9 + s91);
    t86 = (t9 - s91);
    t96 = (t01 - s02);
    t07 = (t01 + s02);
    t17 = (s11 + s72);
    t27 = (s21 - s82);
    a83 = (0.70710678118654757*(s11 - s72));
    a93 = (0.70710678118654757*(s21 + s82));
    s53 = (a83 - a93);
    s63 = (a83 + a93);
    *((T + 2)) = (t76 + t17);
    *((T + 18)) = (t76 - t17);
    *((T + 10)) = (t86 - t27);
    *((T + 26)) = (t86 + t27);
    *((T + 6)) = (t96 + s53);
    *((T + 22)) = (t96 - s53);
    *((T + 14)) = (t07 - s63);
    *((T + 30)) = (t07 + s63);
    t37 = (t31 + s12);
    t47 = (t31 - s12);
    t57 = (t41 - s22);
    t67 = (t41 + s22);
    t77 = (s31 - s92);
    t87 = (s41 - s03);
    a04 = (0.70710678118654757*(s31 + s92));
    a14 = (0.70710678118654757*(s41 + s03));
    s73 = (a04 - a14);
    s83 = (a04 + a14);
    *((T + 3)) = (t37 + t77);
    *((T + 19)) = (t37 - t77);
    *((T + 11)) = (t47 - t87);
    *((T + 27)) = (t47 + t87);
    *((T + 7)) = (t57 + s73);
    *((T + 23)) = (t57 - s73);
    *((T + 15)) = (t67 - s83);
    *((T + 31)) = (t67 + s83);
    {long i; for(i = 0; i <= 30; i++) {
        a24 = (2*i);
        b = (src + a24);
        a34 = (b + 2);
        a44 = (b + 3);
        b2 = (src - a24);
        a54 = (b2 + 1022);
        a64 = (b2 + 1023);
        t97 = (*(a34) + *(a54));
        t08 = (*(a44) - *(a64));
        t18 = (*(a34) - *(a54));
        t28 = (*(a44) + *(a64));
        a74 = (b + 514);
        a84 = (b + 515);
        a94 = (b2 + 510);
        a05 = (b2 + 511);
        t38 = (*(a74) + *(a94));
        t48 = (*(a84) - *(a05));
        t58 = (*(a74) - *(a94));
        t68 = (*(a84) + *(a05));
        t78 = (t97 + t38);
        t88 = (t08 + t48);
        t98 = (t97 - t38);
        t09 = (t08 - t48);
        t19 = (t18 - t68);
        t29 = (t28 + t58);
        t39 = (t18 + t68);
        t49 = (t28 - t58);
        a15 = (b + 130);
        a25 = (b + 131);
        a35 = (b2 + 894);
        a45 = (b2 + 895);
        t59 = (*(a15) + *(a35));
        t69 = (*(a25) - *(a45));
        t79 = (*(a15) - *(a35));
        t89 = (*(a25) + *(a45));
        a55 = (b + 642);
        a65 = (b + 643);
        a75 = (b2 + 382);
        a85 = (b2 + 383);
        t99 = (*(a55) + *(a75));
        t0a = (*(a65) - *(a85));
        t1a = (*(a55) - *(a75));
        t2a = (*(a65) + *(a85));
        t3a = (t59 + t99);
        t4a = (t69 + t0a);
        a95 = (0.70710678118654757*(t59 - t99));
        a06 = (0.70710678118654757*(t69 - t0a));
        s93 = (a95 - a06);
        s04 = (a95 + a06);
        t5a = (t79 - t2a);
        t6a = (t89 + t1a);
        t7a = (t79 + t2a);
        t8a = (t89 - t1a);
        s14 = ((0.92387953251128674*t5a) - (0.38268343236508978*t6a));
        s24 = ((0.38268343236508978*t5a) + (0.92387953251128674*t6a));
        s34 = ((0.38268343236508978*t7a) - (0.92387953251128674*t8a));
        s44 = ((0.92387953251128674*t7a) + (0.38268343236508978*t8a));
        a16 = (b + 258);
        a26 = (b + 259);
        a36 = (b2 + 766);
        a46 = (b2 + 767);
        t9a = (*(a16) + *(a36));
        t0b = (*(a26) - *(a46));
        t1b = (*(a16) - *(a36));
        t2b = (*(a26) + *(a46));
        a56 = (b + 770);
        a66 = (b + 771);
        a76 = (b2 + 254);
        a86 = (b2 + 255);
        t3b = (*(a56) + *(a76));
        t4b = (*(a66) - *(a86));
        t5b = (*(a56) - *(a76));
        t6b = (*(a66) + *(a86));
        t7b = (t9a + t3b);
        t8b = (t0b + t4b);
        t9b = (t9a - t3b);
        t0c = (t0b - t4b);
        a96 = (0.70710678118654757*(t1b - t6b));
        a07 = (0.70710678118654757*(t2b + t5b));
        s54 = (a96 - a07);
        s64 = (a96 + a07);
        a17 = (0.70710678118654757*(t1b + t6b));
        a27 = (0.70710678118654757*(t2b - t5b));
        s74 = (a17 + a27);
        s84 = (a17 - a27);
        a37 = (b + 386);
        a47 = (b + 387);
        a57 = (b2 + 638);
        a67 = (b2 + 639);
        t1c = (*(a37) + *(a57));
        t2c = (*(a47) - *(a67));
        t3c = (*(a37) - *(a57));
        t4c = (*(a47) + *(a67));
        a77 = (b + 898);
        a87 = (b + 899);
        a97 = (b2 + 126);
        a08 = (b2 + 127);
        t5c = (*(a77) + *(a97));
        t6c = (*(a87) - *(a08));
        t7c = (*(a77) - *(a97));
        t8c = (*(a87) + *(a08));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        a18 = (0.70710678118654757*(t1c - t5c));
        a28 = (0.70710678118654757*(t2c - t6c));
        s94 = (a18 + a28);
        s05 = (a18 - a28);
        t1d = (t3c - t8c);
        t2d = (t4c + t7c);
        t3d = (t3c + t8c);
        t4d = (t4c - t7c);
        s15 = ((0.38268343236508978*t1d) - (0.92387953251128674*t2d));
        s25 = ((0.92387953251128674*t1d) + (0.38268343236508978*t2d));
        s35 = ((0.38268343236508978*t4d) - (0.92387953251128674*t3d));
        s45 = ((0.38268343236508978*t3d) + (0.92387953251128674*t4d));
        t5d = (t78 + t7b);
        t6d = (t88 + t8b);
        t7d = (t78 - t7b);
        t8d = (t88 - t8b);
        t9d = (t3a + t9c);
        t0e = (t4a + t0d);
        t1e = (t3a - t9c);
        t2e = (t4a - t0d);
        t3e = (t5d + t9d);
        t4e = (t6d + t0e);
        t5e = (t5d - t9d);
        t6e = (t6d - t0e);
        t7e = (t7d - t2e);
        t8e = (t8d + t1e);
        t9e = (t7d + t2e);
        t0f = (t8d - t1e);
        t1f = (t19 + s54);
        t2f = (t29 + s64);
        t3f = (t19 - s54);
        t4f = (t29 - s64);
        t5f = (s14 + s15);
        t6f = (s24 + s25);
        t7f = (s14 - s15);
        t8f = (s24 - s25);
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        t3g = (t3f - t8f);
        t4g = (t4f + t7f);
        t5g = (t3f + t8f);
        t6g = (t4f - t7f);
        t7g = (t98 - t0c);
        t8g = (t09 + t9b);
        t9g = (t98 + t0c);
        t0h = (t09 - t9b);
        t1h = (s93 - s94);
        t2h = (s04 + s05);
        t3h = (s93 + s94);
        t4h = (s04 - s05);
        t5h = (t7g + t1h);
        t6h = (t8g + t2h);
        t7h = (t7g - t1h);
        t8h = (t8g - t2h);
        t9h = (t9g - t4h);
        t0i = (t0h + t3h);
        t1i = (t9g + t4h);
        t2i = (t0h - t3h);
        t3i = (t39 - s74);
        t4i = (t49 + s84);
        t5i = (t39 + s74);
        t6i = (t49 - s84);
        t7i = (s34 + s35);
        t8i = (s44 - s45);
        t9i = (s34 - s35);
        t0j = (s44 + s45);
        t1j = (t3i + t7i);
        t2j = (t4i + t8i);
        t3j = (t3i - t7i);
        t4j = (t4i - t8i);
        t5j = (t5i - t0j);
        t6j = (t6i + t9i);
        t7j = (t5i + t0j);
        t8j = (t6i - t9i);
        a38 = (32*i);
        a48 = (D279 + a38);
        a58 = (a48 + 1);
        a68 = (a48 + 2);
        a78 = (a48 + 3);
        a88 = (a48 + 4);
        a98 = (a48 + 5);
        a09 = (a48 + 6);
        a19 = (a48 + 7);
        a29 = (a48 + 8);
        a39 = (a48 + 9);
        a49 = (a48 + 10);
        a59 = (a48 + 11);
        a69 = (a48 + 12);
        a79 = (a48 + 13);
        a89 = (a48 + 14);
        a99 = (a48 + 15);
        a0a = (a48 + 16);
        a1a = (a48 + 17);
        a2a = (a48 + 18);
        a3a = (a48 + 19);
        a4a = (a48 + 20);
        a5a = (a48 + 21);
        a6a = (a48 + 22);
        a7a = (a48 + 23);
        a8a = (a48 + 24);
        a9a = (a48 + 25);
        a0b = (a48 + 26);
        a1b = (a48 + 27);
        a2b = (a48 + 28);
        a3b = (a48 + 29);
        a4b = (a48 + 30);
        a5b = (a48 + 31);
        b3 = (T + a38);
        *((b3 + 32)) = ((*(a48)*t3e) + (*(a58)*t4e));
        *((b3 + 48)) = ((*(a48)*t4e) - (*(a58)*t3e));
        *((b3 + 33)) = ((*(a68)*t9f) + (*(a78)*t0g));
        *((b3 + 49)) = ((*(a68)*t0g) - (*(a78)*t9f));
        *((b3 + 34)) = ((*(a88)*t5h) + (*(a98)*t6h));
        *((b3 + 50)) = ((*(a88)*t6h) - (*(a98)*t5h));
        *((b3 + 35)) = ((*(a09)*t1j) + (*(a19)*t2j));
        *((b3 + 51)) = ((*(a09)*t2j) - (*(a19)*t1j));
        *((b3 + 36)) = ((*(a29)*t7e) + (*(a39)*t8e));
        *((b3 + 52)) = ((*(a29)*t8e) - (*(a39)*t7e));
        *((b3 + 37)) = ((*(a49)*t3g) + (*(a59)*t4g));
        *((b3 + 53)) = ((*(a49)*t4g) - (*(a59)*t3g));
        *((b3 + 38)) = ((*(a69)*t9h) + (*(a79)*t0i));
        *((b3 + 54)) = ((*(a69)*t0i) - (*(a79)*t9h));
        *((b3 + 39)) = ((*(a89)*t5j) + (*(a99)*t6j));
        *((b3 + 55)) = ((*(a89)*t6j) - (*(a99)*t5j));
        *((b3 + 40)) = ((*(a0a)*t5e) + (*(a1a)*t6e));
        *((b3 + 56)) = ((*(a0a)*t6e) - (*(a1a)*t5e));
        *((b3 + 41)) = ((*(a2a)*t1g) + (*(a3a)*t2g));
        *((b3 + 57)) = ((*(a2a)*t2g) - (*(a3a)*t1g));
        *((b3 + 42)) = ((*(a4a)*t7h) + (*(a5a)*t8h));
        *((b3 + 58)) = ((*(a4a)*t8h) - (*(a5a)*t7h));
        *((b3 + 43)) = ((*(a6a)*t3j) + (*(a7a)*t4j));
        *((b3 + 59)) = ((*(a6a)*t4j) - (*(a7a)*t3j));
        *((b3 + 44)) = ((*(a8a)*t9e) + (*(a9a)*t0f));
        *((b3 + 60)) = ((*(a8a)*t0f) - (*(a9a)*t9e));
        *((b3 + 45)) = ((*(a0b)*t5g) + (*(a1b)*t6g));
        *((b3 + 61)) = ((*(a0b)*t6g) - (*(a1b)*t5g));
        *((b3 + 46)) = ((*(a2b)*t1i) + (*(a3b)*t2i));
        *((b3 + 62)) = ((*(a2b)*t2i) - (*(a3b)*t1i));
        *((b3 + 47)) = ((*(a4b)*t7j) + (*(a5b)*t8j));
        *((b3 + 63)) = ((*(a4b)*t8j) - (*(a5b)*t7j));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a6b = (T + i2);
        a7b = (a6b + 512);
        t9j = (*(a6b) + *(a7b));
        t0k = (*(a6b) - *(a7b));
        a8b = (a6b + 16);
        a9b = (a6b + 528);
        t1k = (*(a8b) - *(a9b));
        t2k = (*(a8b) + *(a9b));
        a0c = (a6b + 256);
        a1c = (a6b + 272);
        a2c = (a6b + 768);
        a3c = (a6b + 784);
        t3k = (*(a0c) + *(a2c));
        t4k = (*(a1c) - *(a3c));
        a4c = (0.70710678118654757*(*(a0c) - *(a2c)));
        a5c = (0.70710678118654757*(*(a1c) + *(a3c)));
        s55 = (a4c - a5c);
        s65 = (a4c + a5c);
        t5k = (t9j + t3k);
        t6k = (t9j - t3k);
        t7k = (t0k - t4k);
        t8k = (t0k + t4k);
        t9k = (t1k + s55);
        t0l = (t1k - s55);
        t1l = (t2k - s65);
        t2l = (t2k + s65);
        a6c = (a6b + 128);
        a7c = (a6b + 144);
        a8c = (a6b + 896);
        a9c = (a6b + 912);
        t3l = (*(a6c) + *(a8c));
        t4l = (*(a7c) - *(a9c));
        t5l = (*(a6c) - *(a8c));
        t6l = (*(a7c) + *(a9c));
        a0d = (a6b + 640);
        a1d = (a6b + 656);
        a2d = (a6b + 384);
        a3d = (a6b + 400);
        t7l = (*(a0d) + *(a2d));
        t8l = (*(a1d) - *(a3d));
        t9l = (*(a0d) - *(a2d));
        t0m = (*(a1d) + *(a3d));
        t1m = (t3l + t7l);
        t2m = (t4l + t8l);
        t3m = (t5l - t0m);
        t4m = (t6l + t9l);
        t5m = (t5l + t0m);
        t6m = (t6l - t9l);
        s75 = ((0.92387953251128674*t3m) - (0.38268343236508978*t4m));
        s85 = ((0.38268343236508978*t3m) + (0.92387953251128674*t4m));
        a4d = (0.70710678118654757*(t3l - t7l));
        a5d = (0.70710678118654757*(t4l - t8l));
        s95 = (a4d - a5d);
        s06 = (a4d + a5d);
        s16 = ((0.38268343236508978*t5m) - (0.92387953251128674*t6m));
        s26 = ((0.92387953251128674*t5m) + (0.38268343236508978*t6m));
        t7m = (t5k + t1m);
        t8m = (t5k - t1m);
        t9m = (t6k - t2m);
        t0n = (t6k + t2m);
        t1n = (t9k + s75);
        t2n = (t9k - s75);
        t3n = (t0l - s85);
        t4n = (t0l + s85);
        t5n = (t7k + s95);
        t6n = (t7k - s95);
        t7n = (t8k - s06);
        t8n = (t8k + s06);
        t9n = (t1l + s16);
        t0o = (t1l - s16);
        t1o = (t2l - s26);
        t2o = (t2l + s26);
        a6d = (a6b + 32);
        a7d = (a6b + 48);
        a8d = (a6b + 992);
        a9d = (a6b + 1008);
        t3o = (*(a6d) + *(a8d));
        t4o = (*(a7d) - *(a9d));
        t5o = (*(a6d) - *(a8d));
        t6o = (*(a7d) + *(a9d));
        a0e = (a6b + 544);
        a1e = (a6b + 560);
        a2e = (a6b + 480);
        a3e = (a6b + 496);
        t7o = (*(a0e) + *(a2e));
        t8o = (*(a1e) - *(a3e));
        t9o = (*(a0e) - *(a2e));
        t0p = (*(a1e) + *(a3e));
        t1p = (t3o + t7o);
        t2p = (t4o + t8o);
        t3p = (t3o - t7o);
        t4p = (t4o - t8o);
        t5p = (t5o - t0p);
        t6p = (t6o + t9o);
        t7p = (t5o + t0p);
        t8p = (t6o - t9o);
        a4e = (a6b + 288);
        a5e = (a6b + 304);
        a6e = (a6b + 736);
        a7e = (a6b + 752);
        t9p = (*(a4e) + *(a6e));
        t0q = (*(a5e) - *(a7e));
        t1q = (*(a4e) - *(a6e));
        t2q = (*(a5e) + *(a7e));
        a8e = (a6b + 800);
        a9e = (a6b + 816);
        a0f = (a6b + 224);
        a1f = (a6b + 240);
        t3q = (*(a8e) + *(a0f));
        t4q = (*(a9e) - *(a1f));
        t5q = (*(a8e) - *(a0f));
        t6q = (*(a9e) + *(a1f));
        t7q = (t9p + t3q);
        t8q = (t0q + t4q);
        t9q = (t9p - t3q);
        t0r = (t0q - t4q);
        a2f = (0.70710678118654757*(t1q - t6q));
        a3f = (0.70710678118654757*(t2q + t5q));
        s36 = (a2f - a3f);
        s46 = (a2f + a3f);
        a4f = (0.70710678118654757*(t1q + t6q));
        a5f = (0.70710678118654757*(t2q - t5q));
        s56 = (a4f + a5f);
        s66 = (a4f - a5f);
        t1r = (t1p + t7q);
        t2r = (t2p + t8q);
        t3r = (t1p - t7q);
        t4r = (t2p - t8q);
        t5r = (t5p + s36);
        t6r = (t6p + s46);
        t7r = (t5p - s36);
        t8r = (t6p - s46);
        t9r = (t3p - t0r);
        t0s = (t4p + t9q);
        t1s = (t3p + t0r);
        t2s = (t4p - t9q);
        t3s = (t7p - s56);
        t4s = (t8p + s66);
        t5s = (t7p + s56);
        t6s = (t8p - s66);
        s76 = ((0.99518472667219693*t5r) - (0.098017140329560604*t6r));
        s86 = ((0.098017140329560604*t5r) + (0.99518472667219693*t6r));
        s96 = ((0.98078528040323043*t9r) - (0.19509032201612828*t0s));
        s07 = ((0.19509032201612828*t9r) + (0.98078528040323043*t0s));
        s17 = ((0.95694033573220882*t3s) - (0.29028467725446239*t4s));
        s27 = ((0.29028467725446239*t3s) + (0.95694033573220882*t4s));
        s37 = ((0.92387953251128674*t3r) - (0.38268343236508978*t4r));
        s47 = ((0.38268343236508978*t3r) + (0.92387953251128674*t4r));
        s57 = ((0.88192126434835505*t7r) - (0.47139673682599764*t8r));
        s67 = ((0.47139673682599764*t7r) + (0.88192126434835505*t8r));
        s77 = ((0.83146961230254524*t1s) - (0.55557023301960218*t2s));
        s87 = ((0.55557023301960218*t1s) + (0.83146961230254524*t2s));
        s97 = ((0.77301045336273699*t5s) - (0.63439328416364549*t6s));
        s08 = ((0.63439328416364549*t5s) + (0.77301045336273699*t6s));
        a6f = (a6b + 64);
        a7f = (a6b + 80);
        a8f = (a6b + 960);
        a9f = (a6b + 976);
        t7s = (*(a6f) + *(a8f));
        t8s = (*(a7f) - *(a9f));
        t9s = (*(a6f) - *(a8f));
        t0t = (*(a7f) + *(a9f));
        a0g = (a6b + 576);
        a1g = (a6b + 592);
        a2g = (a6b + 448);
        a3g = (a6b + 464);
        t1t = (*(a0g) + *(a2g));
        t2t = (*(a1g) - *(a3g));
        t3t = (*(a0g) - *(a2g));
        t4t = (*(a1g) + *(a3g));
        t5t = (t7s + t1t);
        t6t = (t8s + t2t);
        t7t = (t7s - t1t);
        t8t = (t8s - t2t);
        t9t = (t9s - t4t);
        t0u = (t0t + t3t);
        t1u = (t9s + t4t);
        t2u = (t0t - t3t);
        a4g = (a6b + 320);
        a5g = (a6b + 336);
        a6g = (a6b + 704);
        a7g = (a6b + 720);
        t3u = (*(a4g) + *(a6g));
        t4u = (*(a5g) - *(a7g));
        t5u = (*(a4g) - *(a6g));
        t6u = (*(a5g) + *(a7g));
        a8g = (a6b + 832);
        a9g = (a6b + 848);
        a0h = (a6b + 192);
        a1h = (a6b + 208);
        t7u = (*(a8g) + *(a0h));
        t8u = (*(a9g) - *(a1h));
        t9u = (*(a8g) - *(a0h));
        t0v = (*(a9g) + *(a1h));
        t1v = (t3u + t7u);
        t2v = (t4u + t8u);
        t3v = (t3u - t7u);
        t4v = (t4u - t8u);
        a2h = (0.70710678118654757*(t5u - t0v));
        a3h = (0.70710678118654757*(t6u + t9u));
        s18 = (a2h - a3h);
        s28 = (a2h + a3h);
        a4h = (0.70710678118654757*(t5u + t0v));
        a5h = (0.70710678118654757*(t6u - t9u));
        s38 = (a4h + a5h);
        s48 = (a4h - a5h);
        t5v = (t5t + t1v);
        t6v = (t6t + t2v);
        t7v = (t9t + s18);
        t8v = (t0u + s28);
        t9v = (t9t - s18);
        t0w = (t0u - s28);
        t1w = (t7t - t4v);
        t2w = (t8t + t3v);
        t3w = (t7t + t4v);
        t4w = (t8t - t3v);
        t5w = (t1u - s38);
        t6w = (t2u + s48);
        t7w = (t1u + s38);
        t8w = (t2u - s48);
        s58 = ((0.98078528040323043*t7v) - (0.19509032201612828*t8v));
        s68 = ((0.19509032201612828*t7v) + (0.98078528040323043*t8v));
        s78 = ((0.92387953251128674*t1w) - (0.38268343236508978*t2w));
        s88 = ((0.38268343236508978*t1w) + (0.92387953251128674*t2w));
        s98 = ((0.83146961230254524*t5w) - (0.55557023301960218*t6w));
        s09 = ((0.55557023301960218*t5w) + (0.83146961230254524*t6w));
        a6h = (0.70710678118654757*(t5t - t1v));
        a7h = (0.70710678118654757*(t6t - t2v));
        s19 = (a6h - a7h);
        s29 = (a6h + a7h);
        s39 = ((0.55557023301960218*t9v) - (0.83146961230254524*t0w));
        s49 = ((0.83146961230254524*t9v) + (0.55557023301960218*t0w));
        s59 = ((0.38268343236508978*t3w) - (0.92387953251128674*t4w));
        s69 = ((0.92387953251128674*t3w) + (0.38268343236508978*t4w));
        s79 = ((0.19509032201612828*t7w) - (0.98078528040323043*t8w));
        s89 = ((0.98078528040323043*t7w) + (0.19509032201612828*t8w));
        a8h = (a6b + 96);
        a9h = (a6b + 112);
        a0i = (a6b + 928);
        a1i = (a6b + 944);
        t9w = (*(a8h) + *(a0i));
        t0x = (*(a9h) - *(a1i));
        t1x = (*(a8h) - *(a0i));
        t2x = (*(a9h) + *(a1i));
        a2i = (a6b + 608);
        a3i = (a6b + 624);
        a4i = (a6b + 416);
        a5i = (a6b + 432);
        t3x = (*(a2i) + *(a4i));
        t4x = (*(a3i) - *(a5i));
        t5x = (*(a2i) - *(a4i));
        t6x = (*(a3i) + *(a5i));
        t7x = (t9w + t3x);
        t8x = (t0x + t4x);
        t9x = (t9w - t3x);
        t0y = (t0x - t4x);
        t1y = (t1x - t6x);
        t2y = (t2x + t5x);
        t3y = (t1x + t6x);
        t4y = (t2x - t5x);
        a6i = (a6b + 352);
        a7i = (a6b + 368);
        a8i = (a6b + 672);
        a9i = (a6b + 688);
        t5y = (*(a6i) + *(a8i));
        t6y = (*(a7i) - *(a9i));
        t7y = (*(a6i) - *(a8i));
        t8y = (*(a7i) + *(a9i));
        a0j = (a6b + 864);
        a1j = (a6b + 880);
        a2j = (a6b + 160);
        a3j = (a6b + 176);
        t9y = (*(a0j) + *(a2j));
        t0z = (*(a1j) - *(a3j));
        t1z = (*(a0j) - *(a2j));
        t2z = (*(a1j) + *(a3j));
        t3z = (t5y + t9y);
        t4z = (t6y + t0z);
        t5z = (t5y - t9y);
        t6z = (t6y - t0z);
        a4j = (0.70710678118654757*(t7y - t2z));
        a5j = (0.70710678118654757*(t8y + t1z));
        s99 = (a4j - a5j);
        s0a = (a4j + a5j);
        a6j = (0.70710678118654757*(t7y + t2z));
        a7j = (0.70710678118654757*(t8y - t1z));
        s1a = (a6j + a7j);
        s2a = (a6j - a7j);
        t7z = (t7x + t3z);
        t8z = (t8x + t4z);
        t9z = (t7x - t3z);
        t0A = (t8x - t4z);
        t1A = (t1y + s99);
        t2A = (t2y + s0a);
        t3A = (t1y - s99);
        t4A = (t2y - s0a);
        t5A = (t9x - t6z);
        t6A = (t0y + t5z);
        t7A = (t9x + t6z);
        t8A = (t0y - t5z);
        t9A = (t3y - s1a);
        t0B = (t4y + s2a);
        t1B = (t3y + s1a);
        t2B = (t4y - s2a);
        s3a = ((0.95694033573220882*t1A) - (0.29028467725446239*t2A));
        s4a = ((0.29028467725446239*t1A) + (0.95694033573220882*t2A));
        s5a = ((0.83146961230254524*t5A) - (0.55557023301960218*t6A));
        s6a = ((0.55557023301960218*t5A) + (0.83146961230254524*t6A));
        s7a = ((0.63439328416364549*t9A) - (0.77301045336273699*t0B));
        s8a = ((0.77301045336273699*t9A) + (0.63439328416364549*t0B));
        s9a = ((0.38268343236508978*t9z) - (0.92387953251128674*t0A));
        s0b = ((0.92387953251128674*t9z) + (0.38268343236508978*t0A));
        s1b = ((0.098017140329560604*t3A) - (0.99518472667219693*t4A));
        s2b = ((0.99518472667219693*t3A) + (0.098017140329560604*t4A));
        s3b = ((0.19509032201612828*t7A) + (0.98078528040323043*t8A));
        s4b = ((0.98078528040323043*t7A) - (0.19509032201612828*t8A));
        s5b = ((0.47139673682599764*t1B) + (0.88192126434835505*t2B));
        s6b = ((0.88192126434835505*t1B) - (0.47139673682599764*t2B));
        t3B = (t7m + t5v);
        t4B = (t7m - t5v);
        t5B = (t8m - t6v);
        t6B = (t8m + t6v);
        t7B = (t1r + t7z);
        t8B = (t2r - t8z);
        a8j = (0.70710678118654757*(t1r - t7z));
        a9j = (0.70710678118654757*(t2r + t8z));
        s7b = (a8j - a9j);
        s8b = (a8j + a9j);
        a0k = (dst + i2);
        *(a0k) = (t3B + t7B);
        *((a0k + 512)) = (t3B - t7B);
        *((a0k + 256)) = (t4B - t8B);
        *((a0k + 768)) = (t4B + t8B);
        *((a0k + 128)) = (t5B + s7b);
        *((a0k + 640)) = (t5B - s7b);
        *((a0k + 384)) = (t6B - s8b);
        *((a0k + 896)) = (t6B + s8b);
        t9B = (t1n + s58);
        t0C = (t1n - s58);
        t1C = (t2n - s68);
        t2C = (t2n + s68);
        t3C = (s76 + s3a);
        t4C = (s86 - s4a);
        a1k = (0.70710678118654757*(s76 - s3a));
        a2k = (0.70710678118654757*(s86 + s4a));
        s9b = (a1k - a2k);
        s0c = (a1k + a2k);
        *((a0k + 16)) = (t9B + t3C);
        *((a0k + 528)) = (t9B - t3C);
        *((a0k + 272)) = (t0C - t4C);
        *((a0k + 784)) = (t0C + t4C);
        *((a0k + 144)) = (t1C + s9b);
        *((a0k + 656)) = (t1C - s9b);
        *((a0k + 400)) = (t2C - s0c);
        *((a0k + 912)) = (t2C + s0c);
        t5C = (t5n + s78);
        t6C = (t5n - s78);
        t7C = (t6n - s88);
        t8C = (t6n + s88);
        t9C = (s96 + s5a);
        t0D = (s07 - s6a);
        a3k = (0.70710678118654757*(s96 - s5a));
        a4k = (0.70710678118654757*(s07 + s6a));
        s1c = (a3k - a4k);
        s2c = (a3k + a4k);
        *((a0k + 32)) = (t5C + t9C);
        *((a0k + 544)) = (t5C - t9C);
        *((a0k + 288)) = (t6C - t0D);
        *((a0k + 800)) = (t6C + t0D);
        *((a0k + 160)) = (t7C + s1c);
        *((a0k + 672)) = (t7C - s1c);
        *((a0k + 416)) = (t8C - s2c);
        *((a0k + 928)) = (t8C + s2c);
        t1D = (t9n + s98);
        t2D = (t9n - s98);
        t3D = (t0o - s09);
        t4D = (t0o + s09);
        t5D = (s17 + s7a);
        t6D = (s27 - s8a);
        a5k = (0.70710678118654757*(s17 - s7a));
        a6k = (0.70710678118654757*(s27 + s8a));
        s3c = (a5k - a6k);
        s4c = (a5k + a6k);
        *((a0k + 48)) = (t1D + t5D);
        *((a0k + 560)) = (t1D - t5D);
        *((a0k + 304)) = (t2D - t6D);
        *((a0k + 816)) = (t2D + t6D);
        *((a0k + 176)) = (t3D + s3c);
        *((a0k + 688)) = (t3D - s3c);
        *((a0k + 432)) = (t4D - s4c);
        *((a0k + 944)) = (t4D + s4c);
        t7D = (t9m + s19);
        t8D = (t9m - s19);
        t9D = (t0n - s29);
        t0E = (t0n + s29);
        t1E = (s37 + s9a);
        t2E = (s47 - s0b);
        a7k = (0.70710678118654757*(s37 - s9a));
        a8k = (0.70710678118654757*(s47 + s0b));
        s5c = (a7k - a8k);
        s6c = (a7k + a8k);
        *((a0k + 64)) = (t7D + t1E);
        *((a0k + 576)) = (t7D - t1E);
        *((a0k + 320)) = (t8D - t2E);
        *((a0k + 832)) = (t8D + t2E);
        *((a0k + 192)) = (t9D + s5c);
        *((a0k + 704)) = (t9D - s5c);
        *((a0k + 448)) = (t0E - s6c);
        *((a0k + 960)) = (t0E + s6c);
        t3E = (t3n + s39);
        t4E = (t3n - s39);
        t5E = (t4n - s49);
        t6E = (t4n + s49);
        t7E = (s57 + s1b);
        t8E = (s67 - s2b);
        a9k = (0.70710678118654757*(s57 - s1b));
        a0l = (0.70710678118654757*(s67 + s2b));
        s7c = (a9k - a0l);
        s8c = (a9k + a0l);
        *((a0k + 80)) = (t3E + t7E);
        *((a0k + 592)) = (t3E - t7E);
        *((a0k + 336)) = (t4E - t8E);
        *((a0k + 848)) = (t4E + t8E);
        *((a0k + 208)) = (t5E + s7c);
        *((a0k + 720)) = (t5E - s7c);
        *((a0k + 464)) = (t6E - s8c);
        *((a0k + 976)) = (t6E + s8c);
        t9E = (t7n + s59);
        t0F = (t7n - s59);
        t1F = (t8n - s69);
        t2F = (t8n + s69);
        t3F = (s77 - s3b);
        t4F = (s87 - s4b);
        a1l = (0.70710678118654757*(s77 + s3b));
        a2l = (0.70710678118654757*(s87 + s4b));
        s9c = (a1l - a2l);
        s0d = (a1l + a2l);
        *((a0k + 96)) = (t9E + t3F);
        *((a0k + 608)) = (t9E - t3F);
        *((a0k + 352)) = (t0F - t4F);
        *((a0k + 864)) = (t0F + t4F);
        *((a0k + 224)) = (t1F + s9c);
        *((a0k + 736)) = (t1F - s9c);
        *((a0k + 480)) = (t2F - s0d);
        *((a0k + 992)) = (t2F + s0d);
        t5F = (t1o + s79);
        t6F = (t1o - s79);
        t7F = (t2o - s89);
        t8F = (t2o + s89);
        t9F = (s97 - s5b);
        t0G = (s08 - s6b);
        a3l = (0.70710678118654757*(s97 + s5b));
        a4l = (0.70710678118654757*(s08 + s6b));
        s1d = (a3l - a4l);
        s2d = (a3l + a4l);
        *((a0k + 112)) = (t5F + t9F);
        *((a0k + 624)) = (t5F - t9F);
        *((a0k + 368)) = (t6F - t0G);
        *((a0k + 880)) = (t6F + t0G);
        *((a0k + 240)) = (t7F + s1d);
        *((a0k + 752)) = (t7F - s1d);
        *((a0k + 496)) = (t8F - s2d);
        *((a0k + 1008)) = (t8F + s2d);
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_2048)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[2048];
     double T2[128];
    double  *a09, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0g, *a0h, *a0i, *a0j, *a19, *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1g, *a1h, *a1i, *a1j
            , *a29, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2g, *a2h, *a39, *a3a, *a3b, *a3c, *a3d, *a3e, *a3g, *a3h, *a48, *a49, *a4a, *a4b, *a4e
            , *a4g, *a4h, *a4i, *a4j, *a58, *a59, *a5a, *a5b, *a5e, *a5g, *a5h, *a5i, *a68, *a69, *a6a, *a6b, *a6c, *a6e, *a6g, *a6h, *a6i, *a78
            , *a79, *a7a, *a7b, *a7c, *a7d, *a7e, *a7g, *a7h, *a7i, *a88, *a89, *a8a, *a8b, *a8c, *a8d, *a8e, *a8f, *a8g, *a8h, *a8i, *a98, *a99
            , *a9a, *a9b, *a9c, *a9d, *a9e, *a9f, *a9g, *a9h, *a9i, *b3, *b4, *b5, *b6, *b7;
    const double  *a, *a01, *a02, *a03, *a05, *a08, *a11, *a12, *a13, *a15, *a16, *a2, *a21, *a22, *a23, *a25, *a26, *a3, *a31, *a32, *a33, *a34
            , *a35, *a36, *a37, *a4, *a41, *a44, *a45, *a46, *a47, *a5, *a51, *a54, *a55, *a56, *a57, *a61, *a62, *a64, *a65, *a66, *a67, *a71
            , *a72, *a74, *a75, *a76, *a77, *a8, *a81, *a82, *a84, *a85, *a86, *a87, *a9, *a91, *a92, *a94, *a97, *b, *b2;
    int a24, a38, a6d, a7f;
    double a04, a06, a07, a14, a17, a18, a27, a28, a2i, a2j, a3f, a3i, a3j, a42, a43, a4c, a4d, a4f, a52, a53, a5c, a5d
            , a5f, a6, a63, a6f, a7, a73, a83, a93, a95, a96, s, s01, s02, s03, s04, s05, s06, s07, s11, s12, s13, s14
            , s15, s16, s17, s2, s21, s22, s23, s24, s25, s26, s27, s3, s31, s32, s33, s34, s35, s36, s37, s4, s41, s42
            , s43, s44, s45, s46, s47, s5, s51, s52, s53, s54, s55, s56, s6, s61, s62, s63, s64, s65, s66, s7, s71, s72
            , s73, s74, s75, s76, s8, s81, s82, s83, s84, s85, s86, s9, s91, s92, s93, s94, s95, s96, t, t01, t02, t03
            , t04, t05, t06, t07, t08, t09, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n, t0o, t0p
            , t0q, t0r, t0s, t0t, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i
            , t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2a
            , t2b, t2c, t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t3, t31, t32
            , t33, t34, t35, t36, t37, t38, t39, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h, t3i, t3j, t3k, t3l, t3m, t3n, t3o
            , t3p, t3q, t3r, t3s, t3t, t4, t41, t42, t43, t44, t45, t46, t47, t48, t49, t4a, t4b, t4c, t4d, t4e, t4f, t4g
            , t4h, t4i, t4j, t4k, t4l, t4m, t4n, t4o, t4p, t4q, t4r, t4s, t4t, t5, t51, t52, t53, t54, t55, t56, t57, t58
            , t59, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r, t5s, t5t, t6
            , t61, t62, t63, t64, t65, t66, t67, t68, t69, t6a, t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m
            , t6n, t6o, t6p, t6q, t6r, t6s, t6t, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7a, t7b, t7c, t7d, t7e
            , t7f, t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t8, t81, t82, t83, t84, t85, t86
            , t87, t88, t89, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k, t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s
            , t8t, t9, t91, t92, t93, t94, t95, t96, t97, t98, t99, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k
            , t9l, t9m, t9n, t9o, t9p, t9q, t9r, t9s;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 1024)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 1025)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 512);
    a3 = (src + 1536);
    a4 = (src + 513);
    a5 = (src + 1537);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 128);
    a9 = (src + 1920);
    t51 = (*(a8) + *(a9));
    a01 = (src + 129);
    a11 = (src + 1921);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 1152);
    a31 = (src + 896);
    t91 = (*(a21) + *(a31));
    a41 = (src + 1153);
    a51 = (src + 897);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t51 - t91);
    t42 = (t61 - t02);
    t52 = (t71 - t22);
    t62 = (t81 + t12);
    t72 = (t71 + t22);
    t82 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.9615705608064609*t52) - (0.39018064403225655*t62));
    s01 = ((0.39018064403225655*t52) + (1.9615705608064609*t62));
    s11 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s21 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    s31 = ((1.6629392246050905*t72) - (1.1111404660392044*t82));
    s41 = ((1.1111404660392044*t72) + (1.6629392246050905*t82));
    a61 = (src + 256);
    a71 = (src + 1792);
    t92 = (*(a61) + *(a71));
    a81 = (src + 257);
    a91 = (src + 1793);
    t03 = (*(a81) - *(a91));
    t13 = (*(a61) - *(a71));
    t23 = (*(a81) + *(a91));
    a02 = (src + 1280);
    a12 = (src + 768);
    t33 = (*(a02) + *(a12));
    a22 = (src + 1281);
    a32 = (src + 769);
    t43 = (*(a22) - *(a32));
    t53 = (*(a02) - *(a12));
    t63 = (*(a22) + *(a32));
    t73 = (t13 - t63);
    t83 = (t23 + t53);
    t93 = (t13 + t63);
    t04 = (t23 - t53);
    s51 = (2.0*(t92 + t33));
    s61 = (2.0*(t03 + t43));
    s71 = ((1.8477590650225735*t73) - (0.76536686473017956*t83));
    s81 = ((0.76536686473017956*t73) + (1.8477590650225735*t83));
    a42 = (1.4142135623730951*(t92 - t33));
    a52 = (1.4142135623730951*(t03 - t43));
    s91 = (a42 - a52);
    s02 = (a42 + a52);
    s12 = ((0.76536686473017956*t93) - (1.8477590650225735*t04));
    s22 = ((1.8477590650225735*t93) + (0.76536686473017956*t04));
    a62 = (src + 384);
    a72 = (src + 1664);
    t14 = (*(a62) + *(a72));
    a82 = (src + 385);
    a92 = (src + 1665);
    t24 = (*(a82) - *(a92));
    t34 = (*(a62) - *(a72));
    t44 = (*(a82) + *(a92));
    a03 = (src + 1408);
    a13 = (src + 640);
    t54 = (*(a03) + *(a13));
    a23 = (src + 1409);
    a33 = (src + 641);
    t64 = (*(a23) - *(a33));
    t74 = (*(a03) - *(a13));
    t84 = (*(a23) + *(a33));
    t94 = (t14 - t54);
    t05 = (t24 - t64);
    t15 = (t34 - t84);
    t25 = (t44 + t74);
    t35 = (t34 + t84);
    t45 = (t44 - t74);
    s32 = (2.0*(t14 + t54));
    s42 = (2.0*(t24 + t64));
    s52 = ((1.6629392246050905*t15) - (1.1111404660392044*t25));
    s62 = ((1.1111404660392044*t15) + (1.6629392246050905*t25));
    s72 = ((0.76536686473017956*t94) - (1.8477590650225735*t05));
    s82 = ((1.8477590650225735*t94) + (0.76536686473017956*t05));
    s92 = ((0.39018064403225655*t35) + (1.9615705608064609*t45));
    s03 = ((1.9615705608064609*t35) - (0.39018064403225655*t45));
    t55 = (t7 + s51);
    t65 = (t7 - s51);
    t75 = (t8 - s61);
    t85 = (t8 + s61);
    t95 = (s7 + s32);
    t06 = (s8 - s42);
    a43 = (0.70710678118654757*(s7 - s32));
    a53 = (0.70710678118654757*(s8 + s42));
    s13 = (a43 - a53);
    s23 = (a43 + a53);
    *(T) = (t55 + t95);
    *((T + 16)) = (t55 - t95);
    *((T + 8)) = (t65 - t06);
    *((T + 24)) = (t65 + t06);
    *((T + 4)) = (t75 + s13);
    *((T + 20)) = (t75 - s13);
    *((T + 12)) = (t85 - s23);
    *((T + 28)) = (t85 + s23);
    t16 = (t11 + s71);
    t26 = (t11 - s71);
    t36 = (t21 - s81);
    t46 = (t21 + s81);
    t56 = (s9 + s52);
    t66 = (s01 - s62);
    a63 = (0.70710678118654757*(s9 - s52));
    a73 = (0.70710678118654757*(s01 + s62));
    s33 = (a63 - a73);
    s43 = (a63 + a73);
    *((T + 1)) = (t16 + t56);
    *((T + 17)) = (t16 - t56);
    *((T + 9)) = (t26 - t66);
    *((T + 25)) = (t26 + t66);
    *((T + 5)) = (t36 + s33);
    *((T + 21)) = (t36 - s33);
    *((T + 13)) = (t46 - s43);
    *((T + 29)) = (t46 + s43);
    t76 = (t9 + s91);
    t86 = (t9 - s91);
    t96 = (t01 - s02);
    t07 = (t01 + s02);
    t17 = (s11 + s72);
    t27 = (s21 - s82);
    a83 = (0.70710678118654757*(s11 - s72));
    a93 = (0.70710678118654757*(s21 + s82));
    s53 = (a83 - a93);
    s63 = (a83 + a93);
    *((T + 2)) = (t76 + t17);
    *((T + 18)) = (t76 - t17);
    *((T + 10)) = (t86 - t27);
    *((T + 26)) = (t86 + t27);
    *((T + 6)) = (t96 + s53);
    *((T + 22)) = (t96 - s53);
    *((T + 14)) = (t07 - s63);
    *((T + 30)) = (t07 + s63);
    t37 = (t31 + s12);
    t47 = (t31 - s12);
    t57 = (t41 - s22);
    t67 = (t41 + s22);
    t77 = (s31 - s92);
    t87 = (s41 - s03);
    a04 = (0.70710678118654757*(s31 + s92));
    a14 = (0.70710678118654757*(s41 + s03));
    s73 = (a04 - a14);
    s83 = (a04 + a14);
    *((T + 3)) = (t37 + t77);
    *((T + 19)) = (t37 - t77);
    *((T + 11)) = (t47 - t87);
    *((T + 27)) = (t47 + t87);
    *((T + 7)) = (t57 + s73);
    *((T + 23)) = (t57 - s73);
    *((T + 15)) = (t67 - s83);
    *((T + 31)) = (t67 + s83);
    {long i; for(i = 0; i <= 62; i++) {
        a24 = (2*i);
        b = (src + a24);
        a34 = (b + 2);
        a44 = (b + 3);
        b2 = (src - a24);
        a54 = (b2 + 2046);
        a64 = (b2 + 2047);
        t97 = (*(a34) + *(a54));
        t08 = (*(a44) - *(a64));
        t18 = (*(a34) - *(a54));
        t28 = (*(a44) + *(a64));
        a74 = (b + 1026);
        a84 = (b + 1027);
        a94 = (b2 + 1022);
        a05 = (b2 + 1023);
        t38 = (*(a74) + *(a94));
        t48 = (*(a84) - *(a05));
        t58 = (*(a74) - *(a94));
        t68 = (*(a84) + *(a05));
        t78 = (t97 + t38);
        t88 = (t08 + t48);
        t98 = (t97 - t38);
        t09 = (t08 - t48);
        t19 = (t18 - t68);
        t29 = (t28 + t58);
        t39 = (t18 + t68);
        t49 = (t28 - t58);
        a15 = (b + 258);
        a25 = (b + 259);
        a35 = (b2 + 1790);
        a45 = (b2 + 1791);
        t59 = (*(a15) + *(a35));
        t69 = (*(a25) - *(a45));
        t79 = (*(a15) - *(a35));
        t89 = (*(a25) + *(a45));
        a55 = (b + 1282);
        a65 = (b + 1283);
        a75 = (b2 + 766);
        a85 = (b2 + 767);
        t99 = (*(a55) + *(a75));
        t0a = (*(a65) - *(a85));
        t1a = (*(a55) - *(a75));
        t2a = (*(a65) + *(a85));
        t3a = (t59 + t99);
        t4a = (t69 + t0a);
        a95 = (0.70710678118654757*(t59 - t99));
        a06 = (0.70710678118654757*(t69 - t0a));
        s93 = (a95 - a06);
        s04 = (a95 + a06);
        t5a = (t79 - t2a);
        t6a = (t89 + t1a);
        t7a = (t79 + t2a);
        t8a = (t89 - t1a);
        s14 = ((0.92387953251128674*t5a) - (0.38268343236508978*t6a));
        s24 = ((0.38268343236508978*t5a) + (0.92387953251128674*t6a));
        s34 = ((0.38268343236508978*t7a) - (0.92387953251128674*t8a));
        s44 = ((0.92387953251128674*t7a) + (0.38268343236508978*t8a));
        a16 = (b + 514);
        a26 = (b + 515);
        a36 = (b2 + 1534);
        a46 = (b2 + 1535);
        t9a = (*(a16) + *(a36));
        t0b = (*(a26) - *(a46));
        t1b = (*(a16) - *(a36));
        t2b = (*(a26) + *(a46));
        a56 = (b + 1538);
        a66 = (b + 1539);
        a76 = (b2 + 510);
        a86 = (b2 + 511);
        t3b = (*(a56) + *(a76));
        t4b = (*(a66) - *(a86));
        t5b = (*(a56) - *(a76));
        t6b = (*(a66) + *(a86));
        t7b = (t9a + t3b);
        t8b = (t0b + t4b);
        t9b = (t9a - t3b);
        t0c = (t0b - t4b);
        a96 = (0.70710678118654757*(t1b - t6b));
        a07 = (0.70710678118654757*(t2b + t5b));
        s54 = (a96 - a07);
        s64 = (a96 + a07);
        a17 = (0.70710678118654757*(t1b + t6b));
        a27 = (0.70710678118654757*(t2b - t5b));
        s74 = (a17 + a27);
        s84 = (a17 - a27);
        a37 = (b + 770);
        a47 = (b + 771);
        a57 = (b2 + 1278);
        a67 = (b2 + 1279);
        t1c = (*(a37) + *(a57));
        t2c = (*(a47) - *(a67));
        t3c = (*(a37) - *(a57));
        t4c = (*(a47) + *(a67));
        a77 = (b + 1794);
        a87 = (b + 1795);
        a97 = (b2 + 254);
        a08 = (b2 + 255);
        t5c = (*(a77) + *(a97));
        t6c = (*(a87) - *(a08));
        t7c = (*(a77) - *(a97));
        t8c = (*(a87) + *(a08));
        t9c = (t1c + t5c);
        t0d = (t2c + t6c);
        a18 = (0.70710678118654757*(t1c - t5c));
        a28 = (0.70710678118654757*(t2c - t6c));
        s94 = (a18 + a28);
        s05 = (a18 - a28);
        t1d = (t3c - t8c);
        t2d = (t4c + t7c);
        t3d = (t3c + t8c);
        t4d = (t4c - t7c);
        s15 = ((0.38268343236508978*t1d) - (0.92387953251128674*t2d));
        s25 = ((0.92387953251128674*t1d) + (0.38268343236508978*t2d));
        s35 = ((0.38268343236508978*t4d) - (0.92387953251128674*t3d));
        s45 = ((0.38268343236508978*t3d) + (0.92387953251128674*t4d));
        t5d = (t78 + t7b);
        t6d = (t88 + t8b);
        t7d = (t78 - t7b);
        t8d = (t88 - t8b);
        t9d = (t3a + t9c);
        t0e = (t4a + t0d);
        t1e = (t3a - t9c);
        t2e = (t4a - t0d);
        t3e = (t5d + t9d);
        t4e = (t6d + t0e);
        t5e = (t5d - t9d);
        t6e = (t6d - t0e);
        t7e = (t7d - t2e);
        t8e = (t8d + t1e);
        t9e = (t7d + t2e);
        t0f = (t8d - t1e);
        t1f = (t19 + s54);
        t2f = (t29 + s64);
        t3f = (t19 - s54);
        t4f = (t29 - s64);
        t5f = (s14 + s15);
        t6f = (s24 + s25);
        t7f = (s14 - s15);
        t8f = (s24 - s25);
        t9f = (t1f + t5f);
        t0g = (t2f + t6f);
        t1g = (t1f - t5f);
        t2g = (t2f - t6f);
        t3g = (t3f - t8f);
        t4g = (t4f + t7f);
        t5g = (t3f + t8f);
        t6g = (t4f - t7f);
        t7g = (t98 - t0c);
        t8g = (t09 + t9b);
        t9g = (t98 + t0c);
        t0h = (t09 - t9b);
        t1h = (s93 - s94);
        t2h = (s04 + s05);
        t3h = (s93 + s94);
        t4h = (s04 - s05);
        t5h = (t7g + t1h);
        t6h = (t8g + t2h);
        t7h = (t7g - t1h);
        t8h = (t8g - t2h);
        t9h = (t9g - t4h);
        t0i = (t0h + t3h);
        t1i = (t9g + t4h);
        t2i = (t0h - t3h);
        t3i = (t39 - s74);
        t4i = (t49 + s84);
        t5i = (t39 + s74);
        t6i = (t49 - s84);
        t7i = (s34 + s35);
        t8i = (s44 - s45);
        t9i = (s34 - s35);
        t0j = (s44 + s45);
        t1j = (t3i + t7i);
        t2j = (t4i + t8i);
        t3j = (t3i - t7i);
        t4j = (t4i - t8i);
        t5j = (t5i - t0j);
        t6j = (t6i + t9i);
        t7j = (t5i + t0j);
        t8j = (t6i - t9i);
        a38 = (32*i);
        a48 = (D281 + a38);
        a58 = (a48 + 1);
        a68 = (a48 + 2);
        a78 = (a48 + 3);
        a88 = (a48 + 4);
        a98 = (a48 + 5);
        a09 = (a48 + 6);
        a19 = (a48 + 7);
        a29 = (a48 + 8);
        a39 = (a48 + 9);
        a49 = (a48 + 10);
        a59 = (a48 + 11);
        a69 = (a48 + 12);
        a79 = (a48 + 13);
        a89 = (a48 + 14);
        a99 = (a48 + 15);
        a0a = (a48 + 16);
        a1a = (a48 + 17);
        a2a = (a48 + 18);
        a3a = (a48 + 19);
        a4a = (a48 + 20);
        a5a = (a48 + 21);
        a6a = (a48 + 22);
        a7a = (a48 + 23);
        a8a = (a48 + 24);
        a9a = (a48 + 25);
        a0b = (a48 + 26);
        a1b = (a48 + 27);
        a2b = (a48 + 28);
        a3b = (a48 + 29);
        a4b = (a48 + 30);
        a5b = (a48 + 31);
        b3 = (T + a38);
        *((b3 + 32)) = ((*(a48)*t3e) + (*(a58)*t4e));
        *((b3 + 48)) = ((*(a48)*t4e) - (*(a58)*t3e));
        *((b3 + 33)) = ((*(a68)*t9f) + (*(a78)*t0g));
        *((b3 + 49)) = ((*(a68)*t0g) - (*(a78)*t9f));
        *((b3 + 34)) = ((*(a88)*t5h) + (*(a98)*t6h));
        *((b3 + 50)) = ((*(a88)*t6h) - (*(a98)*t5h));
        *((b3 + 35)) = ((*(a09)*t1j) + (*(a19)*t2j));
        *((b3 + 51)) = ((*(a09)*t2j) - (*(a19)*t1j));
        *((b3 + 36)) = ((*(a29)*t7e) + (*(a39)*t8e));
        *((b3 + 52)) = ((*(a29)*t8e) - (*(a39)*t7e));
        *((b3 + 37)) = ((*(a49)*t3g) + (*(a59)*t4g));
        *((b3 + 53)) = ((*(a49)*t4g) - (*(a59)*t3g));
        *((b3 + 38)) = ((*(a69)*t9h) + (*(a79)*t0i));
        *((b3 + 54)) = ((*(a69)*t0i) - (*(a79)*t9h));
        *((b3 + 39)) = ((*(a89)*t5j) + (*(a99)*t6j));
        *((b3 + 55)) = ((*(a89)*t6j) - (*(a99)*t5j));
        *((b3 + 40)) = ((*(a0a)*t5e) + (*(a1a)*t6e));
        *((b3 + 56)) = ((*(a0a)*t6e) - (*(a1a)*t5e));
        *((b3 + 41)) = ((*(a2a)*t1g) + (*(a3a)*t2g));
        *((b3 + 57)) = ((*(a2a)*t2g) - (*(a3a)*t1g));
        *((b3 + 42)) = ((*(a4a)*t7h) + (*(a5a)*t8h));
        *((b3 + 58)) = ((*(a4a)*t8h) - (*(a5a)*t7h));
        *((b3 + 43)) = ((*(a6a)*t3j) + (*(a7a)*t4j));
        *((b3 + 59)) = ((*(a6a)*t4j) - (*(a7a)*t3j));
        *((b3 + 44)) = ((*(a8a)*t9e) + (*(a9a)*t0f));
        *((b3 + 60)) = ((*(a8a)*t0f) - (*(a9a)*t9e));
        *((b3 + 45)) = ((*(a0b)*t5g) + (*(a1b)*t6g));
        *((b3 + 61)) = ((*(a0b)*t6g) - (*(a1b)*t5g));
        *((b3 + 46)) = ((*(a2b)*t1i) + (*(a3b)*t2i));
        *((b3 + 62)) = ((*(a2b)*t2i) - (*(a3b)*t1i));
        *((b3 + 47)) = ((*(a4b)*t7j) + (*(a5b)*t8j));
        *((b3 + 63)) = ((*(a4b)*t8j) - (*(a5b)*t7j));
    }}
    {long i2; for(i2 = 0; i2 <= 15; i2++) {
        a6b = (T + i2);
        a7b = (a6b + 1024);
        t9j = (*(a6b) + *(a7b));
        t0k = (*(a6b) - *(a7b));
        a8b = (a6b + 16);
        a9b = (a6b + 1040);
        t1k = (*(a8b) - *(a9b));
        t2k = (*(a8b) + *(a9b));
        a0c = (a6b + 512);
        a1c = (a6b + 528);
        a2c = (a6b + 1536);
        a3c = (a6b + 1552);
        t3k = (*(a0c) + *(a2c));
        t4k = (*(a1c) - *(a3c));
        a4c = (0.70710678118654757*(*(a0c) - *(a2c)));
        a5c = (0.70710678118654757*(*(a1c) + *(a3c)));
        s55 = (a4c - a5c);
        s65 = (a4c + a5c);
        t5k = (t9j + t3k);
        t6k = (t9j - t3k);
        t7k = (t0k - t4k);
        t8k = (t0k + t4k);
        t9k = (t1k + s55);
        t0l = (t1k - s55);
        t1l = (t2k - s65);
        t2l = (t2k + s65);
        a6c = (a6b + 256);
        a7c = (a6b + 272);
        a8c = (a6b + 1792);
        a9c = (a6b + 1808);
        t3l = (*(a6c) + *(a8c));
        t4l = (*(a7c) - *(a9c));
        t5l = (*(a6c) - *(a8c));
        t6l = (*(a7c) + *(a9c));
        a0d = (a6b + 1280);
        a1d = (a6b + 1296);
        a2d = (a6b + 768);
        a3d = (a6b + 784);
        t7l = (*(a0d) + *(a2d));
        t8l = (*(a1d) - *(a3d));
        t9l = (*(a0d) - *(a2d));
        t0m = (*(a1d) + *(a3d));
        t1m = (t3l + t7l);
        t2m = (t4l + t8l);
        t3m = (t5l - t0m);
        t4m = (t6l + t9l);
        t5m = (t5l + t0m);
        t6m = (t6l - t9l);
        s75 = ((0.92387953251128674*t3m) - (0.38268343236508978*t4m));
        s85 = ((0.38268343236508978*t3m) + (0.92387953251128674*t4m));
        a4d = (0.70710678118654757*(t3l - t7l));
        a5d = (0.70710678118654757*(t4l - t8l));
        s95 = (a4d - a5d);
        s06 = (a4d + a5d);
        s16 = ((0.38268343236508978*t5m) - (0.92387953251128674*t6m));
        s26 = ((0.92387953251128674*t5m) + (0.38268343236508978*t6m));
        *(T2) = (t5k + t1m);
        *((T2 + 8)) = (t5k - t1m);
        *((T2 + 4)) = (t6k - t2m);
        *((T2 + 12)) = (t6k + t2m);
        *((T2 + 1)) = (t9k + s75);
        *((T2 + 9)) = (t9k - s75);
        *((T2 + 5)) = (t0l - s85);
        *((T2 + 13)) = (t0l + s85);
        *((T2 + 2)) = (t7k + s95);
        *((T2 + 10)) = (t7k - s95);
        *((T2 + 6)) = (t8k - s06);
        *((T2 + 14)) = (t8k + s06);
        *((T2 + 3)) = (t1l + s16);
        *((T2 + 11)) = (t1l - s16);
        *((T2 + 7)) = (t2l - s26);
        *((T2 + 15)) = (t2l + s26);
        {long i3; for(i3 = 0; i3 <= 6; i3++) {
            a6d = (32*i3);
            b4 = (T + i2);
            b5 = (b4 + a6d);
            a7d = (b5 + 32);
            a8d = (b5 + 48);
            b6 = (b4 - a6d);
            a9d = (b6 + 2016);
            a0e = (b6 + 2032);
            t7m = (*(a7d) + *(a9d));
            t8m = (*(a8d) - *(a0e));
            t9m = (*(a7d) - *(a9d));
            t0n = (*(a8d) + *(a0e));
            a1e = (b5 + 1056);
            a2e = (b5 + 1072);
            a3e = (b6 + 992);
            a4e = (b6 + 1008);
            t1n = (*(a1e) + *(a3e));
            t2n = (*(a2e) - *(a4e));
            t3n = (*(a1e) - *(a3e));
            t4n = (*(a2e) + *(a4e));
            t5n = (t7m + t1n);
            t6n = (t8m + t2n);
            t7n = (t7m - t1n);
            t8n = (t8m - t2n);
            t9n = (t9m - t4n);
            t0o = (t0n + t3n);
            t1o = (t9m + t4n);
            t2o = (t0n - t3n);
            a5e = (b5 + 544);
            a6e = (b5 + 560);
            a7e = (b6 + 1504);
            a8e = (b6 + 1520);
            t3o = (*(a5e) + *(a7e));
            t4o = (*(a6e) - *(a8e));
            t5o = (*(a5e) - *(a7e));
            t6o = (*(a6e) + *(a8e));
            a9e = (b5 + 1568);
            a0f = (b5 + 1584);
            a1f = (b6 + 480);
            a2f = (b6 + 496);
            t7o = (*(a9e) + *(a1f));
            t8o = (*(a0f) - *(a2f));
            t9o = (*(a9e) - *(a1f));
            t0p = (*(a0f) + *(a2f));
            t1p = (t3o + t7o);
            t2p = (t4o + t8o);
            t3p = (t3o - t7o);
            t4p = (t4o - t8o);
            a3f = (0.70710678118654757*(t5o - t0p));
            a4f = (0.70710678118654757*(t6o + t9o));
            s36 = (a3f - a4f);
            s46 = (a3f + a4f);
            a5f = (0.70710678118654757*(t5o + t0p));
            a6f = (0.70710678118654757*(t6o - t9o));
            s56 = (a5f + a6f);
            s66 = (a5f - a6f);
            t5p = (t5n + t1p);
            t6p = (t6n + t2p);
            t7p = (t5n - t1p);
            t8p = (t6n - t2p);
            t9p = (t9n + s36);
            t0q = (t0o + s46);
            t1q = (t9n - s36);
            t2q = (t0o - s46);
            t3q = (t7n - t4p);
            t4q = (t8n + t3p);
            t5q = (t7n + t4p);
            t6q = (t8n - t3p);
            t7q = (t1o - s56);
            t8q = (t2o + s66);
            t9q = (t1o + s56);
            t0r = (t2o - s66);
            a7f = (16*i3);
            a8f = (D280 + a7f);
            a9f = (a8f + 1);
            a0g = (a8f + 2);
            a1g = (a8f + 3);
            a2g = (a8f + 4);
            a3g = (a8f + 5);
            a4g = (a8f + 6);
            a5g = (a8f + 7);
            a6g = (a8f + 8);
            a7g = (a8f + 9);
            a8g = (a8f + 10);
            a9g = (a8f + 11);
            a0h = (a8f + 12);
            a1h = (a8f + 13);
            a2h = (a8f + 14);
            a3h = (a8f + 15);
            b7 = (T2 + a7f);
            *((b7 + 16)) = ((*(a8f)*t5p) + (*(a9f)*t6p));
            *((b7 + 24)) = ((*(a8f)*t6p) - (*(a9f)*t5p));
            *((b7 + 17)) = ((*(a0g)*t9p) + (*(a1g)*t0q));
            *((b7 + 25)) = ((*(a0g)*t0q) - (*(a1g)*t9p));
            *((b7 + 18)) = ((*(a2g)*t3q) + (*(a3g)*t4q));
            *((b7 + 26)) = ((*(a2g)*t4q) - (*(a3g)*t3q));
            *((b7 + 19)) = ((*(a4g)*t7q) + (*(a5g)*t8q));
            *((b7 + 27)) = ((*(a4g)*t8q) - (*(a5g)*t7q));
            *((b7 + 20)) = ((*(a6g)*t7p) + (*(a7g)*t8p));
            *((b7 + 28)) = ((*(a6g)*t8p) - (*(a7g)*t7p));
            *((b7 + 21)) = ((*(a8g)*t1q) + (*(a9g)*t2q));
            *((b7 + 29)) = ((*(a8g)*t2q) - (*(a9g)*t1q));
            *((b7 + 22)) = ((*(a0h)*t5q) + (*(a1h)*t6q));
            *((b7 + 30)) = ((*(a0h)*t6q) - (*(a1h)*t5q));
            *((b7 + 23)) = ((*(a2h)*t9q) + (*(a3h)*t0r));
            *((b7 + 31)) = ((*(a2h)*t0r) - (*(a3h)*t9q));
        }}
        {long i4; for(i4 = 0; i4 <= 7; i4++) {
            a4h = (T2 + i4);
            a5h = (a4h + 64);
            t1r = (*(a4h) + *(a5h));
            t2r = (*(a4h) - *(a5h));
            a6h = (a4h + 8);
            a7h = (a4h + 72);
            t3r = (*(a6h) - *(a7h));
            t4r = (*(a6h) + *(a7h));
            a8h = (a4h + 32);
            a9h = (a4h + 40);
            a0i = (a4h + 96);
            a1i = (a4h + 104);
            t5r = (*(a8h) + *(a0i));
            t6r = (*(a9h) - *(a1i));
            a2i = (0.70710678118654757*(*(a8h) - *(a0i)));
            a3i = (0.70710678118654757*(*(a9h) + *(a1i)));
            s76 = (a2i - a3i);
            s86 = (a2i + a3i);
            t7r = (t1r + t5r);
            t8r = (t1r - t5r);
            t9r = (t2r - t6r);
            t0s = (t2r + t6r);
            t1s = (t3r + s76);
            t2s = (t3r - s76);
            t3s = (t4r - s86);
            t4s = (t4r + s86);
            a4i = (a4h + 16);
            a5i = (a4h + 24);
            a6i = (a4h + 112);
            a7i = (a4h + 120);
            t5s = (*(a4i) + *(a6i));
            t6s = (*(a5i) - *(a7i));
            t7s = (*(a4i) - *(a6i));
            t8s = (*(a5i) + *(a7i));
            a8i = (a4h + 80);
            a9i = (a4h + 88);
            a0j = (a4h + 48);
            a1j = (a4h + 56);
            t9s = (*(a8i) + *(a0j));
            t0t = (*(a9i) - *(a1j));
            t1t = (*(a8i) - *(a0j));
            t2t = (*(a9i) + *(a1j));
            t3t = (t5s + t9s);
            t4t = (t6s + t0t);
            t5t = (t7s - t2t);
            t6t = (t8s + t1t);
            t7t = (t7s + t2t);
            t8t = (t8s - t1t);
            s96 = ((0.92387953251128674*t5t) - (0.38268343236508978*t6t));
            s07 = ((0.38268343236508978*t5t) + (0.92387953251128674*t6t));
            a2j = (0.70710678118654757*(t5s - t9s));
            a3j = (0.70710678118654757*(t6s - t0t));
            s17 = (a2j - a3j);
            s27 = (a2j + a3j);
            s37 = ((0.38268343236508978*t7t) - (0.92387953251128674*t8t));
            s47 = ((0.92387953251128674*t7t) + (0.38268343236508978*t8t));
            a4j = (dst + i2 + (16*i4));
            *(a4j) = (t7r + t3t);
            *((a4j + 1024)) = (t7r - t3t);
            *((a4j + 512)) = (t8r - t4t);
            *((a4j + 1536)) = (t8r + t4t);
            *((a4j + 128)) = (t1s + s96);
            *((a4j + 1152)) = (t1s - s96);
            *((a4j + 640)) = (t2s - s07);
            *((a4j + 1664)) = (t2s + s07);
            *((a4j + 256)) = (t9r + s17);
            *((a4j + 1280)) = (t9r - s17);
            *((a4j + 768)) = (t0s - s27);
            *((a4j + 1792)) = (t0s + s27);
            *((a4j + 384)) = (t3s + s37);
            *((a4j + 1408)) = (t3s - s37);
            *((a4j + 896)) = (t4s - s47);
            *((a4j + 1920)) = (t4s + s47);
        }}
    }}
    }
    
    return SPIRAL_OK;
}

SPIRAL_API(spiral_status_t, spiral_rfftinv_double_4096)(const double *pSrc, double *pDst ) {
    const double  *src = (const double *)pSrc; 
    double        *dst = (double *)pDst;
    
    { double T[4096];
     double T2[128];
    double  *a0j, *a0k, *a0l, *a0m, *a0n, *a0o, *a0p, *a0q, *a0s, *a0u, *a0v, *a0w, *a1j, *a1k, *a1l, *a1m, *a1n, *a1o, *a1p, *a1q, *a1r, *a1s
            , *a1u, *a1v, *a1w, *a2j, *a2k, *a2l, *a2m, *a2n, *a2o, *a2p, *a2q, *a2r, *a2s, *a2t, *a2u, *a2v, *a2w, *a3j, *a3k, *a3l, *a3m, *a3n
            , *a3o, *a3p, *a3q, *a3r, *a3s, *a3t, *a3u, *a3v, *a3w, *a4j, *a4k, *a4l, *a4m, *a4n, *a4o, *a4p, *a4q, *a4r, *a4s, *a4t, *a4u, *a4v
            , *a4w, *a5j, *a5k, *a5l, *a5m, *a5n, *a5o, *a5p, *a5q, *a5r, *a5s, *a5t, *a5u, *a5v, *a5w, *a6i, *a6j, *a6k, *a6l, *a6m, *a6n, *a6o
            , *a6p, *a6q, *a6r, *a6s, *a6t, *a6u, *a7i, *a7j, *a7k, *a7l, *a7m, *a7n, *a7o, *a7p, *a7q, *a7r, *a7t, *a7u, *a8i, *a8j, *a8k, *a8l
            , *a8m, *a8n, *a8o, *a8r, *a8t, *a8u, *a8v, *a8w, *a9i, *a9j, *a9k, *a9l, *a9m, *a9n, *a9o, *a9r, *a9t, *a9u, *a9v, *b3, *b4, *b5
            , *b6, *b7;
    const double  *a, *a01, *a02, *a03, *a04, *a05, *a06, *a07, *a0a, *a0b, *a0c, *a0d, *a0e, *a0f, *a0h, *a11, *a12, *a13, *a14, *a15, *a16, *a17
            , *a1a, *a1b, *a1c, *a1d, *a1e, *a1f, *a1h, *a2, *a21, *a22, *a23, *a24, *a25, *a26, *a27, *a2a, *a2b, *a2c, *a2d, *a2e, *a2f, *a2h
            , *a3, *a31, *a32, *a33, *a34, *a35, *a36, *a37, *a3a, *a3c, *a3e, *a3f, *a3g, *a3h, *a4, *a41, *a42, *a44, *a46, *a47, *a4a, *a4c
            , *a4e, *a4f, *a4g, *a4h, *a5, *a51, *a52, *a54, *a56, *a57, *a5a, *a5c, *a5e, *a5g, *a5h, *a62, *a64, *a66, *a6a, *a6c, *a6e, *a6g
            , *a6h, *a72, *a74, *a76, *a79, *a7a, *a7b, *a7c, *a7e, *a7g, *a7h, *a8, *a81, *a82, *a83, *a84, *a86, *a89, *a8a, *a8b, *a8c, *a8e
            , *a8g, *a8h, *a9, *a91, *a92, *a93, *a94, *a96, *a99, *a9a, *a9b, *a9c, *a9d, *a9e, *a9g, *b, *b2;
    int a0r, a1t, a5i, a69;
    double a08, a09, a0g, a0i, a0t, a18, a19, a1g, a1i, a28, a29, a2g, a2i, a38, a39, a3b, a3d, a3i, a43, a45, a48, a49
            , a4b, a4d, a4i, a53, a55, a58, a59, a5b, a5d, a5f, a6, a61, a63, a65, a67, a68, a6b, a6d, a6f, a6v, a6w, a7
            , a71, a73, a75, a77, a78, a7d, a7f, a7s, a7v, a7w, a85, a87, a88, a8d, a8f, a8p, a8q, a8s, a95, a97, a98, a9f
            , a9h, a9p, a9q, a9s, s, s01, s02, s03, s04, s05, s06, s07, s08, s09, s0a, s0b, s0c, s0d, s0e, s0f, s0g, s11
            , s12, s13, s14, s15, s16, s17, s18, s19, s1a, s1b, s1c, s1d, s1e, s1f, s1g, s2, s21, s22, s23, s24, s25, s26
            , s27, s28, s29, s2a, s2b, s2c, s2d, s2e, s2f, s2g, s3, s31, s32, s33, s34, s35, s36, s37, s38, s39, s3a, s3b
            , s3c, s3d, s3e, s3f, s3g, s4, s41, s42, s43, s44, s45, s46, s47, s48, s49, s4a, s4b, s4c, s4d, s4e, s4f, s4g
            , s5, s51, s52, s53, s54, s55, s56, s57, s58, s59, s5a, s5b, s5c, s5d, s5e, s5f, s5g, s6, s61, s62, s63, s64
            , s65, s66, s67, s68, s69, s6a, s6b, s6c, s6d, s6e, s6f, s6g, s7, s71, s72, s73, s74, s75, s76, s77, s78, s79
            , s7a, s7b, s7c, s7d, s7e, s7f, s8, s81, s82, s83, s84, s85, s86, s87, s88, s89, s8a, s8b, s8c, s8d, s8e, s8f
            , s9, s91, s92, s93, s94, s95, s96, s97, s98, s99, s9a, s9b, s9c, s9d, s9e, s9f, t, t01, t02, t03, t04, t05
            , t06, t07, t08, t09, t0A, t0B, t0C, t0D, t0E, t0F, t0G, t0H, t0I, t0J, t0K, t0L, t0M, t0N, t0O, t0P, t0Q, t0R
            , t0S, t0T, t0U, t0V, t0W, t0X, t0Y, t0Z, t0a, t0b, t0c, t0d, t0e, t0f, t0g, t0h, t0i, t0j, t0k, t0l, t0m, t0n
            , t0o, t0p, t0q, t0r, t0s, t0t, t0u, t0v, t0w, t0x, t0y, t0z, t11, t12, t13, t14, t15, t16, t17, t18, t19, t1A
            , t1B, t1C, t1D, t1E, t1F, t1G, t1H, t1I, t1J, t1K, t1L, t1M, t1N, t1O, t1P, t1Q, t1R, t1S, t1T, t1U, t1V, t1W
            , t1X, t1Y, t1a, t1b, t1c, t1d, t1e, t1f, t1g, t1h, t1i, t1j, t1k, t1l, t1m, t1n, t1o, t1p, t1q, t1r, t1s, t1t
            , t1u, t1v, t1w, t1x, t1y, t1z, t2, t21, t22, t23, t24, t25, t26, t27, t28, t29, t2A, t2B, t2C, t2D, t2E, t2F
            , t2G, t2H, t2I, t2J, t2K, t2L, t2M, t2N, t2O, t2P, t2Q, t2R, t2S, t2T, t2U, t2V, t2W, t2X, t2Y, t2a, t2b, t2c
            , t2d, t2e, t2f, t2g, t2h, t2i, t2j, t2k, t2l, t2m, t2n, t2o, t2p, t2q, t2r, t2s, t2t, t2u, t2v, t2w, t2x, t2y
            , t2z, t3, t31, t32, t33, t34, t35, t36, t37, t38, t39, t3A, t3B, t3C, t3D, t3E, t3F, t3G, t3H, t3I, t3J, t3K
            , t3L, t3M, t3N, t3O, t3P, t3Q, t3R, t3S, t3T, t3U, t3V, t3W, t3X, t3Y, t3a, t3b, t3c, t3d, t3e, t3f, t3g, t3h
            , t3i, t3j, t3k, t3l, t3m, t3n, t3o, t3p, t3q, t3r, t3s, t3t, t3u, t3v, t3w, t3x, t3y, t3z, t4, t41, t42, t43
            , t44, t45, t46, t47, t48, t49, t4A, t4B, t4C, t4D, t4E, t4F, t4G, t4H, t4I, t4J, t4K, t4L, t4M, t4N, t4O, t4P
            , t4Q, t4R, t4S, t4T, t4U, t4V, t4W, t4X, t4Y, t4a, t4b, t4c, t4d, t4e, t4f, t4g, t4h, t4i, t4j, t4k, t4l, t4m
            , t4n, t4o, t4p, t4q, t4r, t4s, t4t, t4u, t4v, t4w, t4x, t4y, t4z, t5, t51, t52, t53, t54, t55, t56, t57, t58
            , t59, t5A, t5B, t5C, t5D, t5E, t5F, t5G, t5H, t5I, t5J, t5K, t5L, t5M, t5N, t5O, t5P, t5Q, t5R, t5S, t5T, t5U
            , t5V, t5W, t5X, t5Y, t5a, t5b, t5c, t5d, t5e, t5f, t5g, t5h, t5i, t5j, t5k, t5l, t5m, t5n, t5o, t5p, t5q, t5r
            , t5s, t5t, t5u, t5v, t5w, t5x, t5y, t5z, t6, t61, t62, t63, t64, t65, t66, t67, t68, t69, t6A, t6B, t6C, t6D
            , t6E, t6F, t6G, t6H, t6I, t6J, t6K, t6L, t6M, t6N, t6O, t6P, t6Q, t6R, t6S, t6T, t6U, t6V, t6W, t6X, t6Y, t6a
            , t6b, t6c, t6d, t6e, t6f, t6g, t6h, t6i, t6j, t6k, t6l, t6m, t6n, t6o, t6p, t6q, t6r, t6s, t6t, t6u, t6v, t6w
            , t6x, t6y, t6z, t7, t71, t72, t73, t74, t75, t76, t77, t78, t79, t7A, t7B, t7C, t7D, t7E, t7F, t7G, t7H, t7I
            , t7J, t7K, t7L, t7M, t7N, t7O, t7P, t7Q, t7R, t7S, t7T, t7U, t7V, t7W, t7X, t7Y, t7a, t7b, t7c, t7d, t7e, t7f
            , t7g, t7h, t7i, t7j, t7k, t7l, t7m, t7n, t7o, t7p, t7q, t7r, t7s, t7t, t7u, t7v, t7w, t7x, t7y, t7z, t8, t81
            , t82, t83, t84, t85, t86, t87, t88, t89, t8A, t8B, t8C, t8D, t8E, t8F, t8G, t8H, t8I, t8J, t8K, t8L, t8M, t8N
            , t8O, t8P, t8Q, t8R, t8S, t8T, t8U, t8V, t8W, t8X, t8Y, t8a, t8b, t8c, t8d, t8e, t8f, t8g, t8h, t8i, t8j, t8k
            , t8l, t8m, t8n, t8o, t8p, t8q, t8r, t8s, t8t, t8u, t8v, t8w, t8x, t8y, t8z, t9, t91, t92, t93, t94, t95, t96
            , t97, t98, t99, t9A, t9B, t9C, t9D, t9E, t9F, t9G, t9H, t9I, t9J, t9K, t9L, t9M, t9N, t9O, t9P, t9Q, t9R, t9S
            , t9T, t9U, t9V, t9W, t9X, t9Y, t9a, t9b, t9c, t9d, t9e, t9f, t9g, t9h, t9i, t9j, t9k, t9l, t9m, t9n, t9o, t9p
            , t9q, t9r, t9s, t9t, t9u, t9v, t9w, t9x, t9y, t9z;
    a = (src + 1);
    t = (*(src) + *(a));
    t2 = (*(src) - *(a));
    s = (2**((src + 2048)));
    t3 = (t + s);
    t4 = (t - s);
    s2 = (2**((src + 2049)));
    t5 = (t2 - s2);
    t6 = (t2 + s2);
    a2 = (src + 1024);
    a3 = (src + 3072);
    a4 = (src + 1025);
    a5 = (src + 3073);
    s3 = (2.0*(*(a2) + *(a3)));
    s4 = (2.0*(*(a4) - *(a5)));
    a6 = (1.4142135623730951*(*(a2) - *(a3)));
    a7 = (1.4142135623730951*(*(a4) + *(a5)));
    s5 = (a6 - a7);
    s6 = (a6 + a7);
    t7 = (t3 + s3);
    t8 = (t3 - s3);
    t9 = (t4 - s4);
    t01 = (t4 + s4);
    t11 = (t5 + s5);
    t21 = (t5 - s5);
    t31 = (t6 - s6);
    t41 = (t6 + s6);
    a8 = (src + 512);
    a9 = (src + 3584);
    t51 = (*(a8) + *(a9));
    a01 = (src + 513);
    a11 = (src + 3585);
    t61 = (*(a01) - *(a11));
    t71 = (*(a8) - *(a9));
    t81 = (*(a01) + *(a11));
    a21 = (src + 2560);
    a31 = (src + 1536);
    t91 = (*(a21) + *(a31));
    a41 = (src + 2561);
    a51 = (src + 1537);
    t02 = (*(a41) - *(a51));
    t12 = (*(a21) - *(a31));
    t22 = (*(a41) + *(a51));
    t32 = (t71 - t22);
    t42 = (t81 + t12);
    t52 = (t71 + t22);
    t62 = (t81 - t12);
    s7 = (2.0*(t51 + t91));
    s8 = (2.0*(t61 + t02));
    s9 = ((1.8477590650225735*t32) - (0.76536686473017956*t42));
    s01 = ((0.76536686473017956*t32) + (1.8477590650225735*t42));
    a61 = (1.4142135623730951*(t51 - t91));
    a71 = (1.4142135623730951*(t61 - t02));
    s11 = (a61 - a71);
    s21 = (a61 + a71);
    s31 = ((0.76536686473017956*t52) - (1.8477590650225735*t62));
    s41 = ((1.8477590650225735*t52) + (0.76536686473017956*t62));
    t72 = (t7 + s7);
    t82 = (t7 - s7);
    t92 = (t8 - s8);
    t03 = (t8 + s8);
    t13 = (t11 + s9);
    t23 = (t11 - s9);
    t33 = (t21 - s01);
    t43 = (t21 + s01);
    t53 = (t9 + s11);
    t63 = (t9 - s11);
    t73 = (t01 - s21);
    t83 = (t01 + s21);
    t93 = (t31 + s31);
    t04 = (t31 - s31);
    t14 = (t41 - s41);
    t24 = (t41 + s41);
    a81 = (src + 128);
    a91 = (src + 3968);
    t34 = (*(a81) + *(a91));
    a02 = (src + 129);
    a12 = (src + 3969);
    t44 = (*(a02) - *(a12));
    t54 = (*(a81) - *(a91));
    t64 = (*(a02) + *(a12));
    a22 = (src + 2176);
    a32 = (src + 1920);
    t74 = (*(a22) + *(a32));
    a42 = (src + 2177);
    a52 = (src + 1921);
    t84 = (*(a42) - *(a52));
    t94 = (*(a22) - *(a32));
    t05 = (*(a42) + *(a52));
    t15 = (t34 + t74);
    t25 = (t44 + t84);
    t35 = (t34 - t74);
    t45 = (t44 - t84);
    t55 = (t54 - t05);
    t65 = (t64 + t94);
    t75 = (t54 + t05);
    t85 = (t64 - t94);
    a62 = (src + 1152);
    a72 = (src + 2944);
    t95 = (*(a62) + *(a72));
    a82 = (src + 1153);
    a92 = (src + 2945);
    t06 = (*(a82) - *(a92));
    t16 = (*(a62) - *(a72));
    t26 = (*(a82) + *(a92));
    a03 = (src + 3200);
    a13 = (src + 896);
    t36 = (*(a03) + *(a13));
    a23 = (src + 3201);
    a33 = (src + 897);
    t46 = (*(a23) - *(a33));
    t56 = (*(a03) - *(a13));
    t66 = (*(a23) + *(a33));
    t76 = (t95 + t36);
    t86 = (t06 + t46);
    t96 = (t95 - t36);
    t07 = (t06 - t46);
    a43 = (0.70710678118654757*(t16 - t66));
    a53 = (0.70710678118654757*(t26 + t56));
    s51 = (a43 - a53);
    s61 = (a43 + a53);
    a63 = (0.70710678118654757*(t16 + t66));
    a73 = (0.70710678118654757*(t26 - t56));
    s71 = (a63 + a73);
    s81 = (a63 - a73);
    t17 = (t15 - t76);
    t27 = (t25 - t86);
    t37 = (t55 + s51);
    t47 = (t65 + s61);
    t57 = (t55 - s51);
    t67 = (t65 - s61);
    t77 = (t35 - t07);
    t87 = (t45 + t96);
    t97 = (t35 + t07);
    t08 = (t45 - t96);
    t18 = (t75 - s71);
    t28 = (t85 + s81);
    t38 = (t75 + s71);
    t48 = (t85 - s81);
    s91 = (2.0*(t15 + t76));
    s02 = (2.0*(t25 + t86));
    s12 = ((1.9903694533443939*t37) - (0.19603428065912121*t47));
    s22 = ((0.19603428065912121*t37) + (1.9903694533443939*t47));
    s32 = ((1.9615705608064609*t77) - (0.39018064403225655*t87));
    s42 = ((0.39018064403225655*t77) + (1.9615705608064609*t87));
    s52 = ((1.9138806714644176*t18) - (0.58056935450892477*t28));
    s62 = ((0.58056935450892477*t18) + (1.9138806714644176*t28));
    s72 = ((1.8477590650225735*t17) - (0.76536686473017956*t27));
    s82 = ((0.76536686473017956*t17) + (1.8477590650225735*t27));
    s92 = ((1.7638425286967101*t57) - (0.94279347365199528*t67));
    s03 = ((0.94279347365199528*t57) + (1.7638425286967101*t67));
    s13 = ((1.6629392246050905*t97) - (1.1111404660392044*t08));
    s23 = ((1.1111404660392044*t97) + (1.6629392246050905*t08));
    s33 = ((1.546020906725474*t38) - (1.268786568327291*t48));
    s43 = ((1.268786568327291*t38) + (1.546020906725474*t48));
    a83 = (src + 256);
    a93 = (src + 3840);
    t58 = (*(a83) + *(a93));
    a04 = (src + 257);
    a14 = (src + 3841);
    t68 = (*(a04) - *(a14));
    t78 = (*(a83) - *(a93));
    t88 = (*(a04) + *(a14));
    a24 = (src + 2304);
    a34 = (src + 1792);
    t98 = (*(a24) + *(a34));
    a44 = (src + 2305);
    a54 = (src + 1793);
    t09 = (*(a44) - *(a54));
    t19 = (*(a24) - *(a34));
    t29 = (*(a44) + *(a54));
    t39 = (t58 + t98);
    t49 = (t68 + t09);
    t59 = (t58 - t98);
    t69 = (t68 - t09);
    t79 = (t78 - t29);
    t89 = (t88 + t19);
    t99 = (t78 + t29);
    t0a = (t88 - t19);
    a64 = (src + 1280);
    a74 = (src + 2816);
    t1a = (*(a64) + *(a74));
    a84 = (src + 1281);
    a94 = (src + 2817);
    t2a = (*(a84) - *(a94));
    t3a = (*(a64) - *(a74));
    t4a = (*(a84) + *(a94));
    a05 = (src + 3328);
    a15 = (src + 768);
    t5a = (*(a05) + *(a15));
    a25 = (src + 3329);
    a35 = (src + 769);
    t6a = (*(a25) - *(a35));
    t7a = (*(a05) - *(a15));
    t8a = (*(a25) + *(a35));
    t9a = (t1a + t5a);
    t0b = (t2a + t6a);
    t1b = (t1a - t5a);
    t2b = (t2a - t6a);
    a45 = (0.70710678118654757*(t3a - t8a));
    a55 = (0.70710678118654757*(t4a + t7a));
    s53 = (a45 - a55);
    s63 = (a45 + a55);
    a65 = (0.70710678118654757*(t3a + t8a));
    a75 = (0.70710678118654757*(t4a - t7a));
    s73 = (a65 + a75);
    s83 = (a65 - a75);
    t3b = (t79 + s53);
    t4b = (t89 + s63);
    t5b = (t79 - s53);
    t6b = (t89 - s63);
    t7b = (t59 - t2b);
    t8b = (t69 + t1b);
    t9b = (t59 + t2b);
    t0c = (t69 - t1b);
    t1c = (t99 - s73);
    t2c = (t0a + s83);
    t3c = (t99 + s73);
    t4c = (t0a - s83);
    s93 = (2.0*(t39 + t9a));
    s04 = (2.0*(t49 + t0b));
    s14 = ((1.9615705608064609*t3b) - (0.39018064403225655*t4b));
    s24 = ((0.39018064403225655*t3b) + (1.9615705608064609*t4b));
    s34 = ((1.8477590650225735*t7b) - (0.76536686473017956*t8b));
    s44 = ((0.76536686473017956*t7b) + (1.8477590650225735*t8b));
    s54 = ((1.6629392246050905*t1c) - (1.1111404660392044*t2c));
    s64 = ((1.1111404660392044*t1c) + (1.6629392246050905*t2c));
    a85 = (1.4142135623730951*(t39 - t9a));
    a95 = (1.4142135623730951*(t49 - t0b));
    s74 = (a85 - a95);
    s84 = (a85 + a95);
    s94 = ((1.1111404660392044*t5b) - (1.6629392246050905*t6b));
    s05 = ((1.6629392246050905*t5b) + (1.1111404660392044*t6b));
    s15 = ((0.76536686473017956*t9b) - (1.8477590650225735*t0c));
    s25 = ((1.8477590650225735*t9b) + (0.76536686473017956*t0c));
    s35 = ((0.39018064403225655*t3c) - (1.9615705608064609*t4c));
    s45 = ((1.9615705608064609*t3c) + (0.39018064403225655*t4c));
    a06 = (src + 384);
    a16 = (src + 3712);
    t5c = (*(a06) + *(a16));
    a26 = (src + 385);
    a36 = (src + 3713);
    t6c = (*(a26) - *(a36));
    t7c = (*(a06) - *(a16));
    t8c = (*(a26) + *(a36));
    a46 = (src + 2432);
    a56 = (src + 1664);
    t9c = (*(a46) + *(a56));
    a66 = (src + 2433);
    a76 = (src + 1665);
    t0d = (*(a66) - *(a76));
    t1d = (*(a46) - *(a56));
    t2d = (*(a66) + *(a76));
    t3d = (t5c + t9c);
    t4d = (t6c + t0d);
    t5d = (t5c - t9c);
    t6d = (t6c - t0d);
    t7d = (t7c - t2d);
    t8d = (t8c + t1d);
    t9d = (t7c + t2d);
    t0e = (t8c - t1d);
    a86 = (src + 1408);
    a96 = (src + 2688);
    t1e = (*(a86) + *(a96));
    a07 = (src + 1409);
    a17 = (src + 2689);
    t2e = (*(a07) - *(a17));
    t3e = (*(a86) - *(a96));
    t4e = (*(a07) + *(a17));
    a27 = (src + 3456);
    a37 = (src + 640);
    t5e = (*(a27) + *(a37));
    a47 = (src + 3457);
    a57 = (src + 641);
    t6e = (*(a47) - *(a57));
    t7e = (*(a27) - *(a37));
    t8e = (*(a47) + *(a57));
    t9e = (t1e + t5e);
    t0f = (t2e + t6e);
    t1f = (t1e - t5e);
    t2f = (t2e - t6e);
    a67 = (0.70710678118654757*(t3e - t8e));
    a77 = (0.70710678118654757*(t4e + t7e));
    s55 = (a67 - a77);
    s65 = (a67 + a77);
    a87 = (0.70710678118654757*(t3e + t8e));
    a97 = (0.70710678118654757*(t4e - t7e));
    s75 = (a87 + a97);
    s85 = (a87 - a97);
    t3f = (t3d - t9e);
    t4f = (t4d - t0f);
    t5f = (t7d + s55);
    t6f = (t8d + s65);
    t7f = (t7d - s55);
    t8f = (t8d - s65);
    t9f = (t5d - t2f);
    t0g = (t6d + t1f);
    t1g = (t5d + t2f);
    t2g = (t6d - t1f);
    t3g = (t9d - s75);
    t4g = (t0e + s85);
    t5g = (t9d + s75);
    t6g = (t0e - s85);
    s95 = (2.0*(t3d + t9e));
    s06 = (2.0*(t4d + t0f));
    s16 = ((1.9138806714644176*t5f) - (0.58056935450892477*t6f));
    s26 = ((0.58056935450892477*t5f) + (1.9138806714644176*t6f));
    s36 = ((1.6629392246050905*t9f) - (1.1111404660392044*t0g));
    s46 = ((1.1111404660392044*t9f) + (1.6629392246050905*t0g));
    s56 = ((1.268786568327291*t3g) - (1.546020906725474*t4g));
    s66 = ((1.546020906725474*t3g) + (1.268786568327291*t4g));
    s76 = ((0.76536686473017956*t3f) - (1.8477590650225735*t4f));
    s86 = ((1.8477590650225735*t3f) + (0.76536686473017956*t4f));
    s96 = ((0.19603428065912121*t7f) - (1.9903694533443939*t8f));
    s07 = ((1.9903694533443939*t7f) + (0.19603428065912121*t8f));
    s17 = ((0.39018064403225655*t1g) + (1.9615705608064609*t2g));
    s27 = ((1.9615705608064609*t1g) - (0.39018064403225655*t2g));
    s37 = ((0.94279347365199528*t5g) + (1.7638425286967101*t6g));
    s47 = ((1.7638425286967101*t5g) - (0.94279347365199528*t6g));
    t7g = (t72 + s93);
    t8g = (t72 - s93);
    t9g = (t82 - s04);
    t0h = (t82 + s04);
    t1h = (s91 + s95);
    t2h = (s02 - s06);
    a08 = (0.70710678118654757*(s91 - s95));
    a18 = (0.70710678118654757*(s02 + s06));
    s57 = (a08 - a18);
    s67 = (a08 + a18);
    *(T) = (t7g + t1h);
    *((T + 32)) = (t7g - t1h);
    *((T + 16)) = (t8g - t2h);
    *((T + 48)) = (t8g + t2h);
    *((T + 8)) = (t9g + s57);
    *((T + 40)) = (t9g - s57);
    *((T + 24)) = (t0h - s67);
    *((T + 56)) = (t0h + s67);
    t3h = (t13 + s14);
    t4h = (t13 - s14);
    t5h = (t23 - s24);
    t6h = (t23 + s24);
    t7h = (s12 + s16);
    t8h = (s22 - s26);
    a28 = (0.70710678118654757*(s12 - s16));
    a38 = (0.70710678118654757*(s22 + s26));
    s77 = (a28 - a38);
    s87 = (a28 + a38);
    *((T + 1)) = (t3h + t7h);
    *((T + 33)) = (t3h - t7h);
    *((T + 17)) = (t4h - t8h);
    *((T + 49)) = (t4h + t8h);
    *((T + 9)) = (t5h + s77);
    *((T + 41)) = (t5h - s77);
    *((T + 25)) = (t6h - s87);
    *((T + 57)) = (t6h + s87);
    t9h = (t53 + s34);
    t0i = (t53 - s34);
    t1i = (t63 - s44);
    t2i = (t63 + s44);
    t3i = (s32 + s36);
    t4i = (s42 - s46);
    a48 = (0.70710678118654757*(s32 - s36));
    a58 = (0.70710678118654757*(s42 + s46));
    s97 = (a48 - a58);
    s08 = (a48 + a58);
    *((T + 2)) = (t9h + t3i);
    *((T + 34)) = (t9h - t3i);
    *((T + 18)) = (t0i - t4i);
    *((T + 50)) = (t0i + t4i);
    *((T + 10)) = (t1i + s97);
    *((T + 42)) = (t1i - s97);
    *((T + 26)) = (t2i - s08);
    *((T + 58)) = (t2i + s08);
    t5i = (t93 + s54);
    t6i = (t93 - s54);
    t7i = (t04 - s64);
    t8i = (t04 + s64);
    t9i = (s52 + s56);
    t0j = (s62 - s66);
    a68 = (0.70710678118654757*(s52 - s56));
    a78 = (0.70710678118654757*(s62 + s66));
    s18 = (a68 - a78);
    s28 = (a68 + a78);
    *((T + 3)) = (t5i + t9i);
    *((T + 35)) = (t5i - t9i);
    *((T + 19)) = (t6i - t0j);
    *((T + 51)) = (t6i + t0j);
    *((T + 11)) = (t7i + s18);
    *((T + 43)) = (t7i - s18);
    *((T + 27)) = (t8i - s28);
    *((T + 59)) = (t8i + s28);
    t1j = (t92 + s74);
    t2j = (t92 - s74);
    t3j = (t03 - s84);
    t4j = (t03 + s84);
    t5j = (s72 + s76);
    t6j = (s82 - s86);
    a88 = (0.70710678118654757*(s72 - s76));
    a98 = (0.70710678118654757*(s82 + s86));
    s38 = (a88 - a98);
    s48 = (a88 + a98);
    *((T + 4)) = (t1j + t5j);
    *((T + 36)) = (t1j - t5j);
    *((T + 20)) = (t2j - t6j);
    *((T + 52)) = (t2j + t6j);
    *((T + 12)) = (t3j + s38);
    *((T + 44)) = (t3j - s38);
    *((T + 28)) = (t4j - s48);
    *((T + 60)) = (t4j + s48);
    t7j = (t33 + s94);
    t8j = (t33 - s94);
    t9j = (t43 - s05);
    t0k = (t43 + s05);
    t1k = (s92 + s96);
    t2k = (s03 - s07);
    a09 = (0.70710678118654757*(s92 - s96));
    a19 = (0.70710678118654757*(s03 + s07));
    s58 = (a09 - a19);
    s68 = (a09 + a19);
    *((T + 5)) = (t7j + t1k);
    *((T + 37)) = (t7j - t1k);
    *((T + 21)) = (t8j - t2k);
    *((T + 53)) = (t8j + t2k);
    *((T + 13)) = (t9j + s58);
    *((T + 45)) = (t9j - s58);
    *((T + 29)) = (t0k - s68);
    *((T + 61)) = (t0k + s68);
    t3k = (t73 + s15);
    t4k = (t73 - s15);
    t5k = (t83 - s25);
    t6k = (t83 + s25);
    t7k = (s13 - s17);
    t8k = (s23 - s27);
    a29 = (0.70710678118654757*(s13 + s17));
    a39 = (0.70710678118654757*(s23 + s27));
    s78 = (a29 - a39);
    s88 = (a29 + a39);
    *((T + 6)) = (t3k + t7k);
    *((T + 38)) = (t3k - t7k);
    *((T + 22)) = (t4k - t8k);
    *((T + 54)) = (t4k + t8k);
    *((T + 14)) = (t5k + s78);
    *((T + 46)) = (t5k - s78);
    *((T + 30)) = (t6k - s88);
    *((T + 62)) = (t6k + s88);
    t9k = (t14 + s35);
    t0l = (t14 - s35);
    t1l = (t24 - s45);
    t2l = (t24 + s45);
    t3l = (s33 - s37);
    t4l = (s43 - s47);
    a49 = (0.70710678118654757*(s33 + s37));
    a59 = (0.70710678118654757*(s43 + s47));
    s98 = (a49 - a59);
    s09 = (a49 + a59);
    *((T + 7)) = (t9k + t3l);
    *((T + 39)) = (t9k - t3l);
    *((T + 23)) = (t0l - t4l);
    *((T + 55)) = (t0l + t4l);
    *((T + 15)) = (t1l + s98);
    *((T + 47)) = (t1l - s98);
    *((T + 31)) = (t2l - s09);
    *((T + 63)) = (t2l + s09);
    {long i; for(i = 0; i <= 62; i++) {
        a69 = (2*i);
        b = (src + a69);
        a79 = (b + 2);
        a89 = (b + 3);
        b2 = (src - a69);
        a99 = (b2 + 4094);
        a0a = (b2 + 4095);
        t5l = (*(a79) + *(a99));
        t6l = (*(a89) - *(a0a));
        t7l = (*(a79) - *(a99));
        t8l = (*(a89) + *(a0a));
        a1a = (b + 2050);
        a2a = (b + 2051);
        a3a = (b2 + 2046);
        a4a = (b2 + 2047);
        t9l = (*(a1a) + *(a3a));
        t0m = (*(a2a) - *(a4a));
        t1m = (*(a1a) - *(a3a));
        t2m = (*(a2a) + *(a4a));
        t3m = (t5l + t9l);
        t4m = (t6l + t0m);
        t5m = (t5l - t9l);
        t6m = (t6l - t0m);
        t7m = (t7l - t2m);
        t8m = (t8l + t1m);
        t9m = (t7l + t2m);
        t0n = (t8l - t1m);
        a5a = (b + 1026);
        a6a = (b + 1027);
        a7a = (b2 + 3070);
        a8a = (b2 + 3071);
        t1n = (*(a5a) + *(a7a));
        t2n = (*(a6a) - *(a8a));
        t3n = (*(a5a) - *(a7a));
        t4n = (*(a6a) + *(a8a));
        a9a = (b + 3074);
        a0b = (b + 3075);
        a1b = (b2 + 1022);
        a2b = (b2 + 1023);
        t5n = (*(a9a) + *(a1b));
        t6n = (*(a0b) - *(a2b));
        t7n = (*(a9a) - *(a1b));
        t8n = (*(a0b) + *(a2b));
        t9n = (t1n + t5n);
        t0o = (t2n + t6n);
        t1o = (t1n - t5n);
        t2o = (t2n - t6n);
        a3b = (0.70710678118654757*(t3n - t8n));
        a4b = (0.70710678118654757*(t4n + t7n));
        s19 = (a3b - a4b);
        s29 = (a3b + a4b);
        a5b = (0.70710678118654757*(t3n + t8n));
        a6b = (0.70710678118654757*(t4n - t7n));
        s39 = (a5b + a6b);
        s49 = (a5b - a6b);
        t3o = (t3m + t9n);
        t4o = (t4m + t0o);
        t5o = (t3m - t9n);
        t6o = (t4m - t0o);
        t7o = (t7m + s19);
        t8o = (t8m + s29);
        t9o = (t7m - s19);
        t0p = (t8m - s29);
        t1p = (t5m - t2o);
        t2p = (t6m + t1o);
        t3p = (t5m + t2o);
        t4p = (t6m - t1o);
        t5p = (t9m - s39);
        t6p = (t0n + s49);
        t7p = (t9m + s39);
        t8p = (t0n - s49);
        a7b = (b + 258);
        a8b = (b + 259);
        a9b = (b2 + 3838);
        a0c = (b2 + 3839);
        t9p = (*(a7b) + *(a9b));
        t0q = (*(a8b) - *(a0c));
        t1q = (*(a7b) - *(a9b));
        t2q = (*(a8b) + *(a0c));
        a1c = (b + 2306);
        a2c = (b + 2307);
        a3c = (b2 + 1790);
        a4c = (b2 + 1791);
        t3q = (*(a1c) + *(a3c));
        t4q = (*(a2c) - *(a4c));
        t5q = (*(a1c) - *(a3c));
        t6q = (*(a2c) + *(a4c));
        t7q = (t9p + t3q);
        t8q = (t0q + t4q);
        t9q = (t9p - t3q);
        t0r = (t0q - t4q);
        t1r = (t1q - t6q);
        t2r = (t2q + t5q);
        t3r = (t1q + t6q);
        t4r = (t2q - t5q);
        a5c = (b + 1282);
        a6c = (b + 1283);
        a7c = (b2 + 2814);
        a8c = (b2 + 2815);
        t5r = (*(a5c) + *(a7c));
        t6r = (*(a6c) - *(a8c));
        t7r = (*(a5c) - *(a7c));
        t8r = (*(a6c) + *(a8c));
        a9c = (b + 3330);
        a0d = (b + 3331);
        a1d = (b2 + 766);
        a2d = (b2 + 767);
        t9r = (*(a9c) + *(a1d));
        t0s = (*(a0d) - *(a2d));
        t1s = (*(a9c) - *(a1d));
        t2s = (*(a0d) + *(a2d));
        t3s = (t5r + t9r);
        t4s = (t6r + t0s);
        t5s = (t5r - t9r);
        t6s = (t6r - t0s);
        a3d = (0.70710678118654757*(t7r - t2s));
        a4d = (0.70710678118654757*(t8r + t1s));
        s59 = (a3d - a4d);
        s69 = (a3d + a4d);
        a5d = (0.70710678118654757*(t7r + t2s));
        a6d = (0.70710678118654757*(t8r - t1s));
        s79 = (a5d + a6d);
        s89 = (a5d - a6d);
        t7s = (t7q + t3s);
        t8s = (t8q + t4s);
        a7d = (0.70710678118654757*(t7q - t3s));
        a8d = (0.70710678118654757*(t8q - t4s));
        s99 = (a7d - a8d);
        s0a = (a7d + a8d);
        t9s = (t1r + s59);
        t0t = (t2r + s69);
        t1t = (t1r - s59);
        t2t = (t2r - s69);
        s1a = ((0.98078528040323043*t9s) - (0.19509032201612828*t0t));
        s2a = ((0.19509032201612828*t9s) + (0.98078528040323043*t0t));
        s3a = ((0.55557023301960218*t1t) - (0.83146961230254524*t2t));
        s4a = ((0.83146961230254524*t1t) + (0.55557023301960218*t2t));
        t3t = (t9q - t6s);
        t4t = (t0r + t5s);
        t5t = (t9q + t6s);
        t6t = (t0r - t5s);
        s5a = ((0.92387953251128674*t3t) - (0.38268343236508978*t4t));
        s6a = ((0.38268343236508978*t3t) + (0.92387953251128674*t4t));
        s7a = ((0.38268343236508978*t5t) - (0.92387953251128674*t6t));
        s8a = ((0.92387953251128674*t5t) + (0.38268343236508978*t6t));
        t7t = (t3r - s79);
        t8t = (t4r + s89);
        t9t = (t3r + s79);
        t0u = (t4r - s89);
        s9a = ((0.83146961230254524*t7t) - (0.55557023301960218*t8t));
        s0b = ((0.55557023301960218*t7t) + (0.83146961230254524*t8t));
        s1b = ((0.19509032201612828*t9t) - (0.98078528040323043*t0u));
        s2b = ((0.98078528040323043*t9t) + (0.19509032201612828*t0u));
        a9d = (b + 514);
        a0e = (b + 515);
        a1e = (b2 + 3582);
        a2e = (b2 + 3583);
        t1u = (*(a9d) + *(a1e));
        t2u = (*(a0e) - *(a2e));
        t3u = (*(a9d) - *(a1e));
        t4u = (*(a0e) + *(a2e));
        a3e = (b + 2562);
        a4e = (b + 2563);
        a5e = (b2 + 1534);
        a6e = (b2 + 1535);
        t5u = (*(a3e) + *(a5e));
        t6u = (*(a4e) - *(a6e));
        t7u = (*(a3e) - *(a5e));
        t8u = (*(a4e) + *(a6e));
        t9u = (t1u + t5u);
        t0v = (t2u + t6u);
        t1v = (t1u - t5u);
        t2v = (t2u - t6u);
        t3v = (t3u - t8u);
        t4v = (t4u + t7u);
        t5v = (t3u + t8u);
        t6v = (t4u - t7u);
        a7e = (b + 1538);
        a8e = (b + 1539);
        a9e = (b2 + 2558);
        a0f = (b2 + 2559);
        t7v = (*(a7e) + *(a9e));
        t8v = (*(a8e) - *(a0f));
        t9v = (*(a7e) - *(a9e));
        t0w = (*(a8e) + *(a0f));
        a1f = (b + 3586);
        a2f = (b + 3587);
        a3f = (b2 + 510);
        a4f = (b2 + 511);
        t1w = (*(a1f) + *(a3f));
        t2w = (*(a2f) - *(a4f));
        t3w = (*(a1f) - *(a3f));
        t4w = (*(a2f) + *(a4f));
        t5w = (t7v + t1w);
        t6w = (t8v + t2w);
        t7w = (t7v - t1w);
        t8w = (t8v - t2w);
        a5f = (0.70710678118654757*(t9v - t4w));
        a6f = (0.70710678118654757*(t0w + t3w));
        s3b = (a5f - a6f);
        s4b = (a5f + a6f);
        a7f = (0.70710678118654757*(t9v + t4w));
        a8f = (0.70710678118654757*(t0w - t3w));
        s5b = (a7f + a8f);
        s6b = (a7f - a8f);
        t9w = (t9u + t5w);
        t0x = (t0v + t6w);
        t1x = (t9u - t5w);
        t2x = (t0v - t6w);
        t3x = (t3v + s3b);
        t4x = (t4v + s4b);
        t5x = (t3v - s3b);
        t6x = (t4v - s4b);
        s7b = ((0.92387953251128674*t3x) - (0.38268343236508978*t4x));
        s8b = ((0.38268343236508978*t3x) + (0.92387953251128674*t4x));
        s9b = ((0.38268343236508978*t5x) + (0.92387953251128674*t6x));
        s0c = ((0.92387953251128674*t5x) - (0.38268343236508978*t6x));
        a9f = (0.70710678118654757*(t1v - t8w));
        a0g = (0.70710678118654757*(t2v + t7w));
        s1c = (a9f - a0g);
        s2c = (a9f + a0g);
        a1g = (0.70710678118654757*(t1v + t8w));
        a2g = (0.70710678118654757*(t2v - t7w));
        s3c = (a1g + a2g);
        s4c = (a1g - a2g);
        t7x = (t5v - s5b);
        t8x = (t6v + s6b);
        t9x = (t5v + s5b);
        t0y = (t6v - s6b);
        s5c = ((0.38268343236508978*t7x) - (0.92387953251128674*t8x));
        s6c = ((0.92387953251128674*t7x) + (0.38268343236508978*t8x));
        s7c = ((0.92387953251128674*t9x) + (0.38268343236508978*t0y));
        s8c = ((0.38268343236508978*t9x) - (0.92387953251128674*t0y));
        a3g = (b + 770);
        a4g = (b + 771);
        a5g = (b2 + 3326);
        a6g = (b2 + 3327);
        t1y = (*(a3g) + *(a5g));
        t2y = (*(a4g) - *(a6g));
        t3y = (*(a3g) - *(a5g));
        t4y = (*(a4g) + *(a6g));
        a7g = (b + 2818);
        a8g = (b + 2819);
        a9g = (b2 + 1278);
        a0h = (b2 + 1279);
        t5y = (*(a7g) + *(a9g));
        t6y = (*(a8g) - *(a0h));
        t7y = (*(a7g) - *(a9g));
        t8y = (*(a8g) + *(a0h));
        t9y = (t1y + t5y);
        t0z = (t2y + t6y);
        t1z = (t1y - t5y);
        t2z = (t2y - t6y);
        t3z = (t3y - t8y);
        t4z = (t4y + t7y);
        t5z = (t3y + t8y);
        t6z = (t4y - t7y);
        a1h = (b + 1794);
        a2h = (b + 1795);
        a3h = (b2 + 2302);
        a4h = (b2 + 2303);
        t7z = (*(a1h) + *(a3h));
        t8z = (*(a2h) - *(a4h));
        t9z = (*(a1h) - *(a3h));
        t0A = (*(a2h) + *(a4h));
        a5h = (b + 3842);
        a6h = (b + 3843);
        a7h = (b2 + 254);
        a8h = (b2 + 255);
        t1A = (*(a5h) + *(a7h));
        t2A = (*(a6h) - *(a8h));
        t3A = (*(a5h) - *(a7h));
        t4A = (*(a6h) + *(a8h));
        t5A = (t7z + t1A);
        t6A = (t8z + t2A);
        t7A = (t7z - t1A);
        t8A = (t8z - t2A);
        a9h = (0.70710678118654757*(t9z - t4A));
        a0i = (0.70710678118654757*(t0A + t3A));
        s9c = (a9h - a0i);
        s0d = (a9h + a0i);
        a1i = (0.70710678118654757*(t9z + t4A));
        a2i = (0.70710678118654757*(t0A - t3A));
        s1d = (a1i + a2i);
        s2d = (a1i - a2i);
        t9A = (t9y + t5A);
        t0B = (t0z + t6A);
        a3i = (0.70710678118654757*(t9y - t5A));
        a4i = (0.70710678118654757*(t0z - t6A));
        s3d = (a3i + a4i);
        s4d = (a3i - a4i);
        t1B = (t3z + s9c);
        t2B = (t4z + s0d);
        t3B = (t3z - s9c);
        t4B = (t4z - s0d);
        s5d = ((0.83146961230254524*t1B) - (0.55557023301960218*t2B));
        s6d = ((0.55557023301960218*t1B) + (0.83146961230254524*t2B));
        s7d = ((0.98078528040323043*t3B) + (0.19509032201612828*t4B));
        s8d = ((0.19509032201612828*t3B) - (0.98078528040323043*t4B));
        t5B = (t1z - t8A);
        t6B = (t2z + t7A);
        t7B = (t1z + t8A);
        t8B = (t2z - t7A);
        s9d = ((0.38268343236508978*t5B) - (0.92387953251128674*t6B));
        s0e = ((0.92387953251128674*t5B) + (0.38268343236508978*t6B));
        s1e = ((0.38268343236508978*t8B) - (0.92387953251128674*t7B));
        s2e = ((0.38268343236508978*t7B) + (0.92387953251128674*t8B));
        t9B = (t5z - s1d);
        t0C = (t6z + s2d);
        t1C = (t5z + s1d);
        t2C = (t6z - s2d);
        s3e = ((0.19509032201612828*t9B) + (0.98078528040323043*t0C));
        s4e = ((0.98078528040323043*t9B) - (0.19509032201612828*t0C));
        s5e = ((0.83146961230254524*t2C) - (0.55557023301960218*t1C));
        s6e = ((0.83146961230254524*t1C) + (0.55557023301960218*t2C));
        t3C = (t3o + t9w);
        t4C = (t4o + t0x);
        t5C = (t3o - t9w);
        t6C = (t4o - t0x);
        t7C = (t7s + t9A);
        t8C = (t8s + t0B);
        t9C = (t7s - t9A);
        t0D = (t8s - t0B);
        t1D = (t3C + t7C);
        t2D = (t4C + t8C);
        t3D = (t3C - t7C);
        t4D = (t4C - t8C);
        t5D = (t5C - t0D);
        t6D = (t6C + t9C);
        t7D = (t5C + t0D);
        t8D = (t6C - t9C);
        t9D = (t7o + s7b);
        t0E = (t8o + s8b);
        t1E = (t7o - s7b);
        t2E = (t8o - s8b);
        t3E = (s1a + s5d);
        t4E = (s2a + s6d);
        t5E = (s1a - s5d);
        t6E = (s2a - s6d);
        t7E = (t9D + t3E);
        t8E = (t0E + t4E);
        t9E = (t9D - t3E);
        t0F = (t0E - t4E);
        t1F = (t1E - t6E);
        t2F = (t2E + t5E);
        t3F = (t1E + t6E);
        t4F = (t2E - t5E);
        t5F = (t1p + s1c);
        t6F = (t2p + s2c);
        t7F = (t1p - s1c);
        t8F = (t2p - s2c);
        t9F = (s5a + s9d);
        t0G = (s6a + s0e);
        t1G = (s5a - s9d);
        t2G = (s6a - s0e);
        t3G = (t5F + t9F);
        t4G = (t6F + t0G);
        t5G = (t5F - t9F);
        t6G = (t6F - t0G);
        t7G = (t7F - t2G);
        t8G = (t8F + t1G);
        t9G = (t7F + t2G);
        t0H = (t8F - t1G);
        t1H = (t5p + s5c);
        t2H = (t6p + s6c);
        t3H = (t5p - s5c);
        t4H = (t6p - s6c);
        t5H = (s9a - s3e);
        t6H = (s0b + s4e);
        t7H = (s9a + s3e);
        t8H = (s0b - s4e);
        t9H = (t1H + t5H);
        t0I = (t2H + t6H);
        t1I = (t1H - t5H);
        t2I = (t2H - t6H);
        t3I = (t3H - t8H);
        t4I = (t4H + t7H);
        t5I = (t3H + t8H);
        t6I = (t4H - t7H);
        t7I = (t5o - t2x);
        t8I = (t6o + t1x);
        t9I = (t5o + t2x);
        t0J = (t6o - t1x);
        t1J = (s99 - s3d);
        t2J = (s0a + s4d);
        t3J = (s99 + s3d);
        t4J = (s0a - s4d);
        t5J = (t7I + t1J);
        t6J = (t8I + t2J);
        t7J = (t7I - t1J);
        t8J = (t8I - t2J);
        t9J = (t9I - t4J);
        t0K = (t0J + t3J);
        t1K = (t9I + t4J);
        t2K = (t0J - t3J);
        t3K = (t9o - s9b);
        t4K = (t0p + s0c);
        t5K = (t9o + s9b);
        t6K = (t0p - s0c);
        t7K = (s3a - s7d);
        t8K = (s4a + s8d);
        t9K = (s3a + s7d);
        t0L = (s4a - s8d);
        t1L = (t3K + t7K);
        t2L = (t4K + t8K);
        t3L = (t3K - t7K);
        t4L = (t4K - t8K);
        t5L = (t5K - t0L);
        t6L = (t6K + t9K);
        t7L = (t5K + t0L);
        t8L = (t6K - t9K);
        t9L = (t3p - s3c);
        t0M = (t4p + s4c);
        t1M = (t3p + s3c);
        t2M = (t4p - s4c);
        t3M = (s7a + s1e);
        t4M = (s8a - s2e);
        t5M = (s7a - s1e);
        t6M = (s8a + s2e);
        t7M = (t9L + t3M);
        t8M = (t0M + t4M);
        t9M = (t9L - t3M);
        t0N = (t0M - t4M);
        t1N = (t1M - t6M);
        t2N = (t2M + t5M);
        t3N = (t1M + t6M);
        t4N = (t2M - t5M);
        t5N = (t7p - s7c);
        t6N = (t8p + s8c);
        t7N = (t7p + s7c);
        t8N = (t8p - s8c);
        t9N = (s1b + s5e);
        t0O = (s2b - s6e);
        t1O = (s1b - s5e);
        t2O = (s2b + s6e);
        t3O = (t5N + t9N);
        t4O = (t6N + t0O);
        t5O = (t5N - t9N);
        t6O = (t6N - t0O);
        t7O = (t7N - t2O);
        t8O = (t8N + t1O);
        t9O = (t7N + t2O);
        t0P = (t8N - t1O);
        a5i = (64*i);
        a6i = (D283 + a5i);
        a7i = (a6i + 1);
        a8i = (a6i + 2);
        a9i = (a6i + 3);
        a0j = (a6i + 4);
        a1j = (a6i + 5);
        a2j = (a6i + 6);
        a3j = (a6i + 7);
        a4j = (a6i + 8);
        a5j = (a6i + 9);
        a6j = (a6i + 10);
        a7j = (a6i + 11);
        a8j = (a6i + 12);
        a9j = (a6i + 13);
        a0k = (a6i + 14);
        a1k = (a6i + 15);
        a2k = (a6i + 16);
        a3k = (a6i + 17);
        a4k = (a6i + 18);
        a5k = (a6i + 19);
        a6k = (a6i + 20);
        a7k = (a6i + 21);
        a8k = (a6i + 22);
        a9k = (a6i + 23);
        a0l = (a6i + 24);
        a1l = (a6i + 25);
        a2l = (a6i + 26);
        a3l = (a6i + 27);
        a4l = (a6i + 28);
        a5l = (a6i + 29);
        a6l = (a6i + 30);
        a7l = (a6i + 31);
        a8l = (a6i + 32);
        a9l = (a6i + 33);
        a0m = (a6i + 34);
        a1m = (a6i + 35);
        a2m = (a6i + 36);
        a3m = (a6i + 37);
        a4m = (a6i + 38);
        a5m = (a6i + 39);
        a6m = (a6i + 40);
        a7m = (a6i + 41);
        a8m = (a6i + 42);
        a9m = (a6i + 43);
        a0n = (a6i + 44);
        a1n = (a6i + 45);
        a2n = (a6i + 46);
        a3n = (a6i + 47);
        a4n = (a6i + 48);
        a5n = (a6i + 49);
        a6n = (a6i + 50);
        a7n = (a6i + 51);
        a8n = (a6i + 52);
        a9n = (a6i + 53);
        a0o = (a6i + 54);
        a1o = (a6i + 55);
        a2o = (a6i + 56);
        a3o = (a6i + 57);
        a4o = (a6i + 58);
        a5o = (a6i + 59);
        a6o = (a6i + 60);
        a7o = (a6i + 61);
        a8o = (a6i + 62);
        a9o = (a6i + 63);
        b3 = (T + a5i);
        *((b3 + 64)) = ((*(a6i)*t1D) + (*(a7i)*t2D));
        *((b3 + 96)) = ((*(a6i)*t2D) - (*(a7i)*t1D));
        *((b3 + 65)) = ((*(a8i)*t7E) + (*(a9i)*t8E));
        *((b3 + 97)) = ((*(a8i)*t8E) - (*(a9i)*t7E));
        *((b3 + 66)) = ((*(a0j)*t3G) + (*(a1j)*t4G));
        *((b3 + 98)) = ((*(a0j)*t4G) - (*(a1j)*t3G));
        *((b3 + 67)) = ((*(a2j)*t9H) + (*(a3j)*t0I));
        *((b3 + 99)) = ((*(a2j)*t0I) - (*(a3j)*t9H));
        *((b3 + 68)) = ((*(a4j)*t5J) + (*(a5j)*t6J));
        *((b3 + 100)) = ((*(a4j)*t6J) - (*(a5j)*t5J));
        *((b3 + 69)) = ((*(a6j)*t1L) + (*(a7j)*t2L));
        *((b3 + 101)) = ((*(a6j)*t2L) - (*(a7j)*t1L));
        *((b3 + 70)) = ((*(a8j)*t7M) + (*(a9j)*t8M));
        *((b3 + 102)) = ((*(a8j)*t8M) - (*(a9j)*t7M));
        *((b3 + 71)) = ((*(a0k)*t3O) + (*(a1k)*t4O));
        *((b3 + 103)) = ((*(a0k)*t4O) - (*(a1k)*t3O));
        *((b3 + 72)) = ((*(a2k)*t5D) + (*(a3k)*t6D));
        *((b3 + 104)) = ((*(a2k)*t6D) - (*(a3k)*t5D));
        *((b3 + 73)) = ((*(a4k)*t1F) + (*(a5k)*t2F));
        *((b3 + 105)) = ((*(a4k)*t2F) - (*(a5k)*t1F));
        *((b3 + 74)) = ((*(a6k)*t7G) + (*(a7k)*t8G));
        *((b3 + 106)) = ((*(a6k)*t8G) - (*(a7k)*t7G));
        *((b3 + 75)) = ((*(a8k)*t3I) + (*(a9k)*t4I));
        *((b3 + 107)) = ((*(a8k)*t4I) - (*(a9k)*t3I));
        *((b3 + 76)) = ((*(a0l)*t9J) + (*(a1l)*t0K));
        *((b3 + 108)) = ((*(a0l)*t0K) - (*(a1l)*t9J));
        *((b3 + 77)) = ((*(a2l)*t5L) + (*(a3l)*t6L));
        *((b3 + 109)) = ((*(a2l)*t6L) - (*(a3l)*t5L));
        *((b3 + 78)) = ((*(a4l)*t1N) + (*(a5l)*t2N));
        *((b3 + 110)) = ((*(a4l)*t2N) - (*(a5l)*t1N));
        *((b3 + 79)) = ((*(a6l)*t7O) + (*(a7l)*t8O));
        *((b3 + 111)) = ((*(a6l)*t8O) - (*(a7l)*t7O));
        *((b3 + 80)) = ((*(a8l)*t3D) + (*(a9l)*t4D));
        *((b3 + 112)) = ((*(a8l)*t4D) - (*(a9l)*t3D));
        *((b3 + 81)) = ((*(a0m)*t9E) + (*(a1m)*t0F));
        *((b3 + 113)) = ((*(a0m)*t0F) - (*(a1m)*t9E));
        *((b3 + 82)) = ((*(a2m)*t5G) + (*(a3m)*t6G));
        *((b3 + 114)) = ((*(a2m)*t6G) - (*(a3m)*t5G));
        *((b3 + 83)) = ((*(a4m)*t1I) + (*(a5m)*t2I));
        *((b3 + 115)) = ((*(a4m)*t2I) - (*(a5m)*t1I));
        *((b3 + 84)) = ((*(a6m)*t7J) + (*(a7m)*t8J));
        *((b3 + 116)) = ((*(a6m)*t8J) - (*(a7m)*t7J));
        *((b3 + 85)) = ((*(a8m)*t3L) + (*(a9m)*t4L));
        *((b3 + 117)) = ((*(a8m)*t4L) - (*(a9m)*t3L));
        *((b3 + 86)) = ((*(a0n)*t9M) + (*(a1n)*t0N));
        *((b3 + 118)) = ((*(a0n)*t0N) - (*(a1n)*t9M));
        *((b3 + 87)) = ((*(a2n)*t5O) + (*(a3n)*t6O));
        *((b3 + 119)) = ((*(a2n)*t6O) - (*(a3n)*t5O));
        *((b3 + 88)) = ((*(a4n)*t7D) + (*(a5n)*t8D));
        *((b3 + 120)) = ((*(a4n)*t8D) - (*(a5n)*t7D));
        *((b3 + 89)) = ((*(a6n)*t3F) + (*(a7n)*t4F));
        *((b3 + 121)) = ((*(a6n)*t4F) - (*(a7n)*t3F));
        *((b3 + 90)) = ((*(a8n)*t9G) + (*(a9n)*t0H));
        *((b3 + 122)) = ((*(a8n)*t0H) - (*(a9n)*t9G));
        *((b3 + 91)) = ((*(a0o)*t5I) + (*(a1o)*t6I));
        *((b3 + 123)) = ((*(a0o)*t6I) - (*(a1o)*t5I));
        *((b3 + 92)) = ((*(a2o)*t1K) + (*(a3o)*t2K));
        *((b3 + 124)) = ((*(a2o)*t2K) - (*(a3o)*t1K));
        *((b3 + 93)) = ((*(a4o)*t7L) + (*(a5o)*t8L));
        *((b3 + 125)) = ((*(a4o)*t8L) - (*(a5o)*t7L));
        *((b3 + 94)) = ((*(a6o)*t3N) + (*(a7o)*t4N));
        *((b3 + 126)) = ((*(a6o)*t4N) - (*(a7o)*t3N));
        *((b3 + 95)) = ((*(a8o)*t9O) + (*(a9o)*t0P));
        *((b3 + 127)) = ((*(a8o)*t0P) - (*(a9o)*t9O));
    }}
    {long i2; for(i2 = 0; i2 <= 31; i2++) {
        a0p = (T + i2);
        a1p = (a0p + 2048);
        t1P = (*(a0p) + *(a1p));
        t2P = (*(a0p) - *(a1p));
        a2p = (a0p + 32);
        a3p = (a0p + 2080);
        t3P = (*(a2p) - *(a3p));
        t4P = (*(a2p) + *(a3p));
        a4p = (a0p + 1024);
        a5p = (a0p + 1056);
        a6p = (a0p + 3072);
        a7p = (a0p + 3104);
        t5P = (*(a4p) + *(a6p));
        t6P = (*(a5p) - *(a7p));
        a8p = (0.70710678118654757*(*(a4p) - *(a6p)));
        a9p = (0.70710678118654757*(*(a5p) + *(a7p)));
        s7e = (a8p - a9p);
        s8e = (a8p + a9p);
        t7P = (t1P + t5P);
        t8P = (t1P - t5P);
        t9P = (t2P - t6P);
        t0Q = (t2P + t6P);
        t1Q = (t3P + s7e);
        t2Q = (t3P - s7e);
        t3Q = (t4P - s8e);
        t4Q = (t4P + s8e);
        a0q = (a0p + 512);
        a1q = (a0p + 544);
        a2q = (a0p + 3584);
        a3q = (a0p + 3616);
        t5Q = (*(a0q) + *(a2q));
        t6Q = (*(a1q) - *(a3q));
        t7Q = (*(a0q) - *(a2q));
        t8Q = (*(a1q) + *(a3q));
        a4q = (a0p + 2560);
        a5q = (a0p + 2592);
        a6q = (a0p + 1536);
        a7q = (a0p + 1568);
        t9Q = (*(a4q) + *(a6q));
        t0R = (*(a5q) - *(a7q));
        t1R = (*(a4q) - *(a6q));
        t2R = (*(a5q) + *(a7q));
        t3R = (t5Q + t9Q);
        t4R = (t6Q + t0R);
        t5R = (t7Q - t2R);
        t6R = (t8Q + t1R);
        t7R = (t7Q + t2R);
        t8R = (t8Q - t1R);
        s9e = ((0.92387953251128674*t5R) - (0.38268343236508978*t6R));
        s0f = ((0.38268343236508978*t5R) + (0.92387953251128674*t6R));
        a8q = (0.70710678118654757*(t5Q - t9Q));
        a9q = (0.70710678118654757*(t6Q - t0R));
        s1f = (a8q - a9q);
        s2f = (a8q + a9q);
        s3f = ((0.38268343236508978*t7R) - (0.92387953251128674*t8R));
        s4f = ((0.92387953251128674*t7R) + (0.38268343236508978*t8R));
        *(T2) = (t7P + t3R);
        *((T2 + 8)) = (t7P - t3R);
        *((T2 + 4)) = (t8P - t4R);
        *((T2 + 12)) = (t8P + t4R);
        *((T2 + 1)) = (t1Q + s9e);
        *((T2 + 9)) = (t1Q - s9e);
        *((T2 + 5)) = (t2Q - s0f);
        *((T2 + 13)) = (t2Q + s0f);
        *((T2 + 2)) = (t9P + s1f);
        *((T2 + 10)) = (t9P - s1f);
        *((T2 + 6)) = (t0Q - s2f);
        *((T2 + 14)) = (t0Q + s2f);
        *((T2 + 3)) = (t3Q + s3f);
        *((T2 + 11)) = (t3Q - s3f);
        *((T2 + 7)) = (t4Q - s4f);
        *((T2 + 15)) = (t4Q + s4f);
        {long i3; for(i3 = 0; i3 <= 6; i3++) {
            a0r = (64*i3);
            b4 = (T + i2);
            b5 = (b4 + a0r);
            a1r = (b5 + 64);
            a2r = (b5 + 96);
            b6 = (b4 - a0r);
            a3r = (b6 + 4032);
            a4r = (b6 + 4064);
            t9R = (*(a1r) + *(a3r));
            t0S = (*(a2r) - *(a4r));
            t1S = (*(a1r) - *(a3r));
            t2S = (*(a2r) + *(a4r));
            a5r = (b5 + 2112);
            a6r = (b5 + 2144);
            a7r = (b6 + 1984);
            a8r = (b6 + 2016);
            t3S = (*(a5r) + *(a7r));
            t4S = (*(a6r) - *(a8r));
            t5S = (*(a5r) - *(a7r));
            t6S = (*(a6r) + *(a8r));
            t7S = (t9R + t3S);
            t8S = (t0S + t4S);
            t9S = (t9R - t3S);
            t0T = (t0S - t4S);
            t1T = (t1S - t6S);
            t2T = (t2S + t5S);
            t3T = (t1S + t6S);
            t4T = (t2S - t5S);
            a9r = (b5 + 1088);
            a0s = (b5 + 1120);
            a1s = (b6 + 3008);
            a2s = (b6 + 3040);
            t5T = (*(a9r) + *(a1s));
            t6T = (*(a0s) - *(a2s));
            t7T = (*(a9r) - *(a1s));
            t8T = (*(a0s) + *(a2s));
            a3s = (b5 + 3136);
            a4s = (b5 + 3168);
            a5s = (b6 + 960);
            a6s = (b6 + 992);
            t9T = (*(a3s) + *(a5s));
            t0U = (*(a4s) - *(a6s));
            t1U = (*(a3s) - *(a5s));
            t2U = (*(a4s) + *(a6s));
            t3U = (t5T + t9T);
            t4U = (t6T + t0U);
            t5U = (t5T - t9T);
            t6U = (t6T - t0U);
            a7s = (0.70710678118654757*(t7T - t2U));
            a8s = (0.70710678118654757*(t8T + t1U));
            s5f = (a7s - a8s);
            s6f = (a7s + a8s);
            a9s = (0.70710678118654757*(t7T + t2U));
            a0t = (0.70710678118654757*(t8T - t1U));
            s7f = (a9s + a0t);
            s8f = (a9s - a0t);
            t7U = (t7S + t3U);
            t8U = (t8S + t4U);
            t9U = (t7S - t3U);
            t0V = (t8S - t4U);
            t1V = (t1T + s5f);
            t2V = (t2T + s6f);
            t3V = (t1T - s5f);
            t4V = (t2T - s6f);
            t5V = (t9S - t6U);
            t6V = (t0T + t5U);
            t7V = (t9S + t6U);
            t8V = (t0T - t5U);
            t9V = (t3T - s7f);
            t0W = (t4T + s8f);
            t1W = (t3T + s7f);
            t2W = (t4T - s8f);
            a1t = (16*i3);
            a2t = (D282 + a1t);
            a3t = (a2t + 1);
            a4t = (a2t + 2);
            a5t = (a2t + 3);
            a6t = (a2t + 4);
            a7t = (a2t + 5);
            a8t = (a2t + 6);
            a9t = (a2t + 7);
            a0u = (a2t + 8);
            a1u = (a2t + 9);
            a2u = (a2t + 10);
            a3u = (a2t + 11);
            a4u = (a2t + 12);
            a5u = (a2t + 13);
            a6u = (a2t + 14);
            a7u = (a2t + 15);
            b7 = (T2 + a1t);
            *((b7 + 16)) = ((*(a2t)*t7U) + (*(a3t)*t8U));
            *((b7 + 24)) = ((*(a2t)*t8U) - (*(a3t)*t7U));
            *((b7 + 17)) = ((*(a4t)*t1V) + (*(a5t)*t2V));
            *((b7 + 25)) = ((*(a4t)*t2V) - (*(a5t)*t1V));
            *((b7 + 18)) = ((*(a6t)*t5V) + (*(a7t)*t6V));
            *((b7 + 26)) = ((*(a6t)*t6V) - (*(a7t)*t5V));
            *((b7 + 19)) = ((*(a8t)*t9V) + (*(a9t)*t0W));
            *((b7 + 27)) = ((*(a8t)*t0W) - (*(a9t)*t9V));
            *((b7 + 20)) = ((*(a0u)*t9U) + (*(a1u)*t0V));
            *((b7 + 28)) = ((*(a0u)*t0V) - (*(a1u)*t9U));
            *((b7 + 21)) = ((*(a2u)*t3V) + (*(a3u)*t4V));
            *((b7 + 29)) = ((*(a2u)*t4V) - (*(a3u)*t3V));
            *((b7 + 22)) = ((*(a4u)*t7V) + (*(a5u)*t8V));
            *((b7 + 30)) = ((*(a4u)*t8V) - (*(a5u)*t7V));
            *((b7 + 23)) = ((*(a6u)*t1W) + (*(a7u)*t2W));
            *((b7 + 31)) = ((*(a6u)*t2W) - (*(a7u)*t1W));
        }}
        {long i4; for(i4 = 0; i4 <= 7; i4++) {
            a8u = (T2 + i4);
            a9u = (a8u + 64);
            t3W = (*(a8u) + *(a9u));
            t4W = (*(a8u) - *(a9u));
            a0v = (a8u + 8);
            a1v = (a8u + 72);
            t5W = (*(a0v) - *(a1v));
            t6W = (*(a0v) + *(a1v));
            a2v = (a8u + 32);
            a3v = (a8u + 40);
            a4v = (a8u + 96);
            a5v = (a8u + 104);
            t7W = (*(a2v) + *(a4v));
            t8W = (*(a3v) - *(a5v));
            a6v = (0.70710678118654757*(*(a2v) - *(a4v)));
            a7v = (0.70710678118654757*(*(a3v) + *(a5v)));
            s9f = (a6v - a7v);
            s0g = (a6v + a7v);
            t9W = (t3W + t7W);
            t0X = (t3W - t7W);
            t1X = (t4W - t8W);
            t2X = (t4W + t8W);
            t3X = (t5W + s9f);
            t4X = (t5W - s9f);
            t5X = (t6W - s0g);
            t6X = (t6W + s0g);
            a8v = (a8u + 16);
            a9v = (a8u + 24);
            a0w = (a8u + 112);
            a1w = (a8u + 120);
            t7X = (*(a8v) + *(a0w));
            t8X = (*(a9v) - *(a1w));
            t9X = (*(a8v) - *(a0w));
            t0Y = (*(a9v) + *(a1w));
            a2w = (a8u + 80);
            a3w = (a8u + 88);
            a4w = (a8u + 48);
            a5w = (a8u + 56);
            t1Y = (*(a2w) + *(a4w));
            t2Y = (*(a3w) - *(a5w));
            t3Y = (*(a2w) - *(a4w));
            t4Y = (*(a3w) + *(a5w));
            t5Y = (t7X + t1Y);
            t6Y = (t8X + t2Y);
            t7Y = (t9X - t4Y);
            t8Y = (t0Y + t3Y);
            t9Y = (t9X + t4Y);
            t0Z = (t0Y - t3Y);
            s1g = ((0.92387953251128674*t7Y) - (0.38268343236508978*t8Y));
            s2g = ((0.38268343236508978*t7Y) + (0.92387953251128674*t8Y));
            a6w = (0.70710678118654757*(t7X - t1Y));
            a7w = (0.70710678118654757*(t8X - t2Y));
            s3g = (a6w - a7w);
            s4g = (a6w + a7w);
            s5g = ((0.38268343236508978*t9Y) - (0.92387953251128674*t0Z));
            s6g = ((0.92387953251128674*t9Y) + (0.38268343236508978*t0Z));
            a8w = (dst + i2 + (32*i4));
            *(a8w) = (t9W + t5Y);
            *((a8w + 2048)) = (t9W - t5Y);
            *((a8w + 1024)) = (t0X - t6Y);
            *((a8w + 3072)) = (t0X + t6Y);
            *((a8w + 256)) = (t3X + s1g);
            *((a8w + 2304)) = (t3X - s1g);
            *((a8w + 1280)) = (t4X - s2g);
            *((a8w + 3328)) = (t4X + s2g);
            *((a8w + 512)) = (t1X + s3g);
            *((a8w + 2560)) = (t1X - s3g);
            *((a8w + 1536)) = (t2X - s4g);
            *((a8w + 3584)) = (t2X + s4g);
            *((a8w + 768)) = (t5X + s5g);
            *((a8w + 2816)) = (t5X - s5g);
            *((a8w + 1792)) = (t6X - s6g);
            *((a8w + 3840)) = (t6X + s6g);
        }}
    }}
    }
    
    return SPIRAL_OK;
}

